/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { DomainChart } from "./DomainChart";
import { fromEnum, enumGetBox, markType } from "igniteui-react-core";
import { HorizontalAlignment_$type } from "igniteui-react-core";
import { VerticalAlignment_$type } from "igniteui-react-core";
import { Visibility_$type } from "igniteui-react-core";
import { ValueAxisLabelLocation_$type } from "./ValueAxisLabelLocation";
import { AngleAxisLabelLocation_$type } from "./AngleAxisLabelLocation";
import { AxisLabelSettings } from "./AxisLabelSettings";
import { AxisDefaults } from "./AxisDefaults";
import { TitleSettings } from "./TitleSettings";
import { ScalerParams } from "./ScalerParams";
import { DeviceUtils } from "igniteui-react-core";
/**
 * @hidden
 */
export let RadialBaseChart = /*@__PURE__*/ (() => {
    class RadialBaseChart extends DomainChart {
        constructor() {
            super(...arguments);
            this.aay = null;
            this.aaz = null;
            this.abd = 0;
            this.abf = 5;
            this.abe = 0;
            this.abc = 5;
            this.abw = 5;
            this.aby = 0;
            this.abx = 5;
            this.abv = 0;
            this.agz = null;
            this.ag6 = null;
            this.agx = null;
            this.agy = null;
            this.abq = 0;
            this.ab9 = 0;
            this.abp = NaN;
            this.ab8 = NaN;
            this.abs = NaN;
            this.acb = NaN;
            this.abr = NaN;
            this.aca = NaN;
            this.abo = NaN;
            this.ab7 = NaN;
            this.ag5 = null;
            this.ahc = null;
            this.adn = null;
            this.adr = null;
            this.adp = null;
            this.adt = null;
            this.adi = null;
            this.adj = null;
            this.ag0 = null;
            this.ag7 = null;
            this.abg = DeviceUtils.g(1);
            this.abz = DeviceUtils.g(1);
            this.abj = DeviceUtils.g(1);
            this.ab2 = DeviceUtils.g(1);
            this.ag2 = null;
            this.ag9 = null;
            this.ag3 = null;
            this.aha = null;
            this.abk = DeviceUtils.g(1);
            this.ab3 = DeviceUtils.g(1);
            this.abl = DeviceUtils.g(8);
            this.ab4 = 0;
            this.ag4 = null;
            this.ahb = null;
            this.abm = DeviceUtils.g(1);
            this.ab5 = DeviceUtils.g(1);
            this.ado = null;
            this.ads = null;
            this.ag1 = null;
            this.ag8 = null;
            this.abb = 0;
            this.abu = 0;
            this.aba = NaN;
            this.abh = NaN;
            this.abi = NaN;
            this.abt = NaN;
            this.ab0 = NaN;
            this.ab1 = NaN;
            this.abn = 0;
            this.ab6 = -90;
            this.aa6 = false;
            this.aa7 = false;
            this.ags = 1;
            this.ahv = 1;
            this.agr = 1;
            this.agt = 2;
            this.aht = 0;
            this.ahu = 1;
            this.ahz = 0;
            this.ah0 = 0;
            this.aa4 = 4;
            this.aau = 4;
            this.adm = null;
            this.aaq = null;
            this.adq = null;
            this.aar = null;
        }
        provideContainer(a) {
            if (a != null) {
                let b = this.aaw();
                let c = this.aax();
                if (b != null) {
                    b.provideRenderer(a);
                }
                if (c != null) {
                    c.provideRenderer(a);
                }
            }
            super.provideContainer(a);
        }
        vs() {
            super.vs();
            let a = this.aaw();
            let b = this.aax();
            if (a != null && a.az != null) {
                this.ahf = a.az.textColor;
            }
            if (b != null && b.az != null) {
                this.ahm = b.az.textColor;
            }
            this.ahk = AxisDefaults.axis_TickBrush;
            this.ahr = AxisDefaults.axis_TickBrush;
            this.ahg = AxisDefaults.axis_MajorBrush;
            this.ahn = AxisDefaults.axis_MajorBrush;
            this.ahj = AxisDefaults.axis_LineBrush;
            this.ahq = AxisDefaults.axis_LineBrush;
        }
        wn(a, b, c) {
            super.wn(a, b, c);
            switch (a) {
                case "AngleAxisLabelLeftMargin":
                    this.agj((d) => d.leftMargin = this.acf);
                    break;
                case "AngleAxisLabelTopMargin":
                    this.agj((d) => d.topMargin = this.ach);
                    break;
                case "AngleAxisLabelRightMargin":
                    this.agj((d) => d.rightMargin = this.acg);
                    break;
                case "AngleAxisLabelBottomMargin":
                    this.agj((d) => d.bottomMargin = this.ace);
                    break;
                case "ValueAxisLabelLeftMargin":
                    this.ago((d) => d.leftMargin = this.ac2);
                    break;
                case "ValueAxisLabelTopMargin":
                    this.ago((d) => d.topMargin = this.ac4);
                    break;
                case "ValueAxisLabelRightMargin":
                    this.ago((d) => d.rightMargin = this.ac3);
                    break;
                case "ValueAxisLabelBottomMargin":
                    this.ago((d) => d.bottomMargin = this.ac1);
                    break;
                case "ActualItemsSource":
                case "ShouldDisplayMockData":
                case "ShouldUseSkeletonStyleForMockData":
                    this.ahd = this.zo(this.ahf);
                    this.ahe = this.zo(this.ahm);
                    break;
                case "AngleAxisLabelTextColor":
                    this.ahd = this.zo(this.ahf);
                    break;
                case "ValueAxisLabelTextColor":
                    this.ahe = this.zo(this.ahm);
                    break;
                case "ActualAngleAxisLabelTextColor":
                    this.agj((d) => d.textColor = this.ahd);
                    break;
                case "ActualValueAxisLabelTextColor":
                    this.ago((d) => d.textColor = this.ahe);
                    break;
                case "AngleAxisTitleMargin":
                    this.agl((d) => d.margin = this.acs);
                    break;
                case "ValueAxisTitleMargin":
                    this.agq((d) => d.margin = this.adf);
                    break;
                case "AngleAxisTitleLeftMargin":
                    this.agl((d) => d.leftMargin = this.acr);
                    break;
                case "ValueAxisTitleLeftMargin":
                    this.agq((d) => d.leftMargin = this.ade);
                    break;
                case "AngleAxisTitleTopMargin":
                    this.agl((d) => d.topMargin = this.acu);
                    break;
                case "ValueAxisTitleTopMargin":
                    this.agq((d) => d.topMargin = this.adh);
                    break;
                case "AngleAxisTitleRightMargin":
                    this.agl((d) => d.rightMargin = this.act);
                    break;
                case "ValueAxisTitleRightMargin":
                    this.agq((d) => d.rightMargin = this.adg);
                    break;
                case "AngleAxisTitleBottomMargin":
                    this.agl((d) => d.bottomMargin = this.acq);
                    break;
                case "ValueAxisTitleBottomMargin":
                    this.agq((d) => d.bottomMargin = this.add);
                    break;
                case "AngleAxisTitleTextColor":
                    this.agl((d) => d.textColor = this.ahl);
                    break;
                case "ValueAxisTitleTextColor":
                    this.agq((d) => d.textColor = this.ahs);
                    break;
                case "AngleAxisFormatLabel":
                    this.agh((d) => d.au = this.aa0);
                    break;
                case "ValueAxisFormatLabel":
                    this.agm((d) => d.au = this.aa1);
                    break;
            }
        }
        get aa0() {
            return this.aay;
        }
        set aa0(a) {
            let b = this.aa0;
            if (a != b) {
                this.aay = a;
                this.wj("AngleAxisFormatLabel", b, this.aa0);
            }
        }
        get aa1() {
            return this.aaz;
        }
        set aa1(a) {
            let b = this.aa1;
            if (a != b) {
                this.aaz = a;
                this.wj("ValueAxisFormatLabel", b, this.aa1);
            }
        }
        get acf() {
            return this.abd;
        }
        set acf(a) {
            let b = this.acf;
            if (a != b) {
                this.abd = a;
                this.wj("AngleAxisLabelLeftMargin", b, this.acf);
            }
        }
        get ach() {
            return this.abf;
        }
        set ach(a) {
            let b = this.ach;
            if (a != b) {
                this.abf = a;
                this.wj("AngleAxisLabelTopMargin", b, this.ach);
            }
        }
        get acg() {
            return this.abe;
        }
        set acg(a) {
            let b = this.acg;
            if (a != b) {
                this.abe = a;
                this.wj("AngleAxisLabelRightMargin", b, this.acg);
            }
        }
        get ace() {
            return this.abc;
        }
        set ace(a) {
            let b = this.ace;
            if (a != b) {
                this.abc = a;
                this.wj("AngleAxisLabelBottomMargin", b, this.ace);
            }
        }
        get ac2() {
            return this.abw;
        }
        set ac2(a) {
            let b = this.ac2;
            if (a != b) {
                this.abw = a;
                this.wj("ValueAxisLabelLeftMargin", b, this.ac2);
            }
        }
        get ac4() {
            return this.aby;
        }
        set ac4(a) {
            let b = this.ac4;
            if (a != b) {
                this.aby = a;
                this.wj("ValueAxisLabelTopMargin", b, this.ac4);
            }
        }
        get ac3() {
            return this.abx;
        }
        set ac3(a) {
            let b = this.ac3;
            if (a != b) {
                this.abx = a;
                this.wj("ValueAxisLabelRightMargin", b, this.ac3);
            }
        }
        get ac1() {
            return this.abv;
        }
        set ac1(a) {
            let b = this.ac1;
            if (a != b) {
                this.abv = a;
                this.wj("ValueAxisLabelBottomMargin", b, this.ac1);
            }
        }
        get ahf() {
            return this.agz;
        }
        set ahf(a) {
            let b = this.ahf;
            if (a != b) {
                this.agz = a;
                this.wj("AngleAxisLabelTextColor", b, this.ahf);
            }
        }
        get ahm() {
            return this.ag6;
        }
        set ahm(a) {
            let b = this.ahm;
            if (a != b) {
                this.ag6 = a;
                this.wj("ValueAxisLabelTextColor", b, this.ahm);
            }
        }
        get ahd() {
            return this.agx;
        }
        set ahd(a) {
            let b = this.agx;
            if (a != b) {
                this.agx = a;
                this.wj("ActualAngleAxisLabelTextColor", b, this.ahd);
            }
        }
        get ahe() {
            return this.agy;
        }
        set ahe(a) {
            let b = this.agy;
            if (a != b) {
                this.agy = a;
                this.wj("ActualValueAxisLabelTextColor", b, this.ahe);
            }
        }
        get acs() {
            return this.abq;
        }
        set acs(a) {
            let b = this.acs;
            if (a != b) {
                this.abq = a;
                this.wj("AngleAxisTitleMargin", b, this.acs);
            }
        }
        get adf() {
            return this.ab9;
        }
        set adf(a) {
            let b = this.adf;
            if (a != b) {
                this.ab9 = a;
                this.wj("ValueAxisTitleMargin", b, this.adf);
            }
        }
        get acr() {
            return this.abp;
        }
        set acr(a) {
            let b = this.acr;
            if (a != b) {
                this.abp = a;
                this.wj("AngleAxisTitleLeftMargin", b, this.acr);
            }
        }
        get ade() {
            return this.ab8;
        }
        set ade(a) {
            let b = this.ade;
            if (a != b) {
                this.ab8 = a;
                this.wj("ValueAxisTitleLeftMargin", b, this.ade);
            }
        }
        get acu() {
            return this.abs;
        }
        set acu(a) {
            let b = this.acu;
            if (a != b) {
                this.abs = a;
                this.wj("AngleAxisTitleTopMargin", b, this.acu);
            }
        }
        get adh() {
            return this.acb;
        }
        set adh(a) {
            let b = this.adh;
            if (a != b) {
                this.acb = a;
                this.wj("ValueAxisTitleTopMargin", b, this.adh);
            }
        }
        get act() {
            return this.abr;
        }
        set act(a) {
            let b = this.act;
            if (a != b) {
                this.abr = a;
                this.wj("AngleAxisTitleRightMargin", b, this.act);
            }
        }
        get adg() {
            return this.aca;
        }
        set adg(a) {
            let b = this.adg;
            if (a != b) {
                this.aca = a;
                this.wj("ValueAxisTitleRightMargin", b, this.adg);
            }
        }
        get acq() {
            return this.abo;
        }
        set acq(a) {
            let b = this.acq;
            if (a != b) {
                this.abo = a;
                this.wj("AngleAxisTitleBottomMargin", b, this.acq);
            }
        }
        get add() {
            return this.ab7;
        }
        set add(a) {
            let b = this.add;
            if (a != b) {
                this.ab7 = a;
                this.wj("ValueAxisTitleBottomMargin", b, this.add);
            }
        }
        get ahl() {
            return this.ag5;
        }
        set ahl(a) {
            let b = this.ahl;
            if (a != b) {
                this.ag5 = a;
                this.wj("AngleAxisTitleTextColor", b, this.ahl);
            }
        }
        get ahs() {
            return this.ahc;
        }
        set ahs(a) {
            let b = this.ahs;
            if (a != b) {
                this.ahc = a;
                this.wj("ValueAxisTitleTextColor", b, this.ahs);
            }
        }
        wo(a, b, c) {
            super.wo(a, b, c);
            switch (a) {
                case "AngleAxisLabelTextStyle":
                    this.agj((d) => d.textStyle = this.aea);
                    break;
                case "ValueAxisLabelTextStyle":
                    this.ago((d) => d.textStyle = this.afi);
                    break;
                case "AngleAxisTitleTextStyle":
                    this.agl((d) => d.textStyle = this.ae0);
                    break;
                case "ValueAxisTitleTextStyle":
                    this.agq((d) => d.textStyle = this.af8);
                    break;
            }
        }
        get aea() {
            return this.adn;
        }
        set aea(a) {
            let b = this.aea;
            if (a != b) {
                this.adn = a;
                this.wj("AngleAxisLabelTextStyle", b, this.aea);
            }
        }
        get afi() {
            return this.adr;
        }
        set afi(a) {
            let b = this.afi;
            if (a != b) {
                this.adr = a;
                this.wj("ValueAxisLabelTextStyle", b, this.afi);
            }
        }
        get ae0() {
            return this.adp;
        }
        set ae0(a) {
            let b = this.ae0;
            if (a != b) {
                this.adp = a;
                this.wj("AngleAxisTitleTextStyle", b, this.ae0);
            }
        }
        get af8() {
            return this.adt;
        }
        set af8(a) {
            let b = this.af8;
            if (a != b) {
                this.adt = a;
                this.wj("ValueAxisTitleTextStyle", b, this.af8);
            }
        }
        age(a) {
            this.agb(a, (b) => b.leftMargin = this.acf);
            this.agb(a, (b) => b.topMargin = this.ach);
            this.agb(a, (b) => b.rightMargin = this.acg);
            this.agb(a, (b) => b.bottomMargin = this.ace);
            this.agb(a, (b) => b.textColor = this.ahd);
            this.agc(a, (b) => b.textColor = this.ahl);
            this.agc(a, (b) => b.leftMargin = this.acr);
            this.agc(a, (b) => b.topMargin = this.acu);
            this.agc(a, (b) => b.rightMargin = this.act);
            this.agc(a, (b) => b.bottomMargin = this.acq);
            this.agb(a, (b) => b.textStyle = this.aea);
            this.agc(a, (b) => b.textStyle = this.ae0);
        }
        agg(a) {
            this.agb(a, (b) => b.leftMargin = this.ac2);
            this.agb(a, (b) => b.topMargin = this.ac4);
            this.agb(a, (b) => b.rightMargin = this.ac3);
            this.agb(a, (b) => b.bottomMargin = this.ac1);
            this.agb(a, (b) => b.textColor = this.ahe);
            this.agc(a, (b) => b.textColor = this.ahs);
            this.agc(a, (b) => b.leftMargin = this.ade);
            this.agc(a, (b) => b.topMargin = this.adh);
            this.agc(a, (b) => b.rightMargin = this.adg);
            this.agc(a, (b) => b.bottomMargin = this.add);
            this.agb(a, (b) => b.textStyle = this.afi);
            this.agc(a, (b) => b.textStyle = this.af8);
        }
        xf(a) {
            let b = this.be(a);
            let c = this.dc(a, b);
            if (c == null) {
                return;
            }
            c.itemsSource = this.ia(a);
            if (a.highlightedData != null) {
                c.highlightedItemsSource = this.ib(a);
            }
            c.name = this.q6(a);
            c.title = this.q7(a, b);
            this.dataChart.series.add(c);
        }
        agh(a) {
            this.agi(a, null);
        }
        agi(a, b) {
            a(this.aaw());
        }
        agn(a, b) {
            a(this.aax());
        }
        agm(a) {
            this.agn(a, true);
        }
        vb(a, b) {
            this.agh(a);
            this.agn(a, b);
        }
        agl(a) {
            this.agc(this.aaw(), a);
        }
        agq(a) {
            this.agc(this.aax(), a);
        }
        ago(a) {
            this.agb(this.aax(), a);
        }
        agj(a) {
            this.agb(this.aaw(), a);
        }
        acv(a) {
            let b = this.aaw();
            return b.el(a, new ScalerParams(1, this.zx, this.zw, b.ch));
        }
        acx(a) {
            let b = this.aaw();
            return b.eo(a, new ScalerParams(1, this.zx, this.zw, b.ch));
        }
        acw(a) {
            let b = this.aax();
            return b.el(a, new ScalerParams(1, this.zx, this.zw, b.ch));
        }
        acy(a) {
            let b = this.aax();
            return b.eo(a, new ScalerParams(1, this.zx, this.zw, b.ch));
        }
        xc(a) {
            super.xc(a);
            if (a == null) {
                return;
            }
            if (a.axes != null) {
                let b = this.aaw();
                let c = this.aax();
                if (a.axes.contains(b)) {
                    a.axes.remove(b);
                }
                if (a.axes.contains(c)) {
                    a.axes.remove(c);
                }
            }
        }
        static ae3(a, b) {
            for (let c of fromEnum(b)) {
                let d = c.findMatchingHint(16);
                if (d != null) {
                    let e = d.path;
                    return e;
                }
            }
            return null;
        }
        vn(a, b) {
            super.vn(a, b);
            if (a == this.dataChart) {
                this.dataChart.axes.add(this.aaw());
                this.dataChart.axes.add(this.aax());
            }
        }
        agd(a) {
            if (a != null && this.l8 != null && a.fn == null) {
                a.provideRenderer(this.l8);
            }
            a.jz = this.ahg;
            a.et = this.aci;
            a.j0 = this.ahh;
            a.ew = this.acl;
            a.j2 = this.ahj;
            a.fi = this.acm;
            a.j1 = this.ahi;
            a.fj = this.acn;
            a.j3 = this.ahk;
            a.fk = this.aco;
            a.c4 = true;
            a.cu = this.shouldAvoidAxisAnnotationCollisions;
            a.cw = this.shouldAvoidAxisAnnotationCollisions;
            let b = a == this.aaw();
            if (b) {
                a.g8 = this.aer;
            }
            a.f2 = this.adk;
            a.gi = this.ad1;
            a.ah = this.aas;
            this.agb(a, (c) => c.angle = this.acd);
            this.agb(a, (c) => {
                if (c.extent != this.acc) {
                    c.extent = this.acc;
                }
            });
            this.agb(a, (c) => {
                if (c.maximumExtent != this.acj) {
                    c.maximumExtent = this.acj;
                }
            });
            this.agb(a, (c) => {
                if (c.maximumExtentPercentage != this.ack) {
                    c.maximumExtentPercentage = this.ack;
                }
            });
            this.agb(a, (c) => c.horizontalAlignment = this.agu);
            this.agb(a, (c) => c.verticalAlignment = this.ahw);
            this.agb(a, (c) => c.visibility = this.ah1);
            this.agb(a, (c) => c.location = this.aa2(this.aav));
            this.agc(a, (c) => c.horizontalAlignment = this.agv);
            this.agc(a, (c) => c.angle = this.acp);
            this.age(a);
        }
        agf(a) {
            if (a == null) {
                return;
            }
            if (this.l8 != null && a.fn == null) {
                a.provideRenderer(this.l8);
            }
            a.cu = this.shouldAvoidAxisAnnotationCollisions;
            a.cw = this.shouldAvoidAxisAnnotationCollisions;
            this.agb(a, (b) => b.angle = this.ac0);
            this.agb(a, (b) => {
                if (b.extent != this.acz) {
                    b.extent = this.acz;
                }
            });
            this.agb(a, (b) => {
                if (b.maximumExtent != this.ac6) {
                    b.maximumExtent = this.ac6;
                }
            });
            this.agb(a, (b) => {
                if (b.maximumExtentPercentage != this.ac7) {
                    b.maximumExtentPercentage = this.ac7;
                }
            });
            this.agb(a, (b) => b.horizontalAlignment = this.agw);
            this.agb(a, (b) => b.verticalAlignment = this.ahx);
            this.agb(a, (b) => b.visibility = this.ah2);
            this.agb(a, (b) => b.location = this.aa3(this.aa5));
            this.agc(a, (b) => b.verticalAlignment = this.ahy);
            this.agc(a, (b) => b.angle = this.adc);
            a.jz = this.ahn;
            a.et = this.ac5;
            a.j0 = this.aho;
            a.ew = this.ac8;
            a.j2 = this.ahq;
            a.fi = this.ac9;
            a.j1 = this.ahp;
            a.fj = this.ada;
            a.j3 = this.ahr;
            a.fk = this.adb;
            let b = a == this.aax();
            if (b) {
                a.g8 = this.afz;
            }
            a.gi = this.ae9;
            a.ah = this.aat;
            this.agg(a);
        }
        vk() {
            super.vk();
            this.agd(this.aaw());
            this.agf(this.aax());
        }
        agb(a, b) {
            if (a == null) {
                return;
            }
            if (a.az == null) {
                a.az = new AxisLabelSettings();
                a.az.angle = a.d7();
                a.az.bottomMargin = a.d8();
                a.az.leftMargin = a.d9();
                a.az.rightMargin = a.ea();
                a.az.topMargin = a.eb();
                a.az.horizontalAlignment = a.ju();
                a.az.location = a.a0();
                a.az.verticalAlignment = a.ko();
            }
            b(a.az);
        }
        agc(a, b) {
            if (a == null) {
                return;
            }
            if (a.bf == null) {
                a.bf = new TitleSettings();
                a.bf.bottomMargin = a.ed();
                a.bf.leftMargin = a.ee();
                a.bf.rightMargin = a.ef();
                a.bf.topMargin = a.eg();
                a.bf.location = a.a1();
                a.bf.angle = a.ec();
                a.bf.horizontalAlignment = a.jv();
                a.bf.verticalAlignment = a.kp();
            }
            b(a.bf);
        }
        wj(a, b, c) {
            super.wj(a, b, c);
            switch (a) {
                case "AngleAxisLabelAngle":
                    this.agj((d) => d.angle = this.acd);
                    break;
                case "ValueAxisLabelAngle":
                    this.ago((d) => d.angle = this.ac0);
                    break;
                case "AngleAxisLabelHorizontalAlignment":
                    this.agj((d) => d.horizontalAlignment = this.agu);
                    break;
                case "ValueAxisLabelHorizontalAlignment":
                    this.ago((d) => d.horizontalAlignment = this.agw);
                    break;
                case "AngleAxisLabelVerticalAlignment":
                    this.agj((d) => d.verticalAlignment = this.ahw);
                    break;
                case "ValueAxisLabelVerticalAlignment":
                    this.ago((d) => d.verticalAlignment = this.ahx);
                    break;
                case "AngleAxisLabelVisibility":
                    this.agj((d) => d.visibility = this.ah1);
                    break;
                case "ValueAxisLabelVisibility":
                    this.ago((d) => d.visibility = this.ah2);
                    break;
                case "AngleAxisLabel":
                    this.agh((d) => d.f2 = this.adk);
                    break;
                case "ValueAxisLabel":
                    this.agm((d) => d.f2 = this.adl);
                    break;
                case "AngleAxisLabelFormat":
                    this.agh((d) => d.gi = this.ad1);
                    break;
                case "AngleAxisLabelFormatSpecifiers":
                    this.agh((d) => d.ah = this.aas);
                    break;
                case "ValueAxisLabelFormat":
                    this.agm((d) => d.gi = this.ae9);
                    break;
                case "ValueAxisLabelFormatSpecifiers":
                    this.agm((d) => d.ah = this.aat);
                    break;
                case "AngleAxisTitleAngle":
                    this.agl((d) => d.angle = this.acp);
                    break;
                case "ValueAxisTitleAngle":
                    this.agq((d) => d.angle = this.adc);
                    break;
                case "AngleAxisTitleAlignment":
                    this.agl((d) => d.horizontalAlignment = this.agv);
                    break;
                case "ValueAxisTitleAlignment":
                    this.agq((d) => d.verticalAlignment = this.ahy);
                    break;
                case "AngleAxisTitle":
                    this.agh((d) => d.g8 = this.aer);
                    break;
                case "ValueAxisTitle":
                    this.agn((d) => d.g8 = this.afz, false);
                    break;
                case "AngleAxisMajorStroke":
                    this.agi((d) => d.jz = this.ahg, a);
                    break;
                case "ValueAxisMajorStroke":
                    this.agm((d) => d.jz = this.ahn);
                    break;
                case "AngleAxisMajorStrokeThickness":
                    this.agi((d) => d.et = this.aci, a);
                    break;
                case "ValueAxisMajorStrokeThickness":
                    this.agm((d) => d.et = this.ac5);
                    break;
                case "AngleAxisMinorStroke":
                    this.agh((d) => d.j0 = this.ahh);
                    break;
                case "ValueAxisMinorStroke":
                    this.agm((d) => d.j0 = this.aho);
                    break;
                case "AngleAxisMinorStrokeThickness":
                    this.agh((d) => d.ew = this.acl);
                    break;
                case "ValueAxisMinorStrokeThickness":
                    this.agm((d) => d.ew = this.ac8);
                    break;
                case "AngleAxisTickLength":
                    this.agh((d) => d.fj = this.acn);
                    break;
                case "ValueAxisTickLength":
                    this.agm((d) => d.fj = this.ada);
                    break;
                case "AngleAxisTickStroke":
                    this.agh((d) => d.j3 = this.ahk);
                    break;
                case "ValueAxisTickStroke":
                    this.agm((d) => d.j3 = this.ahr);
                    break;
                case "AngleAxisTickStrokeThickness":
                    this.agh((d) => d.fk = this.aco);
                    break;
                case "ValueAxisTickStrokeThickness":
                    this.agm((d) => d.fk = this.adb);
                    break;
                case "AngleAxisStroke":
                    this.agh((d) => d.j2 = this.ahj);
                    break;
                case "ValueAxisStroke":
                    this.agm((d) => d.j2 = this.ahq);
                    break;
                case "AngleAxisStrokeThickness":
                    this.agh((d) => d.fi = this.acm);
                    break;
                case "ValueAxisStrokeThickness":
                    this.agm((d) => d.fi = this.ac9);
                    break;
                case "AngleAxisExtent":
                    this.agj((d) => d.extent = this.acc);
                    break;
                case "AngleAxisMaximumExtent":
                    this.agj((d) => d.maximumExtent = this.acj);
                    break;
                case "AngleAxisMaximumExtentPercentage":
                    this.agj((d) => d.maximumExtentPercentage = this.ack);
                    break;
                case "ValueAxisExtent":
                    this.ago((d) => d.extent = this.acz);
                    break;
                case "ValueAxisMaximumExtent":
                    this.ago((d) => d.maximumExtent = this.acj);
                    break;
                case "ValueAxisMaximumExtentPercentage":
                    this.ago((d) => d.maximumExtentPercentage = this.ack);
                    break;
                case "AngleAxisStrip":
                    this.agh((d) => d.j1 = this.ahi);
                    break;
                case "ValueAxisStrip":
                    this.agm((d) => d.j1 = this.ahp);
                    break;
                case "AngleAxisInverted":
                    this.agh((d) => d.ch = this.aa8);
                    break;
                case "ValueAxisInverted":
                    this.agm((d) => d.ch = this.aa9);
                    break;
                case "ValueAxisLabelLocation":
                    this.agp();
                    break;
                case "AngleAxisLabelLocation":
                    this.agk();
                    break;
            }
        }
        agp() {
            let a = this.aa3(this.aa5);
            if (a == 2 || a == 7) {
                this.agw = 2;
            }
            else {
                this.agw = 0;
            }
            this.ago((b) => b.location = a);
        }
        agk() {
            let a = this.aa2(this.aav);
            if (a == 1 || a == 5) {
                this.ahw = 0;
            }
            else {
                this.ahw = 2;
            }
            this.agj((b) => b.location = a);
        }
        aa3(a) {
            if (a == 0) {
                return 2;
            }
            else if (a == 1) {
                return 3;
            }
            else if (a == 3) {
                return 7;
            }
            else if (a == 2) {
                return 6;
            }
            else {
                if (this.cb == 1) {
                    return 3;
                }
                else {
                    return 2;
                }
            }
        }
        aa2(a) {
            if (a == 1) {
                return 1;
            }
            else if (a == 0) {
                return 0;
            }
            else if (a == 3) {
                return 5;
            }
            else if (a == 2) {
                return 4;
            }
            else {
                return 1;
            }
        }
        get adk() {
            return this.adi;
        }
        set adk(a) {
            let b = this.adk;
            if (a != b) {
                this.adi = a;
                this.wj("AngleAxisLabel", b, this.adk);
            }
        }
        get adl() {
            return this.adj;
        }
        set adl(a) {
            let b = this.adl;
            if (a != b) {
                this.adj = a;
                this.wj("ValueAxisLabel", b, this.adl);
            }
        }
        get ahg() {
            return this.ag0;
        }
        set ahg(a) {
            let b = this.ahg;
            if (a != b) {
                this.ag0 = a;
                this.wj("AngleAxisMajorStroke", b, this.ahg);
            }
        }
        get ahn() {
            return this.ag7;
        }
        set ahn(a) {
            let b = this.ahn;
            if (a != b) {
                this.ag7 = a;
                this.wj("ValueAxisMajorStroke", b, this.ahn);
            }
        }
        get aci() {
            return this.abg;
        }
        set aci(a) {
            let b = this.aci;
            if (a != b) {
                this.abg = a;
                this.wj("AngleAxisMajorStrokeThickness", b, this.aci);
            }
        }
        get ac5() {
            return this.abz;
        }
        set ac5(a) {
            let b = this.ac5;
            if (a != b) {
                this.abz = a;
                this.wj("ValueAxisMajorStrokeThickness", b, this.ac5);
            }
        }
        get acl() {
            return this.abj;
        }
        set acl(a) {
            let b = this.acl;
            if (a != b) {
                this.abj = a;
                this.wj("AngleAxisMinorStrokeThickness", b, this.acl);
            }
        }
        get ac8() {
            return this.ab2;
        }
        set ac8(a) {
            let b = this.ac8;
            if (a != b) {
                this.ab2 = a;
                this.wj("ValueAxisMinorStrokeThickness", b, this.ac8);
            }
        }
        get ahi() {
            return this.ag2;
        }
        set ahi(a) {
            let b = this.ahi;
            if (a != b) {
                this.ag2 = a;
                this.wj("AngleAxisStrip", b, this.ahi);
            }
        }
        get ahp() {
            return this.ag9;
        }
        set ahp(a) {
            let b = this.ahp;
            if (a != b) {
                this.ag9 = a;
                this.wj("ValueAxisStrip", b, this.ahp);
            }
        }
        get ahj() {
            return this.ag3;
        }
        set ahj(a) {
            let b = this.ahj;
            if (a != b) {
                this.ag3 = a;
                this.wj("AngleAxisStroke", b, this.ahj);
            }
        }
        get ahq() {
            return this.aha;
        }
        set ahq(a) {
            let b = this.ahq;
            if (a != b) {
                this.aha = a;
                this.wj("ValueAxisStroke", b, this.ahq);
            }
        }
        get acm() {
            return this.abk;
        }
        set acm(a) {
            let b = this.acm;
            if (a != b) {
                this.abk = a;
                this.wj("AngleAxisStrokeThickness", b, this.acm);
            }
        }
        get ac9() {
            return this.ab3;
        }
        set ac9(a) {
            let b = this.ac9;
            if (a != b) {
                this.ab3 = a;
                this.wj("ValueAxisStrokeThickness", b, this.ac9);
            }
        }
        get acn() {
            return this.abl;
        }
        set acn(a) {
            let b = this.acn;
            if (a != b) {
                this.abl = a;
                this.wj("AngleAxisTickLength", b, this.acn);
            }
        }
        get ada() {
            return this.ab4;
        }
        set ada(a) {
            let b = this.ada;
            if (a != b) {
                this.ab4 = a;
                this.wj("ValueAxisTickLength", b, this.ada);
            }
        }
        get ahk() {
            return this.ag4;
        }
        set ahk(a) {
            let b = this.ahk;
            if (a != b) {
                this.ag4 = a;
                this.wj("AngleAxisTickStroke", b, this.ahk);
            }
        }
        get ahr() {
            return this.ahb;
        }
        set ahr(a) {
            let b = this.ahr;
            if (a != b) {
                this.ahb = a;
                this.wj("ValueAxisTickStroke", b, this.ahr);
            }
        }
        get aco() {
            return this.abm;
        }
        set aco(a) {
            let b = this.aco;
            if (a != b) {
                this.abm = a;
                this.wj("AngleAxisTickStrokeThickness", b, this.aco);
            }
        }
        get adb() {
            return this.ab5;
        }
        set adb(a) {
            let b = this.adb;
            if (a != b) {
                this.ab5 = a;
                this.wj("ValueAxisTickStrokeThickness", b, this.adb);
            }
        }
        get aer() {
            return this.ado;
        }
        set aer(a) {
            let b = this.aer;
            if (a != b) {
                this.ado = a;
                this.wj("AngleAxisTitle", b, this.aer);
            }
        }
        get afz() {
            return this.ads;
        }
        set afz(a) {
            let b = this.afz;
            if (a != b) {
                this.ads = a;
                this.wj("ValueAxisTitle", b, this.afz);
            }
        }
        get ahh() {
            return this.ag1;
        }
        set ahh(a) {
            let b = this.ahh;
            if (a != b) {
                this.ag1 = a;
                this.wj("AngleAxisMinorStroke", b, this.ahh);
            }
        }
        get aho() {
            return this.ag8;
        }
        set aho(a) {
            let b = this.aho;
            if (a != b) {
                this.ag8 = a;
                this.wj("ValueAxisMinorStroke", b, this.aho);
            }
        }
        get acd() {
            return this.abb;
        }
        set acd(a) {
            let b = this.acd;
            if (a != b) {
                this.abb = a;
                this.wj("AngleAxisLabelAngle", b, this.acd);
            }
        }
        get ac0() {
            return this.abu;
        }
        set ac0(a) {
            let b = this.ac0;
            if (a != b) {
                this.abu = a;
                this.wj("ValueAxisLabelAngle", b, this.ac0);
            }
        }
        get acc() {
            return this.aba;
        }
        set acc(a) {
            let b = this.acc;
            if (a != b) {
                this.aba = a;
                this.wj("AngleAxisExtent", b, this.acc);
            }
        }
        get acj() {
            return this.abh;
        }
        set acj(a) {
            let b = this.acj;
            if (a != b) {
                this.abh = a;
                this.wj("AngleAxisMaximumExtent", b, this.acj);
            }
        }
        get ack() {
            return this.abi;
        }
        set ack(a) {
            let b = this.ack;
            if (a != b) {
                this.abi = a;
                this.wj("AngleAxisMaximumExtentPercentage", b, this.ack);
            }
        }
        get acz() {
            return this.abt;
        }
        set acz(a) {
            let b = this.acz;
            if (a != b) {
                this.abt = a;
                this.wj("ValueAxisExtent", b, this.acz);
            }
        }
        get ac6() {
            return this.ab0;
        }
        set ac6(a) {
            let b = this.ac6;
            if (a != b) {
                this.ab0 = a;
                this.wj("ValueAxisMaximumExtent", b, this.ac6);
            }
        }
        get ac7() {
            return this.ab1;
        }
        set ac7(a) {
            let b = this.ac7;
            if (a != b) {
                this.ab1 = a;
                this.wj("ValueAxisMaximumExtentPercentage", b, this.ac7);
            }
        }
        get acp() {
            return this.abn;
        }
        set acp(a) {
            let b = this.acp;
            if (a != b) {
                this.abn = a;
                this.wj("AngleAxisTitleAngle", b, this.acp);
            }
        }
        get adc() {
            return this.ab6;
        }
        set adc(a) {
            let b = this.adc;
            if (a != b) {
                this.ab6 = a;
                this.wj("ValueAxisTitleAngle", b, this.adc);
            }
        }
        get aa8() {
            return this.aa6;
        }
        set aa8(a) {
            let b = this.aa8;
            if (a != b) {
                this.aa6 = a;
                this.wj("AngleAxisInverted", b, this.aa8);
            }
        }
        get aa9() {
            return this.aa7;
        }
        set aa9(a) {
            let b = this.aa9;
            if (a != b) {
                this.aa7 = a;
                this.wj("ValueAxisInverted", b, this.aa9);
            }
        }
        get agv() {
            return this.ags;
        }
        set agv(a) {
            let b = this.agv;
            if (a != b) {
                this.ags = a;
                this.wj("AngleAxisTitleAlignment", enumGetBox(HorizontalAlignment_$type, b), enumGetBox(HorizontalAlignment_$type, this.agv));
            }
        }
        get ahy() {
            return this.ahv;
        }
        set ahy(a) {
            let b = this.ahy;
            if (a != b) {
                this.ahv = a;
                this.wj("ValueAxisTitleAlignment", enumGetBox(VerticalAlignment_$type, b), enumGetBox(VerticalAlignment_$type, this.ahy));
            }
        }
        get agu() {
            return this.agr;
        }
        set agu(a) {
            let b = this.agu;
            if (a != b) {
                this.agr = a;
                this.wj("AngleAxisLabelHorizontalAlignment", enumGetBox(HorizontalAlignment_$type, b), enumGetBox(HorizontalAlignment_$type, this.agu));
            }
        }
        get_agw() {
            return this.agt;
        }
        set_agw(a) {
            let b = this.agw;
            if (a != b) {
                this.agt = a;
                this.wj("ValueAxisLabelHorizontalAlignment", enumGetBox(HorizontalAlignment_$type, b), enumGetBox(HorizontalAlignment_$type, this.agw));
            }
        }
        get agw() {
            return this.get_agw();
        }
        set agw(a) {
            this.set_agw(a);
        }
        get ahw() {
            return this.aht;
        }
        set ahw(a) {
            let b = this.ahw;
            if (a != b) {
                this.aht = a;
                this.wj("AngleAxisLabelVerticalAlignment", enumGetBox(VerticalAlignment_$type, b), enumGetBox(VerticalAlignment_$type, this.ahw));
            }
        }
        get ahx() {
            return this.ahu;
        }
        set ahx(a) {
            let b = this.ahx;
            if (a != b) {
                this.ahu = a;
                this.wj("ValueAxisLabelVerticalAlignment", enumGetBox(VerticalAlignment_$type, b), enumGetBox(VerticalAlignment_$type, this.ahx));
            }
        }
        get ah1() {
            return this.ahz;
        }
        set ah1(a) {
            let b = this.ah1;
            if (a != b) {
                this.ahz = a;
                this.wj("AngleAxisLabelVisibility", enumGetBox(Visibility_$type, b), enumGetBox(Visibility_$type, this.ah1));
            }
        }
        get ah2() {
            return this.ah0;
        }
        set ah2(a) {
            let b = this.ah2;
            if (a != b) {
                this.ah0 = a;
                this.wj("ValueAxisLabelVisibility", enumGetBox(Visibility_$type, b), enumGetBox(Visibility_$type, this.ah2));
            }
        }
        get_aa5() {
            return this.aa4;
        }
        set_aa5(a) {
            let b = this.aa5;
            if (a != b) {
                this.aa4 = a;
                this.wj("ValueAxisLabelLocation", enumGetBox(ValueAxisLabelLocation_$type, b), enumGetBox(ValueAxisLabelLocation_$type, this.aa5));
            }
        }
        get aa5() {
            return this.get_aa5();
        }
        set aa5(a) {
            this.set_aa5(a);
        }
        get_aav() {
            return this.aau;
        }
        set_aav(a) {
            let b = this.aav;
            if (a != b) {
                this.aau = a;
                this.wj("AngleAxisLabelLocation", enumGetBox(AngleAxisLabelLocation_$type, b), enumGetBox(AngleAxisLabelLocation_$type, this.aav));
            }
        }
        get aav() {
            return this.get_aav();
        }
        set aav(a) {
            this.set_aav(a);
        }
        get ad1() {
            return this.adm;
        }
        set ad1(a) {
            let b = this.adm;
            if (a != b) {
                this.adm = a;
                this.wj("AngleAxisLabelFormat", b, this.adm);
            }
        }
        get aas() {
            return this.aaq;
        }
        set aas(a) {
            let b = this.aaq;
            if (a != b) {
                this.aaq = a;
                this.wj("AngleAxisLabelFormatSpecifiers", b, this.aaq);
            }
        }
        get ae9() {
            return this.adq;
        }
        set ae9(a) {
            let b = this.adq;
            if (a != b) {
                this.adq = a;
                this.wj("ValueAxisLabelFormat", b, this.adq);
            }
        }
        get aat() {
            return this.aar;
        }
        set aat(a) {
            let b = this.aar;
            if (a != b) {
                this.aar = a;
                this.wj("ValueAxisLabelFormatSpecifiers", b, this.aar);
            }
        }
    }
    RadialBaseChart.$t = /*@__PURE__*/ markType(RadialBaseChart, 'RadialBaseChart', DomainChart.$);
    return RadialBaseChart;
})();
