/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends, __read, __spreadArray, __values } from "tslib";
import { Brush } from "igniteui-react-core";
import { XYChart } from "./XYChart";
import { IndicatorPane } from "./IndicatorPane";
import { Base, BaseError, EventArgs, runOn, delegateRemove, delegateCombine, fromEnum, typeCast, EnumUtil, Number_$type, String_$type, enumGetBox, markType, TypeRegistrar, fromEn } from "igniteui-react-core";
import { List$1 } from "igniteui-react-core";
import { DataSeriesType_$type } from "igniteui-react-core";
import { IDataSeriesAdapterRule_$type } from "igniteui-react-core";
import { SimpleFinancialPriceSeriesRule } from "igniteui-react-core";
import { SubCollectionsRule } from "igniteui-react-core";
import { XamDataChart } from "./XamDataChart";
import { FinancialChartVolumeType_$type } from "./FinancialChartVolumeType";
import { FinancialChartXAxisMode_$type } from "./FinancialChartXAxisMode";
import { FinancialChartYAxisMode_$type } from "./FinancialChartYAxisMode";
import { FinancialChartType_$type } from "./FinancialChartType";
import { NumericYAxis } from "./NumericYAxis";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { FinancialChartZoomSliderType_$type } from "./FinancialChartZoomSliderType";
import { BrushCollection } from "igniteui-react-core";
import { FinancialChartRangeSelectorOptionCollection } from "./FinancialChartRangeSelectorOptionCollection";
import { ObservableCollection$1 } from "igniteui-react-core";
import { TemplatedHtmlControl } from "./TemplatedHtmlControl";
import { FinancialChartContext } from "./FinancialChartContext";
import { FinancialChartToolbarContext } from "./FinancialChartToolbarContext";
import { FinancialChartViewModel } from "./FinancialChartViewModel";
import { FinancialChartToolbarViewModel } from "./FinancialChartToolbarViewModel";
import { AxisDefaults } from "./AxisDefaults";
import { Defaults } from "./Defaults";
import { BrushUtil } from "igniteui-react-core";
import { Series } from "./Series";
import { Rect } from "igniteui-react-core";
import { Axis } from "./Axis";
import { AxisLabelSettings } from "./AxisLabelSettings";
import { MarkerSeries } from "./MarkerSeries";
import { IZoomableCategoryAxis_$type } from "./IZoomableCategoryAxis";
import { SyncSettings } from "./SyncSettings";
import { SyncManager } from "./SyncManager";
import { FinancialOverlayType_$type } from "./FinancialOverlayType";
import { ArrayExtension } from "igniteui-react-core";
import { FinancialIndicatorType_$type } from "./FinancialIndicatorType";
import { IndicatorDisplayType_$type } from "./IndicatorDisplayType";
import { ITimeRangeSelectorAxis_$type } from "./ITimeRangeSelectorAxis";
import { FinancialChartVisualData } from "./FinancialChartVisualData";
import { FinancialChartCustomIndicatorArgs } from "./FinancialChartCustomIndicatorArgs";
import { ScalerParams } from "./ScalerParams";
import { stringReplace, stringJoin, stringIsNullOrEmpty } from "igniteui-react-core";
import { timeSpanFromDays } from "igniteui-react-core";
import { dateMaxValue, dateMinValue } from "igniteui-react-core";
import { isNaN_, isInfinity } from "igniteui-react-core";
import { FinancialChartTypePicker } from "./FinancialChartTypePicker";
import { FinancialChartIndicatorMenu } from "./FinancialChartIndicatorMenu";
import { TrendLineType_$type } from "igniteui-react-core";
import { FinancialChartIndicatorMenuContext } from "./FinancialChartIndicatorMenuContext";
import { FinancialChartTypePickerContext } from "./FinancialChartTypePickerContext";
import { FinancialChartRangeSelectorContext } from "./FinancialChartRangeSelectorContext";
import { FinancialChartToolbarVisualData } from "./FinancialChartToolbarVisualData";
import { FinancialChartRangeSelectorViewModel } from "./FinancialChartRangeSelectorViewModel";
import { FinancialChartRangeSelectorView } from "./FinancialChartRangeSelectorView";
/**
 * @hidden
 */
var FinancialChart = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(FinancialChart, _super);
    function FinancialChart() {
        var _this = _super.call(this) || this;
        _this.ajv = null;
        _this.amt = null;
        _this.amr = null;
        _this.amo = null;
        _this.amq = null;
        _this.ams = null;
        _this.amp = null;
        _this.ai1 = null;
        _this.anb = null;
        _this.anc = null;
        _this.am8 = null;
        _this.and = null;
        _this.ane = null;
        _this.am9 = null;
        _this.ana = null;
        _this.akj = null;
        _this.alt = 40;
        _this.ajp = null;
        _this.ajn = null;
        _this.ajr = null;
        _this.ajw = null;
        _this.anm = null;
        _this.akf = null;
        _this.ak5 = false;
        _this.ak4 = false;
        _this.alc = false;
        _this.akr = false;
        _this.amz = 10;
        _this.al0 = NaN;
        _this.al2 = NaN;
        _this.al1 = NaN;
        _this.al3 = 0;
        _this.ai7 = 0;
        _this.aja = 0;
        _this.alv = 3;
        _this.aly = NaN;
        _this.alw = NaN;
        _this.alx = NaN;
        _this.alz = NaN;
        _this.ajc = 0;
        _this.akm = true;
        _this.ai3 = 0;
        _this.akn = false;
        _this.ajh = null;
        _this.ajj = null;
        _this.ale = null;
        _this.akp = true;
        _this.ako = false;
        _this.akq = false;
        _this.akg = null;
        _this.aje = 1;
        _this.ah5 = null;
        _this.ah6 = null;
        _this.ah7 = null;
        _this.ah8 = null;
        _this.aia = null;
        _this.ah9 = null;
        _this.ah4 = null;
        _this.ah3 = null;
        _this.alu = 1;
        _this.als = 1;
        _this.alr = 2;
        _this.alq = 1;
        _this.ajt = null;
        _this.amv = -2147483648;
        _this.alp = 2;
        _this.amy = 3;
        _this.amw = 10;
        _this.amu = 30;
        _this.amx = 9;
        _this.aiy = null;
        _this.aiz = null;
        _this.aiu = null;
        _this.applyCustomIndicators = null;
        _this.arg = null;
        _this.al4 = 1;
        _this.akl = false;
        _this.ajl = null;
        _this.alm = dateMinValue();
        _this.all = dateMaxValue();
        _this.alj = null;
        _this.u8();
        _this.alj = new ObservableCollection$1(Base.$, 0);
        if (_this.xAxisBreaks != null) {
            var a = _this.xAxisBreaks;
            a.collectionChanged = delegateCombine(a.collectionChanged, function (a, b) { return _this.aq5(); });
        }
        _this.aqq();
        return _this;
    }
    FinancialChart.prototype.wo = function (a, b, c) {
        _super.prototype.wo.call(this, a, b, c);
        switch (a) {
            case "ToolbarTemplate":
            case "RangeSelectorTemplate":
                this.ai2 = new FinancialChartToolbar(this, this.anj);
                break;
            case "Toolbar":
                var d = b;
                if (d != null) {
                    d.chartTypeChanged = delegateRemove(d.chartTypeChanged, runOn(this, this.aqd));
                    d.trendLineTypeChanged = delegateRemove(d.trendLineTypeChanged, runOn(this, this.aqg));
                    d.volumeTypeChanged = delegateRemove(d.volumeTypeChanged, runOn(this, this.aqh));
                    d.l(null);
                }
                if (this.ai2 != null) {
                    this.ai2.ac = this.ai9;
                    this.ai2.ai = this.ec;
                    this.ai2.y = this.ai4;
                    this.ai2.al = this.ak2;
                    if (this.amq != null) {
                        this.ai2.l(this.amq);
                    }
                    var e = this.ai2;
                    e.chartTypeChanged = delegateCombine(e.chartTypeChanged, runOn(this, this.aqd));
                    ;
                    var f = this.ai2;
                    f.trendLineTypeChanged = delegateCombine(f.trendLineTypeChanged, runOn(this, this.aqg));
                    var g = this.ai2;
                    g.volumeTypeChanged = delegateCombine(g.volumeTypeChanged, runOn(this, this.aqh));
                }
                break;
            case "ChartType":
                if (this.ai2 != null) {
                    this.ai2.y = this.ai4;
                }
                break;
            case "VolumeType":
                if (this.ai2 != null) {
                    this.ai2.ac = this.ai9;
                }
                break;
            case "TrendLineType":
                if (this.ai2 != null) {
                    this.ai2.ai = this.ec;
                }
                break;
            case "IsToolbarVisible":
                if (this.ai2 == null) {
                    break;
                }
                this.ai2.al = this.ak2;
                this.setGridRows();
                break;
        }
    };
    FinancialChart.prototype.aqh = function (a, b) {
        this.ai9 = this.ai2.ac;
    };
    FinancialChart.prototype.aqg = function (a, b) {
        this.ec = this.ai2.ai;
    };
    FinancialChart.prototype.aqd = function (a, b) {
        this.ai4 = this.ai2.y;
    };
    FinancialChart.prototype.aqq = function () {
        this.ajv = new IndicatorPane();
        this.ajm = TypeRegistrar.create("FinancialLegend");
    };
    FinancialChart.prototype.provideGrid = function (a) {
        this.amt = a;
        this.arb();
        this.setGridRows();
        if (this.ai2 != null) {
            this.ai2.bg(a);
        }
    };
    FinancialChart.prototype.onDocumentClick = function (a) {
        if (this.ai2 != null) {
            this.ai2.bl(a);
        }
    };
    FinancialChart.prototype.getContext = function () {
        var a = this.ai2.v();
        var b = new FinancialChartContext();
        b.vm = new FinancialChartViewModel();
        b.vm.toolbar = a;
        b.container = this.l8;
        b.toolbarContainer = this.amq;
        b.legendContainer = this.amp;
        b.indicatorsContainer = this.amo;
        b.volumeContainer = this.amr;
        b.zoomContainer = this.ams;
        return b;
    };
    FinancialChart.prototype.provideContainer = function (a) {
        var b = a;
        if (b != null) {
            var c = "financialChartMainGrid";
            var d = b.createElement("div");
            d.setStyleProperty("width", "100%");
            d.setStyleProperty("height", "100%");
            if (this.ai2 == null) {
                this.ai2 = new FinancialChartToolbar(this, this.anj);
            }
            this.ai2.w.isIndicatorMenuVisible = this.akt && this.aku;
            this.amq = b.getSubRenderer(d);
            this.ai2.l(this.amq);
            var e = b.createElement("div");
            e.setStyleProperty("width", "100%");
            e.setStyleProperty("height", "100%");
            var f = b.createElement("div");
            f.setStyleProperty("width", "100%");
            f.setStyleProperty("height", "100%");
            this.amp = b.getSubRenderer(f);
            var g = b.createElement("div");
            g.setStyleProperty("width", "100%");
            g.setStyleProperty("height", "100%");
            this.amo = b.getSubRenderer(g);
            var h = b.createElement("div");
            h.setStyleProperty("width", "100%");
            h.setStyleProperty("height", "100%");
            this.amr = b.getSubRenderer(h);
            var i = b.createElement("div");
            i.setStyleProperty("width", "100%");
            i.setStyleProperty("height", "100%");
            this.ams = b.getSubRenderer(i);
            a = b.getSubRenderer(e);
        }
        else {
            this.amq = null;
            if (this.ai2 != null) {
                this.ai2.l(null);
            }
            if (this.akk != null) {
                this.akk.provideContainer(null);
                this.akk = null;
            }
            if (this.ajm != null) {
                this.ajm.provideContainer(null);
            }
        }
        _super.prototype.provideContainer.call(this, a);
        if (b != null) {
            if (this.volumeChart != null) {
                this.volumeChart.dc.b4(this.amr);
            }
            if (this.ajv != null) {
                this.ajv.h(this.amo);
            }
            if (this.zoomSliderChart != null) {
                this.zoomSliderChart.dc.b4(this.ams);
                if (a != null) {
                    this.apx();
                }
                else {
                    this.akk = null;
                }
            }
            if (this.ajm != null) {
                this.ajm.provideContainer(this.amp);
            }
            this.setGridRows();
        }
    };
    FinancialChart.prototype.aq1 = function (a, b, c) {
        if (a != null) {
            a.provideContainer(null);
        }
        if (b != null) {
            b.dc.b4(c);
        }
        this.setGridRows();
    };
    FinancialChart.prototype.arf = function (a, b) {
        this.aq1(a, b, this.ams);
        if (b == null) {
            return;
        }
        this.apx();
    };
    FinancialChart.prototype.apx = function () {
        var _this = this;
        if (this.ams == null) {
            return;
        }
        if (this.akk != null) {
            this.akk.provideContainer(null);
        }
        this.akk = TypeRegistrar.create("ZoomSlider");
        this.akk.provideContainer(this.ams);
        var a = this.akk;
        a.windowRectChanged = delegateCombine(a.windowRectChanged, function (a, b) {
            if (_this.dataChart != null) {
                _this.dataChart.xc = new Rect(0, _this.akk.windowRect.left, _this.dataChart.wt.top, _this.akk.windowRect.width, _this.dataChart.wt.height);
            }
        });
        this.apy();
    };
    FinancialChart.prototype.ard = function (a, b) {
        this.aq1(a, b, this.amr);
    };
    FinancialChart.prototype.setGridRows = function () {
        if (this.amt == null) {
            return;
        }
        var a = new Array(6);
        a[0] = (this.ak2 ? this.ama : 0) + "px";
        a[1] = this.aky ? "min-content" : "0px";
        a[2] = "auto";
        a[3] = this.indicatorCharts == null || this.indicatorCharts.count == 0 ? "0px" : this.indicatorCharts.count * 150 + "px";
        a[4] = this.volumeChart == null ? "0px" : "100px";
        a[5] = this.zoomSliderChart == null ? "0px" : "100px";
        if (this.akk != null) {
            if (a[5] == "0px") {
                this.akk.hide();
            }
            else {
                this.akk.show();
            }
        }
        this.amt.setStyleProperty("-ms-grid-rows", stringReplace(stringJoin.apply(void 0, __spreadArray([" "], __read(a), false)), "auto", "1fr"));
        this.amt.setStyleProperty("grid-template-rows", stringJoin.apply(void 0, __spreadArray([" "], __read(a), false)));
        if (this.l8 == null) {
            return;
        }
        if (this.dataChart != null) {
            this.dataChart.notifyContainerResized();
        }
        if (this.ajv != null) {
            this.ajv.f();
        }
        if (this.volumeChart != null) {
            this.volumeChart.notifyContainerResized();
        }
        if (this.zoomSliderChart != null) {
            this.zoomSliderChart.notifyContainerResized();
        }
        if (this.akk != null) {
            this.akk.notifySizeChanged();
        }
    };
    FinancialChart.prototype.vs = function () {
        var e_1, _a;
        _super.prototype.vs.call(this);
        this.aa5 = 1;
        this.agw = 0;
        this.ada = 0;
        this.ahq = null;
        this.ahj = AxisDefaults.axis_LineBrush;
        this.acs = AxisDefaults.axis_TickStroke;
        this.acr = AxisDefaults.categoryAxis_TickLength;
        this.ahk = AxisDefaults.axis_TickBrush;
        this.ahg = null;
        this.arh = AxisDefaults.axis_MajorBrush;
        this.amn = AxisDefaults.axis_MajorStroke;
        this.finalValueAnnotationsVisible = true;
        this.crosshairsAnnotationEnabled = true;
        this.gu = false;
        this.crosshairsDisplayMode = 0;
        this.ju = Defaults.crosshairLineThickness;
        this.y4 = Defaults.crosshairLineBrush;
        this.yz = Defaults.crosshairXAxisAnnotationBackground;
        this.y0 = Defaults.crosshairXAxisAnnotationTextColor;
        this.ke = NaN;
        this.j6 = 40;
        this.ha = true;
        this.hi = false;
        if (this.dataChart != null) {
            var a = this.dataChart.dc.j.e();
            this.aid = a.d;
            this.aie = a.e;
            this.aic = a.d;
            this.arh = this.dataChart.abh;
        }
        var b = new BrushCollection();
        b.add(((function () {
            var $ret = new Brush();
            $ret.fill = "#8BDC5C";
            return $ret;
        })()));
        b.add(((function () {
            var $ret = new Brush();
            $ret.fill = "#8961A9";
            return $ret;
        })()));
        b.add(((function () {
            var $ret = new Brush();
            $ret.fill = "#6DB1FF";
            return $ret;
        })()));
        b.add(((function () {
            var $ret = new Brush();
            $ret.fill = "#82E9D9";
            return $ret;
        })()));
        b.add(((function () {
            var $ret = new Brush();
            $ret.fill = "#EA3C63";
            return $ret;
        })()));
        b.add(((function () {
            var $ret = new Brush();
            $ret.fill = "#735656";
            return $ret;
        })()));
        b.add(((function () {
            var $ret = new Brush();
            $ret.fill = "#F8CE4F";
            return $ret;
        })()));
        b.add(((function () {
            var $ret = new Brush();
            $ret.fill = "#A8A8B7";
            return $ret;
        })()));
        b.add(((function () {
            var $ret = new Brush();
            $ret.fill = "#E051A9";
            return $ret;
        })()));
        b.add(((function () {
            var $ret = new Brush();
            $ret.fill = "#FF903B";
            return $ret;
        })()));
        var c = new BrushCollection();
        try {
            for (var _b = __values(fromEnum(b)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var d = _c.value;
                c.add(BrushUtil.p(d, 0.3));
            }
        }
        catch (e_1_1) {
            e_1 = { error: e_1_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_1)
                    throw e_1.error;
            }
        }
        this.aif = c;
        this.aig = b;
    };
    FinancialChart.prototype.aqx = function () {
        if (this.ajv != null) {
            this.ajv.b = null;
            this.ajv.b = this.indicatorCharts;
        }
        this.setGridRows();
    };
    FinancialChart.prototype.aqy = function () {
        this.setGridRows();
    };
    FinancialChart.prototype.aq7 = function () {
        this.aqx();
    };
    FinancialChart.prototype.apw = function () {
        if (this.akk == null || this.zoomSliderChart == null || this.dataChart == null || this.dataChart.series.count == 0) {
            return;
        }
        var a = this.l8.rootWrapper.width();
        var b = this.dataChart.xb.left + this.dataChart.xb.width;
        var c = this.dataChart.xb.left;
        var d = a - b;
        this.akk.startInset = c - this.akk.trackStartInset;
        this.akk.endInset = d - this.akk.trackEndInset;
        if (this.akk.endInset < 0) {
            var e = this.akk.endInset;
            this.akk.endInset = 0;
            this.dataChart.ih += (e * -1);
        }
        if (this.akk.startInset < 0) {
            var f = this.akk.startInset;
            this.akk.startInset = 0;
            this.dataChart.ib += (f * -1);
        }
        this.zoomSliderChart.ib = c;
        this.zoomSliderChart.ih = d;
        this.zoomSliderChart.hw = this.akk.barExtent;
    };
    FinancialChart.prototype.aqn = function () {
        this.apw();
    };
    FinancialChart.prototype.vp = function (a) {
        _super.prototype.vp.call(this, a);
        if (a != null) {
            a.hv = 0;
        }
    };
    FinancialChart.prototype.ari = function (a) {
        return a.wm();
    };
    FinancialChart.prototype.arl = function () {
        return this.amp == null ? null : this.ark(this.amp.rootWrapper);
    };
    FinancialChart.prototype.arj = function (a) {
        if (a == null || a.d == null) {
            return null;
        }
        return this.ark(a.d.rootWrapper);
    };
    FinancialChart.prototype.ark = function (a) {
        if (a == null) {
            return null;
        }
        var b = a.getOffset();
        return new Rect(0, b.left, b.top, a.width(), a.height());
    };
    FinancialChart.prototype.al5 = function () {
        if (this.amt == null) {
            return NaN;
        }
        var a = this.amt.getOffset();
        return this.amt.width() + (a == null ? 0 : a.left);
    };
    FinancialChart.prototype.v1 = function (source_, a, b) {
        _super.prototype.v1.call(this, source_, a, b);
        if (this.zoomSliderChart != null) {
            this.zoomSliderChart.ow(source_, a, b);
        }
    };
    FinancialChart.prototype.v2 = function (source_, a, b) {
        _super.prototype.v2.call(this, source_, a, b);
        if (this.zoomSliderChart != null) {
            this.zoomSliderChart.ox(source_, a, b);
        }
    };
    FinancialChart.prototype.v0 = function (source_) {
        _super.prototype.v0.call(this, source_);
        if (this.zoomSliderChart != null) {
            this.zoomSliderChart.op(source_);
        }
    };
    FinancialChart.prototype.v4 = function (source_, a, b, c) {
        _super.prototype.v4.call(this, source_, a, b, c);
        if (this.zoomSliderChart != null) {
            this.zoomSliderChart.oy(source_, a, b, c);
        }
    };
    FinancialChart.prototype.vv = function (a, b) {
        _super.prototype.vv.call(this, a, b);
        if (this.akz(a)) {
            a.toolTip = null;
        }
    };
    Object.defineProperty(FinancialChart.prototype, "ai2", {
        get: function () {
            return this.ai1;
        },
        set: function (a) {
            var b = this.ai2;
            if (a != b) {
                this.ai1 = a;
                this.wj("Toolbar", b, this.ai2);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ani", {
        get: function () {
            return this.anb;
        },
        set: function (a) {
            var b = this.ani;
            if (a != b) {
                this.anb = a;
                this.wj("RangeSelectorTemplate", b, this.ani);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "anj", {
        get: function () {
            return this.anc;
        },
        set: function (a) {
            var b = this.anj;
            if (a != b) {
                this.anc = a;
                this.wj("ToolbarTemplate", b, this.anj);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "anf", {
        get: function () {
            return this.am8;
        },
        set: function (a) {
            var b = this.anf;
            if (a != b) {
                this.am8 = a;
                this.wj("ChartTypePickerTemplate", b, this.anf);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ank", {
        get: function () {
            return this.and;
        },
        set: function (a) {
            var b = this.ank;
            if (a != b) {
                this.and = a;
                this.wj("TrendLineTypePickerTemplate", b, this.ank);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "anl", {
        get: function () {
            return this.ane;
        },
        set: function (a) {
            var b = this.anl;
            if (a != b) {
                this.ane = a;
                this.wj("VolumeTypePickerTemplate", b, this.anl);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ang", {
        get: function () {
            return this.am9;
        },
        set: function (a) {
            var b = this.ang;
            if (a != b) {
                this.am9 = a;
                this.wj("IndicatorMenuTemplate", b, this.ang);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "anh", {
        get: function () {
            return this.ana;
        },
        set: function (a) {
            var b = this.anh;
            if (a != b) {
                this.ana = a;
                this.wj("OverlayPickerTemplate", b, this.anh);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "akk", {
        get: function () {
            return this.akj;
        },
        set: function (a) {
            var b = this.akk;
            if (a != b) {
                this.akj = a;
                this.wj("ZoomSlider", b, this.akk);
            }
        },
        enumerable: false,
        configurable: true
    });
    FinancialChart.prototype.get_j6 = function () {
        return _super.prototype.get_j6.call(this);
    };
    FinancialChart.prototype.set_j6 = function (a) {
        _super.prototype.set_j6.call(this, a);
    };
    FinancialChart.prototype.get_ha = function () {
        return _super.prototype.get_ha.call(this);
    };
    FinancialChart.prototype.set_ha = function (a) {
        _super.prototype.set_ha.call(this, a);
    };
    Object.defineProperty(FinancialChart.prototype, "ama", {
        get: function () {
            return this.alt;
        },
        set: function (a) {
            var b = this.ama;
            if (a != b) {
                this.alt = a;
                this.wj("ToolbarHeight", b, this.ama);
            }
        },
        enumerable: false,
        configurable: true
    });
    FinancialChart.prototype.aau = function () {
        return this.xAxis;
    };
    FinancialChart.prototype.aav = function () {
        return this.yAxis;
    };
    FinancialChart.prototype.onAttachedToUI = function () {
        _super.prototype.onAttachedToUI.call(this);
        if (this.akk != null) {
            this.akk.onAttachedToUI();
        }
    };
    FinancialChart.prototype.onDetachedFromUI = function () {
        _super.prototype.onDetachedFromUI.call(this);
        if (this.akk != null) {
            this.akk.onDetachedFromUI();
        }
    };
    FinancialChart.prototype.be = function (a) {
        return 20;
    };
    FinancialChart.prototype.get_h6 = function () {
        return ((function () {
            var $ret = new List$1(DataSeriesType_$type, 0);
            $ret.add(20);
            return $ret;
        })());
    };
    Object.defineProperty(FinancialChart.prototype, "h6", {
        get: function () {
            return this.get_h6();
        },
        enumerable: false,
        configurable: true
    });
    FinancialChart.prototype.get_h5 = function () {
        return ((function () {
            var $ret = new List$1(IDataSeriesAdapterRule_$type, 0);
            $ret.add(new SimpleFinancialPriceSeriesRule());
            $ret.add(new SubCollectionsRule());
            return $ret;
        })());
    };
    Object.defineProperty(FinancialChart.prototype, "h5", {
        get: function () {
            return this.get_h5();
        },
        enumerable: false,
        configurable: true
    });
    FinancialChart.prototype.aio = function (a) {
        return this.aip(a);
    };
    FinancialChart.prototype.aj2 = function (a) {
        return this.aj3(a);
    };
    FinancialChart.prototype.ain = function (a) {
        var b = this.aio(0);
        b.name = a;
        return b;
    };
    FinancialChart.prototype.u3 = function () {
        this.xAxis = this.ain("xAxis");
        this.yAxis = this.aj2(0);
        this.yAxis.name = "yAxis";
        this.volumeAxis = this.aj2(0);
        this.volumeAxis.name = "volumeAxis";
        this.volumeXAxis = this.ain("volumeXAxis");
        this.alg = new List$1(NumericYAxis.$, 0);
        this.ali = new List$1(CategoryAxisBase.$, 0);
        this.indicatorAxis = this.aj2(0);
        this.indicatorAxis.name = "indicatorAxis";
        this.indicatorXAxis = this.ain("indicatorXAxis_0");
        this.alg.add(this.indicatorAxis);
        this.ali.add(this.indicatorXAxis);
        if (this.xAxis.az == null) {
            this.xAxis.az = new AxisLabelSettings();
        }
        if (this.yAxis.az == null) {
            this.yAxis.az = new AxisLabelSettings();
        }
        if (this.volumeAxis.az == null) {
            this.volumeAxis.az = new AxisLabelSettings();
        }
        if (this.volumeXAxis.az == null) {
            this.volumeAxis.az = new AxisLabelSettings();
        }
        if (this.indicatorAxis.az == null) {
            this.indicatorAxis.az = new AxisLabelSettings();
        }
        if (this.indicatorXAxis.az == null) {
            this.indicatorXAxis.az = new AxisLabelSettings();
        }
        this.zoomSliderAxis = this.aj2(0);
        this.zoomSliderAxis.name = "zoomSliderAxis";
        this.zoomSliderXAxis = this.ain("zoomSliderXAxis");
        if (this.zoomSliderAxis.az == null) {
            this.zoomSliderAxis.az = new AxisLabelSettings();
        }
        if (this.zoomSliderXAxis.az == null) {
            this.zoomSliderXAxis.az = new AxisLabelSettings();
        }
    };
    FinancialChart.prototype.ux = function (a, b) {
        var c = typeCast(MarkerSeries.$, a);
        if (c != null) {
            c.xf = this.c2(a, b);
        }
    };
    FinancialChart.prototype.c1 = function (a) {
        if (a != null) {
            return 1;
        }
        return _super.prototype.c1.call(this, a);
    };
    FinancialChart.prototype.xe = function (a) {
        if (a.suggestedSecondaryAxis == 2) {
            this.yAxis.lo = true;
            this.yAxis.mm = 10;
        }
    };
    FinancialChart.prototype.xh = function () {
        this.yAxis.lo = this.ak9;
        this.yAxis.mm = this.am7;
    };
    FinancialChart.prototype.ai6 = function (a) {
        var b;
        if (this.ai4 == 0) {
            if (a == null || a.index > 0 || stringIsNullOrEmpty(a.getMemberPathFor(12))) {
                b = 4;
            }
            else {
                b = 2;
            }
        }
        else {
            b = this.ai4;
        }
        b = this.ai5(b);
        return b;
    };
    FinancialChart.prototype.ai5 = function (a) {
        if ((a == 1 || a == 2)) {
            if (TypeRegistrar.isRegistered("FinancialPriceSeries")) {
                return a;
            }
            a = 4;
        }
        if (a == 4) {
            if (TypeRegistrar.isRegistered("LineSeries")) {
                return a;
            }
            a = 3;
        }
        if (a == 3) {
            if (TypeRegistrar.isRegistered("ColumnSeries")) {
                return a;
            }
        }
        return a;
    };
    FinancialChart.prototype.ajf = function (a) {
        if ((a == 2 || a == 3)) {
            if (TypeRegistrar.isRegistered("FinancialPriceSeries")) {
                return a;
            }
            a = 5;
        }
        if (a == 5) {
            if (TypeRegistrar.isRegistered("LineSeries")) {
                return a;
            }
            a = 6;
        }
        if (a == 6) {
            if (TypeRegistrar.isRegistered("AreaSeries")) {
                return a;
            }
            a = 4;
        }
        if (a == 4) {
            if (TypeRegistrar.isRegistered("ColumnSeries")) {
                return a;
            }
        }
        return a;
    };
    FinancialChart.prototype.ai8 = function (a) {
        if (a == 2) {
            if (TypeRegistrar.isRegistered("LineSeries")) {
                return a;
            }
            a = 3;
        }
        if (a == 3) {
            if (TypeRegistrar.isRegistered("AreaSeries")) {
                return a;
            }
            a = 1;
        }
        if (a == 1) {
            if (TypeRegistrar.isRegistered("ColumnSeries")) {
                return a;
            }
        }
        return a;
    };
    FinancialChart.prototype.anu = function (a) {
        var b = a.getMemberPathFor(14);
        if (stringIsNullOrEmpty(b)) {
            b = a.getMemberPathFor(11);
        }
        return b;
    };
    FinancialChart.prototype.aip = function (axisType_) {
        if ((this.externalObject)) {
            return (this.externalObject.createXAxis(axisType_).i);
        }
        else {
            var a = void 0;
            switch (axisType_) {
                case 0:
                    if (TypeRegistrar.isRegistered("OrdinalTimeXAxis")) {
                        a = TypeRegistrar.create("OrdinalTimeXAxis");
                    }
                    else if (TypeRegistrar.isRegistered("TimeXAxis")) {
                        a = TypeRegistrar.create("TimeXAxis");
                    }
                    else {
                        throw new BaseError(1, "no valid axes loaded");
                    }
                    return a;
                case 1:
                    if (TypeRegistrar.isRegistered("TimeXAxis")) {
                        a = TypeRegistrar.create("TimeXAxis");
                    }
                    else if (TypeRegistrar.isRegistered("OrdinalTimeXAxis")) {
                        a = TypeRegistrar.create("OrdinalTimeXAxis");
                    }
                    else {
                        throw new BaseError(1, "no valid axes loaded");
                    }
                    return a;
            }
            return null;
        }
    };
    FinancialChart.prototype.aj3 = function (axisType_) {
        if ((this.externalObject)) {
            return (this.externalObject.createYAxis(axisType_).i);
        }
        else {
            var a = void 0;
            switch (axisType_) {
                case 0:
                    if (TypeRegistrar.isRegistered("NumericYAxis")) {
                        a = TypeRegistrar.create("NumericYAxis");
                    }
                    else if (TypeRegistrar.isRegistered("PercentChangeYAxis")) {
                        a = TypeRegistrar.create("PercentChangeYAxis");
                    }
                    else {
                        throw new BaseError(1, "no valid axes loaded");
                    }
                    return a;
                case 1:
                    if (TypeRegistrar.isRegistered("PercentChangeYAxis")) {
                        a = TypeRegistrar.create("PercentChangeYAxis");
                    }
                    else if (TypeRegistrar.isRegistered("NumericYAxis")) {
                        a = TypeRegistrar.create("NumericYAxis");
                    }
                    else {
                        throw new BaseError(1, "no valid axes loaded");
                    }
                    return a;
            }
            return null;
        }
    };
    FinancialChart.prototype.aj9 = function () {
        return this.df(1);
    };
    FinancialChart.prototype.aka = function () {
        return this.df(0);
    };
    FinancialChart.prototype.aj8 = function () {
        return this.df(2);
    };
    FinancialChart.prototype.akb = function () {
        return this.df(20);
    };
    Object.defineProperty(FinancialChart.prototype, "aks", {
        get: function () {
            return (TypeRegistrar.isRegistered("HorizontalAnchoredCategorySeriesProxy"));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ajq", {
        get: function () {
            if (TypeRegistrar.isRegistered("HorizontalAnchoredCategorySeriesProxy")) {
                return TypeRegistrar.create("HorizontalAnchoredCategorySeriesProxy");
            }
            else {
                throw new BaseError(1, "horizontal series module is not loaded, but is required.");
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "akv", {
        get: function () {
            return (TypeRegistrar.isRegistered("FinancialPriceSeriesProxy"));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ajo", {
        get: function () {
            if (TypeRegistrar.isRegistered("FinancialPriceSeriesProxy")) {
                return TypeRegistrar.create("FinancialPriceSeriesProxy");
            }
            else {
                throw new BaseError(1, "financial series module is not loaded, but is required.");
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "akt", {
        get: function () {
            return (TypeRegistrar.isRegistered("IndicatorProxy"));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ajs", {
        get: function () {
            if (TypeRegistrar.isRegistered("IndicatorProxy")) {
                return TypeRegistrar.create("IndicatorProxy");
            }
            else {
                throw new BaseError(1, "financial series module is not loaded, but is required.");
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "aku", {
        get: function () {
            return (TypeRegistrar.isRegistered("OverlayProxy"));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ajx", {
        get: function () {
            if (TypeRegistrar.isRegistered("OverlayProxy")) {
                return TypeRegistrar.create("OverlayProxy");
            }
            else {
                throw new BaseError(1, "overlay series module is not loaded, but is required.");
            }
        },
        enumerable: false,
        configurable: true
    });
    FinancialChart.prototype.dc = function (a, b) {
        var c = this.anu(a);
        switch (this.ai6(a)) {
            case 3:
                var d = this.aj9();
                this.ajq.setValueMemberPath(d, c);
                this.ajq.setXAxis(d, this.xAxis);
                this.ajq.setYAxis(d, this.yAxis);
                this.ajq.setCategoryMode(d, 1);
                return d;
            case 4:
                var e = this.aka();
                this.ajq.setValueMemberPath(e, c);
                this.ajq.setXAxis(e, this.xAxis);
                this.ajq.setYAxis(e, this.yAxis);
                this.ajq.setCategoryMode(e, 1);
                return e;
            default:
            case 1:
            case 2:
                var f = this.akb();
                this.ajo.setOpenMemberPath(f, a.getMemberPathFor(11));
                this.ajo.setHighMemberPath(f, a.getMemberPathFor(12));
                this.ajo.setLowMemberPath(f, a.getMemberPathFor(13));
                this.ajo.setCloseMemberPath(f, a.getMemberPathFor(14));
                this.ajo.setVolumeMemberPath(f, a.getMemberPathFor(15));
                this.ajo.setXAxis(f, this.xAxis);
                this.ajo.setYAxis(f, this.yAxis);
                this.ajo.setDisplayType(f, this.ai4 == 1 ? 1 : 0);
                this.ajo.setCategoryMode(f, 1);
                return f;
        }
    };
    FinancialChart.prototype.xg = function () {
        _super.prototype.xg.call(this);
        this.aql(this.xAxis);
        this.aq9(false);
        if (this.ai9 != 0 && this.volumeChart != null) {
            this.aqs();
        }
        this.aql(this.volumeXAxis);
        this.aql(this.indicatorXAxis);
        this.aq6();
        this.aq8();
        if (this.ajg != 0) {
            this.aqt();
            this.aql(this.zoomSliderXAxis);
        }
    };
    FinancialChart.prototype.agi = function (a, b) {
        var e_2, _a;
        _super.prototype.agi.call(this, a, b);
        a(this.volumeXAxis);
        if (this.ali != null) {
            try {
                for (var _b = __values(fromEnum(this.ali)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var c = _c.value;
                    a(c);
                }
            }
            catch (e_2_1) {
                e_2 = { error: e_2_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_2)
                        throw e_2.error;
                }
            }
        }
        var d = true;
        switch (b) {
            case "XAxisMajorStroke":
            case "XAxisMajorStrokeThickness":
                d = false;
                break;
        }
        if (d) {
            a(this.zoomSliderXAxis);
        }
    };
    FinancialChart.prototype.agn = function (a, b) {
        var e_3, _a;
        _super.prototype.agn.call(this, a, b);
        if (b) {
            a(this.volumeAxis);
            if (this.alg != null) {
                try {
                    for (var _b = __values(fromEnum(this.alg)), _c = _b.next(); !_c.done; _c = _b.next()) {
                        var c = _c.value;
                        a(c);
                    }
                }
                catch (e_3_1) {
                    e_3 = { error: e_3_1 };
                }
                finally {
                    try {
                        if (_c && !_c.done && (_a = _b.return))
                            _a.call(_b);
                    }
                    finally {
                        if (e_3)
                            throw e_3.error;
                    }
                }
            }
            a(this.zoomSliderAxis);
        }
    };
    FinancialChart.prototype.aqp = function (a) {
        var b = typeCast(IZoomableCategoryAxis_$type, this.xAxis);
        if (b != null) {
            a(b);
        }
    };
    FinancialChart.prototype.agl = function (a) {
        _super.prototype.agl.call(this, a);
        this.agc(this.volumeXAxis, a);
        this.agc(this.indicatorXAxis, a);
        this.agc(this.zoomSliderXAxis, a);
    };
    FinancialChart.prototype.agq = function (a) {
        _super.prototype.agq.call(this, a);
        this.agc(this.volumeAxis, a);
        this.agc(this.indicatorAxis, a);
        this.agc(this.zoomSliderAxis, a);
    };
    FinancialChart.prototype.ago = function (a) {
        _super.prototype.ago.call(this, a);
        this.agb(this.volumeAxis, a);
        this.agb(this.indicatorAxis, a);
        this.agb(this.zoomSliderAxis, a);
    };
    FinancialChart.prototype.agj = function (a) {
        _super.prototype.agj.call(this, a);
        this.agb(this.volumeXAxis, a);
        this.agb(this.indicatorXAxis, a);
        this.agb(this.zoomSliderXAxis, a);
    };
    FinancialChart.prototype.vo = function (a) {
        var _this = this;
        _super.prototype.vo.call(this, a);
        if (a == null) {
            return;
        }
        if (a == this.zoomSliderChart) {
            a.x7 = a.ya = false;
            a.legend = null;
            if (this.dataChart != null) {
                a.ag = this.dataChart.ag;
                a.aj = this.dataChart.aj;
            }
        }
        else {
            SyncManager.d(a, ((function () {
                var $ret = new SyncSettings();
                $ret.syncChannel = _this.aop();
                $ret.synchronizeHorizontally = true;
                $ret.synchronizeVertically = false;
                return $ret;
            })()));
            SyncManager.c(a);
        }
        a.cz = 2;
    };
    FinancialChart.prototype.aop = function () {
        if (this.anm == null) {
            FinancialChart.am6++;
            this.anm = FinancialChart.am6.toString();
        }
        return this.anm;
    };
    FinancialChart.prototype.ap7 = function (a, b) {
        this.apt();
        this.aqn();
    };
    FinancialChart.prototype.apt = function () {
        var e_4, _a;
        if (this.yAxis.b8()) {
            return;
        }
        var a = this.yAxis.aw.bg;
        if (this.ai9 != 0) {
            a = Math.max(a, this.volumeAxis.aw.bg);
        }
        try {
            for (var _b = __values(fromEnum(this.alg)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var b = _c.value;
                a = Math.max(a, b.aw.bg);
            }
        }
        catch (e_4_1) {
            e_4 = { error: e_4_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_4)
                    throw e_4.error;
            }
        }
        this.apu(a);
    };
    FinancialChart.prototype.apu = function (a) {
        var e_5, _a;
        if (this.yAxis.b8()) {
            return;
        }
        this.yAxis.eu = this.volumeAxis.eu = a;
        try {
            for (var _b = __values(fromEnum(this.alg)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var b = _c.value;
                b.eu = a;
            }
        }
        catch (e_5_1) {
            e_5 = { error: e_5_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_5)
                    throw e_5.error;
            }
        }
        this.zoomSliderAxis.eu = this.yAxis.eu;
    };
    FinancialChart.prototype.apz = function (a) {
        if (this.indicatorCharts == null) {
            return;
        }
        for (var b = 0; b < this.indicatorCharts.count; b++) {
            var c = this.indicatorCharts._inner[b];
            for (var d = 0; d < c.series.count; d++) {
                var e = c.series._inner[d];
                if (!(this.akx(e))) {
                    continue;
                }
                a(c.series._inner[d], b);
            }
        }
    };
    FinancialChart.prototype.ap2 = function (a) {
        if (this.volumeChart == null) {
            return;
        }
        for (var b = 0; b < this.volumeChart.series.count; b++) {
            var c = this.volumeChart.series._inner[b];
            if (c.eu) {
                continue;
            }
            a(this.volumeChart.series._inner[b], b);
        }
    };
    FinancialChart.prototype.ap0 = function (a) {
        if (this.dataChart == null) {
            return;
        }
        for (var b = 0; b < this.dataChart.series.count; b++) {
            var c = this.dataChart.series._inner[b];
            if (!this.akz(c)) {
                continue;
            }
            a(c, b);
        }
    };
    FinancialChart.prototype.ap1 = function (a, b) {
        if (this.dataChart == null) {
            return;
        }
        for (var c = 0; c < this.dataChart.series.count; c++) {
            var d = this.dataChart.series._inner[c];
            if (this.akz(d)) {
                continue;
            }
            var e = this.am0(d, c);
            a(d, e);
        }
        if (b) {
            this.ap3(a);
        }
    };
    FinancialChart.prototype.ap3 = function (a) {
        if (this.zoomSliderChart == null) {
            return;
        }
        for (var b = 0; b < this.zoomSliderChart.series.count; b++) {
            var c = this.zoomSliderChart.series._inner[b];
            if (c.eu) {
                continue;
            }
            a(this.zoomSliderChart.series._inner[b], b);
        }
    };
    FinancialChart.prototype.am0 = function (a, b) {
        if (a.da != this.dataChart) {
            return b;
        }
        var c = this.bf == null || this.bf.dataSeries == null ? 0 : this.bf.dataSeries.count;
        var d = this.ajk == null ? 0 : this.ajk.count;
        return b - (c * d);
    };
    FinancialChart.prototype.vd = function (a) {
        _super.prototype.vd.call(this, a);
        this.ap2(a);
        this.apz(a);
        this.ap3(a);
    };
    Object.defineProperty(FinancialChart.prototype, "volumeChart", {
        get: function () {
            return this.akf;
        },
        set: function (a) {
            var b = this.volumeChart;
            if (a != b) {
                this.akf = a;
                this.wj("VolumeChart", b, this.volumeChart);
            }
        },
        enumerable: false,
        configurable: true
    });
    FinancialChart.prototype.aqs = function () {
        if (this.dataChart == null) {
            return;
        }
        this.volumeChart.series.clear();
        var a = new List$1(Series.$, 0);
        var b = -1;
        for (var c = 0; c < this.dataChart.series.count; c++) {
            var d = this.dataChart.series._inner[c];
            if (this.akz(d) || d.eu) {
                continue;
            }
            b++;
            var e = void 0;
            var f = this.ai9;
            f = this.ai8(f);
            switch (f) {
                case 2:
                    e = this.aka();
                    break;
                case 3:
                    e = this.aj8();
                    break;
                default:
                case 1:
                    e = this.aj9();
                    break;
            }
            this.ajq.setCategoryMode(e, 1);
            e.name = "volumeSeries_" + b;
            e.itemsSource = d.itemsSource;
            this.ajq.setXAxis(e, this.volumeXAxis);
            this.ajq.setYAxis(e, this.volumeAxis);
            this.ajq.setValueMemberPath(e, this.bf != null && this.bf.dataSeries != null && this.bf.dataSeries.count > b ? this.bf.dataSeries._inner[b].getMemberPathFor(15) : null);
            e.title = d.title + " Volume";
            e.vk = ArrayExtension.getModulus$1(Brush.$, this.aih, b);
            e.v0 = ArrayExtension.getModulus$1(Brush.$, this.aii, b);
            e.jq = this.amb;
            a.add(e);
        }
        var g = this.h2("volume", false);
        if (g != null) {
            a.o(g);
        }
        for (var h = 0; h < a.count; h++) {
            var i = a._inner[h];
            this.volumeChart.series.add(i);
            this.vt(i, h);
        }
    };
    FinancialChart.prototype.akw = function (a) {
        if (!this.aks) {
            return false;
        }
        return this.ajq.matchesType(a);
    };
    FinancialChart.prototype.ak0 = function (a) {
        if (!this.akv) {
            return false;
        }
        return this.ajo.matchesType(a);
    };
    FinancialChart.prototype.akx = function (a) {
        if (!this.akt) {
            return false;
        }
        return this.ajs.matchesType(a);
    };
    FinancialChart.prototype.akz = function (a) {
        if (!this.aku) {
            return false;
        }
        return this.ajx.matchesType(a);
    };
    FinancialChart.prototype.aqr = function () {
        if (this.dataChart == null) {
            return;
        }
        var a = 0;
        var b = this.aji == null ? 0 : this.aji.count;
        var c = this.customIndicatorNames == null ? 0 : this.customIndicatorNames.count;
        var d = b + c;
        for (var e = 0; e < d; e++) {
            var f = new List$1(Series.$, 0);
            var g = this.indicatorCharts._inner[e];
            var h = e >= b;
            var i = h ? this.customIndicatorNames._inner[e - b] : EnumUtil.getName(FinancialIndicatorType_$type, this.aji._inner[e]);
            var j = -1;
            for (var k = 0; k < this.dataChart.series.count; k++) {
                var l = this.dataChart.series._inner[k];
                if (this.akz(l) || l.eu) {
                    continue;
                }
                j++;
                var m = void 0;
                if (h) {
                    var n = this.akc("Custom");
                    this.ajs.handleCustomIndicatorEvent(n, runOn(this, this.ap5));
                    m = n;
                }
                else {
                    m = this.ake(this.aji._inner[e]);
                }
                if (m == null) {
                    continue;
                }
                m.name = "indicator_" + a++;
                this.ajs.setXAxis(m, this.ali._inner[e]);
                this.ajs.setYAxis(m, this.alg._inner[e]);
                m.itemsSource = l.itemsSource;
                this.ajs.setOpenMemberPath(m, this.bf.dataSeries._inner[j].getMemberPathFor(11));
                this.ajs.setHighMemberPath(m, this.bf.dataSeries._inner[j].getMemberPathFor(12));
                this.ajs.setLowMemberPath(m, this.bf.dataSeries._inner[j].getMemberPathFor(13));
                this.ajs.setCloseMemberPath(m, this.bf.dataSeries._inner[j].getMemberPathFor(14));
                this.ajs.setVolumeMemberPath(m, this.bf.dataSeries._inner[j].getMemberPathFor(15));
                m.title = l.title + " " + i;
                m.vk = ArrayExtension.getModulus$1(Brush.$, this.aib, e);
                m.jq = this.al7;
                if (this.akx(m)) {
                    this.ajs.setNegativeBrush(m, ArrayExtension.getModulus$1(Brush.$, this.aic, e));
                    this.ajs.setDisplayType(m, ArrayExtension.getModulus$1(IndicatorDisplayType_$type, this.aju, e));
                }
                if (this.am2 != -2147483648 && this.akx(m)) {
                    this.ajs.setPeriodOverride(m, this.am2);
                }
                if (this.akx(m)) {
                    this.ajs.setSmoothingPeriod(m, this.am5);
                }
                if (this.akx(m)) {
                    this.ajs.setSignalPeriod(m, this.am4);
                }
                if (this.akx(m)) {
                    this.ajs.setShortPeriod(m, this.am3);
                    this.ajs.setLongPeriod(m, this.am1);
                }
                this.vt(m, e);
                f.add(m);
            }
            var o = this.h2(i, false);
            for (var p = 0; p < f.count; p++) {
                var q = f._inner[p];
                g.series.add(q);
            }
            if (o != null) {
                for (var r = 0; r < o.count; r++) {
                    var s = o._inner[r];
                    g.series.add(s);
                    this.vt(s, r);
                }
            }
        }
    };
    FinancialChart.prototype.akc = function (indicatorName_) {
        return (this.externalObject.createIndicator(indicatorName_ + 'Indicator').i);
    };
    FinancialChart.prototype.ake = function (a) {
        return this.akc(EnumUtil.getName(FinancialIndicatorType_$type, a));
    };
    FinancialChart.prototype.aq9 = function (a) {
        if (this.ai2 == null) {
            return;
        }
        var b = this.xAxis;
        if (b.actualMinimumValue > b.actualMaximumValue) {
            return;
        }
        this.ai2.as = b.actualMinimumValue;
        this.ai2.ar = b.actualMaximumValue;
        if (a) {
            this.ai2.au = b.visibleMinimum;
            this.ai2.at = b.visibleMaximum;
        }
        this.ai2.bn();
    };
    FinancialChart.prototype.l9 = function () {
        var e_6, _a, e_7, _b;
        var _this = this;
        var a = ((function () {
            var $ret = new FinancialChartVisualData();
            $ret.mainChart = _super.prototype.l9.call(_this);
            $ret.volumeChart = _this.volumeChart == null ? null : _this.volumeChart.zj();
            $ret.toolbar = _this.ai2 == null ? null : _this.ai2.aj();
            $ret.zoomChart = _this.zoomSliderChart == null ? null : _this.zoomSliderChart.zj();
            return $ret;
        })());
        if (this.indicatorCharts != null) {
            a.indicatorCharts = new List$1(Base.$, 0);
            try {
                for (var _c = __values(fromEnum(this.indicatorCharts)), _d = _c.next(); !_d.done; _d = _c.next()) {
                    var b = _d.value;
                    a.indicatorCharts.add1(b.zj());
                }
            }
            catch (e_6_1) {
                e_6 = { error: e_6_1 };
            }
            finally {
                try {
                    if (_d && !_d.done && (_a = _c.return))
                        _a.call(_c);
                }
                finally {
                    if (e_6)
                        throw e_6.error;
                }
            }
        }
        if (this.dataChart != null) {
            a.mainChartLeft = this.ari(this.dataChart).x;
            a.mainChartTop = this.ari(this.dataChart).y;
        }
        if (this.volumeChart != null) {
            a.volumeChartLeft = this.ari(this.volumeChart).x;
            a.volumeChartTop = this.ari(this.volumeChart).y;
        }
        if (this.zoomSliderChart != null) {
            a.zoomChartLeft = this.ari(this.zoomSliderChart).x;
            a.zoomChartTop = this.ari(this.zoomSliderChart).y;
        }
        if (this.ai2 != null) {
            var c = this.arj(this.ai2);
            a.toolbarLeft = c.left;
            a.toolbarTop = c.top;
            a.toolbarWidth = c.width;
            a.toolbarHeight = c.height;
        }
        if (this.indicatorCharts != null) {
            a.indicatorChartLefts = new List$1(Number_$type, 0);
            a.indicatorChartTops = new List$1(Number_$type, 0);
            try {
                for (var _e = __values(fromEnum(this.indicatorCharts)), _f = _e.next(); !_f.done; _f = _e.next()) {
                    var d = _f.value;
                    a.indicatorChartLefts.add(this.ari(d).x);
                    a.indicatorChartTops.add(this.ari(d).y);
                }
            }
            catch (e_7_1) {
                e_7 = { error: e_7_1 };
            }
            finally {
                try {
                    if (_f && !_f.done && (_b = _e.return))
                        _b.call(_e);
                }
                finally {
                    if (e_7)
                        throw e_7.error;
                }
            }
        }
        var e = this.arl();
        a.legendLeft = e.left;
        a.legendTop = e.top;
        a.legendWidth = e.width;
        a.legendHeight = e.height;
        a.legend = this.ajm == null ? null : this.ajm.exportVisualData();
        return a;
    };
    FinancialChart.prototype.anr = function () {
        var a = this.l9();
        a.scaleByViewport();
        return a.serialize();
    };
    FinancialChart.prototype.akd = function (overlayName_) {
        return (this.externalObject.createOverlay(overlayName_ + 'Overlay').i);
    };
    FinancialChart.prototype.aq8 = function () {
        var e_8, _a, e_9, _b;
        if (this.dataChart == null) {
            return;
        }
        var a = new List$1(Series.$, 0);
        try {
            for (var _c = __values(fromEnum(this.dataChart.series)), _d = _c.next(); !_d.done; _d = _c.next()) {
                var b = _d.value;
                if (this.akz(b)) {
                    a.add(b);
                }
            }
        }
        catch (e_8_1) {
            e_8 = { error: e_8_1 };
        }
        finally {
            try {
                if (_d && !_d.done && (_a = _c.return))
                    _a.call(_c);
            }
            finally {
                if (e_8)
                    throw e_8.error;
            }
        }
        try {
            for (var _e = __values(fromEnum(a)), _f = _e.next(); !_f.done; _f = _e.next()) {
                var c = _f.value;
                this.dataChart.series.remove(c);
            }
        }
        catch (e_9_1) {
            e_9 = { error: e_9_1 };
        }
        finally {
            try {
                if (_f && !_f.done && (_b = _e.return))
                    _b.call(_e);
            }
            finally {
                if (e_9)
                    throw e_9.error;
            }
        }
        if (this.ajk == null) {
            return;
        }
        var d = new List$1(Series.$, 0);
        var e = -1;
        for (var f = 0; f < this.dataChart.series.count; f++) {
            var g = this.dataChart.series._inner[f];
            if (this.akz(g) || g.eu) {
                continue;
            }
            e++;
            for (var h = 0; h < this.ajk.count; h++) {
                var i = this.ajk._inner[h];
                var j = void 0;
                switch (i) {
                    case 1:
                        j = this.akd(EnumUtil.getName(FinancialOverlayType_$type, i));
                        break;
                    default:
                    case 0:
                        j = this.akd(EnumUtil.getName(FinancialOverlayType_$type, i));
                        break;
                }
                j.name = g.name + "_" + EnumUtil.getName(FinancialOverlayType_$type, i);
                this.ajx.setXAxis(j, this.xAxis);
                this.ajx.setYAxis(j, this.yAxis);
                j.itemsSource = g.itemsSource;
                var k = e * this.ajk.count + h;
                j.vk = ArrayExtension.getModulus$1(Brush.$, this.aif, k);
                j.v0 = ArrayExtension.getModulus$1(Brush.$, this.aig, k);
                j.jq = this.al9;
                j.title = g.title + " " + EnumUtil.getName(FinancialOverlayType_$type, i);
                var l = g;
                if (l == null) {
                    continue;
                }
                var m = this.bf.dataSeries._inner[e];
                this.ajx.setOpenMemberPath(j, m.getMemberPathFor(11));
                this.ajx.setHighMemberPath(j, m.getMemberPathFor(12));
                this.ajx.setLowMemberPath(j, m.getMemberPathFor(13));
                this.ajx.setCloseMemberPath(j, m.getMemberPathFor(14));
                this.ajx.setVolumeMemberPath(j, m.getMemberPathFor(15));
                d.add(j);
            }
        }
        var n = new Array(this.dataChart.series.count);
        this.dataChart.series.copyTo(n, 0);
        this.dataChart.skipDataCleanup = true;
        this.dataChart.series.clear();
        this.dataChart.skipDataCleanup = false;
        for (var o = 0; o < n.length; o++) {
            n[o].index = -1;
        }
        d.o(n);
        for (var p = 0; p < d.count; p++) {
            var q = d._inner[p];
            this.dataChart.series.add(q);
            this.vt(q, p);
        }
    };
    FinancialChart.prototype.aq6 = function () {
        var e_10, _a;
        if (this.ak5) {
            return;
        }
        this.ak5 = true;
        if (this.indicatorCharts != null) {
            var a = this.indicatorCharts;
            this.indicatorCharts = null;
            try {
                for (var _b = __values(fromEnum(a)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var b = _c.value;
                    this.aqm(b);
                }
            }
            catch (e_10_1) {
                e_10 = { error: e_10_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_10)
                        throw e_10.error;
                }
            }
        }
        if ((this.aji == null || this.aji.count == 0) && (this.customIndicatorNames == null || this.customIndicatorNames.count == 0)) {
            this.indicatorCharts = null;
            if (this.alg != null) {
                this.alg.clear();
            }
            if (this.ali != null) {
                this.ali.clear();
            }
            this.aqx();
            this.aq7();
            this.ak5 = false;
            return;
        }
        if (this.indicatorCharts == null) {
            this.indicatorCharts = new List$1(XamDataChart.$, 0);
        }
        this.indicatorCharts.clear();
        this.alg.clear();
        this.ali.clear();
        var c = this.aji == null ? 0 : this.aji.count;
        var d = this.customIndicatorNames == null ? 0 : this.customIndicatorNames.count;
        var e = c + d;
        for (var f = 0; f < e; f++) {
            var g = new XamDataChart();
            this.indicatorCharts.add(g);
            this.aqk(g, null);
            var h = f >= c;
            if (h) {
                g.ml = this.customIndicatorNames._inner[f - c];
            }
            else {
                g.ml = this.ant(this.aji._inner[f]);
            }
            if (this.indicatorAxis != null) {
                var i = void 0;
                var j = void 0;
                if (f == 0) {
                    i = this.indicatorAxis;
                    j = this.indicatorXAxis;
                }
                else {
                    i = new NumericYAxis();
                    if (!this.indicatorXAxis.ce) {
                        j = this.aio(0);
                    }
                    else {
                        j = this.aio(1);
                    }
                }
                j.name = "indicatorXAxis_" + f;
                i.name = "indicatorAxis_" + f;
                g.axes.add(i);
                g.axes.add(j);
                this.alg.add(i);
                this.ali.add(j);
                if (this.gm) {
                    this.agf(i);
                }
                if (this.gm) {
                    this.agd(j);
                }
            }
        }
        this.aqx();
        this.aqr();
        if (this.ai2 != null) {
            this.ai2.ae = this.aji;
        }
        this.apv();
        this.aq7();
        this.ak5 = false;
    };
    FinancialChart.prototype.vl = function () {
        var e_11, _a, e_12, _b;
        _super.prototype.vl.call(this);
        this.agd(this.xAxis);
        this.agd(this.volumeXAxis);
        if (this.ali != null) {
            try {
                for (var _c = __values(fromEnum(this.ali)), _d = _c.next(); !_d.done; _d = _c.next()) {
                    var a = _d.value;
                    this.agd(a);
                }
            }
            catch (e_11_1) {
                e_11 = { error: e_11_1 };
            }
            finally {
                try {
                    if (_d && !_d.done && (_a = _c.return))
                        _a.call(_c);
                }
                finally {
                    if (e_11)
                        throw e_11.error;
                }
            }
        }
        this.agf(this.yAxis);
        this.agf(this.volumeAxis);
        if (this.alg != null) {
            try {
                for (var _e = __values(fromEnum(this.alg)), _f = _e.next(); !_f.done; _f = _e.next()) {
                    var b = _f.value;
                    this.agf(b);
                }
            }
            catch (e_12_1) {
                e_12 = { error: e_12_1 };
            }
            finally {
                try {
                    if (_f && !_f.done && (_b = _e.return))
                        _b.call(_e);
                }
                finally {
                    if (e_12)
                        throw e_12.error;
                }
            }
        }
        this.agd(this.zoomSliderXAxis);
        this.agf(this.zoomSliderAxis);
    };
    FinancialChart.prototype.get_hh = function () {
        return !this.ak3;
    };
    Object.defineProperty(FinancialChart.prototype, "alb", {
        get: function () {
            return (this.externalObject._dynamicContent);
        },
        enumerable: false,
        configurable: true
    });
    FinancialChart.prototype.are = function (a, b) {
        this.aq0(a, b, this.ams);
        this.apv();
        if (this.zoomSliderChart != null) {
            this.zoomSliderChart.axes.add(this.zoomSliderAxis);
            this.zoomSliderChart.axes.add(this.zoomSliderXAxis);
        }
        this.aqt();
        this.zoomSliderXAxis.itemsSource = this.xAxis.itemsSource;
        this.aqy();
        this.arf(a, b);
    };
    FinancialChart.prototype.aqt = function () {
        if (this.dataChart == null || this.zoomSliderChart == null) {
            return;
        }
        this.zoomSliderChart.series.clear();
        var a = new List$1(Series.$, 0);
        for (var b = 0; b < this.dataChart.series.count; b++) {
            var c = this.dataChart.series._inner[b];
            if (this.akz(c) || c.eu) {
                continue;
            }
            var d = void 0;
            var e = this.ajg;
            e = this.ajf(e);
            var f = this.am0(c, b);
            if (e == 1) {
                switch (this.ai6(this.bf != null && this.bf.dataSeries != null && this.bf.dataSeries.count > f ? this.bf.dataSeries._inner[f] : null)) {
                    case 1:
                        e = 2;
                        break;
                    case 2:
                        e = 3;
                        break;
                    case 3:
                        e = 4;
                        break;
                    case 4:
                        e = 5;
                        break;
                }
            }
            switch (e) {
                case 2:
                    d = this.akb();
                    this.ajo.setDisplayType(d, 1);
                    break;
                case 3:
                    d = this.akb();
                    this.ajo.setDisplayType(d, 0);
                    break;
                case 5:
                    d = this.aka();
                    break;
                case 6:
                    d = this.aj8();
                    break;
                default:
                case 4:
                    d = this.aj9();
                    break;
            }
            var g = this.bf != null && this.bf.dataSeries != null && this.bf.dataSeries.count > f ? this.bf.dataSeries._inner[f] : null;
            if (d.e0 && !d.e8) {
                this.ajq.setCategoryMode(d, 1);
                this.ajq.setXAxis(d, this.zoomSliderXAxis);
                this.ajq.setYAxis(d, this.zoomSliderAxis);
                this.ajq.setValueMemberPath(d, g == null ? null : this.anu(g));
            }
            else if (d.e8) {
                this.ajo.setCategoryMode(d, 1);
                this.ajo.setXAxis(d, this.zoomSliderXAxis);
                this.ajo.setYAxis(d, this.zoomSliderAxis);
                if (g != null) {
                    this.ajo.setOpenMemberPath(d, g.getMemberPathFor(11));
                    this.ajo.setHighMemberPath(d, g.getMemberPathFor(12));
                    this.ajo.setLowMemberPath(d, g.getMemberPathFor(13));
                    this.ajo.setCloseMemberPath(d, g.getMemberPathFor(14));
                    this.ajo.setVolumeMemberPath(d, g.getMemberPathFor(15));
                }
            }
            d.name = "zoomSliderSeries_" + f;
            d.itemsSource = c.itemsSource;
            d.title = c.title;
            d.jq = this.kk;
            a.add(d);
        }
        for (var h = 0; h < a.count; h++) {
            var i = a._inner[h];
            this.zoomSliderChart.series.add(i);
            this.vt(i, h);
        }
    };
    FinancialChart.prototype.v9 = function (a, b, c) {
        var e_13, _a;
        _super.prototype.v9.call(this, a, b, c);
        if (a == null || !b) {
            return;
        }
        var d = true;
        var e = true;
        switch (c) {
            case "Brushes":
            case "Outlines":
                d = e = false;
                break;
        }
        if (this.indicatorCharts != null && d) {
            try {
                for (var _b = __values(fromEnum(this.indicatorCharts)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var f = _c.value;
                    a(f);
                }
            }
            catch (e_13_1) {
                e_13 = { error: e_13_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_13)
                        throw e_13.error;
                }
            }
        }
        if (this.volumeChart != null && e) {
            a(this.volumeChart);
        }
        if (this.zoomSliderChart != null) {
            a(this.zoomSliderChart);
        }
    };
    FinancialChart.prototype.ap5 = function (a, b) {
        var c = b;
        var d = a;
        var e = -1;
        if (this.indicatorCharts != null) {
            e = this.indicatorCharts.indexOf(d.da);
        }
        e -= this.aji == null ? 0 : this.aji.count;
        if (this.applyCustomIndicators != null) {
            this.applyCustomIndicators(this, new FinancialChartCustomIndicatorArgs(c, d, e));
        }
    };
    FinancialChart.prototype.aq2 = function (a, b, c) {
        if (a != null) {
            if (b != null) {
                a.axes.remove(b);
            }
            a.axes.add(c);
        }
        if (this.gm) {
            this.agd(c);
        }
    };
    Object.defineProperty(FinancialChart.prototype, "ala", {
        get: function () {
            return TypeRegistrar.isRegistered("IgxZoomSliderComponent");
        },
        enumerable: false,
        configurable: true
    });
    FinancialChart.prototype.ap6 = function (a, b) {
        this.aq6();
    };
    FinancialChart.prototype.ak1 = function (a, b) {
        if (b <= (0)) {
            return false;
        }
        switch (a) {
            case 5: return true;
            case 4:
            case 3: return b >= timeSpanFromDays(365);
            case 2: return b >= timeSpanFromDays(180);
            case 1: return b >= timeSpanFromDays(90);
            case 0: return b >= timeSpanFromDays(30);
        }
        return false;
    };
    FinancialChart.prototype.aqw = function () {
        var e_14, _a;
        var a = this.ai0 != null ? this.ai0 : new FinancialChartRangeSelectorOptionCollection(1, [5, 4, 3, 2, 1, 0]);
        var b = new FinancialChartRangeSelectorOptionCollection(0);
        var c = this.xAxis;
        var d = +(c.actualMaximumValue) - +(c.actualMinimumValue);
        try {
            for (var _b = __values(fromEnum(a)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var e = _c.value;
                if (this.ak1(e, d)) {
                    b.add(e);
                }
            }
        }
        catch (e_14_1) {
            e_14 = { error: e_14_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_14)
                    throw e_14.error;
            }
        }
        this.aiz = b;
        if (this.ai2 != null) {
            this.ai2.u = this.aiz;
        }
    };
    FinancialChart.prototype.aqa = function (a, b) {
        this.aqw();
    };
    FinancialChart.prototype.aqf = function (a, b) {
        this.ajk = this.ai2.ag;
    };
    FinancialChart.prototype.aqe = function (a, b) {
        this.aji = this.ai2.ae;
    };
    FinancialChart.prototype.ap8 = function (a, b) {
        this.aq6();
    };
    FinancialChart.prototype.ap9 = function (a, b) {
        this.aq8();
    };
    FinancialChart.prototype.aqj = function (a, b) {
        var c = a;
        if (c.bg == null) {
            return;
        }
        if (this.ak3) {
            this.aqv(c.bg);
        }
    };
    FinancialChart.prototype.aqm = function (a) {
        SyncManager.e(a);
        a.axes.clear();
        a.series.clear();
        a.gridAreaRectChanged = delegateRemove(a.gridAreaRectChanged, runOn(this, this.ap7));
        a.provideContainer(null);
        if (this.volumeChart == null && this.indicatorCharts == null) {
            this.yAxis.eu = this.volumeAxis.eu = this.indicatorAxis.eu = 0;
            this.xAxis.az.visibility = this.ah1;
        }
    };
    FinancialChart.prototype.aqk = function (a, b) {
        var c = a != this.zoomSliderChart;
        if (c) {
            if (this.dataChart != null) {
                a.xc = new Rect(0, this.dataChart.wt.x, a.xc.y, this.dataChart.wt.width, a.xc.height);
            }
            var d = ((function () {
                var $ret = new SyncSettings();
                $ret.syncChannel = "one";
                $ret.synchronizeHorizontally = true;
                $ret.synchronizeVertically = false;
                return $ret;
            })());
            SyncManager.d(a, d);
            SyncManager.c(a);
        }
        a.gridAreaRectChanged = delegateCombine(a.gridAreaRectChanged, runOn(this, this.ap7));
        this.vn(a, b);
    };
    FinancialChart.prototype.apv = function () {
        if (this.indicatorCharts != null || this.volumeChart != null) {
            this.agb(this.xAxis, function (a) { return a.visibility = 1; });
        }
        var _loop_1 = function (a) {
            var b = this_1.ali._inner[a];
            var c = a < this_1.ali.count - 1 || this_1.volumeChart != null;
            this_1.agb(b, function (d) { return d.visibility = c ? 1 : 0; });
        };
        var this_1 = this;
        for (var a = 0; a < this.ali.count; a++) {
            _loop_1(a);
        }
    };
    FinancialChart.prototype.aq0 = function (a, b, c) {
        if (a != null) {
            this.aqm(a);
        }
        if (b != null) {
            this.aqk(b, c);
        }
    };
    FinancialChart.prototype.arc = function (a, b) {
        this.aq0(a, b, this.amr);
        this.apv();
        if (this.volumeChart != null) {
            if (this.volumeAxis != null) {
                this.volumeChart.axes.add(this.volumeAxis);
                this.volumeChart.axes.add(this.volumeXAxis);
            }
            this.aqs();
            this.volumeXAxis.itemsSource = this.xAxis.itemsSource;
        }
        this.ard(a, b);
    };
    FinancialChart.prototype.aqb = function (a, b) {
        this.ara();
    };
    FinancialChart.prototype.ara = function () {
        if (this.ai2 == null || +(this.ai2.au) == +(dateMaxValue()) || +(this.ai2.at) == +(dateMinValue()) || this.dataChart == null) {
            return;
        }
        var a = this.xAxis;
        var b = a.getWindowRectForSelection(this.ai2.au, this.ai2.at);
        if (b.width == 0 || isNaN_(b.width) || isInfinity(b.width)) {
            return;
        }
        this.ak4 = true;
        this.dataChart.xc = new Rect(0, b.left, this.dataChart.xc.top, b.width, this.dataChart.xc.height);
        if (this.akk != null) {
            this.akk.windowRect = this.dataChart.wt;
        }
        if (this.ak3) {
            this.aqv(this.dataChart);
        }
        this.ak4 = false;
    };
    FinancialChart.prototype.aqi = function (a, b) {
        this.aqw();
        this.aq9(!this.ak4);
    };
    FinancialChart.prototype.ap4 = function (a, b) {
        var _this = this;
        if (!this.ak4) {
            if (this.ak3) {
                this.aqv(a);
            }
            var c = false;
            var d = this.ws(function () { return _this.aq9(true); }, c);
            c = d.p1;
            if (this.akk != null) {
                this.akk.windowRect = this.dataChart.wt;
            }
        }
    };
    FinancialChart.prototype.aq4 = function (a, b, c, d) {
        var e_15, _a;
        if (a == null || b == null) {
            return;
        }
        if (c != -1) {
            this.ak4 = true;
            a.xc = new Rect(0, d, a.wt.top, c, a.wt.height);
            this.ak4 = false;
        }
        var e = 1.7976931348623157E+308;
        var f = -1.7976931348623157E+308;
        var g = new Rect(0, 0, 0, 1, 1);
        var h = new ScalerParams(0, g, g, this.yAxis.ch, a.wx);
        try {
            for (var _b = __values(fromEnum(a.series)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var i = _c.value;
                h.b = i.iz();
                var j = i.az(a.wt);
                var k = j == null || j.c == 1.7976931348623157E+308 || isNaN_(j.c);
                if (k) {
                    continue;
                }
                var l = b.el(j.c, h);
                var m = b.el(j.b, h);
                f = Math.max(f, l);
                e = Math.min(e, m);
            }
        }
        catch (e_15_1) {
            e_15 = { error: e_15_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_15)
                    throw e_15.error;
            }
        }
        var n = a.wt.width;
        if (c != -1) {
            n = c;
        }
        var o = a.wt.left;
        if (d != -1) {
            o = d;
        }
        if (e == 1.7976931348623157E+308 || f == -1.7976931348623157E+308 || isNaN_(e) || isNaN_(f)) {
            return;
        }
        this.ak4 = true;
        var p = new Rect(0, o, e, n, f - e);
        a.xc = p;
        this.ak4 = false;
    };
    FinancialChart.prototype.aq3 = function (a) {
        if (a == null) {
            return;
        }
        if (a == this.dataChart) {
            this.aq4(this.dataChart, this.yAxis, -1, -1);
            if (this.volumeChart != null) {
                this.aq4(this.volumeChart, this.volumeAxis, this.dataChart.wt.width, this.dataChart.wt.left);
            }
        }
        else if (a == this.volumeChart) {
            this.aq4(this.volumeChart, this.volumeAxis, -1, -1);
            this.aq4(this.dataChart, this.yAxis, this.volumeChart.wt.width, this.volumeChart.wt.left);
        }
    };
    FinancialChart.prototype.aqv = function (a) {
        var _this = this;
        this.wr(function () { return _this.aq3(a); });
    };
    FinancialChart.prototype.aqc = function (a, b) {
        if (this.ak3) {
            this.aqv(a);
        }
    };
    FinancialChart.prototype.arb = function () {
        if (!this.alb) {
            return;
        }
        this.apy();
        if (this.ajg == 0) {
            this.resetZoom();
            this.zoomSliderChart = null;
            this.ams.rootWrapper.removeChildren();
        }
        else if (this.zoomSliderChart == null) {
            this.zoomSliderChart = ((function () {
                var $ret = new XamDataChart();
                $ret.name = "ZoomSliderChart";
                return $ret;
            })());
            this.aqy();
        }
        else {
            this.aqt();
        }
    };
    FinancialChart.prototype.apy = function () {
        var container_ = this.ams.rootWrapper.getNativeElement();
        var containerParent_ = container_.parentElement;
        if (this.akk != null && containerParent_ != null && !this.alc) {
            this.alc = true;
            if (TypeRegistrar.isRegistered("IgxZoomSliderComponent")) {
                var z_ = this.akk;
                var f_ = this.externalObject;
                var sliderComponent_ = TypeRegistrar.get("IgxZoomSliderComponent");
                var sliderInstance_ = TypeRegistrar.create("IgxZoomSliderComponent");
                sliderInstance_._implementation = z_;
                sliderComponent_._staticStyling(container_, sliderInstance_, f_);
            }
        }
    };
    FinancialChart.prototype.aq5 = function () {
        var _this = this;
        if (this.ajb != 1) {
            return;
        }
        this.agh(function (a) {
            var e_16, _a;
            var b;
            b = a.breaks;
            b.clear();
            if (_this.xAxisBreaks == null) {
                return;
            }
            try {
                for (var _b = __values(fromEnum(_this.xAxisBreaks)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var c = _c.value;
                    b.add(c);
                }
            }
            catch (e_16_1) {
                e_16 = { error: e_16_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_16)
                        throw e_16.error;
                }
            }
        });
    };
    FinancialChart.prototype.xl = function (a, b, c) {
        _super.prototype.xl.call(this, a, b, c);
        if (this.bf.dataSeries.count > 0) {
            if (this.ajb == 1 && stringIsNullOrEmpty(this.n3)) {
                this.ce.setXMemberPath(a, c.getMemberPathFor(17));
            }
            if (stringIsNullOrEmpty(this.n5)) {
                this.ce.setYMemberPath(a, this.anu(c));
            }
            if (stringIsNullOrEmpty(this.nq)) {
                this.ce.setLabelMemberPath(a, this.anu(c));
            }
            if (stringIsNullOrEmpty(this.nm)) {
                this.ce.setContentMemberPath(a, this.anu(c));
            }
        }
    };
    FinancialChart.prototype.ant = function (a) {
        switch (a) {
            case 0: return "Absolute Volume Oscillator";
            case 1: return "Accumulation/Distribution Indicator";
            case 2: return "Average Directional Index";
            case 3: return "Average True Range Indicator";
            case 4: return "Bollinger Bandwidth";
            case 5: return "Chaikin Oscillator";
            case 6: return "Chaikin Volatility Indicator";
            case 7: return "Commodity Channel Index";
            case 8: return "Detrended Price Oscillator";
            case 9: return "Ease of Movement Indicator";
            case 10: return "Fast Stochastic Oscillator";
            case 11: return "Force Index Indicator";
            case 12: return "Full Stochastic Oscillator";
            case 13: return "Market Facilitation Index";
            case 14: return "Mass Index Indicator";
            case 15: return "Median Price Indicator";
            case 16: return "Money Flow Index";
            case 17: return "MACD Indicator";
            case 18: return "Negative Volume Index";
            case 19: return "On Balance Volume Indicator";
            case 20: return "Percentage Price Oscillator";
            case 21: return "Percentage Volume Oscillator";
            case 22: return "Positive Volume Index";
            case 23: return "Price Volume Trend";
            case 24: return "ROC - Rate of Change Indicator";
            case 25: return "RSI - Relative Strength Index";
            case 26: return "Slow Stochastic Oscillator";
            case 27: return "Standard Deviation Indicator";
            case 28: return "Stoch RSI";
            case 29: return "TRIX Indicator";
            case 30: return "Typical Price Indicator";
            case 31: return "Ultimate Oscillator";
            case 32: return "Weighted Close Indicator";
            case 33: return "Williams %R Indicator";
            default: return "Unknown";
        }
    };
    FinancialChart.prototype.agd = function (a) {
        var e_17, _a;
        var _this = this;
        _super.prototype.agd.call(this, a);
        var b = a;
        this.aql(b);
        if (a.bg != null) {
            try {
                for (var _b = __values(fromEnum(a.bg.series)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var c = _c.value;
                    if (this.akw(c)) {
                        this.ajq.setXAxis(c, b);
                    }
                    else if (this.ak0(c)) {
                        this.ajo.setXAxis(c, b);
                    }
                    else if (this.akx(c)) {
                        this.ajs.setXAxis(c, b);
                    }
                    else if (this.akz(c)) {
                        this.ajx.setXAxis(c, b);
                    }
                }
            }
            catch (e_17_1) {
                e_17 = { error: e_17_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_17)
                        throw e_17.error;
                }
            }
        }
        this.aqp(function (d) {
            d.zoomMaximumCategoryRange = _this.amc;
            d.zoomMaximumItemSpan = _this.amd;
            d.zoomToCategoryRange = _this.ame;
            d.zoomToCategoryStart = _this.amf;
            d.zoomToItemSpan = _this.amg;
        });
        var d = a == this.zoomSliderXAxis;
        if (d) {
            a.jz = this.arh;
            a.et = this.amn;
            this.agb(a, function (e) { return e.visibility = 1; });
        }
        var e = a;
        e.minimumValue = this.alo;
        e.maximumValue = this.aln;
        a.b1 = this.ak6;
    };
    FinancialChart.prototype.agf = function (a) {
        var e_18, _a;
        _super.prototype.agf.call(this, a);
        if (a.bg != null && a == this.yAxis) {
            try {
                for (var _b = __values(fromEnum(a.bg.series)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var b = _c.value;
                    if (this.akw(b)) {
                        this.ajq.setYAxis(b, this.yAxis);
                    }
                    else if (this.ak0(b)) {
                        this.ajo.setYAxis(b, this.yAxis);
                    }
                    else if (this.akx(b)) {
                        this.ajs.setYAxis(b, this.yAxis);
                    }
                    else if (this.akz(b)) {
                        this.ajx.setYAxis(b, this.yAxis);
                    }
                }
            }
            catch (e_18_1) {
                e_18 = { error: e_18_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_18)
                        throw e_18.error;
                }
            }
        }
        a.lf = this.ak7;
        a.mc = this.aml;
        a.mb = this.amk;
        if (a == this.yAxis) {
            a.l8 = this.amj;
        }
        var c = a == this.zoomSliderAxis;
        if (c) {
            this.agb(a, function (d) { return d.visibility = 1; });
        }
        a.b1 = this.ak8;
    };
    FinancialChart.prototype.aql = function (a) {
        a.itemsSource = this.dataChart != null && this.dataChart.series.count > 0 ? this.dataChart.series._inner[0].itemsSource : null;
        a.f2 = XYChart.adw(a, this.bf.dataSeries);
        if (this.bf.dataSeries.count > 0) {
            var b = this.bf.dataSeries._inner[0].getMemberPathFor(17);
            a.h1(b);
        }
    };
    FinancialChart.prototype.vt = function (a, b) {
        if (a == null) {
            return;
        }
        var c = this.zoomSliderChart == a.da;
        var d = this.dataChart != null && this.dataChart.series.contains(a);
        if (d && !a.eu && !this.akz(a)) {
            a.l5 = "Financial Series";
        }
        _super.prototype.vt.call(this, a, b);
        if ((d || c) && a.fn) {
            a.r7(this.aid != null ? ArrayExtension.getModulus$1(Brush.$, this.aid, b) : null, this.aie != null ? ArrayExtension.getModulus$1(Brush.$, this.aie, b) : null);
        }
        var e = this.akx(a);
        if (this.akz(a)) {
            a.vk = this.aif != null ? ArrayExtension.getModulus$1(Brush.$, this.aif, b) : null;
            a.v0 = this.aig != null ? ArrayExtension.getModulus$1(Brush.$, this.aig, b) : null;
            a.jq = this.al9;
        }
        else if (e) {
            a.vk = this.aib != null ? ArrayExtension.getModulus$1(Brush.$, this.aib, b) : null;
            a.jq = this.al7;
        }
        else if (!a.eu && (d || c)) {
            a.vk = this.z != null ? ArrayExtension.getModulus$1(Brush.$, this.z, b) : null;
            a.v0 = this.ad != null ? ArrayExtension.getModulus$1(Brush.$, this.ad, b) : null;
        }
        var f = this.volumeChart != null && this.volumeChart == a.da;
        if (f) {
            a.jq = this.amb;
        }
        a.legend = c || f || e || !a.isUsableInLegend ? null : this.legend != null ? this.legend : this.aky ? this.ajm : null;
    };
    FinancialChart.prototype.vu = function (a, b) {
        _super.prototype.vu.call(this, a, b);
        if (a == null) {
            return;
        }
    };
    FinancialChart.prototype.wj = function (a, b, c) {
        var e_19, _a, e_20, _b;
        var _this = this;
        _super.prototype.wj.call(this, a, b, c);
        switch (a) {
            case "YAxisIsLogarithmic":
                this.yAxis.lo = this.ak9;
                if (this.volumeAxis != null) {
                    this.volumeAxis.lo = this.ak9;
                }
                if (this.zoomSliderAxis != null) {
                    this.zoomSliderAxis.lo = this.ak9;
                }
                break;
            case "YAxisLogarithmBase":
                this.yAxis.mm = this.am7;
                if (this.volumeAxis != null) {
                    this.volumeAxis.mm = this.am7;
                }
                if (this.zoomSliderAxis != null) {
                    this.zoomSliderAxis.mm = this.am7;
                }
                break;
            case "VolumeType":
                var d = EnumUtil.getEnumValue(FinancialChartVolumeType_$type, b);
                if (this.ai9 == 0) {
                    this.volumeChart = null;
                }
                else if (this.volumeChart == null) {
                    this.volumeChart = ((function () {
                        var $ret = new XamDataChart();
                        $ret.name = "VolumeChart";
                        return $ret;
                    })());
                }
                else {
                    this.aqs();
                }
                break;
            case "VolumeChart":
                this.arc(typeCast(XamDataChart.$, b), typeCast(XamDataChart.$, c));
                break;
            case "DataChart":
                if (typeCast(XamDataChart.$, b) !== null) {
                    var e = b;
                    e.gridAreaRectChanged = delegateRemove(e.gridAreaRectChanged, runOn(this, this.ap7));
                    e.actualWindowRectChanged = delegateRemove(e.actualWindowRectChanged, runOn(this, this.ap4));
                    e.seriesDataUpdated = delegateRemove(e.seriesDataUpdated, runOn(this, this.aqc));
                }
                if (this.dataChart != null) {
                    var f = this.dataChart;
                    f.gridAreaRectChanged = delegateCombine(f.gridAreaRectChanged, runOn(this, this.ap7));
                    var g = this.dataChart;
                    g.actualWindowRectChanged = delegateCombine(g.actualWindowRectChanged, runOn(this, this.ap4));
                    var h = this.dataChart;
                    h.seriesDataUpdated = delegateCombine(h.seriesDataUpdated, runOn(this, this.aqc));
                }
                this.arb();
                break;
            case "XAxisMode":
                this.xAxis = this.aio(this.ajb);
                this.xAxis.name = "xAxis";
                this.volumeXAxis = this.aio(this.ajb);
                this.volumeXAxis.name = "volumeXAxis";
                this.indicatorXAxis = this.aio(this.ajb);
                this.indicatorXAxis.name = "indicatorXAxis_0";
                this.zoomSliderXAxis = this.aio(this.ajb);
                this.zoomSliderXAxis.name = "zoomSliderXAxis";
                this.agb(this.zoomSliderXAxis, function (i) { return i.visibility = 1; });
                this.apv();
                if (this.ajb == 1) {
                    this.aq5();
                }
                break;
            case "YAxisMode":
                this.yAxis = this.aj2(this.ajd);
                this.yAxis.name = "yAxis";
                this.zoomSliderAxis = this.aj2(this.ajd);
                this.zoomSliderAxis.name = "zoomSliderAxis";
                this.volumeAxis = this.aj2(this.ajd);
                this.volumeAxis.name = "volumeAxis";
                break;
            case "Toolbar":
                var i = typeCast(FinancialChartToolbar.$, b);
                if (i != null) {
                    i.rangeChanged = delegateRemove(i.rangeChanged, runOn(this, this.aqb));
                    i.indicatorTypesChanged = delegateRemove(i.indicatorTypesChanged, runOn(this, this.aqe));
                    i.overlayTypesChanged = delegateRemove(i.overlayTypesChanged, runOn(this, this.aqf));
                }
                if (this.ai2 != null) {
                    this.ai2.ae = this.aji;
                    this.ai2.ag = this.ajk;
                    this.ai2.u = this.aiz;
                    this.aq9(true);
                    var j = this.ai2;
                    j.rangeChanged = delegateCombine(j.rangeChanged, runOn(this, this.aqb));
                    var k = this.ai2;
                    k.indicatorTypesChanged = delegateCombine(k.indicatorTypesChanged, runOn(this, this.aqe));
                    var l = this.ai2;
                    l.overlayTypesChanged = delegateCombine(l.overlayTypesChanged, runOn(this, this.aqf));
                }
                break;
            case "XAxis":
                var m = typeCast(CategoryAxisBase.$, b);
                if (m != null) {
                    if (this.dataChart != null) {
                        this.dataChart.axes.remove(m);
                    }
                }
                var n = typeCast(ITimeRangeSelectorAxis_$type, b);
                if (n != null) {
                    n.visibleRangeChanged = delegateRemove(n.visibleRangeChanged, runOn(this, this.aqi));
                }
                if (this.dataChart != null) {
                    this.dataChart.axes.add(this.xAxis);
                }
                if (this.gm) {
                    this.agd(this.xAxis);
                    this.va();
                }
                this.aq9(false);
                this.ara();
                this.aqw();
                var o = this.xAxis;
                o.visibleRangeChanged = delegateCombine(o.visibleRangeChanged, runOn(this, this.aqi));
                break;
            case "XAxisZoomMaximumCategoryRange":
                this.aqp(function (p) { return p.zoomMaximumCategoryRange = _this.amc; });
                break;
            case "XAxisZoomMaximumItemSpan":
                this.aqp(function (p) { return p.zoomMaximumItemSpan = _this.amd; });
                break;
            case "XAxisZoomToCategoryRange":
                this.aqp(function (p) { return p.zoomToCategoryRange = _this.ame; });
                break;
            case "XAxisZoomToCategoryStart":
                this.aqp(function (p) { return p.zoomToCategoryStart = _this.amf; });
                break;
            case "XAxisZoomToItemSpan":
                this.aqp(function (p) { return p.zoomToItemSpan = _this.amg; });
                break;
            case "ChartType":
                this.ve();
                break;
            case "VolumeXAxis":
                this.aq2(this.volumeChart, typeCast(Axis.$, b), this.volumeXAxis);
                break;
            case "ZoomSliderXAxis":
                this.aq2(this.zoomSliderChart, typeCast(Axis.$, b), this.zoomSliderXAxis);
                break;
            case "IndicatorXAxis":
                this.aq6();
                break;
            case "YAxis":
                var p = typeCast(NumericYAxis.$, b);
                if (p != null) {
                    if (this.dataChart != null) {
                        this.dataChart.axes.remove(p);
                    }
                }
                if (this.dataChart != null) {
                    this.dataChart.axes.add(this.yAxis);
                }
                if (this.gm) {
                    this.agf(this.yAxis);
                    this.agf(this.yAxis);
                }
                var q = this.yAxis;
                q.rangeChanged = delegateCombine(q.rangeChanged, runOn(this, this.aqj));
                break;
            case "VolumeAxis":
                var r = typeCast(Axis.$, b);
                if (this.volumeChart != null && r != null) {
                    this.volumeChart.axes.remove(r);
                }
                if (this.volumeChart != null && this.volumeAxis != null) {
                    this.volumeChart.axes.add(this.volumeAxis);
                    this.aqs();
                }
                if (this.gm) {
                    this.agf(this.volumeAxis);
                }
                var s = this.volumeAxis;
                s.rangeChanged = delegateCombine(s.rangeChanged, runOn(this, this.aqj));
                break;
            case "IndicatorAxis":
                if (this.indicatorCharts != null) {
                    for (var t = 0; t < this.indicatorCharts.count; t++) {
                        var u = this.indicatorCharts._inner[t];
                        var v = new List$1(Axis.$, 0);
                        try {
                            for (var _c = (e_19 = void 0, __values(fromEnum(u.axes))), _d = _c.next(); !_d.done; _d = _c.next()) {
                                var w = _d.value;
                                if (typeCast(NumericYAxis.$, w) !== null) {
                                    v.add(w);
                                }
                            }
                        }
                        catch (e_19_1) {
                            e_19 = { error: e_19_1 };
                        }
                        finally {
                            try {
                                if (_d && !_d.done && (_a = _c.return))
                                    _a.call(_c);
                            }
                            finally {
                                if (e_19)
                                    throw e_19.error;
                            }
                        }
                        try {
                            for (var _e = (e_20 = void 0, __values(fromEnum(v))), _f = _e.next(); !_f.done; _f = _e.next()) {
                                var x = _f.value;
                                u.axes.remove(x);
                            }
                        }
                        catch (e_20_1) {
                            e_20 = { error: e_20_1 };
                        }
                        finally {
                            try {
                                if (_f && !_f.done && (_b = _e.return))
                                    _b.call(_e);
                            }
                            finally {
                                if (e_20)
                                    throw e_20.error;
                            }
                        }
                        var y = null;
                        if (t == 0) {
                            y = this.indicatorAxis;
                        }
                        else if (this.ajd == 1) {
                            y = this.aj2(this.ajd);
                        }
                        else if (typeCast(NumericYAxis.$, this.indicatorAxis) !== null) {
                            y = new NumericYAxis();
                        }
                        if (y != null) {
                            u.axes.add(y);
                        }
                        if (this.gm) {
                            this.agf(y);
                        }
                    }
                }
                break;
            case "IsWindowSyncedToVisibleRange":
                if (this.dataChart != null) {
                    this.dataChart.ya = this.hi && this.hh;
                }
                if (this.volumeChart != null) {
                    this.volumeChart.ya = this.hi && this.hh;
                }
                if (this.ak3) {
                    this.aq3(this.dataChart);
                }
                else {
                    this.volumeChart.zh = 1;
                }
                break;
            case "IndicatorTypes":
                var z = typeCast(ObservableCollection$1.$.specialize(FinancialIndicatorType_$type), b);
                if (z != null) {
                    z.collectionChanged = delegateRemove(z.collectionChanged, runOn(this, this.ap8));
                }
                var aa = typeCast(ObservableCollection$1.$.specialize(FinancialIndicatorType_$type), c);
                if (aa != null) {
                    aa.collectionChanged = delegateCombine(aa.collectionChanged, runOn(this, this.ap8));
                }
                this.aq6();
                break;
            case "OverlayTypes":
                var ab = typeCast(ObservableCollection$1.$.specialize(FinancialOverlayType_$type), b);
                if (ab != null) {
                    ab.collectionChanged = delegateRemove(ab.collectionChanged, runOn(this, this.ap9));
                }
                var ac = typeCast(ObservableCollection$1.$.specialize(FinancialOverlayType_$type), c);
                if (ac != null) {
                    ac.collectionChanged = delegateCombine(ac.collectionChanged, runOn(this, this.ap9));
                }
                this.aq8();
                break;
            case "YAxisAbbreviateLargeNumbers":
                this.agm(function (ad) { return ad.lf = _this.ak7; });
                break;
            case "YAxisMinimumValue":
                this.agn(function (ad) { return ad.mc = _this.aml; }, false);
                break;
            case "YAxisMaximumValue":
                this.agn(function (ad) { return ad.mb = _this.amk; }, false);
                break;
            case "YAxisInterval":
                this.agn(function (ad) { return ad.l8 = _this.amj; }, false);
                break;
            case "Thickness":
            case "ZoomSliderType":
                this.arb();
                break;
            case "ZoomSliderChart":
                if (!this.ala) {
                    return;
                }
                this.are(typeCast(XamDataChart.$, b), typeCast(XamDataChart.$, c));
                break;
            case "NegativeBrushes":
            case "NegativeOutlines":
                this.ap1(function (ad, ae) {
                    if (ad.fn) {
                        ad.r7(_this.aid != null ? ArrayExtension.getModulus$1(Brush.$, _this.aid, ae) : null, _this.aie != null ? ArrayExtension.getModulus$1(Brush.$, _this.aie, ae) : null);
                    }
                }, true);
                break;
            case "OverlayBrushes":
                this.ap0(function (ad, ae) { return ad.vk = _this.aif != null ? ArrayExtension.getModulus$1(Brush.$, _this.aif, ae) : null; });
                break;
            case "OverlayOutlines":
                this.ap0(function (ad, ae) { return ad.v0 = _this.aig != null ? ArrayExtension.getModulus$1(Brush.$, _this.aig, ae) : null; });
                break;
            case "OverlayThickness":
                this.ap0(function (ad, ae) { return ad.jq = _this.al9; });
                break;
            case "OverlayMultiplier":
                this.ap0(function (ad, ae) { return _this.ajx.setMultiplier(ad, _this.al8); });
                break;
            case "VolumeBrushes":
                this.ap2(function (ad, ae) { return ad.vk = ArrayExtension.getModulus$1(Brush.$, _this.aih, ae); });
                break;
            case "VolumeOutlines":
                this.ap2(function (ad, ae) { return ad.v0 = ArrayExtension.getModulus$1(Brush.$, _this.aii, ae); });
                break;
            case "VolumeThickness":
                this.ap2(function (ad, ae) { return ad.jq = _this.amb; });
                break;
            case "IndicatorNegativeBrushes":
                this.apz(function (ad, ae) { return _this.ajs.setNegativeBrush(ad, ArrayExtension.getModulus$1(Brush.$, _this.aic, ae)); });
                break;
            case "IndicatorBrushes":
                this.apz(function (ad, ae) { return ad.vk = ArrayExtension.getModulus$1(Brush.$, _this.aib, ae); });
                break;
            case "IndicatorThickness":
                this.apz(function (ad, ae) { return ad.jq = _this.al7; });
                break;
            case "IndicatorDisplayTypes":
                this.apz(function (ad, ae) { return _this.ajs.setDisplayType(ad, ArrayExtension.getModulus$1(IndicatorDisplayType_$type, _this.aju, ae)); });
                break;
            case "IndicatorPeriod":
                this.apz(function (ad, ae) {
                    if (_this.am2 == -2147483648) {
                        return;
                    }
                    _this.ajs.setPeriodOverride(ad, _this.am2);
                });
                break;
            case "IndicatorMultiplier":
                this.apz(function (ad, ae) { return _this.ajs.setMultiplier(ad, _this.al6); });
                break;
            case "IndicatorSmoothingPeriod":
                this.apz(function (ad, ae) { return _this.ajs.setSmoothingPeriod(ad, _this.am5); });
                break;
            case "IndicatorShortPeriod":
                this.apz(function (ad, ae) { return _this.ajs.setShortPeriod(ad, _this.am3); });
                break;
            case "IndicatorLongPeriod":
                this.apz(function (ad, ae) { return _this.ajs.setLongPeriod(ad, _this.am1); });
                break;
            case "IndicatorSignalPeriod":
                this.apz(function (ad, ae) { return _this.ajs.setSignalPeriod(ad, _this.am4); });
                break;
            case "RangeSelectorOptions":
                var ad = typeCast(FinancialChartRangeSelectorOptionCollection.$, b);
                if (ad != null) {
                    ad.collectionChanged = delegateRemove(ad.collectionChanged, runOn(this, this.aqa));
                }
                if (this.ai0 != null) {
                    var ae = this.ai0;
                    ae.collectionChanged = delegateCombine(ae.collectionChanged, runOn(this, this.aqa));
                }
                this.aqw();
                break;
            case "CustomIndicatorNames":
                var af = typeCast(ObservableCollection$1.$.specialize(String_$type), b);
                if (af != null) {
                    af.collectionChanged = delegateRemove(af.collectionChanged, runOn(this, this.ap6));
                }
                if (this.customIndicatorNames != null) {
                    var ag = this.customIndicatorNames;
                    ag.collectionChanged = delegateCombine(ag.collectionChanged, runOn(this, this.ap6));
                }
                this.aq6();
                break;
            case "Legend":
                if (this.zoomSliderChart != null) {
                    this.zoomSliderChart.legend = null;
                }
                break;
            case "Brushes":
                this.ap1(function (ah, ai) { return ah.vk = _this.z != null ? ArrayExtension.getModulus$1(Brush.$, _this.z, ai) : null; }, true);
                break;
            case "Outlines":
                this.ap1(function (ah, ai) { return ah.v0 = _this.ad != null ? ArrayExtension.getModulus$1(Brush.$, _this.ad, ai) : null; }, true);
                break;
            case "XAxisLabelVisibility":
                if (this.ah1 == 0 && this.zoomSliderXAxis != null) {
                    this.agb(this.zoomSliderXAxis, function (ah) { return ah.visibility = 1; });
                }
                this.apv();
                break;
            case "YAxisLabelVisibility":
                if (this.ah2 != 0 || this.zoomSliderAxis == null) {
                    break;
                }
                this.agb(this.zoomSliderAxis, function (ah) { return ah.visibility = 1; });
                break;
            case "ZoomSliderXAxisMajorStroke":
                this.zoomSliderXAxis.jz = this.arh;
                break;
            case "ZoomSliderXAxisMajorStrokeThickness":
                this.zoomSliderXAxis.et = this.amn;
                break;
            case "FinancialChartLegend":
            case "IsLegendVisible":
                var ah_1 = this.aky && this.legend == null;
                {
                    var ai = function (aj, ak) {
                        if (aj.isUsableInLegend) {
                            aj.legend = ah_1 ? _this.ajm : null;
                        }
                    };
                    this.ap1(ai, false);
                    this.ap0(ai);
                }
                break;
            case "ZoomSliderAxis":
                var aj = typeCast(Axis.$, b);
                if (aj != null && this.zoomSliderChart != null) {
                    this.zoomSliderChart.axes.remove(aj);
                }
                if (this.zoomSliderAxis != null) {
                    if (this.zoomSliderChart != null) {
                        this.zoomSliderChart.axes.add(this.zoomSliderAxis);
                        this.aqt();
                        this.zoomSliderXAxis.itemsSource = this.xAxis.itemsSource;
                    }
                    if (this.gm) {
                        this.agf(this.zoomSliderAxis);
                    }
                    this.agb(this.zoomSliderAxis, function (ak) { return ak.visibility = 1; });
                }
                break;
            case "XAxisMinimumValue":
                this.agh(function (ak) {
                    var al = typeCast(ITimeRangeSelectorAxis_$type, ak);
                    if (al != null) {
                        al.minimumValue = _this.alo;
                    }
                });
                break;
            case "XAxisMaximumValue":
                this.agh(function (ak) {
                    var al = typeCast(ITimeRangeSelectorAxis_$type, ak);
                    if (al != null) {
                        al.maximumValue = _this.aln;
                    }
                });
                break;
            case FinancialChart.ao2:
                this.agi(function (ak) { return ak.b1 = _this.ak6; }, a);
                break;
            case FinancialChart.apd:
                this.agm(function (ak) { return ak.b1 = _this.ak8; });
                break;
        }
    };
    FinancialChart.prototype.get_cb = function () {
        return 1;
    };
    Object.defineProperty(FinancialChart.prototype, "cb", {
        get: function () {
            return this.get_cb();
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ak9", {
        get: function () {
            return this.akr;
        },
        set: function (a) {
            var b = this.ak9;
            if (a != b) {
                this.akr = a;
                this.wj("YAxisIsLogarithmic", b, this.ak9);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "am7", {
        get: function () {
            return this.amz;
        },
        set: function (a) {
            var b = this.am7;
            if (a != b) {
                this.amz = a;
                this.wj("YAxisLogarithmBase", b, this.am7);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "amj", {
        get: function () {
            return this.al0;
        },
        set: function (a) {
            var b = this.amj;
            if (a != b) {
                this.al0 = a;
                this.wj("YAxisInterval", b, this.amj);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "aml", {
        get: function () {
            return this.al2;
        },
        set: function (a) {
            var b = this.aml;
            if (a != b) {
                this.al2 = a;
                this.wj("YAxisMinimumValue", b, this.aml);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "amk", {
        get: function () {
            return this.al1;
        },
        set: function (a) {
            var b = this.amk;
            if (a != b) {
                this.al1 = a;
                this.wj("YAxisMaximumValue", b, this.amk);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "amm", {
        get: function () {
            return this.al3;
        },
        set: function (a) {
            var b = this.amm;
            if (a != b) {
                this.al3 = a;
                this.wj("YAxisMinorInterval", b, this.amm);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ami", {
        get: function () {
            return this.yAxis.l4;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "amh", {
        get: function () {
            return this.yAxis.l3;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ai9", {
        get: function () {
            return this.ai7;
        },
        set: function (a) {
            var b = this.ai9;
            if (a != b) {
                this.ai7 = a;
                this.wj("VolumeType", enumGetBox(FinancialChartVolumeType_$type, b), enumGetBox(FinancialChartVolumeType_$type, this.ai9));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ajb", {
        get: function () {
            return this.aja;
        },
        set: function (a) {
            var b = this.ajb;
            if (a != b) {
                this.aja = a;
                this.wj("XAxisMode", enumGetBox(FinancialChartXAxisMode_$type, b), enumGetBox(FinancialChartXAxisMode_$type, this.ajb));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "amc", {
        get: function () {
            return this.alv;
        },
        set: function (a) {
            var b = this.amc;
            if (a != b) {
                this.alv = a;
                this.wj("XAxisZoomMaximumCategoryRange", b, this.amc);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "amf", {
        get: function () {
            return this.aly;
        },
        set: function (a) {
            var b = this.amf;
            if (a != b) {
                this.aly = a;
                this.wj("XAxisZoomToCategoryStart", b, this.amf);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "amd", {
        get: function () {
            return this.alw;
        },
        set: function (a) {
            var b = this.amd;
            if (a != b) {
                this.alw = a;
                this.wj("XAxisZoomMaximumItemSpan", b, this.amd);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ame", {
        get: function () {
            return this.alx;
        },
        set: function (a) {
            var b = this.ame;
            if (a != b) {
                this.alx = a;
                this.wj("XAxisZoomToCategoryRange", b, this.ame);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "amg", {
        get: function () {
            return this.alz;
        },
        set: function (a) {
            var b = this.amg;
            if (a != b) {
                this.alz = a;
                this.wj("XAxisZoomToItemSpan", b, this.amg);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ajd", {
        get: function () {
            return this.ajc;
        },
        set: function (a) {
            var b = this.ajd;
            if (a != b) {
                this.ajc = a;
                this.wj("YAxisMode", enumGetBox(FinancialChartYAxisMode_$type, b), enumGetBox(FinancialChartYAxisMode_$type, this.ajd));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ak2", {
        get: function () {
            return this.akm;
        },
        set: function (a) {
            var b = this.ak2;
            if (a != b) {
                this.akm = a;
                this.wj("IsToolbarVisible", b, this.ak2);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ai4", {
        get: function () {
            return this.ai3;
        },
        set: function (a) {
            var b = this.ai4;
            if (a != b) {
                this.ai3 = a;
                this.wj("ChartType", enumGetBox(FinancialChartType_$type, b), enumGetBox(FinancialChartType_$type, this.ai4));
            }
        },
        enumerable: false,
        configurable: true
    });
    FinancialChart.prototype.get_agw = function () {
        return _super.prototype.get_agw.call(this);
    };
    FinancialChart.prototype.set_agw = function (a) {
        _super.prototype.set_agw.call(this, a);
    };
    Object.defineProperty(FinancialChart.prototype, "ak3", {
        get: function () {
            return this.akn;
        },
        set: function (a) {
            var b = this.ak3;
            if (a != b) {
                this.akn = a;
                this.wj("IsWindowSyncedToVisibleRange", b, this.ak3);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "aji", {
        get: function () {
            return this.ajh;
        },
        set: function (a) {
            var b = this.aji;
            if (a != b) {
                this.ajh = a;
                this.wj("IndicatorTypes", b, this.aji);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ajk", {
        get: function () {
            return this.ajj;
        },
        set: function (a) {
            var b = this.ajk;
            if (a != b) {
                this.ajj = a;
                this.wj("OverlayTypes", b, this.ajk);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "indicatorCharts", {
        get: function () {
            return this.ale;
        },
        set: function (a) {
            var b = this.indicatorCharts;
            if (a != b) {
                this.ale = a;
                this.wj("IndicatorCharts", b, this.indicatorCharts);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ak7", {
        get: function () {
            return this.akp;
        },
        set: function (a) {
            var b = this.ak7;
            if (a != b) {
                this.akp = a;
                this.wj("YAxisAbbreviateLargeNumbers", b, this.ak7);
            }
        },
        enumerable: false,
        configurable: true
    });
    FinancialChart.prototype.get_ke = function () {
        return _super.prototype.get_ke.call(this);
    };
    FinancialChart.prototype.set_ke = function (a) {
        _super.prototype.set_ke.call(this, a);
    };
    Object.defineProperty(FinancialChart.prototype, "ak6", {
        get: function () {
            return this.ako;
        },
        set: function (a) {
            var b = this.ak6;
            if (a != b) {
                this.ako = a;
                this.wj(FinancialChart.ao2, b, this.ak6);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ak8", {
        get: function () {
            return this.akq;
        },
        set: function (a) {
            var b = this.ak8;
            if (a != b) {
                this.akq = a;
                this.wj(FinancialChart.apd, b, this.ak8);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "zoomSliderChart", {
        get: function () {
            return this.akg;
        },
        set: function (a) {
            var b = this.zoomSliderChart;
            if (a != b) {
                this.akg = a;
                this.wj("ZoomSliderChart", b, this.zoomSliderChart);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "zoomSliderAxis", {
        get: function () {
            return this.aj1;
        },
        set: function (a) {
            var b = this.zoomSliderAxis;
            if (a != b) {
                this.aj1 = a;
                this.wj("ZoomSliderAxis", b, this.zoomSliderAxis);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "zoomSliderXAxis", {
        get: function () {
            return this.aim;
        },
        set: function (a) {
            var b = this.zoomSliderXAxis;
            if (a != b) {
                this.aim = a;
                this.wj("ZoomSliderXAxis", b, this.zoomSliderXAxis);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ajg", {
        get: function () {
            return this.aje;
        },
        set: function (a) {
            var b = this.ajg;
            if (a != b) {
                this.aje = a;
                this.wj("ZoomSliderType", enumGetBox(FinancialChartZoomSliderType_$type, b), enumGetBox(FinancialChartZoomSliderType_$type, this.ajg));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "aid", {
        get: function () {
            return this.ah5;
        },
        set: function (a) {
            var b = this.aid;
            if (a != b) {
                this.ah5 = a;
                this.wj("NegativeBrushes", b, this.aid);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "aie", {
        get: function () {
            return this.ah6;
        },
        set: function (a) {
            var b = this.aie;
            if (a != b) {
                this.ah6 = a;
                this.wj("NegativeOutlines", b, this.aie);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "aif", {
        get: function () {
            return this.ah7;
        },
        set: function (a) {
            var b = this.aif;
            if (a != b) {
                this.ah7 = a;
                this.wj("OverlayBrushes", b, this.aif);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "aig", {
        get: function () {
            return this.ah8;
        },
        set: function (a) {
            var b = this.aig;
            if (a != b) {
                this.ah8 = a;
                this.wj("OverlayOutlines", b, this.aig);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "aii", {
        get: function () {
            return this.aia;
        },
        set: function (a) {
            var b = this.aii;
            if (a != b) {
                this.aia = a;
                this.wj("VolumeOutlines", b, this.aii);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "aih", {
        get: function () {
            return this.ah9;
        },
        set: function (a) {
            var b = this.aih;
            if (a != b) {
                this.ah9 = a;
                this.wj("VolumeBrushes", b, this.aih);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "aic", {
        get: function () {
            return this.ah4;
        },
        set: function (a) {
            var b = this.aic;
            if (a != b) {
                this.ah4 = a;
                this.wj("IndicatorNegativeBrushes", b, this.aic);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "aib", {
        get: function () {
            return this.ah3;
        },
        set: function (a) {
            var b = this.aib;
            if (a != b) {
                this.ah3 = a;
                this.wj("IndicatorBrushes", b, this.aib);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "amb", {
        get: function () {
            return this.alu;
        },
        set: function (a) {
            var b = this.amb;
            if (a != b) {
                this.alu = a;
                this.wj("VolumeThickness", b, this.amb);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "al9", {
        get: function () {
            return this.als;
        },
        set: function (a) {
            var b = this.al9;
            if (a != b) {
                this.als = a;
                this.wj("OverlayThickness", b, this.al9);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "al8", {
        get: function () {
            return this.alr;
        },
        set: function (a) {
            var b = this.al8;
            if (a != b) {
                this.alr = a;
                this.wj("OverlayMultiplier", b, this.al8);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "al7", {
        get: function () {
            return this.alq;
        },
        set: function (a) {
            var b = this.al7;
            if (a != b) {
                this.alq = a;
                this.wj("IndicatorThickness", b, this.al7);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "aju", {
        get: function () {
            return this.ajt;
        },
        set: function (a) {
            var b = this.aju;
            if (a != b) {
                this.ajt = a;
                this.wj("IndicatorDisplayTypes", b, this.aju);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "am2", {
        get: function () {
            return this.amv;
        },
        set: function (a) {
            var b = this.am2;
            if (a != b) {
                this.amv = a;
                this.wj("IndicatorPeriod", b, this.am2);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "al6", {
        get: function () {
            return this.alp;
        },
        set: function (a) {
            var b = this.al6;
            if (a != b) {
                this.alp = a;
                this.wj("IndicatorMultiplier", b, this.al6);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "am5", {
        get: function () {
            return this.amy;
        },
        set: function (a) {
            var b = this.am5;
            if (a != b) {
                this.amy = a;
                this.wj("IndicatorSmoothingPeriod", b, this.am5);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "am3", {
        get: function () {
            return this.amw;
        },
        set: function (a) {
            var b = this.am3;
            if (a != b) {
                this.amw = a;
                this.wj("IndicatorShortPeriod", b, this.am3);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "am1", {
        get: function () {
            return this.amu;
        },
        set: function (a) {
            var b = this.am1;
            if (a != b) {
                this.amu = a;
                this.wj("IndicatorLongPeriod", b, this.am1);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "am4", {
        get: function () {
            return this.amx;
        },
        set: function (a) {
            var b = this.am4;
            if (a != b) {
                this.amx = a;
                this.wj("IndicatorSignalPeriod", b, this.am4);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ai0", {
        get: function () {
            return this.aiy;
        },
        set: function (a) {
            var b = this.ai0;
            if (a != b) {
                this.aiy = a;
                this.wj("RangeSelectorOptions", b, this.ai0);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "customIndicatorNames", {
        get: function () {
            return this.aiu;
        },
        set: function (a) {
            var b = this.aiu;
            if (a != b) {
                this.aiu = a;
                this.wj("CustomIndicatorNames", b, this.customIndicatorNames);
            }
        },
        enumerable: false,
        configurable: true
    });
    FinancialChart.prototype.get_hi = function () {
        return _super.prototype.get_hi.call(this);
    };
    FinancialChart.prototype.set_hi = function (a) {
        _super.prototype.set_hi.call(this, a);
    };
    Object.defineProperty(FinancialChart.prototype, "arh", {
        get: function () {
            return this.arg;
        },
        set: function (a) {
            var b = this.arh;
            if (a != b) {
                this.arg = a;
                this.wj("ZoomSliderXAxisMajorStroke", b, this.arh);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "amn", {
        get: function () {
            return this.al4;
        },
        set: function (a) {
            var b = this.amn;
            if (a != b) {
                this.al4 = a;
                this.wj("ZoomSliderXAxisMajorStrokeThickness", b, this.amn);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "aky", {
        get: function () {
            return this.akl;
        },
        set: function (a) {
            var b = this.aky;
            if (a != b) {
                this.akl = a;
                this.wj("IsLegendVisible", b, this.aky);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ajm", {
        get: function () {
            return this.ajl;
        },
        set: function (a) {
            var b = this.ajm;
            if (a != b) {
                this.ajl = a;
                this.wj("FinancialChartLegend", b, this.ajm);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "xAxis", {
        get: function () {
            return this.ail;
        },
        set: function (a) {
            var b = this.xAxis;
            if (a != b) {
                this.ail = a;
                this.wj("XAxis", b, this.xAxis);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "yAxis", {
        get: function () {
            return this.aj0;
        },
        set: function (a) {
            var b = this.yAxis;
            if (a != b) {
                this.aj0 = a;
                this.wj("YAxis", b, this.yAxis);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "volumeAxis", {
        get: function () {
            return this.ajz;
        },
        set: function (a) {
            var b = this.volumeAxis;
            if (a != b) {
                this.ajz = a;
                this.wj("VolumeAxis", b, this.volumeAxis);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "volumeXAxis", {
        get: function () {
            return this.aik;
        },
        set: function (a) {
            var b = this.volumeXAxis;
            if (a != b) {
                this.aik = a;
                this.wj("VolumeXAxis", b, this.volumeXAxis);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "indicatorAxis", {
        get: function () {
            return this.ajy;
        },
        set: function (a) {
            var b = this.indicatorAxis;
            if (a != b) {
                this.ajy = a;
                this.wj("IndicatorAxis", b, this.indicatorAxis);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "indicatorXAxis", {
        get: function () {
            return this.aij;
        },
        set: function (a) {
            var b = this.indicatorXAxis;
            if (a != b) {
                this.aij = a;
                this.wj("IndicatorXAxis", b, this.indicatorXAxis);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "alg", {
        get: function () {
            return this.ald;
        },
        set: function (a) {
            var b = this.alg;
            if (a != b) {
                this.ald = a;
                this.wj("IndicatorAxes", b, this.alg);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ali", {
        get: function () {
            return this.alf;
        },
        set: function (a) {
            var b = this.ali;
            if (a != b) {
                this.alf = a;
                this.wj("IndicatorXAxes", b, this.ali);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "alo", {
        get: function () {
            return this.alm;
        },
        set: function (a) {
            var b = this.alo;
            if (+a != +b) {
                this.alm = a;
                this.wj("XAxisMinimumValue", b, this.alo);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "aln", {
        get: function () {
            return this.all;
        },
        set: function (a) {
            var b = this.aln;
            if (+a != +b) {
                this.all = a;
                this.wj("XAxisMaximumValue", b, this.aln);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "xAxisBreaks", {
        get: function () {
            return this.alj;
        },
        enumerable: false,
        configurable: true
    });
    FinancialChart.$t = markType(FinancialChart, 'FinancialChart', XYChart.$);
    FinancialChart.am6 = 0;
    FinancialChart.ao2 = "XAxisEnhancedIntervalPreferMoreCategoryLabels";
    FinancialChart.apd = "YAxisEnhancedIntervalPreferMoreCategoryLabels";
    return FinancialChart;
}(XYChart));
export { FinancialChart };
/**
 * @hidden
 */
var FinancialChartToolbar = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(FinancialChartToolbar, _super);
    function FinancialChartToolbar(a, b) {
        var _this = _super.call(this, "financialChartToolbar", b, "") || this;
        _this.o = null;
        _this.r = null;
        _this.z = null;
        _this.p = null;
        _this.w = null;
        _this.aq = dateMaxValue();
        _this.ap = dateMinValue();
        _this.ao = dateMaxValue();
        _this.an = dateMinValue();
        _this.rangeChanged = null;
        _this.chartTypeChanged = null;
        _this.trendLineTypeChanged = null;
        _this.volumeTypeChanged = null;
        _this.indicatorTypesChanged = null;
        _this.overlayTypesChanged = null;
        _this.x = 0;
        _this.ah = 0;
        _this.ab = 0;
        _this.ad = null;
        _this.af = null;
        _this.t = null;
        _this.ak = false;
        _this.o = a;
        _this.w = new FinancialChartToolbarViewModel();
        _this.s = new FinancialChartRangeSelector(a != null ? a.ani : null);
        _this.aa = new FinancialChartTypePicker(a != null ? a.anf : null);
        _this.q = new FinancialChartIndicatorMenu(1, a != null ? a.ang : null);
        return _this;
    }
    FinancialChartToolbar.prototype.bg = function (a) {
        var b = a.querySelectorAll(".financialChartToolbarArea");
        if (b != null && b.length > 0) {
            this.g = b[0];
            if (!this.al) {
                this.g.hide();
            }
        }
        var c = a.querySelectorAll(".financialChartIndicatorMenu");
        if (c != null && c.length > 0) {
            this.q.g = c[0];
        }
        var d = a.querySelectorAll(".financialChartRangeSelector");
        if (d != null && d.length > 0) {
            this.s.g = d[0];
        }
        var e = a.querySelectorAll(".financialChartTypePicker");
        if (e != null && e.length > 0) {
            this.aa.g = e[0];
        }
    };
    FinancialChartToolbar.prototype.bl = function (a) {
        this.q.u(a);
        this.aa.u(a);
    };
    Object.defineProperty(FinancialChartToolbar.prototype, "s", {
        get: function () {
            return this.r;
        },
        set: function (a) {
            var b = this.s;
            if (a != b) {
                this.r = a;
                this.bm("RangeSelector", b, this.s);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChartToolbar.prototype, "aa", {
        get: function () {
            return this.z;
        },
        set: function (a) {
            var b = this.aa;
            if (a != b) {
                this.z = a;
                this.bm("ChartTypePicker", b, this.aa);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChartToolbar.prototype, "q", {
        get: function () {
            return this.p;
        },
        set: function (a) {
            var b = this.q;
            if (a != b) {
                this.p = a;
                this.bm("IndicatorMenu", b, this.q);
            }
        },
        enumerable: false,
        configurable: true
    });
    FinancialChartToolbar.prototype.bm = function (a, b, c) {
        switch (a) {
            case "RangeStart":
                if (this.s != null) {
                    this.s.t = this.as;
                }
                break;
            case "RangeEnd":
                if (this.s != null) {
                    this.s.s = this.ar;
                }
                break;
            case "SelectionStart":
                if (this.s != null) {
                    this.s.v = this.au;
                }
                break;
            case "SelectionEnd":
                if (this.s != null) {
                    this.s.u = this.at;
                }
                break;
            case "RangeSelector":
                var d = b;
                if (d != null) {
                    d.rangeChanged = delegateRemove(d.rangeChanged, runOn(this, this.bj));
                }
                if (this.s != null) {
                    this.s.t = this.as;
                    this.s.s = this.ar;
                    this.s.o = this.u;
                    this.s.v = this.au;
                    this.s.u = this.at;
                    var e = this.s;
                    e.rangeChanged = delegateCombine(e.rangeChanged, runOn(this, this.bj));
                }
                break;
            case "ChartTypePicker":
                var f = b;
                if (f != null) {
                    f.selectionChanged = delegateRemove(f.selectionChanged, runOn(this, this.bi));
                }
                if (this.aa != null) {
                    this.aa.w = this.y;
                    var g = this.aa;
                    g.selectionChanged = delegateCombine(g.selectionChanged, runOn(this, this.bi));
                }
                break;
            case "ChartType":
                if (this.aa != null) {
                    this.aa.w = this.y;
                }
                break;
            case "RangeSelectorOptions":
                if (this.s != null) {
                    this.s.o = this.u;
                }
                break;
            case "IsToolbarVisible":
                if (this.g == null) {
                    break;
                }
                if (this.al) {
                    this.g.show();
                }
                else {
                    this.g.hide();
                }
                break;
            case "IndicatorMenu":
                var h = typeCast(FinancialChartIndicatorMenu.$, b);
                if (h != null) {
                    h.selectionChanged = delegateRemove(h.selectionChanged, runOn(this, this.bh));
                }
                if (this.q != null) {
                    var i = this.q;
                    i.selectionChanged = delegateCombine(i.selectionChanged, runOn(this, this.bh));
                }
                break;
            case "IndicatorTypes":
                if (this.indicatorTypesChanged != null) {
                    this.indicatorTypesChanged(this, EventArgs.empty);
                }
                break;
            case "OverlayTypes":
                if (this.overlayTypesChanged != null) {
                    this.overlayTypesChanged(this, EventArgs.empty);
                }
                break;
            case "TrendLineType":
                if (this.trendLineTypeChanged != null) {
                    this.trendLineTypeChanged(this, EventArgs.empty);
                }
                break;
            case "VolumeType":
                if (this.volumeTypeChanged != null) {
                    this.volumeTypeChanged(this, EventArgs.empty);
                }
                break;
        }
    };
    FinancialChartToolbar.prototype.bh = function (a, b) {
        this.ag = this.q.z;
        this.ae = this.q.y;
        this.ai = this.q.aa;
        this.ac = this.q.x;
    };
    FinancialChartToolbar.prototype.bi = function (a, b) {
        this.y = this.aa.w;
        if (this.chartTypeChanged != null) {
            this.chartTypeChanged(this, b);
        }
    };
    FinancialChartToolbar.prototype.bj = function (a, b) {
        this.au = this.s.v;
        this.at = this.s.u;
        if (this.rangeChanged != null) {
            this.rangeChanged(this, b);
        }
    };
    FinancialChartToolbar.prototype.v = function () {
        var _this = this;
        var a = new FinancialChartToolbarContext();
        a.container = this.d;
        a.vm = this.w;
        a.vm.financialChartIndicatorMenu = ((function () {
            var $ret = new FinancialChartIndicatorMenuContext();
            $ret.vm = _this.q.p;
            return $ret;
        })());
        a.vm.financialChartTypePicker = ((function () {
            var $ret = new FinancialChartTypePickerContext();
            $ret.vm = _this.aa.p;
            return $ret;
        })());
        a.vm.financialChartRangeSelector = ((function () {
            var $ret = new FinancialChartRangeSelectorContext();
            $ret.vm = _this.s.q;
            return $ret;
        })());
        return a;
    };
    FinancialChartToolbar.prototype.l = function (a) {
        _super.prototype.l.call(this, a);
        if (a == null) {
            return;
        }
        this.s.l(a);
        this.aa.l(a);
        this.q.l(a);
        this.bk();
    };
    FinancialChartToolbar.prototype.bk = function () {
    };
    Object.defineProperty(FinancialChartToolbar.prototype, "au", {
        get: function () {
            return this.aq;
        },
        set: function (a) {
            var b = this.au;
            if (+a != +b) {
                this.aq = a;
                this.bm("SelectionStart", b, this.au);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChartToolbar.prototype, "at", {
        get: function () {
            return this.ap;
        },
        set: function (a) {
            var b = this.at;
            if (+a != +b) {
                this.ap = a;
                this.bm("SelectionEnd", b, this.at);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChartToolbar.prototype, "as", {
        get: function () {
            return this.ao;
        },
        set: function (a) {
            var b = this.as;
            if (+a != +b) {
                this.ao = a;
                this.bm("RangeStart", b, this.as);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChartToolbar.prototype, "ar", {
        get: function () {
            return this.an;
        },
        set: function (a) {
            var b = this.ar;
            if (+a != +b) {
                this.an = a;
                this.bm("RangeEnd", b, this.ar);
            }
        },
        enumerable: false,
        configurable: true
    });
    FinancialChartToolbar.prototype.bn = function () {
        if (this.s != null) {
            this.s.ab();
        }
    };
    Object.defineProperty(FinancialChartToolbar.prototype, "y", {
        get: function () {
            return this.x;
        },
        set: function (a) {
            var b = this.y;
            if (a != b) {
                this.x = a;
                this.bm("ChartType", enumGetBox(FinancialChartType_$type, b), enumGetBox(FinancialChartType_$type, this.y));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChartToolbar.prototype, "ai", {
        get: function () {
            return this.ah;
        },
        set: function (a) {
            var b = this.ai;
            if (a != b) {
                this.ah = a;
                this.bm("TrendLineType", enumGetBox(TrendLineType_$type, b), enumGetBox(TrendLineType_$type, this.ai));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChartToolbar.prototype, "ac", {
        get: function () {
            return this.ab;
        },
        set: function (a) {
            var b = this.ac;
            if (a != b) {
                this.ab = a;
                this.bm("VolumeType", enumGetBox(FinancialChartVolumeType_$type, b), enumGetBox(FinancialChartVolumeType_$type, this.ac));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChartToolbar.prototype, "ae", {
        get: function () {
            return this.ad;
        },
        set: function (a) {
            var b = this.ae;
            if (!FinancialChartToolbar.am(b, a)) {
                this.ad = a;
                this.bm("IndicatorTypes", b, this.ae);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChartToolbar.prototype, "ag", {
        get: function () {
            return this.af;
        },
        set: function (a) {
            var b = this.ag;
            if (!FinancialChartToolbar.am(b, a)) {
                this.af = a;
                this.bm("OverlayTypes", b, this.ag);
            }
        },
        enumerable: false,
        configurable: true
    });
    FinancialChartToolbar.am = function (a, b) {
        var e_21, _a;
        if (a == b) {
            return true;
        }
        if ((a == null && b != null) || (a != null && b == null)) {
            return false;
        }
        if (a.count != b.count) {
            return false;
        }
        try {
            for (var _b = __values(fromEn(a)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var c = _c.value;
                if (!b.contains(c)) {
                    return false;
                }
            }
        }
        catch (e_21_1) {
            e_21 = { error: e_21_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_21)
                    throw e_21.error;
            }
        }
        return true;
    };
    FinancialChartToolbar.prototype.aj = function () {
        var _this = this;
        return ((function () {
            var $ret = new FinancialChartToolbarVisualData();
            $ret.rangeSelector = _this.s == null ? null : _this.s.r();
            return $ret;
        })());
    };
    Object.defineProperty(FinancialChartToolbar.prototype, "u", {
        get: function () {
            return this.t;
        },
        set: function (a) {
            var b = this.u;
            if (a != b) {
                this.t = a;
                this.bm("RangeSelectorOptions", b, this.u);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChartToolbar.prototype, "al", {
        get: function () {
            return this.ak;
        },
        set: function (a) {
            var b = this.al;
            if (a != b) {
                this.ak = a;
                this.bm("IsToolbarVisible", b, this.al);
            }
        },
        enumerable: false,
        configurable: true
    });
    FinancialChartToolbar.$t = markType(FinancialChartToolbar, 'FinancialChartToolbar', TemplatedHtmlControl.$);
    return FinancialChartToolbar;
}(TemplatedHtmlControl));
export { FinancialChartToolbar };
/**
 * @hidden
 */
var FinancialChartRangeSelector = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(FinancialChartRangeSelector, _super);
    function FinancialChartRangeSelector(a) {
        var _this = _super.call(this, "financialChartRangeSelector", a, "") || this;
        _this.q = null;
        _this.rangeChanged = null;
        _this.p = null;
        _this.p = new FinancialChartRangeSelectorView();
        _this.q = new FinancialChartRangeSelectorViewModel();
        _this.q.onRangeChanged = runOn(_this, _this.z);
        _this.p.c = _this.q;
        return _this;
    }
    Object.defineProperty(FinancialChartRangeSelector.prototype, "v", {
        get: function () {
            return this.q.selectionStart;
        },
        set: function (a) {
            this.q.selectionStart = a;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChartRangeSelector.prototype, "u", {
        get: function () {
            return this.q.selectionEnd;
        },
        set: function (a) {
            this.q.selectionEnd = a;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChartRangeSelector.prototype, "t", {
        get: function () {
            return this.q.rangeStart;
        },
        set: function (a) {
            this.q.rangeStart = a;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChartRangeSelector.prototype, "s", {
        get: function () {
            return this.q.rangeEnd;
        },
        set: function (a) {
            this.q.rangeEnd = a;
        },
        enumerable: false,
        configurable: true
    });
    FinancialChartRangeSelector.prototype.ab = function () {
        if (this.q.onPropertiesChanged()) {
            this.p.g(this.q);
        }
    };
    FinancialChartRangeSelector.prototype.l = function (a) {
        _super.prototype.l.call(this, a);
        this.p.f(this.d, this.q);
    };
    FinancialChartRangeSelector.prototype.z = function () {
        if (this.rangeChanged != null) {
            this.rangeChanged(this, EventArgs.empty);
        }
    };
    FinancialChartRangeSelector.prototype.r = function () {
        return this.p.d(this.g);
    };
    Object.defineProperty(FinancialChartRangeSelector.prototype, "o", {
        get: function () {
            return this.q.options;
        },
        set: function (a) {
            var b = !FinancialChartToolbar.am(this.q.options, a);
            if (b) {
                this.q.options = a;
                this.aa();
            }
        },
        enumerable: false,
        configurable: true
    });
    FinancialChartRangeSelector.prototype.aa = function () {
        var a = false;
        if (this.q != null) {
            a = this.q.p();
        }
        if (this.p != null) {
            this.p.i(this.o);
            if (a) {
                if (this.q.notifyChanged != null) {
                    this.q.notifyChanged();
                }
            }
        }
    };
    FinancialChartRangeSelector.$t = markType(FinancialChartRangeSelector, 'FinancialChartRangeSelector', TemplatedHtmlControl.$);
    FinancialChartRangeSelector.x = 0;
    return FinancialChartRangeSelector;
}(TemplatedHtmlControl));
export { FinancialChartRangeSelector };
