/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends, __values } from "tslib";
import { DomainChart } from "./DomainChart";
import { fromEnum, enumGetBox, markType } from "igniteui-react-core";
import { HorizontalAlignment_$type } from "igniteui-react-core";
import { VerticalAlignment_$type } from "igniteui-react-core";
import { Visibility_$type } from "igniteui-react-core";
import { ValueAxisLabelLocation_$type } from "./ValueAxisLabelLocation";
import { AngleAxisLabelLocation_$type } from "./AngleAxisLabelLocation";
import { AxisLabelSettings } from "./AxisLabelSettings";
import { AxisDefaults } from "./AxisDefaults";
import { TitleSettings } from "./TitleSettings";
import { ScalerParams } from "./ScalerParams";
import { DeviceUtils } from "igniteui-react-core";
/**
 * @hidden
 */
var RadialBaseChart = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(RadialBaseChart, _super);
    function RadialBaseChart() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.aay = null;
        _this.aaz = null;
        _this.abd = 0;
        _this.abf = 5;
        _this.abe = 0;
        _this.abc = 5;
        _this.abw = 5;
        _this.aby = 0;
        _this.abx = 5;
        _this.abv = 0;
        _this.agz = null;
        _this.ag6 = null;
        _this.agx = null;
        _this.agy = null;
        _this.abq = 0;
        _this.ab9 = 0;
        _this.abp = NaN;
        _this.ab8 = NaN;
        _this.abs = NaN;
        _this.acb = NaN;
        _this.abr = NaN;
        _this.aca = NaN;
        _this.abo = NaN;
        _this.ab7 = NaN;
        _this.ag5 = null;
        _this.ahc = null;
        _this.adn = null;
        _this.adr = null;
        _this.adp = null;
        _this.adt = null;
        _this.adi = null;
        _this.adj = null;
        _this.ag0 = null;
        _this.ag7 = null;
        _this.abg = DeviceUtils.g(1);
        _this.abz = DeviceUtils.g(1);
        _this.abj = DeviceUtils.g(1);
        _this.ab2 = DeviceUtils.g(1);
        _this.ag2 = null;
        _this.ag9 = null;
        _this.ag3 = null;
        _this.aha = null;
        _this.abk = DeviceUtils.g(1);
        _this.ab3 = DeviceUtils.g(1);
        _this.abl = DeviceUtils.g(8);
        _this.ab4 = 0;
        _this.ag4 = null;
        _this.ahb = null;
        _this.abm = DeviceUtils.g(1);
        _this.ab5 = DeviceUtils.g(1);
        _this.ado = null;
        _this.ads = null;
        _this.ag1 = null;
        _this.ag8 = null;
        _this.abb = 0;
        _this.abu = 0;
        _this.aba = NaN;
        _this.abh = NaN;
        _this.abi = NaN;
        _this.abt = NaN;
        _this.ab0 = NaN;
        _this.ab1 = NaN;
        _this.abn = 0;
        _this.ab6 = -90;
        _this.aa6 = false;
        _this.aa7 = false;
        _this.ags = 1;
        _this.ahv = 1;
        _this.agr = 1;
        _this.agt = 2;
        _this.aht = 0;
        _this.ahu = 1;
        _this.ahz = 0;
        _this.ah0 = 0;
        _this.aa4 = 4;
        _this.aau = 4;
        _this.adm = null;
        _this.aaq = null;
        _this.adq = null;
        _this.aar = null;
        return _this;
    }
    RadialBaseChart.prototype.provideContainer = function (a) {
        if (a != null) {
            var b = this.aaw();
            var c = this.aax();
            if (b != null) {
                b.provideRenderer(a);
            }
            if (c != null) {
                c.provideRenderer(a);
            }
        }
        _super.prototype.provideContainer.call(this, a);
    };
    RadialBaseChart.prototype.vs = function () {
        _super.prototype.vs.call(this);
        var a = this.aaw();
        var b = this.aax();
        if (a != null && a.az != null) {
            this.ahf = a.az.textColor;
        }
        if (b != null && b.az != null) {
            this.ahm = b.az.textColor;
        }
        this.ahk = AxisDefaults.axis_TickBrush;
        this.ahr = AxisDefaults.axis_TickBrush;
        this.ahg = AxisDefaults.axis_MajorBrush;
        this.ahn = AxisDefaults.axis_MajorBrush;
        this.ahj = AxisDefaults.axis_LineBrush;
        this.ahq = AxisDefaults.axis_LineBrush;
    };
    RadialBaseChart.prototype.wn = function (a, b, c) {
        var _this = this;
        _super.prototype.wn.call(this, a, b, c);
        switch (a) {
            case "AngleAxisLabelLeftMargin":
                this.agj(function (d) { return d.leftMargin = _this.acf; });
                break;
            case "AngleAxisLabelTopMargin":
                this.agj(function (d) { return d.topMargin = _this.ach; });
                break;
            case "AngleAxisLabelRightMargin":
                this.agj(function (d) { return d.rightMargin = _this.acg; });
                break;
            case "AngleAxisLabelBottomMargin":
                this.agj(function (d) { return d.bottomMargin = _this.ace; });
                break;
            case "ValueAxisLabelLeftMargin":
                this.ago(function (d) { return d.leftMargin = _this.ac2; });
                break;
            case "ValueAxisLabelTopMargin":
                this.ago(function (d) { return d.topMargin = _this.ac4; });
                break;
            case "ValueAxisLabelRightMargin":
                this.ago(function (d) { return d.rightMargin = _this.ac3; });
                break;
            case "ValueAxisLabelBottomMargin":
                this.ago(function (d) { return d.bottomMargin = _this.ac1; });
                break;
            case "ActualItemsSource":
            case "ShouldDisplayMockData":
            case "ShouldUseSkeletonStyleForMockData":
                this.ahd = this.zo(this.ahf);
                this.ahe = this.zo(this.ahm);
                break;
            case "AngleAxisLabelTextColor":
                this.ahd = this.zo(this.ahf);
                break;
            case "ValueAxisLabelTextColor":
                this.ahe = this.zo(this.ahm);
                break;
            case "ActualAngleAxisLabelTextColor":
                this.agj(function (d) { return d.textColor = _this.ahd; });
                break;
            case "ActualValueAxisLabelTextColor":
                this.ago(function (d) { return d.textColor = _this.ahe; });
                break;
            case "AngleAxisTitleMargin":
                this.agl(function (d) { return d.margin = _this.acs; });
                break;
            case "ValueAxisTitleMargin":
                this.agq(function (d) { return d.margin = _this.adf; });
                break;
            case "AngleAxisTitleLeftMargin":
                this.agl(function (d) { return d.leftMargin = _this.acr; });
                break;
            case "ValueAxisTitleLeftMargin":
                this.agq(function (d) { return d.leftMargin = _this.ade; });
                break;
            case "AngleAxisTitleTopMargin":
                this.agl(function (d) { return d.topMargin = _this.acu; });
                break;
            case "ValueAxisTitleTopMargin":
                this.agq(function (d) { return d.topMargin = _this.adh; });
                break;
            case "AngleAxisTitleRightMargin":
                this.agl(function (d) { return d.rightMargin = _this.act; });
                break;
            case "ValueAxisTitleRightMargin":
                this.agq(function (d) { return d.rightMargin = _this.adg; });
                break;
            case "AngleAxisTitleBottomMargin":
                this.agl(function (d) { return d.bottomMargin = _this.acq; });
                break;
            case "ValueAxisTitleBottomMargin":
                this.agq(function (d) { return d.bottomMargin = _this.add; });
                break;
            case "AngleAxisTitleTextColor":
                this.agl(function (d) { return d.textColor = _this.ahl; });
                break;
            case "ValueAxisTitleTextColor":
                this.agq(function (d) { return d.textColor = _this.ahs; });
                break;
            case "AngleAxisFormatLabel":
                this.agh(function (d) { return d.au = _this.aa0; });
                break;
            case "ValueAxisFormatLabel":
                this.agm(function (d) { return d.au = _this.aa1; });
                break;
        }
    };
    Object.defineProperty(RadialBaseChart.prototype, "aa0", {
        get: function () {
            return this.aay;
        },
        set: function (a) {
            var b = this.aa0;
            if (a != b) {
                this.aay = a;
                this.wj("AngleAxisFormatLabel", b, this.aa0);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "aa1", {
        get: function () {
            return this.aaz;
        },
        set: function (a) {
            var b = this.aa1;
            if (a != b) {
                this.aaz = a;
                this.wj("ValueAxisFormatLabel", b, this.aa1);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "acf", {
        get: function () {
            return this.abd;
        },
        set: function (a) {
            var b = this.acf;
            if (a != b) {
                this.abd = a;
                this.wj("AngleAxisLabelLeftMargin", b, this.acf);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "ach", {
        get: function () {
            return this.abf;
        },
        set: function (a) {
            var b = this.ach;
            if (a != b) {
                this.abf = a;
                this.wj("AngleAxisLabelTopMargin", b, this.ach);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "acg", {
        get: function () {
            return this.abe;
        },
        set: function (a) {
            var b = this.acg;
            if (a != b) {
                this.abe = a;
                this.wj("AngleAxisLabelRightMargin", b, this.acg);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "ace", {
        get: function () {
            return this.abc;
        },
        set: function (a) {
            var b = this.ace;
            if (a != b) {
                this.abc = a;
                this.wj("AngleAxisLabelBottomMargin", b, this.ace);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "ac2", {
        get: function () {
            return this.abw;
        },
        set: function (a) {
            var b = this.ac2;
            if (a != b) {
                this.abw = a;
                this.wj("ValueAxisLabelLeftMargin", b, this.ac2);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "ac4", {
        get: function () {
            return this.aby;
        },
        set: function (a) {
            var b = this.ac4;
            if (a != b) {
                this.aby = a;
                this.wj("ValueAxisLabelTopMargin", b, this.ac4);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "ac3", {
        get: function () {
            return this.abx;
        },
        set: function (a) {
            var b = this.ac3;
            if (a != b) {
                this.abx = a;
                this.wj("ValueAxisLabelRightMargin", b, this.ac3);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "ac1", {
        get: function () {
            return this.abv;
        },
        set: function (a) {
            var b = this.ac1;
            if (a != b) {
                this.abv = a;
                this.wj("ValueAxisLabelBottomMargin", b, this.ac1);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "ahf", {
        get: function () {
            return this.agz;
        },
        set: function (a) {
            var b = this.ahf;
            if (a != b) {
                this.agz = a;
                this.wj("AngleAxisLabelTextColor", b, this.ahf);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "ahm", {
        get: function () {
            return this.ag6;
        },
        set: function (a) {
            var b = this.ahm;
            if (a != b) {
                this.ag6 = a;
                this.wj("ValueAxisLabelTextColor", b, this.ahm);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "ahd", {
        get: function () {
            return this.agx;
        },
        set: function (a) {
            var b = this.agx;
            if (a != b) {
                this.agx = a;
                this.wj("ActualAngleAxisLabelTextColor", b, this.ahd);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "ahe", {
        get: function () {
            return this.agy;
        },
        set: function (a) {
            var b = this.agy;
            if (a != b) {
                this.agy = a;
                this.wj("ActualValueAxisLabelTextColor", b, this.ahe);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "acs", {
        get: function () {
            return this.abq;
        },
        set: function (a) {
            var b = this.acs;
            if (a != b) {
                this.abq = a;
                this.wj("AngleAxisTitleMargin", b, this.acs);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "adf", {
        get: function () {
            return this.ab9;
        },
        set: function (a) {
            var b = this.adf;
            if (a != b) {
                this.ab9 = a;
                this.wj("ValueAxisTitleMargin", b, this.adf);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "acr", {
        get: function () {
            return this.abp;
        },
        set: function (a) {
            var b = this.acr;
            if (a != b) {
                this.abp = a;
                this.wj("AngleAxisTitleLeftMargin", b, this.acr);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "ade", {
        get: function () {
            return this.ab8;
        },
        set: function (a) {
            var b = this.ade;
            if (a != b) {
                this.ab8 = a;
                this.wj("ValueAxisTitleLeftMargin", b, this.ade);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "acu", {
        get: function () {
            return this.abs;
        },
        set: function (a) {
            var b = this.acu;
            if (a != b) {
                this.abs = a;
                this.wj("AngleAxisTitleTopMargin", b, this.acu);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "adh", {
        get: function () {
            return this.acb;
        },
        set: function (a) {
            var b = this.adh;
            if (a != b) {
                this.acb = a;
                this.wj("ValueAxisTitleTopMargin", b, this.adh);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "act", {
        get: function () {
            return this.abr;
        },
        set: function (a) {
            var b = this.act;
            if (a != b) {
                this.abr = a;
                this.wj("AngleAxisTitleRightMargin", b, this.act);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "adg", {
        get: function () {
            return this.aca;
        },
        set: function (a) {
            var b = this.adg;
            if (a != b) {
                this.aca = a;
                this.wj("ValueAxisTitleRightMargin", b, this.adg);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "acq", {
        get: function () {
            return this.abo;
        },
        set: function (a) {
            var b = this.acq;
            if (a != b) {
                this.abo = a;
                this.wj("AngleAxisTitleBottomMargin", b, this.acq);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "add", {
        get: function () {
            return this.ab7;
        },
        set: function (a) {
            var b = this.add;
            if (a != b) {
                this.ab7 = a;
                this.wj("ValueAxisTitleBottomMargin", b, this.add);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "ahl", {
        get: function () {
            return this.ag5;
        },
        set: function (a) {
            var b = this.ahl;
            if (a != b) {
                this.ag5 = a;
                this.wj("AngleAxisTitleTextColor", b, this.ahl);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "ahs", {
        get: function () {
            return this.ahc;
        },
        set: function (a) {
            var b = this.ahs;
            if (a != b) {
                this.ahc = a;
                this.wj("ValueAxisTitleTextColor", b, this.ahs);
            }
        },
        enumerable: false,
        configurable: true
    });
    RadialBaseChart.prototype.wo = function (a, b, c) {
        var _this = this;
        _super.prototype.wo.call(this, a, b, c);
        switch (a) {
            case "AngleAxisLabelTextStyle":
                this.agj(function (d) { return d.textStyle = _this.aea; });
                break;
            case "ValueAxisLabelTextStyle":
                this.ago(function (d) { return d.textStyle = _this.afi; });
                break;
            case "AngleAxisTitleTextStyle":
                this.agl(function (d) { return d.textStyle = _this.ae0; });
                break;
            case "ValueAxisTitleTextStyle":
                this.agq(function (d) { return d.textStyle = _this.af8; });
                break;
        }
    };
    Object.defineProperty(RadialBaseChart.prototype, "aea", {
        get: function () {
            return this.adn;
        },
        set: function (a) {
            var b = this.aea;
            if (a != b) {
                this.adn = a;
                this.wj("AngleAxisLabelTextStyle", b, this.aea);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "afi", {
        get: function () {
            return this.adr;
        },
        set: function (a) {
            var b = this.afi;
            if (a != b) {
                this.adr = a;
                this.wj("ValueAxisLabelTextStyle", b, this.afi);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "ae0", {
        get: function () {
            return this.adp;
        },
        set: function (a) {
            var b = this.ae0;
            if (a != b) {
                this.adp = a;
                this.wj("AngleAxisTitleTextStyle", b, this.ae0);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "af8", {
        get: function () {
            return this.adt;
        },
        set: function (a) {
            var b = this.af8;
            if (a != b) {
                this.adt = a;
                this.wj("ValueAxisTitleTextStyle", b, this.af8);
            }
        },
        enumerable: false,
        configurable: true
    });
    RadialBaseChart.prototype.age = function (a) {
        var _this = this;
        this.agb(a, function (b) { return b.leftMargin = _this.acf; });
        this.agb(a, function (b) { return b.topMargin = _this.ach; });
        this.agb(a, function (b) { return b.rightMargin = _this.acg; });
        this.agb(a, function (b) { return b.bottomMargin = _this.ace; });
        this.agb(a, function (b) { return b.textColor = _this.ahd; });
        this.agc(a, function (b) { return b.textColor = _this.ahl; });
        this.agc(a, function (b) { return b.leftMargin = _this.acr; });
        this.agc(a, function (b) { return b.topMargin = _this.acu; });
        this.agc(a, function (b) { return b.rightMargin = _this.act; });
        this.agc(a, function (b) { return b.bottomMargin = _this.acq; });
        this.agb(a, function (b) { return b.textStyle = _this.aea; });
        this.agc(a, function (b) { return b.textStyle = _this.ae0; });
    };
    RadialBaseChart.prototype.agg = function (a) {
        var _this = this;
        this.agb(a, function (b) { return b.leftMargin = _this.ac2; });
        this.agb(a, function (b) { return b.topMargin = _this.ac4; });
        this.agb(a, function (b) { return b.rightMargin = _this.ac3; });
        this.agb(a, function (b) { return b.bottomMargin = _this.ac1; });
        this.agb(a, function (b) { return b.textColor = _this.ahe; });
        this.agc(a, function (b) { return b.textColor = _this.ahs; });
        this.agc(a, function (b) { return b.leftMargin = _this.ade; });
        this.agc(a, function (b) { return b.topMargin = _this.adh; });
        this.agc(a, function (b) { return b.rightMargin = _this.adg; });
        this.agc(a, function (b) { return b.bottomMargin = _this.add; });
        this.agb(a, function (b) { return b.textStyle = _this.afi; });
        this.agc(a, function (b) { return b.textStyle = _this.af8; });
    };
    RadialBaseChart.prototype.xf = function (a) {
        var b = this.be(a);
        var c = this.dc(a, b);
        if (c == null) {
            return;
        }
        c.itemsSource = this.ia(a);
        if (a.highlightedData != null) {
            c.highlightedItemsSource = this.ib(a);
        }
        c.name = this.q6(a);
        c.title = this.q7(a, b);
        this.dataChart.series.add(c);
    };
    RadialBaseChart.prototype.agh = function (a) {
        this.agi(a, null);
    };
    RadialBaseChart.prototype.agi = function (a, b) {
        a(this.aaw());
    };
    RadialBaseChart.prototype.agn = function (a, b) {
        a(this.aax());
    };
    RadialBaseChart.prototype.agm = function (a) {
        this.agn(a, true);
    };
    RadialBaseChart.prototype.vb = function (a, b) {
        this.agh(a);
        this.agn(a, b);
    };
    RadialBaseChart.prototype.agl = function (a) {
        this.agc(this.aaw(), a);
    };
    RadialBaseChart.prototype.agq = function (a) {
        this.agc(this.aax(), a);
    };
    RadialBaseChart.prototype.ago = function (a) {
        this.agb(this.aax(), a);
    };
    RadialBaseChart.prototype.agj = function (a) {
        this.agb(this.aaw(), a);
    };
    RadialBaseChart.prototype.acv = function (a) {
        var b = this.aaw();
        return b.el(a, new ScalerParams(1, this.zx, this.zw, b.ch));
    };
    RadialBaseChart.prototype.acx = function (a) {
        var b = this.aaw();
        return b.eo(a, new ScalerParams(1, this.zx, this.zw, b.ch));
    };
    RadialBaseChart.prototype.acw = function (a) {
        var b = this.aax();
        return b.el(a, new ScalerParams(1, this.zx, this.zw, b.ch));
    };
    RadialBaseChart.prototype.acy = function (a) {
        var b = this.aax();
        return b.eo(a, new ScalerParams(1, this.zx, this.zw, b.ch));
    };
    RadialBaseChart.prototype.xc = function (a) {
        _super.prototype.xc.call(this, a);
        if (a == null) {
            return;
        }
        if (a.axes != null) {
            var b = this.aaw();
            var c = this.aax();
            if (a.axes.contains(b)) {
                a.axes.remove(b);
            }
            if (a.axes.contains(c)) {
                a.axes.remove(c);
            }
        }
    };
    RadialBaseChart.ae3 = function (a, b) {
        var e_1, _a;
        try {
            for (var _b = __values(fromEnum(b)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var c = _c.value;
                var d = c.findMatchingHint(16);
                if (d != null) {
                    var e = d.path;
                    return e;
                }
            }
        }
        catch (e_1_1) {
            e_1 = { error: e_1_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_1)
                    throw e_1.error;
            }
        }
        return null;
    };
    RadialBaseChart.prototype.vn = function (a, b) {
        _super.prototype.vn.call(this, a, b);
        if (a == this.dataChart) {
            this.dataChart.axes.add(this.aaw());
            this.dataChart.axes.add(this.aax());
        }
    };
    RadialBaseChart.prototype.agd = function (a) {
        var _this = this;
        if (a != null && this.l8 != null && a.fn == null) {
            a.provideRenderer(this.l8);
        }
        a.jz = this.ahg;
        a.et = this.aci;
        a.j0 = this.ahh;
        a.ew = this.acl;
        a.j2 = this.ahj;
        a.fi = this.acm;
        a.j1 = this.ahi;
        a.fj = this.acn;
        a.j3 = this.ahk;
        a.fk = this.aco;
        a.c4 = true;
        a.cu = this.shouldAvoidAxisAnnotationCollisions;
        a.cw = this.shouldAvoidAxisAnnotationCollisions;
        var b = a == this.aaw();
        if (b) {
            a.g8 = this.aer;
        }
        a.f2 = this.adk;
        a.gi = this.ad1;
        a.ah = this.aas;
        this.agb(a, function (c) { return c.angle = _this.acd; });
        this.agb(a, function (c) {
            if (c.extent != _this.acc) {
                c.extent = _this.acc;
            }
        });
        this.agb(a, function (c) {
            if (c.maximumExtent != _this.acj) {
                c.maximumExtent = _this.acj;
            }
        });
        this.agb(a, function (c) {
            if (c.maximumExtentPercentage != _this.ack) {
                c.maximumExtentPercentage = _this.ack;
            }
        });
        this.agb(a, function (c) { return c.horizontalAlignment = _this.agu; });
        this.agb(a, function (c) { return c.verticalAlignment = _this.ahw; });
        this.agb(a, function (c) { return c.visibility = _this.ah1; });
        this.agb(a, function (c) { return c.location = _this.aa2(_this.aav); });
        this.agc(a, function (c) { return c.horizontalAlignment = _this.agv; });
        this.agc(a, function (c) { return c.angle = _this.acp; });
        this.age(a);
    };
    RadialBaseChart.prototype.agf = function (a) {
        var _this = this;
        if (a == null) {
            return;
        }
        if (this.l8 != null && a.fn == null) {
            a.provideRenderer(this.l8);
        }
        a.cu = this.shouldAvoidAxisAnnotationCollisions;
        a.cw = this.shouldAvoidAxisAnnotationCollisions;
        this.agb(a, function (b) { return b.angle = _this.ac0; });
        this.agb(a, function (b) {
            if (b.extent != _this.acz) {
                b.extent = _this.acz;
            }
        });
        this.agb(a, function (b) {
            if (b.maximumExtent != _this.ac6) {
                b.maximumExtent = _this.ac6;
            }
        });
        this.agb(a, function (b) {
            if (b.maximumExtentPercentage != _this.ac7) {
                b.maximumExtentPercentage = _this.ac7;
            }
        });
        this.agb(a, function (b) { return b.horizontalAlignment = _this.agw; });
        this.agb(a, function (b) { return b.verticalAlignment = _this.ahx; });
        this.agb(a, function (b) { return b.visibility = _this.ah2; });
        this.agb(a, function (b) { return b.location = _this.aa3(_this.aa5); });
        this.agc(a, function (b) { return b.verticalAlignment = _this.ahy; });
        this.agc(a, function (b) { return b.angle = _this.adc; });
        a.jz = this.ahn;
        a.et = this.ac5;
        a.j0 = this.aho;
        a.ew = this.ac8;
        a.j2 = this.ahq;
        a.fi = this.ac9;
        a.j1 = this.ahp;
        a.fj = this.ada;
        a.j3 = this.ahr;
        a.fk = this.adb;
        var b = a == this.aax();
        if (b) {
            a.g8 = this.afz;
        }
        a.gi = this.ae9;
        a.ah = this.aat;
        this.agg(a);
    };
    RadialBaseChart.prototype.vk = function () {
        _super.prototype.vk.call(this);
        this.agd(this.aaw());
        this.agf(this.aax());
    };
    RadialBaseChart.prototype.agb = function (a, b) {
        if (a == null) {
            return;
        }
        if (a.az == null) {
            a.az = new AxisLabelSettings();
            a.az.angle = a.d7();
            a.az.bottomMargin = a.d8();
            a.az.leftMargin = a.d9();
            a.az.rightMargin = a.ea();
            a.az.topMargin = a.eb();
            a.az.horizontalAlignment = a.ju();
            a.az.location = a.a0();
            a.az.verticalAlignment = a.ko();
        }
        b(a.az);
    };
    RadialBaseChart.prototype.agc = function (a, b) {
        if (a == null) {
            return;
        }
        if (a.bf == null) {
            a.bf = new TitleSettings();
            a.bf.bottomMargin = a.ed();
            a.bf.leftMargin = a.ee();
            a.bf.rightMargin = a.ef();
            a.bf.topMargin = a.eg();
            a.bf.location = a.a1();
            a.bf.angle = a.ec();
            a.bf.horizontalAlignment = a.jv();
            a.bf.verticalAlignment = a.kp();
        }
        b(a.bf);
    };
    RadialBaseChart.prototype.wj = function (a, b, c) {
        var _this = this;
        _super.prototype.wj.call(this, a, b, c);
        switch (a) {
            case "AngleAxisLabelAngle":
                this.agj(function (d) { return d.angle = _this.acd; });
                break;
            case "ValueAxisLabelAngle":
                this.ago(function (d) { return d.angle = _this.ac0; });
                break;
            case "AngleAxisLabelHorizontalAlignment":
                this.agj(function (d) { return d.horizontalAlignment = _this.agu; });
                break;
            case "ValueAxisLabelHorizontalAlignment":
                this.ago(function (d) { return d.horizontalAlignment = _this.agw; });
                break;
            case "AngleAxisLabelVerticalAlignment":
                this.agj(function (d) { return d.verticalAlignment = _this.ahw; });
                break;
            case "ValueAxisLabelVerticalAlignment":
                this.ago(function (d) { return d.verticalAlignment = _this.ahx; });
                break;
            case "AngleAxisLabelVisibility":
                this.agj(function (d) { return d.visibility = _this.ah1; });
                break;
            case "ValueAxisLabelVisibility":
                this.ago(function (d) { return d.visibility = _this.ah2; });
                break;
            case "AngleAxisLabel":
                this.agh(function (d) { return d.f2 = _this.adk; });
                break;
            case "ValueAxisLabel":
                this.agm(function (d) { return d.f2 = _this.adl; });
                break;
            case "AngleAxisLabelFormat":
                this.agh(function (d) { return d.gi = _this.ad1; });
                break;
            case "AngleAxisLabelFormatSpecifiers":
                this.agh(function (d) { return d.ah = _this.aas; });
                break;
            case "ValueAxisLabelFormat":
                this.agm(function (d) { return d.gi = _this.ae9; });
                break;
            case "ValueAxisLabelFormatSpecifiers":
                this.agm(function (d) { return d.ah = _this.aat; });
                break;
            case "AngleAxisTitleAngle":
                this.agl(function (d) { return d.angle = _this.acp; });
                break;
            case "ValueAxisTitleAngle":
                this.agq(function (d) { return d.angle = _this.adc; });
                break;
            case "AngleAxisTitleAlignment":
                this.agl(function (d) { return d.horizontalAlignment = _this.agv; });
                break;
            case "ValueAxisTitleAlignment":
                this.agq(function (d) { return d.verticalAlignment = _this.ahy; });
                break;
            case "AngleAxisTitle":
                this.agh(function (d) { return d.g8 = _this.aer; });
                break;
            case "ValueAxisTitle":
                this.agn(function (d) { return d.g8 = _this.afz; }, false);
                break;
            case "AngleAxisMajorStroke":
                this.agi(function (d) { return d.jz = _this.ahg; }, a);
                break;
            case "ValueAxisMajorStroke":
                this.agm(function (d) { return d.jz = _this.ahn; });
                break;
            case "AngleAxisMajorStrokeThickness":
                this.agi(function (d) { return d.et = _this.aci; }, a);
                break;
            case "ValueAxisMajorStrokeThickness":
                this.agm(function (d) { return d.et = _this.ac5; });
                break;
            case "AngleAxisMinorStroke":
                this.agh(function (d) { return d.j0 = _this.ahh; });
                break;
            case "ValueAxisMinorStroke":
                this.agm(function (d) { return d.j0 = _this.aho; });
                break;
            case "AngleAxisMinorStrokeThickness":
                this.agh(function (d) { return d.ew = _this.acl; });
                break;
            case "ValueAxisMinorStrokeThickness":
                this.agm(function (d) { return d.ew = _this.ac8; });
                break;
            case "AngleAxisTickLength":
                this.agh(function (d) { return d.fj = _this.acn; });
                break;
            case "ValueAxisTickLength":
                this.agm(function (d) { return d.fj = _this.ada; });
                break;
            case "AngleAxisTickStroke":
                this.agh(function (d) { return d.j3 = _this.ahk; });
                break;
            case "ValueAxisTickStroke":
                this.agm(function (d) { return d.j3 = _this.ahr; });
                break;
            case "AngleAxisTickStrokeThickness":
                this.agh(function (d) { return d.fk = _this.aco; });
                break;
            case "ValueAxisTickStrokeThickness":
                this.agm(function (d) { return d.fk = _this.adb; });
                break;
            case "AngleAxisStroke":
                this.agh(function (d) { return d.j2 = _this.ahj; });
                break;
            case "ValueAxisStroke":
                this.agm(function (d) { return d.j2 = _this.ahq; });
                break;
            case "AngleAxisStrokeThickness":
                this.agh(function (d) { return d.fi = _this.acm; });
                break;
            case "ValueAxisStrokeThickness":
                this.agm(function (d) { return d.fi = _this.ac9; });
                break;
            case "AngleAxisExtent":
                this.agj(function (d) { return d.extent = _this.acc; });
                break;
            case "AngleAxisMaximumExtent":
                this.agj(function (d) { return d.maximumExtent = _this.acj; });
                break;
            case "AngleAxisMaximumExtentPercentage":
                this.agj(function (d) { return d.maximumExtentPercentage = _this.ack; });
                break;
            case "ValueAxisExtent":
                this.ago(function (d) { return d.extent = _this.acz; });
                break;
            case "ValueAxisMaximumExtent":
                this.ago(function (d) { return d.maximumExtent = _this.acj; });
                break;
            case "ValueAxisMaximumExtentPercentage":
                this.ago(function (d) { return d.maximumExtentPercentage = _this.ack; });
                break;
            case "AngleAxisStrip":
                this.agh(function (d) { return d.j1 = _this.ahi; });
                break;
            case "ValueAxisStrip":
                this.agm(function (d) { return d.j1 = _this.ahp; });
                break;
            case "AngleAxisInverted":
                this.agh(function (d) { return d.ch = _this.aa8; });
                break;
            case "ValueAxisInverted":
                this.agm(function (d) { return d.ch = _this.aa9; });
                break;
            case "ValueAxisLabelLocation":
                this.agp();
                break;
            case "AngleAxisLabelLocation":
                this.agk();
                break;
        }
    };
    RadialBaseChart.prototype.agp = function () {
        var a = this.aa3(this.aa5);
        if (a == 2 || a == 7) {
            this.agw = 2;
        }
        else {
            this.agw = 0;
        }
        this.ago(function (b) { return b.location = a; });
    };
    RadialBaseChart.prototype.agk = function () {
        var a = this.aa2(this.aav);
        if (a == 1 || a == 5) {
            this.ahw = 0;
        }
        else {
            this.ahw = 2;
        }
        this.agj(function (b) { return b.location = a; });
    };
    RadialBaseChart.prototype.aa3 = function (a) {
        if (a == 0) {
            return 2;
        }
        else if (a == 1) {
            return 3;
        }
        else if (a == 3) {
            return 7;
        }
        else if (a == 2) {
            return 6;
        }
        else {
            if (this.cb == 1) {
                return 3;
            }
            else {
                return 2;
            }
        }
    };
    RadialBaseChart.prototype.aa2 = function (a) {
        if (a == 1) {
            return 1;
        }
        else if (a == 0) {
            return 0;
        }
        else if (a == 3) {
            return 5;
        }
        else if (a == 2) {
            return 4;
        }
        else {
            return 1;
        }
    };
    Object.defineProperty(RadialBaseChart.prototype, "adk", {
        get: function () {
            return this.adi;
        },
        set: function (a) {
            var b = this.adk;
            if (a != b) {
                this.adi = a;
                this.wj("AngleAxisLabel", b, this.adk);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "adl", {
        get: function () {
            return this.adj;
        },
        set: function (a) {
            var b = this.adl;
            if (a != b) {
                this.adj = a;
                this.wj("ValueAxisLabel", b, this.adl);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "ahg", {
        get: function () {
            return this.ag0;
        },
        set: function (a) {
            var b = this.ahg;
            if (a != b) {
                this.ag0 = a;
                this.wj("AngleAxisMajorStroke", b, this.ahg);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "ahn", {
        get: function () {
            return this.ag7;
        },
        set: function (a) {
            var b = this.ahn;
            if (a != b) {
                this.ag7 = a;
                this.wj("ValueAxisMajorStroke", b, this.ahn);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "aci", {
        get: function () {
            return this.abg;
        },
        set: function (a) {
            var b = this.aci;
            if (a != b) {
                this.abg = a;
                this.wj("AngleAxisMajorStrokeThickness", b, this.aci);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "ac5", {
        get: function () {
            return this.abz;
        },
        set: function (a) {
            var b = this.ac5;
            if (a != b) {
                this.abz = a;
                this.wj("ValueAxisMajorStrokeThickness", b, this.ac5);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "acl", {
        get: function () {
            return this.abj;
        },
        set: function (a) {
            var b = this.acl;
            if (a != b) {
                this.abj = a;
                this.wj("AngleAxisMinorStrokeThickness", b, this.acl);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "ac8", {
        get: function () {
            return this.ab2;
        },
        set: function (a) {
            var b = this.ac8;
            if (a != b) {
                this.ab2 = a;
                this.wj("ValueAxisMinorStrokeThickness", b, this.ac8);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "ahi", {
        get: function () {
            return this.ag2;
        },
        set: function (a) {
            var b = this.ahi;
            if (a != b) {
                this.ag2 = a;
                this.wj("AngleAxisStrip", b, this.ahi);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "ahp", {
        get: function () {
            return this.ag9;
        },
        set: function (a) {
            var b = this.ahp;
            if (a != b) {
                this.ag9 = a;
                this.wj("ValueAxisStrip", b, this.ahp);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "ahj", {
        get: function () {
            return this.ag3;
        },
        set: function (a) {
            var b = this.ahj;
            if (a != b) {
                this.ag3 = a;
                this.wj("AngleAxisStroke", b, this.ahj);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "ahq", {
        get: function () {
            return this.aha;
        },
        set: function (a) {
            var b = this.ahq;
            if (a != b) {
                this.aha = a;
                this.wj("ValueAxisStroke", b, this.ahq);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "acm", {
        get: function () {
            return this.abk;
        },
        set: function (a) {
            var b = this.acm;
            if (a != b) {
                this.abk = a;
                this.wj("AngleAxisStrokeThickness", b, this.acm);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "ac9", {
        get: function () {
            return this.ab3;
        },
        set: function (a) {
            var b = this.ac9;
            if (a != b) {
                this.ab3 = a;
                this.wj("ValueAxisStrokeThickness", b, this.ac9);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "acn", {
        get: function () {
            return this.abl;
        },
        set: function (a) {
            var b = this.acn;
            if (a != b) {
                this.abl = a;
                this.wj("AngleAxisTickLength", b, this.acn);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "ada", {
        get: function () {
            return this.ab4;
        },
        set: function (a) {
            var b = this.ada;
            if (a != b) {
                this.ab4 = a;
                this.wj("ValueAxisTickLength", b, this.ada);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "ahk", {
        get: function () {
            return this.ag4;
        },
        set: function (a) {
            var b = this.ahk;
            if (a != b) {
                this.ag4 = a;
                this.wj("AngleAxisTickStroke", b, this.ahk);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "ahr", {
        get: function () {
            return this.ahb;
        },
        set: function (a) {
            var b = this.ahr;
            if (a != b) {
                this.ahb = a;
                this.wj("ValueAxisTickStroke", b, this.ahr);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "aco", {
        get: function () {
            return this.abm;
        },
        set: function (a) {
            var b = this.aco;
            if (a != b) {
                this.abm = a;
                this.wj("AngleAxisTickStrokeThickness", b, this.aco);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "adb", {
        get: function () {
            return this.ab5;
        },
        set: function (a) {
            var b = this.adb;
            if (a != b) {
                this.ab5 = a;
                this.wj("ValueAxisTickStrokeThickness", b, this.adb);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "aer", {
        get: function () {
            return this.ado;
        },
        set: function (a) {
            var b = this.aer;
            if (a != b) {
                this.ado = a;
                this.wj("AngleAxisTitle", b, this.aer);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "afz", {
        get: function () {
            return this.ads;
        },
        set: function (a) {
            var b = this.afz;
            if (a != b) {
                this.ads = a;
                this.wj("ValueAxisTitle", b, this.afz);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "ahh", {
        get: function () {
            return this.ag1;
        },
        set: function (a) {
            var b = this.ahh;
            if (a != b) {
                this.ag1 = a;
                this.wj("AngleAxisMinorStroke", b, this.ahh);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "aho", {
        get: function () {
            return this.ag8;
        },
        set: function (a) {
            var b = this.aho;
            if (a != b) {
                this.ag8 = a;
                this.wj("ValueAxisMinorStroke", b, this.aho);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "acd", {
        get: function () {
            return this.abb;
        },
        set: function (a) {
            var b = this.acd;
            if (a != b) {
                this.abb = a;
                this.wj("AngleAxisLabelAngle", b, this.acd);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "ac0", {
        get: function () {
            return this.abu;
        },
        set: function (a) {
            var b = this.ac0;
            if (a != b) {
                this.abu = a;
                this.wj("ValueAxisLabelAngle", b, this.ac0);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "acc", {
        get: function () {
            return this.aba;
        },
        set: function (a) {
            var b = this.acc;
            if (a != b) {
                this.aba = a;
                this.wj("AngleAxisExtent", b, this.acc);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "acj", {
        get: function () {
            return this.abh;
        },
        set: function (a) {
            var b = this.acj;
            if (a != b) {
                this.abh = a;
                this.wj("AngleAxisMaximumExtent", b, this.acj);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "ack", {
        get: function () {
            return this.abi;
        },
        set: function (a) {
            var b = this.ack;
            if (a != b) {
                this.abi = a;
                this.wj("AngleAxisMaximumExtentPercentage", b, this.ack);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "acz", {
        get: function () {
            return this.abt;
        },
        set: function (a) {
            var b = this.acz;
            if (a != b) {
                this.abt = a;
                this.wj("ValueAxisExtent", b, this.acz);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "ac6", {
        get: function () {
            return this.ab0;
        },
        set: function (a) {
            var b = this.ac6;
            if (a != b) {
                this.ab0 = a;
                this.wj("ValueAxisMaximumExtent", b, this.ac6);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "ac7", {
        get: function () {
            return this.ab1;
        },
        set: function (a) {
            var b = this.ac7;
            if (a != b) {
                this.ab1 = a;
                this.wj("ValueAxisMaximumExtentPercentage", b, this.ac7);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "acp", {
        get: function () {
            return this.abn;
        },
        set: function (a) {
            var b = this.acp;
            if (a != b) {
                this.abn = a;
                this.wj("AngleAxisTitleAngle", b, this.acp);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "adc", {
        get: function () {
            return this.ab6;
        },
        set: function (a) {
            var b = this.adc;
            if (a != b) {
                this.ab6 = a;
                this.wj("ValueAxisTitleAngle", b, this.adc);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "aa8", {
        get: function () {
            return this.aa6;
        },
        set: function (a) {
            var b = this.aa8;
            if (a != b) {
                this.aa6 = a;
                this.wj("AngleAxisInverted", b, this.aa8);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "aa9", {
        get: function () {
            return this.aa7;
        },
        set: function (a) {
            var b = this.aa9;
            if (a != b) {
                this.aa7 = a;
                this.wj("ValueAxisInverted", b, this.aa9);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "agv", {
        get: function () {
            return this.ags;
        },
        set: function (a) {
            var b = this.agv;
            if (a != b) {
                this.ags = a;
                this.wj("AngleAxisTitleAlignment", enumGetBox(HorizontalAlignment_$type, b), enumGetBox(HorizontalAlignment_$type, this.agv));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "ahy", {
        get: function () {
            return this.ahv;
        },
        set: function (a) {
            var b = this.ahy;
            if (a != b) {
                this.ahv = a;
                this.wj("ValueAxisTitleAlignment", enumGetBox(VerticalAlignment_$type, b), enumGetBox(VerticalAlignment_$type, this.ahy));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "agu", {
        get: function () {
            return this.agr;
        },
        set: function (a) {
            var b = this.agu;
            if (a != b) {
                this.agr = a;
                this.wj("AngleAxisLabelHorizontalAlignment", enumGetBox(HorizontalAlignment_$type, b), enumGetBox(HorizontalAlignment_$type, this.agu));
            }
        },
        enumerable: false,
        configurable: true
    });
    RadialBaseChart.prototype.get_agw = function () {
        return this.agt;
    };
    RadialBaseChart.prototype.set_agw = function (a) {
        var b = this.agw;
        if (a != b) {
            this.agt = a;
            this.wj("ValueAxisLabelHorizontalAlignment", enumGetBox(HorizontalAlignment_$type, b), enumGetBox(HorizontalAlignment_$type, this.agw));
        }
    };
    Object.defineProperty(RadialBaseChart.prototype, "agw", {
        get: function () {
            return this.get_agw();
        },
        set: function (a) {
            this.set_agw(a);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "ahw", {
        get: function () {
            return this.aht;
        },
        set: function (a) {
            var b = this.ahw;
            if (a != b) {
                this.aht = a;
                this.wj("AngleAxisLabelVerticalAlignment", enumGetBox(VerticalAlignment_$type, b), enumGetBox(VerticalAlignment_$type, this.ahw));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "ahx", {
        get: function () {
            return this.ahu;
        },
        set: function (a) {
            var b = this.ahx;
            if (a != b) {
                this.ahu = a;
                this.wj("ValueAxisLabelVerticalAlignment", enumGetBox(VerticalAlignment_$type, b), enumGetBox(VerticalAlignment_$type, this.ahx));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "ah1", {
        get: function () {
            return this.ahz;
        },
        set: function (a) {
            var b = this.ah1;
            if (a != b) {
                this.ahz = a;
                this.wj("AngleAxisLabelVisibility", enumGetBox(Visibility_$type, b), enumGetBox(Visibility_$type, this.ah1));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "ah2", {
        get: function () {
            return this.ah0;
        },
        set: function (a) {
            var b = this.ah2;
            if (a != b) {
                this.ah0 = a;
                this.wj("ValueAxisLabelVisibility", enumGetBox(Visibility_$type, b), enumGetBox(Visibility_$type, this.ah2));
            }
        },
        enumerable: false,
        configurable: true
    });
    RadialBaseChart.prototype.get_aa5 = function () {
        return this.aa4;
    };
    RadialBaseChart.prototype.set_aa5 = function (a) {
        var b = this.aa5;
        if (a != b) {
            this.aa4 = a;
            this.wj("ValueAxisLabelLocation", enumGetBox(ValueAxisLabelLocation_$type, b), enumGetBox(ValueAxisLabelLocation_$type, this.aa5));
        }
    };
    Object.defineProperty(RadialBaseChart.prototype, "aa5", {
        get: function () {
            return this.get_aa5();
        },
        set: function (a) {
            this.set_aa5(a);
        },
        enumerable: false,
        configurable: true
    });
    RadialBaseChart.prototype.get_aav = function () {
        return this.aau;
    };
    RadialBaseChart.prototype.set_aav = function (a) {
        var b = this.aav;
        if (a != b) {
            this.aau = a;
            this.wj("AngleAxisLabelLocation", enumGetBox(AngleAxisLabelLocation_$type, b), enumGetBox(AngleAxisLabelLocation_$type, this.aav));
        }
    };
    Object.defineProperty(RadialBaseChart.prototype, "aav", {
        get: function () {
            return this.get_aav();
        },
        set: function (a) {
            this.set_aav(a);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "ad1", {
        get: function () {
            return this.adm;
        },
        set: function (a) {
            var b = this.adm;
            if (a != b) {
                this.adm = a;
                this.wj("AngleAxisLabelFormat", b, this.adm);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "aas", {
        get: function () {
            return this.aaq;
        },
        set: function (a) {
            var b = this.aaq;
            if (a != b) {
                this.aaq = a;
                this.wj("AngleAxisLabelFormatSpecifiers", b, this.aaq);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "ae9", {
        get: function () {
            return this.adq;
        },
        set: function (a) {
            var b = this.adq;
            if (a != b) {
                this.adq = a;
                this.wj("ValueAxisLabelFormat", b, this.adq);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "aat", {
        get: function () {
            return this.aar;
        },
        set: function (a) {
            var b = this.aar;
            if (a != b) {
                this.aar = a;
                this.wj("ValueAxisLabelFormatSpecifiers", b, this.aar);
            }
        },
        enumerable: false,
        configurable: true
    });
    RadialBaseChart.$t = markType(RadialBaseChart, 'RadialBaseChart', DomainChart.$);
    return RadialBaseChart;
}(DomainChart));
export { RadialBaseChart };
