/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends, __values } from "tslib";
import { DomainChart } from "./DomainChart";
import { fromEnum, enumGetBox, markType } from "igniteui-react-core";
import { HorizontalAlignment_$type } from "igniteui-react-core";
import { VerticalAlignment_$type } from "igniteui-react-core";
import { Visibility_$type } from "igniteui-react-core";
import { YAxisLabelLocation_$type } from "./YAxisLabelLocation";
import { XAxisLabelLocation_$type } from "./XAxisLabelLocation";
import { AxisLabelSettings } from "./AxisLabelSettings";
import { AxisDefaults } from "./AxisDefaults";
import { TitleSettings } from "./TitleSettings";
import { ScalerParams } from "./ScalerParams";
import { DeviceUtils } from "igniteui-react-core";
/**
 * @hidden
 */
var XYChart = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(XYChart, _super);
    function XYChart() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.aaw = null;
        _this.aax = null;
        _this.abd = 0;
        _this.abf = 5;
        _this.abe = 0;
        _this.abc = 5;
        _this.abw = 5;
        _this.aby = 0;
        _this.abx = 5;
        _this.abv = 0;
        _this.agz = null;
        _this.ag6 = null;
        _this.agx = null;
        _this.agy = null;
        _this.abq = 0;
        _this.ab9 = 0;
        _this.abp = NaN;
        _this.ab8 = NaN;
        _this.abs = NaN;
        _this.acb = NaN;
        _this.abr = NaN;
        _this.aca = NaN;
        _this.abo = NaN;
        _this.ab7 = NaN;
        _this.ag5 = null;
        _this.ahc = null;
        _this.adn = null;
        _this.adr = null;
        _this.adp = null;
        _this.adt = null;
        _this.adi = null;
        _this.adj = null;
        _this.ag0 = null;
        _this.ag7 = null;
        _this.abg = DeviceUtils.g(1);
        _this.abz = DeviceUtils.g(1);
        _this.abj = DeviceUtils.g(1);
        _this.ab2 = DeviceUtils.g(1);
        _this.ag2 = null;
        _this.ag9 = null;
        _this.ag3 = null;
        _this.aha = null;
        _this.abk = DeviceUtils.g(1);
        _this.ab3 = DeviceUtils.g(1);
        _this.abl = DeviceUtils.g(8);
        _this.ab4 = 0;
        _this.ag4 = null;
        _this.ahb = null;
        _this.abm = DeviceUtils.g(1);
        _this.ab5 = DeviceUtils.g(1);
        _this.ado = null;
        _this.ads = null;
        _this.ag1 = null;
        _this.ag8 = null;
        _this.abb = 0;
        _this.abu = 0;
        _this.aba = NaN;
        _this.abt = NaN;
        _this.abh = NaN;
        _this.ab0 = NaN;
        _this.abi = NaN;
        _this.ab1 = NaN;
        _this.abn = 0;
        _this.ab6 = -90;
        _this.aa6 = false;
        _this.aa7 = false;
        _this.ags = 1;
        _this.ahv = 1;
        _this.agr = 1;
        _this.agt = 2;
        _this.aht = 0;
        _this.ahu = 1;
        _this.ahz = 0;
        _this.ah0 = 0;
        _this.aa4 = 4;
        _this.aa2 = 4;
        _this.adm = null;
        _this.aaq = null;
        _this.adq = null;
        _this.aar = null;
        return _this;
    }
    XYChart.prototype.provideContainer = function (a) {
        if (a != null) {
            var b = this.aau();
            var c = this.aav();
            if (b != null) {
                b.provideRenderer(a);
            }
            if (c != null) {
                c.provideRenderer(a);
            }
        }
        _super.prototype.provideContainer.call(this, a);
    };
    XYChart.prototype.vs = function () {
        _super.prototype.vs.call(this);
        var a = this.aau();
        var b = this.aav();
        if (a != null && a.az != null) {
            this.ahf = a.az.textColor;
        }
        if (b != null && b.az != null) {
            this.ahm = b.az.textColor;
        }
        this.ahk = AxisDefaults.axis_TickBrush;
        this.ahr = AxisDefaults.axis_TickBrush;
        this.ahg = AxisDefaults.axis_MajorBrush;
        this.ahn = AxisDefaults.axis_MajorBrush;
        this.ahj = AxisDefaults.axis_LineBrush;
        this.ahq = AxisDefaults.axis_LineBrush;
    };
    XYChart.prototype.wn = function (a, b, c) {
        var _this = this;
        _super.prototype.wn.call(this, a, b, c);
        switch (a) {
            case "XAxisLabelLeftMargin":
                this.agj(function (d) { return d.leftMargin = _this.acj; });
                break;
            case "XAxisLabelTopMargin":
                this.agj(function (d) { return d.topMargin = _this.acl; });
                break;
            case "XAxisLabelRightMargin":
                this.agj(function (d) { return d.rightMargin = _this.ack; });
                break;
            case "XAxisLabelBottomMargin":
                this.agj(function (d) { return d.bottomMargin = _this.aci; });
                break;
            case "YAxisLabelLeftMargin":
                this.ago(function (d) { return d.leftMargin = _this.ac2; });
                break;
            case "YAxisLabelTopMargin":
                this.ago(function (d) { return d.topMargin = _this.ac4; });
                break;
            case "YAxisLabelRightMargin":
                this.ago(function (d) { return d.rightMargin = _this.ac3; });
                break;
            case "YAxisLabelBottomMargin":
                this.ago(function (d) { return d.bottomMargin = _this.ac1; });
                break;
            case "ActualItemsSource":
            case "ShouldDisplayMockData":
            case "ShouldUseSkeletonStyleForMockData":
                this.ahd = this.zo(this.ahf);
                this.ahe = this.zo(this.ahm);
                break;
            case "XAxisLabelTextColor":
                this.ahd = this.zo(this.ahf);
                break;
            case "YAxisLabelTextColor":
                this.ahe = this.zo(this.ahm);
                break;
            case "ActualXAxisLabelTextColor":
                this.agj(function (d) { return d.textColor = _this.ahd; });
                break;
            case "ActualYAxisLabelTextColor":
                this.ago(function (d) { return d.textColor = _this.ahe; });
                break;
            case "XAxisTitleMargin":
                this.agl(function (d) { return d.margin = _this.acw; });
                break;
            case "YAxisTitleMargin":
                this.agq(function (d) { return d.margin = _this.adf; });
                break;
            case "XAxisTitleLeftMargin":
                this.agl(function (d) { return d.leftMargin = _this.acv; });
                break;
            case "YAxisTitleLeftMargin":
                this.agq(function (d) { return d.leftMargin = _this.ade; });
                break;
            case "XAxisTitleTopMargin":
                this.agl(function (d) { return d.topMargin = _this.acy; });
                break;
            case "YAxisTitleTopMargin":
                this.agq(function (d) { return d.topMargin = _this.adh; });
                break;
            case "XAxisTitleRightMargin":
                this.agl(function (d) { return d.rightMargin = _this.acx; });
                break;
            case "YAxisTitleRightMargin":
                this.agq(function (d) { return d.rightMargin = _this.adg; });
                break;
            case "XAxisTitleBottomMargin":
                this.agl(function (d) { return d.bottomMargin = _this.acu; });
                break;
            case "YAxisTitleBottomMargin":
                this.agq(function (d) { return d.bottomMargin = _this.add; });
                break;
            case "XAxisTitleTextColor":
                this.agl(function (d) { return d.textColor = _this.ahl; });
                break;
            case "YAxisTitleTextColor":
                this.agq(function (d) { return d.textColor = _this.ahs; });
                break;
            case "XAxisFormatLabel":
                this.agh(function (d) { return d.au = _this.aay; });
                break;
            case "YAxisFormatLabel":
                this.agm(function (d) { return d.au = _this.aaz; });
                break;
        }
    };
    Object.defineProperty(XYChart.prototype, "aay", {
        get: function () {
            return this.aaw;
        },
        set: function (a) {
            var b = this.aay;
            if (a != b) {
                this.aaw = a;
                this.wj("XAxisFormatLabel", b, this.aay);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "aaz", {
        get: function () {
            return this.aax;
        },
        set: function (a) {
            var b = this.aaz;
            if (a != b) {
                this.aax = a;
                this.wj("YAxisFormatLabel", b, this.aaz);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "acj", {
        get: function () {
            return this.abd;
        },
        set: function (a) {
            var b = this.acj;
            if (a != b) {
                this.abd = a;
                this.wj("XAxisLabelLeftMargin", b, this.acj);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "acl", {
        get: function () {
            return this.abf;
        },
        set: function (a) {
            var b = this.acl;
            if (a != b) {
                this.abf = a;
                this.wj("XAxisLabelTopMargin", b, this.acl);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ack", {
        get: function () {
            return this.abe;
        },
        set: function (a) {
            var b = this.ack;
            if (a != b) {
                this.abe = a;
                this.wj("XAxisLabelRightMargin", b, this.ack);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "aci", {
        get: function () {
            return this.abc;
        },
        set: function (a) {
            var b = this.aci;
            if (a != b) {
                this.abc = a;
                this.wj("XAxisLabelBottomMargin", b, this.aci);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ac2", {
        get: function () {
            return this.abw;
        },
        set: function (a) {
            var b = this.ac2;
            if (a != b) {
                this.abw = a;
                this.wj("YAxisLabelLeftMargin", b, this.ac2);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ac4", {
        get: function () {
            return this.aby;
        },
        set: function (a) {
            var b = this.ac4;
            if (a != b) {
                this.aby = a;
                this.wj("YAxisLabelTopMargin", b, this.ac4);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ac3", {
        get: function () {
            return this.abx;
        },
        set: function (a) {
            var b = this.ac3;
            if (a != b) {
                this.abx = a;
                this.wj("YAxisLabelRightMargin", b, this.ac3);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ac1", {
        get: function () {
            return this.abv;
        },
        set: function (a) {
            var b = this.ac1;
            if (a != b) {
                this.abv = a;
                this.wj("YAxisLabelBottomMargin", b, this.ac1);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ahf", {
        get: function () {
            return this.agz;
        },
        set: function (a) {
            var b = this.ahf;
            if (a != b) {
                this.agz = a;
                this.wj("XAxisLabelTextColor", b, this.ahf);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ahm", {
        get: function () {
            return this.ag6;
        },
        set: function (a) {
            var b = this.ahm;
            if (a != b) {
                this.ag6 = a;
                this.wj("YAxisLabelTextColor", b, this.ahm);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ahd", {
        get: function () {
            return this.agx;
        },
        set: function (a) {
            var b = this.agx;
            if (a != b) {
                this.agx = a;
                this.wj("ActualXAxisLabelTextColor", b, this.ahd);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ahe", {
        get: function () {
            return this.agy;
        },
        set: function (a) {
            var b = this.agy;
            if (a != b) {
                this.agy = a;
                this.wj("ActualYAxisLabelTextColor", b, this.ahe);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "acw", {
        get: function () {
            return this.abq;
        },
        set: function (a) {
            var b = this.acw;
            if (a != b) {
                this.abq = a;
                this.wj("XAxisTitleMargin", b, this.acw);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "adf", {
        get: function () {
            return this.ab9;
        },
        set: function (a) {
            var b = this.adf;
            if (a != b) {
                this.ab9 = a;
                this.wj("YAxisTitleMargin", b, this.adf);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "acv", {
        get: function () {
            return this.abp;
        },
        set: function (a) {
            var b = this.acv;
            if (a != b) {
                this.abp = a;
                this.wj("XAxisTitleLeftMargin", b, this.acv);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ade", {
        get: function () {
            return this.ab8;
        },
        set: function (a) {
            var b = this.ade;
            if (a != b) {
                this.ab8 = a;
                this.wj("YAxisTitleLeftMargin", b, this.ade);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "acy", {
        get: function () {
            return this.abs;
        },
        set: function (a) {
            var b = this.acy;
            if (a != b) {
                this.abs = a;
                this.wj("XAxisTitleTopMargin", b, this.acy);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "adh", {
        get: function () {
            return this.acb;
        },
        set: function (a) {
            var b = this.adh;
            if (a != b) {
                this.acb = a;
                this.wj("YAxisTitleTopMargin", b, this.adh);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "acx", {
        get: function () {
            return this.abr;
        },
        set: function (a) {
            var b = this.acx;
            if (a != b) {
                this.abr = a;
                this.wj("XAxisTitleRightMargin", b, this.acx);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "adg", {
        get: function () {
            return this.aca;
        },
        set: function (a) {
            var b = this.adg;
            if (a != b) {
                this.aca = a;
                this.wj("YAxisTitleRightMargin", b, this.adg);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "acu", {
        get: function () {
            return this.abo;
        },
        set: function (a) {
            var b = this.acu;
            if (a != b) {
                this.abo = a;
                this.wj("XAxisTitleBottomMargin", b, this.acu);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "add", {
        get: function () {
            return this.ab7;
        },
        set: function (a) {
            var b = this.add;
            if (a != b) {
                this.ab7 = a;
                this.wj("YAxisTitleBottomMargin", b, this.add);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ahl", {
        get: function () {
            return this.ag5;
        },
        set: function (a) {
            var b = this.ahl;
            if (a != b) {
                this.ag5 = a;
                this.wj("XAxisTitleTextColor", b, this.ahl);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ahs", {
        get: function () {
            return this.ahc;
        },
        set: function (a) {
            var b = this.ahs;
            if (a != b) {
                this.ahc = a;
                this.wj("YAxisTitleTextColor", b, this.ahs);
            }
        },
        enumerable: false,
        configurable: true
    });
    XYChart.prototype.wo = function (a, b, c) {
        var _this = this;
        _super.prototype.wo.call(this, a, b, c);
        switch (a) {
            case "XAxisLabelTextStyle":
                this.agj(function (d) { return d.textStyle = _this.aeb; });
                break;
            case "YAxisLabelTextStyle":
                this.ago(function (d) { return d.textStyle = _this.afi; });
                break;
            case "XAxisTitleTextStyle":
                this.agl(function (d) { return d.textStyle = _this.ae1; });
                break;
            case "YAxisTitleTextStyle":
                this.agq(function (d) { return d.textStyle = _this.af8; });
                break;
        }
    };
    Object.defineProperty(XYChart.prototype, "aeb", {
        get: function () {
            return this.adn;
        },
        set: function (a) {
            var b = this.aeb;
            if (a != b) {
                this.adn = a;
                this.wj("XAxisLabelTextStyle", b, this.aeb);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "afi", {
        get: function () {
            return this.adr;
        },
        set: function (a) {
            var b = this.afi;
            if (a != b) {
                this.adr = a;
                this.wj("YAxisLabelTextStyle", b, this.afi);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ae1", {
        get: function () {
            return this.adp;
        },
        set: function (a) {
            var b = this.ae1;
            if (a != b) {
                this.adp = a;
                this.wj("XAxisTitleTextStyle", b, this.ae1);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "af8", {
        get: function () {
            return this.adt;
        },
        set: function (a) {
            var b = this.af8;
            if (a != b) {
                this.adt = a;
                this.wj("YAxisTitleTextStyle", b, this.af8);
            }
        },
        enumerable: false,
        configurable: true
    });
    XYChart.prototype.age = function (a) {
        var _this = this;
        this.agb(a, function (b) { return b.leftMargin = _this.acj; });
        this.agb(a, function (b) { return b.topMargin = _this.acl; });
        this.agb(a, function (b) { return b.rightMargin = _this.ack; });
        this.agb(a, function (b) { return b.bottomMargin = _this.aci; });
        this.agb(a, function (b) { return b.textColor = _this.ahd; });
        this.agc(a, function (b) { return b.textColor = _this.ahl; });
        this.agc(a, function (b) { return b.leftMargin = _this.acv; });
        this.agc(a, function (b) { return b.topMargin = _this.acy; });
        this.agc(a, function (b) { return b.rightMargin = _this.acx; });
        this.agc(a, function (b) { return b.bottomMargin = _this.acu; });
        this.agb(a, function (b) { return b.textStyle = _this.aeb; });
        this.agc(a, function (b) { return b.textStyle = _this.ae1; });
    };
    XYChart.prototype.agg = function (a) {
        var _this = this;
        this.agb(a, function (b) { return b.leftMargin = _this.ac2; });
        this.agb(a, function (b) { return b.topMargin = _this.ac4; });
        this.agb(a, function (b) { return b.rightMargin = _this.ac3; });
        this.agb(a, function (b) { return b.bottomMargin = _this.ac1; });
        this.agb(a, function (b) { return b.textColor = _this.ahe; });
        this.agc(a, function (b) { return b.textColor = _this.ahs; });
        this.agc(a, function (b) { return b.leftMargin = _this.ade; });
        this.agc(a, function (b) { return b.topMargin = _this.adh; });
        this.agc(a, function (b) { return b.rightMargin = _this.adg; });
        this.agc(a, function (b) { return b.bottomMargin = _this.add; });
        this.agb(a, function (b) { return b.textStyle = _this.afi; });
        this.agc(a, function (b) { return b.textStyle = _this.af8; });
    };
    XYChart.prototype.xf = function (a) {
        var b = this.be(a);
        var c = this.dc(a, b);
        if (c == null) {
            return;
        }
        c.itemsSource = this.ia(a);
        if (a.highlightedData != null) {
            c.highlightedItemsSource = this.ib(a);
        }
        c.name = this.q6(a);
        c.title = this.q7(a, b);
        this.dataChart.series.add(c);
    };
    XYChart.prototype.agh = function (a) {
        this.agi(a, null);
    };
    XYChart.prototype.agi = function (a, b) {
        a(this.aau());
    };
    XYChart.prototype.agn = function (a, b) {
        a(this.aav());
    };
    XYChart.prototype.agm = function (a) {
        this.agn(a, true);
    };
    XYChart.prototype.vb = function (a, b) {
        this.agh(a);
        this.agn(a, b);
    };
    XYChart.prototype.agl = function (a) {
        this.agc(this.aau(), a);
    };
    XYChart.prototype.agq = function (a) {
        this.agc(this.aav(), a);
    };
    XYChart.prototype.ago = function (a) {
        this.agb(this.aav(), a);
    };
    XYChart.prototype.agj = function (a) {
        this.agb(this.aau(), a);
    };
    XYChart.prototype.acc = function (a) {
        var b = this.aau();
        return b.el(a, new ScalerParams(1, this.zx, this.zw, b.ch));
    };
    XYChart.prototype.ace = function (a) {
        var b = this.aau();
        return b.eo(a, new ScalerParams(1, this.zx, this.zw, b.ch));
    };
    XYChart.prototype.acd = function (a) {
        var b = this.aav();
        return b.el(a, new ScalerParams(1, this.zx, this.zw, b.ch));
    };
    XYChart.prototype.acf = function (a) {
        var b = this.aav();
        return b.eo(a, new ScalerParams(1, this.zx, this.zw, b.ch));
    };
    XYChart.prototype.xc = function (a) {
        _super.prototype.xc.call(this, a);
        if (a == null) {
            return;
        }
        if (a.axes != null) {
            var b = this.aau();
            var c = this.aav();
            if (a.axes.contains(b)) {
                a.axes.remove(b);
            }
            if (a.axes.contains(c)) {
                a.axes.remove(c);
            }
        }
    };
    XYChart.adw = function (a, b) {
        var e_1, _a;
        try {
            for (var _b = __values(fromEnum(b)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var c = _c.value;
                var d = c.findMatchingHint(16);
                if (d != null) {
                    var e = d.path;
                    return e;
                }
            }
        }
        catch (e_1_1) {
            e_1 = { error: e_1_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_1)
                    throw e_1.error;
            }
        }
        return null;
    };
    XYChart.prototype.vn = function (a, b) {
        _super.prototype.vn.call(this, a, b);
        if (a == this.dataChart) {
            this.dataChart.axes.add(this.aau());
            this.dataChart.axes.add(this.aav());
        }
    };
    XYChart.prototype.agd = function (a) {
        var _this = this;
        if (a != null && this.l8 != null && a.fn == null) {
            a.provideRenderer(this.l8);
        }
        a.jz = this.ahg;
        a.et = this.acm;
        a.j0 = this.ahh;
        a.ew = this.acp;
        a.j2 = this.ahj;
        a.fi = this.acq;
        a.j1 = this.ahi;
        a.fj = this.acr;
        a.j3 = this.ahk;
        a.fk = this.acs;
        a.c4 = true;
        a.cu = this.shouldAvoidAxisAnnotationCollisions;
        a.cw = this.shouldAvoidAxisAnnotationCollisions;
        var b = a == this.aau();
        if (b) {
            a.g8 = this.aes;
        }
        a.f2 = this.adk;
        a.gi = this.ad2;
        a.ah = this.aas;
        this.agb(a, function (c) { return c.angle = _this.ach; });
        this.agb(a, function (c) {
            if (c.extent != _this.acg) {
                c.extent = _this.acg;
            }
        });
        this.agb(a, function (c) {
            if (c.maximumExtent != _this.acn) {
                c.maximumExtent = _this.acn;
            }
        });
        this.agb(a, function (c) {
            if (c.maximumExtentPercentage != _this.aco) {
                c.maximumExtentPercentage = _this.aco;
            }
        });
        this.agb(a, function (c) { return c.horizontalAlignment = _this.agu; });
        this.agb(a, function (c) { return c.verticalAlignment = _this.ahw; });
        this.agb(a, function (c) { return c.visibility = _this.ah1; });
        this.agb(a, function (c) { return c.location = _this.aa0(_this.aa3); });
        this.agc(a, function (c) { return c.horizontalAlignment = _this.agv; });
        this.agc(a, function (c) { return c.angle = _this.act; });
        this.age(a);
    };
    XYChart.prototype.agf = function (a) {
        var _this = this;
        if (a == null) {
            return;
        }
        if (this.l8 != null && a.fn == null) {
            a.provideRenderer(this.l8);
        }
        a.cu = this.shouldAvoidAxisAnnotationCollisions;
        a.cw = this.shouldAvoidAxisAnnotationCollisions;
        this.agb(a, function (b) { return b.angle = _this.ac0; });
        this.agb(a, function (b) {
            if (b.extent != _this.acz) {
                b.extent = _this.acz;
            }
        });
        this.agb(a, function (b) {
            if (b.maximumExtent != _this.ac6) {
                b.maximumExtent = _this.ac6;
            }
        });
        this.agb(a, function (b) {
            if (b.maximumExtentPercentage != _this.ac7) {
                b.maximumExtentPercentage = _this.ac7;
            }
        });
        this.agb(a, function (b) { return b.horizontalAlignment = _this.agw; });
        this.agb(a, function (b) { return b.verticalAlignment = _this.ahx; });
        this.agb(a, function (b) { return b.visibility = _this.ah2; });
        this.agb(a, function (b) { return b.location = _this.aa1(_this.aa5); });
        this.agc(a, function (b) { return b.verticalAlignment = _this.ahy; });
        this.agc(a, function (b) { return b.angle = _this.adc; });
        a.jz = this.ahn;
        a.et = this.ac5;
        a.j0 = this.aho;
        a.ew = this.ac8;
        a.j2 = this.ahq;
        a.fi = this.ac9;
        a.j1 = this.ahp;
        a.fj = this.ada;
        a.j3 = this.ahr;
        a.fk = this.adb;
        var b = a == this.aav();
        if (b) {
            a.g8 = this.afz;
        }
        a.gi = this.ae9;
        a.ah = this.aat;
        this.agg(a);
    };
    XYChart.prototype.vk = function () {
        _super.prototype.vk.call(this);
        this.agd(this.aau());
        this.agf(this.aav());
    };
    XYChart.prototype.agb = function (a, b) {
        if (a == null) {
            return;
        }
        if (a.az == null) {
            a.az = new AxisLabelSettings();
            a.az.angle = a.d7();
            a.az.bottomMargin = a.d8();
            a.az.leftMargin = a.d9();
            a.az.rightMargin = a.ea();
            a.az.topMargin = a.eb();
            a.az.horizontalAlignment = a.ju();
            a.az.location = a.a0();
            a.az.verticalAlignment = a.ko();
        }
        b(a.az);
    };
    XYChart.prototype.agc = function (a, b) {
        if (a == null) {
            return;
        }
        if (a.bf == null) {
            a.bf = new TitleSettings();
            a.bf.bottomMargin = a.ed();
            a.bf.leftMargin = a.ee();
            a.bf.rightMargin = a.ef();
            a.bf.topMargin = a.eg();
            a.bf.location = a.a1();
            a.bf.angle = a.ec();
            a.bf.horizontalAlignment = a.jv();
            a.bf.verticalAlignment = a.kp();
        }
        b(a.bf);
    };
    XYChart.prototype.wj = function (a, b, c) {
        var _this = this;
        _super.prototype.wj.call(this, a, b, c);
        switch (a) {
            case "XAxisLabelAngle":
                this.agj(function (d) { return d.angle = _this.ach; });
                break;
            case "YAxisLabelAngle":
                this.ago(function (d) { return d.angle = _this.ac0; });
                break;
            case "XAxisLabelHorizontalAlignment":
                this.agj(function (d) { return d.horizontalAlignment = _this.agu; });
                break;
            case "YAxisLabelHorizontalAlignment":
                this.ago(function (d) { return d.horizontalAlignment = _this.agw; });
                break;
            case "XAxisLabelVerticalAlignment":
                this.agj(function (d) { return d.verticalAlignment = _this.ahw; });
                break;
            case "YAxisLabelVerticalAlignment":
                this.ago(function (d) { return d.verticalAlignment = _this.ahx; });
                break;
            case "XAxisLabelVisibility":
                this.agj(function (d) { return d.visibility = _this.ah1; });
                break;
            case "YAxisLabelVisibility":
                this.ago(function (d) { return d.visibility = _this.ah2; });
                break;
            case "XAxisLabel":
                this.agh(function (d) { return d.f2 = _this.adk; });
                break;
            case "YAxisLabel":
                this.agm(function (d) { return d.f2 = _this.adl; });
                break;
            case "XAxisLabelFormat":
                this.agh(function (d) { return d.gi = _this.ad2; });
                break;
            case "XAxisLabelFormatSpecifiers":
                this.agh(function (d) { return d.ah = _this.aas; });
                break;
            case "YAxisLabelFormat":
                this.agm(function (d) { return d.gi = _this.ae9; });
                break;
            case "YAxisLabelFormatSpecifiers":
                this.agm(function (d) { return d.ah = _this.aat; });
                break;
            case "XAxisTitleAngle":
                this.agl(function (d) { return d.angle = _this.act; });
                break;
            case "YAxisTitleAngle":
                this.agq(function (d) { return d.angle = _this.adc; });
                break;
            case "XAxisTitleAlignment":
                this.agl(function (d) { return d.horizontalAlignment = _this.agv; });
                break;
            case "YAxisTitleAlignment":
                this.agq(function (d) { return d.verticalAlignment = _this.ahy; });
                break;
            case "XAxisTitle":
                this.agh(function (d) { return d.g8 = _this.aes; });
                break;
            case "YAxisTitle":
                this.agn(function (d) { return d.g8 = _this.afz; }, false);
                break;
            case "XAxisMajorStroke":
                this.agi(function (d) { return d.jz = _this.ahg; }, a);
                break;
            case "YAxisMajorStroke":
                this.agm(function (d) { return d.jz = _this.ahn; });
                break;
            case "XAxisMajorStrokeThickness":
                this.agi(function (d) { return d.et = _this.acm; }, a);
                break;
            case "YAxisMajorStrokeThickness":
                this.agm(function (d) { return d.et = _this.ac5; });
                break;
            case "XAxisMinorStroke":
                this.agh(function (d) { return d.j0 = _this.ahh; });
                break;
            case "YAxisMinorStroke":
                this.agm(function (d) { return d.j0 = _this.aho; });
                break;
            case "XAxisMinorStrokeThickness":
                this.agh(function (d) { return d.ew = _this.acp; });
                break;
            case "YAxisMinorStrokeThickness":
                this.agm(function (d) { return d.ew = _this.ac8; });
                break;
            case "XAxisTickLength":
                this.agh(function (d) { return d.fj = _this.acr; });
                break;
            case "YAxisTickLength":
                this.agm(function (d) { return d.fj = _this.ada; });
                break;
            case "XAxisTickStroke":
                this.agh(function (d) { return d.j3 = _this.ahk; });
                break;
            case "YAxisTickStroke":
                this.agm(function (d) { return d.j3 = _this.ahr; });
                break;
            case "XAxisTickStrokeThickness":
                this.agh(function (d) { return d.fk = _this.acs; });
                break;
            case "YAxisTickStrokeThickness":
                this.agm(function (d) { return d.fk = _this.adb; });
                break;
            case "XAxisStroke":
                this.agh(function (d) { return d.j2 = _this.ahj; });
                break;
            case "YAxisStroke":
                this.agm(function (d) { return d.j2 = _this.ahq; });
                break;
            case "XAxisStrokeThickness":
                this.agh(function (d) { return d.fi = _this.acq; });
                break;
            case "YAxisStrokeThickness":
                this.agm(function (d) { return d.fi = _this.ac9; });
                break;
            case "XAxisExtent":
                this.agj(function (d) { return d.extent = _this.acg; });
                break;
            case "YAxisExtent":
                this.ago(function (d) { return d.extent = _this.acz; });
                break;
            case "XAxisMaximumExtent":
                this.agj(function (d) { return d.maximumExtent = _this.acn; });
                break;
            case "YAxisMaximumExtent":
                this.ago(function (d) { return d.maximumExtent = _this.ac6; });
                break;
            case "XAxisMaximumExtentPercentage":
                this.agj(function (d) { return d.maximumExtentPercentage = _this.aco; });
                break;
            case "YAxisMaximumExtentPercentage":
                this.ago(function (d) { return d.maximumExtentPercentage = _this.ac7; });
                break;
            case "XAxisStrip":
                this.agh(function (d) { return d.j1 = _this.ahi; });
                break;
            case "YAxisStrip":
                this.agm(function (d) { return d.j1 = _this.ahp; });
                break;
            case "XAxisInverted":
                this.agh(function (d) { return d.ch = _this.aa8; });
                break;
            case "YAxisInverted":
                this.agm(function (d) { return d.ch = _this.aa9; });
                break;
            case "YAxisLabelLocation":
                this.agp();
                break;
            case "XAxisLabelLocation":
                this.agk();
                break;
        }
    };
    XYChart.prototype.agp = function () {
        var a = this.aa1(this.aa5);
        if (a == 2 || a == 7) {
            this.agw = 2;
        }
        else {
            this.agw = 0;
        }
        this.ago(function (b) { return b.location = a; });
    };
    XYChart.prototype.agk = function () {
        var a = this.aa0(this.aa3);
        if (a == 1 || a == 5) {
            this.ahw = 0;
        }
        else {
            this.ahw = 2;
        }
        this.agj(function (b) { return b.location = a; });
    };
    XYChart.prototype.aa1 = function (a) {
        if (a == 0) {
            return 2;
        }
        else if (a == 1) {
            return 3;
        }
        else if (a == 3) {
            return 7;
        }
        else if (a == 2) {
            return 6;
        }
        else {
            if (this.cb == 1) {
                return 3;
            }
            else {
                return 2;
            }
        }
    };
    XYChart.prototype.aa0 = function (a) {
        if (a == 1) {
            return 1;
        }
        else if (a == 0) {
            return 0;
        }
        else if (a == 3) {
            return 5;
        }
        else if (a == 2) {
            return 4;
        }
        else {
            return 1;
        }
    };
    Object.defineProperty(XYChart.prototype, "adk", {
        get: function () {
            return this.adi;
        },
        set: function (a) {
            var b = this.adk;
            if (a != b) {
                this.adi = a;
                this.wj("XAxisLabel", b, this.adk);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "adl", {
        get: function () {
            return this.adj;
        },
        set: function (a) {
            var b = this.adl;
            if (a != b) {
                this.adj = a;
                this.wj("YAxisLabel", b, this.adl);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ahg", {
        get: function () {
            return this.ag0;
        },
        set: function (a) {
            var b = this.ahg;
            if (a != b) {
                this.ag0 = a;
                this.wj("XAxisMajorStroke", b, this.ahg);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ahn", {
        get: function () {
            return this.ag7;
        },
        set: function (a) {
            var b = this.ahn;
            if (a != b) {
                this.ag7 = a;
                this.wj("YAxisMajorStroke", b, this.ahn);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "acm", {
        get: function () {
            return this.abg;
        },
        set: function (a) {
            var b = this.acm;
            if (a != b) {
                this.abg = a;
                this.wj("XAxisMajorStrokeThickness", b, this.acm);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ac5", {
        get: function () {
            return this.abz;
        },
        set: function (a) {
            var b = this.ac5;
            if (a != b) {
                this.abz = a;
                this.wj("YAxisMajorStrokeThickness", b, this.ac5);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "acp", {
        get: function () {
            return this.abj;
        },
        set: function (a) {
            var b = this.acp;
            if (a != b) {
                this.abj = a;
                this.wj("XAxisMinorStrokeThickness", b, this.acp);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ac8", {
        get: function () {
            return this.ab2;
        },
        set: function (a) {
            var b = this.ac8;
            if (a != b) {
                this.ab2 = a;
                this.wj("YAxisMinorStrokeThickness", b, this.ac8);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ahi", {
        get: function () {
            return this.ag2;
        },
        set: function (a) {
            var b = this.ahi;
            if (a != b) {
                this.ag2 = a;
                this.wj("XAxisStrip", b, this.ahi);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ahp", {
        get: function () {
            return this.ag9;
        },
        set: function (a) {
            var b = this.ahp;
            if (a != b) {
                this.ag9 = a;
                this.wj("YAxisStrip", b, this.ahp);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ahj", {
        get: function () {
            return this.ag3;
        },
        set: function (a) {
            var b = this.ahj;
            if (a != b) {
                this.ag3 = a;
                this.wj("XAxisStroke", b, this.ahj);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ahq", {
        get: function () {
            return this.aha;
        },
        set: function (a) {
            var b = this.ahq;
            if (a != b) {
                this.aha = a;
                this.wj("YAxisStroke", b, this.ahq);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "acq", {
        get: function () {
            return this.abk;
        },
        set: function (a) {
            var b = this.acq;
            if (a != b) {
                this.abk = a;
                this.wj("XAxisStrokeThickness", b, this.acq);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ac9", {
        get: function () {
            return this.ab3;
        },
        set: function (a) {
            var b = this.ac9;
            if (a != b) {
                this.ab3 = a;
                this.wj("YAxisStrokeThickness", b, this.ac9);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "acr", {
        get: function () {
            return this.abl;
        },
        set: function (a) {
            var b = this.acr;
            if (a != b) {
                this.abl = a;
                this.wj("XAxisTickLength", b, this.acr);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ada", {
        get: function () {
            return this.ab4;
        },
        set: function (a) {
            var b = this.ada;
            if (a != b) {
                this.ab4 = a;
                this.wj("YAxisTickLength", b, this.ada);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ahk", {
        get: function () {
            return this.ag4;
        },
        set: function (a) {
            var b = this.ahk;
            if (a != b) {
                this.ag4 = a;
                this.wj("XAxisTickStroke", b, this.ahk);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ahr", {
        get: function () {
            return this.ahb;
        },
        set: function (a) {
            var b = this.ahr;
            if (a != b) {
                this.ahb = a;
                this.wj("YAxisTickStroke", b, this.ahr);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "acs", {
        get: function () {
            return this.abm;
        },
        set: function (a) {
            var b = this.acs;
            if (a != b) {
                this.abm = a;
                this.wj("XAxisTickStrokeThickness", b, this.acs);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "adb", {
        get: function () {
            return this.ab5;
        },
        set: function (a) {
            var b = this.adb;
            if (a != b) {
                this.ab5 = a;
                this.wj("YAxisTickStrokeThickness", b, this.adb);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "aes", {
        get: function () {
            return this.ado;
        },
        set: function (a) {
            var b = this.aes;
            if (a != b) {
                this.ado = a;
                this.wj("XAxisTitle", b, this.aes);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "afz", {
        get: function () {
            return this.ads;
        },
        set: function (a) {
            var b = this.afz;
            if (a != b) {
                this.ads = a;
                this.wj("YAxisTitle", b, this.afz);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ahh", {
        get: function () {
            return this.ag1;
        },
        set: function (a) {
            var b = this.ahh;
            if (a != b) {
                this.ag1 = a;
                this.wj("XAxisMinorStroke", b, this.ahh);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "aho", {
        get: function () {
            return this.ag8;
        },
        set: function (a) {
            var b = this.aho;
            if (a != b) {
                this.ag8 = a;
                this.wj("YAxisMinorStroke", b, this.aho);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ach", {
        get: function () {
            return this.abb;
        },
        set: function (a) {
            var b = this.ach;
            if (a != b) {
                this.abb = a;
                this.wj("XAxisLabelAngle", b, this.ach);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ac0", {
        get: function () {
            return this.abu;
        },
        set: function (a) {
            var b = this.ac0;
            if (a != b) {
                this.abu = a;
                this.wj("YAxisLabelAngle", b, this.ac0);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "acg", {
        get: function () {
            return this.aba;
        },
        set: function (a) {
            var b = this.acg;
            if (a != b) {
                this.aba = a;
                this.wj("XAxisExtent", b, this.acg);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "acz", {
        get: function () {
            return this.abt;
        },
        set: function (a) {
            var b = this.acz;
            if (a != b) {
                this.abt = a;
                this.wj("YAxisExtent", b, this.acz);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "acn", {
        get: function () {
            return this.abh;
        },
        set: function (a) {
            var b = this.acn;
            if (a != b) {
                this.abh = a;
                this.wj("XAxisMaximumExtent", b, this.acn);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ac6", {
        get: function () {
            return this.ab0;
        },
        set: function (a) {
            var b = this.ac6;
            if (a != b) {
                this.ab0 = a;
                this.wj("YAxisMaximumExtent", b, this.ac6);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "aco", {
        get: function () {
            return this.abi;
        },
        set: function (a) {
            var b = this.aco;
            if (a != b) {
                this.abi = a;
                this.wj("XAxisMaximumExtentPercentage", b, this.aco);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ac7", {
        get: function () {
            return this.ab1;
        },
        set: function (a) {
            var b = this.ac7;
            if (a != b) {
                this.ab1 = a;
                this.wj("YAxisMaximumExtentPercentage", b, this.ac7);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "act", {
        get: function () {
            return this.abn;
        },
        set: function (a) {
            var b = this.act;
            if (a != b) {
                this.abn = a;
                this.wj("XAxisTitleAngle", b, this.act);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "adc", {
        get: function () {
            return this.ab6;
        },
        set: function (a) {
            var b = this.adc;
            if (a != b) {
                this.ab6 = a;
                this.wj("YAxisTitleAngle", b, this.adc);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "aa8", {
        get: function () {
            return this.aa6;
        },
        set: function (a) {
            var b = this.aa8;
            if (a != b) {
                this.aa6 = a;
                this.wj("XAxisInverted", b, this.aa8);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "aa9", {
        get: function () {
            return this.aa7;
        },
        set: function (a) {
            var b = this.aa9;
            if (a != b) {
                this.aa7 = a;
                this.wj("YAxisInverted", b, this.aa9);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "agv", {
        get: function () {
            return this.ags;
        },
        set: function (a) {
            var b = this.agv;
            if (a != b) {
                this.ags = a;
                this.wj("XAxisTitleAlignment", enumGetBox(HorizontalAlignment_$type, b), enumGetBox(HorizontalAlignment_$type, this.agv));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ahy", {
        get: function () {
            return this.ahv;
        },
        set: function (a) {
            var b = this.ahy;
            if (a != b) {
                this.ahv = a;
                this.wj("YAxisTitleAlignment", enumGetBox(VerticalAlignment_$type, b), enumGetBox(VerticalAlignment_$type, this.ahy));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "agu", {
        get: function () {
            return this.agr;
        },
        set: function (a) {
            var b = this.agu;
            if (a != b) {
                this.agr = a;
                this.wj("XAxisLabelHorizontalAlignment", enumGetBox(HorizontalAlignment_$type, b), enumGetBox(HorizontalAlignment_$type, this.agu));
            }
        },
        enumerable: false,
        configurable: true
    });
    XYChart.prototype.get_agw = function () {
        return this.agt;
    };
    XYChart.prototype.set_agw = function (a) {
        var b = this.agw;
        if (a != b) {
            this.agt = a;
            this.wj("YAxisLabelHorizontalAlignment", enumGetBox(HorizontalAlignment_$type, b), enumGetBox(HorizontalAlignment_$type, this.agw));
        }
    };
    Object.defineProperty(XYChart.prototype, "agw", {
        get: function () {
            return this.get_agw();
        },
        set: function (a) {
            this.set_agw(a);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ahw", {
        get: function () {
            return this.aht;
        },
        set: function (a) {
            var b = this.ahw;
            if (a != b) {
                this.aht = a;
                this.wj("XAxisLabelVerticalAlignment", enumGetBox(VerticalAlignment_$type, b), enumGetBox(VerticalAlignment_$type, this.ahw));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ahx", {
        get: function () {
            return this.ahu;
        },
        set: function (a) {
            var b = this.ahx;
            if (a != b) {
                this.ahu = a;
                this.wj("YAxisLabelVerticalAlignment", enumGetBox(VerticalAlignment_$type, b), enumGetBox(VerticalAlignment_$type, this.ahx));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ah1", {
        get: function () {
            return this.ahz;
        },
        set: function (a) {
            var b = this.ah1;
            if (a != b) {
                this.ahz = a;
                this.wj("XAxisLabelVisibility", enumGetBox(Visibility_$type, b), enumGetBox(Visibility_$type, this.ah1));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ah2", {
        get: function () {
            return this.ah0;
        },
        set: function (a) {
            var b = this.ah2;
            if (a != b) {
                this.ah0 = a;
                this.wj("YAxisLabelVisibility", enumGetBox(Visibility_$type, b), enumGetBox(Visibility_$type, this.ah2));
            }
        },
        enumerable: false,
        configurable: true
    });
    XYChart.prototype.get_aa5 = function () {
        return this.aa4;
    };
    XYChart.prototype.set_aa5 = function (a) {
        var b = this.aa5;
        if (a != b) {
            this.aa4 = a;
            this.wj("YAxisLabelLocation", enumGetBox(YAxisLabelLocation_$type, b), enumGetBox(YAxisLabelLocation_$type, this.aa5));
        }
    };
    Object.defineProperty(XYChart.prototype, "aa5", {
        get: function () {
            return this.get_aa5();
        },
        set: function (a) {
            this.set_aa5(a);
        },
        enumerable: false,
        configurable: true
    });
    XYChart.prototype.get_aa3 = function () {
        return this.aa2;
    };
    XYChart.prototype.set_aa3 = function (a) {
        var b = this.aa3;
        if (a != b) {
            this.aa2 = a;
            this.wj("XAxisLabelLocation", enumGetBox(XAxisLabelLocation_$type, b), enumGetBox(XAxisLabelLocation_$type, this.aa3));
        }
    };
    Object.defineProperty(XYChart.prototype, "aa3", {
        get: function () {
            return this.get_aa3();
        },
        set: function (a) {
            this.set_aa3(a);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ad2", {
        get: function () {
            return this.adm;
        },
        set: function (a) {
            var b = this.adm;
            if (a != b) {
                this.adm = a;
                this.wj("XAxisLabelFormat", b, this.adm);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "aas", {
        get: function () {
            return this.aaq;
        },
        set: function (a) {
            var b = this.aaq;
            if (a != b) {
                this.aaq = a;
                this.wj("XAxisLabelFormatSpecifiers", b, this.aaq);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ae9", {
        get: function () {
            return this.adq;
        },
        set: function (a) {
            var b = this.adq;
            if (a != b) {
                this.adq = a;
                this.wj("YAxisLabelFormat", b, this.adq);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "aat", {
        get: function () {
            return this.aar;
        },
        set: function (a) {
            var b = this.aar;
            if (a != b) {
                this.aar = a;
                this.wj("YAxisLabelFormatSpecifiers", b, this.aar);
            }
        },
        enumerable: false,
        configurable: true
    });
    XYChart.$t = markType(XYChart, 'XYChart', DomainChart.$);
    return XYChart;
}(DomainChart));
export { XYChart };
