import { AnnotationLayer } from "./AnnotationLayer";
import { DependencyProperty } from "igniteui-react-core";
import { IFastItemColumn$1 } from "igniteui-react-core";
import { Base, Type, Point } from "igniteui-react-core";
import { Series } from "./Series";
import { CalloutPlacementPositionsCollection } from "./CalloutPlacementPositionsCollection";
import { LabelCollisionPlacementPositions } from "igniteui-react-core";
import { HighlightedValueLabelMode } from "igniteui-react-core";
import { AutoCalloutVisibilityMode } from "./AutoCalloutVisibilityMode";
import { Brush } from "igniteui-react-core";
import { Thickness } from "igniteui-react-core";
import { CalloutCollisionMode } from "igniteui-react-core";
import { FontInfo } from "igniteui-react-core";
import { Rect } from "igniteui-react-core";
import { CalloutLayerFrame } from "./CalloutLayerFrame";
import { Size } from "igniteui-react-core";
import { CalloutAnnotationWrapper } from "./CalloutAnnotationWrapper";
import { FastItemsSourceEventAction } from "igniteui-react-core";
import { CalloutLabelUpdatingEventArgs } from "./CalloutLabelUpdatingEventArgs";
import { CalloutSeriesSelectingEventArgs } from "./CalloutSeriesSelectingEventArgs";
import { CalloutStyleUpdatingEventArgs } from "./CalloutStyleUpdatingEventArgs";
import { CalloutRenderStyleUpdatingEventArgs } from "./CalloutRenderStyleUpdatingEventArgs";
import { SeriesView } from "./SeriesView";
import { Frame } from "./Frame";
import { CalloutContentUpdatingEventArgs } from "./CalloutContentUpdatingEventArgs";
import { DataContext } from "igniteui-react-core";
import { SeriesHitTestMode } from "./SeriesHitTestMode";
import { HashPool$2 } from "igniteui-react-core";
import { AxisRange } from "./AxisRange";
import { NumericAxisBase } from "./NumericAxisBase";
import { AnnotationLayerView } from "./AnnotationLayerView";
import { RenderingContext } from "igniteui-react-core";
import { TextBlock } from "igniteui-react-core";
import { Visibility } from "igniteui-react-core";
/**
 * @hidden
 */
export declare class CalloutLayer extends AnnotationLayer {
    static $t: Type;
    protected bk(): Series;
    protected get_eq(): boolean;
    constructor();
    private aep;
    private aey;
    private aeq;
    protected pd(a: FastItemsSourceEventAction, b: number, c: number, d: string): void;
    gg(a: boolean): boolean;
    abm: boolean;
    abo: boolean;
    abn: boolean;
    abp: boolean;
    private agv;
    ach: number;
    acf: number;
    aci: number;
    acg: number;
    private abe;
    private aa9;
    private abb;
    private aba;
    private agt;
    wy(): Size;
    private ab2;
    private ae6;
    private ae7;
    calloutStyleUpdating: (sender: any, args: CalloutStyleUpdatingEventArgs) => void;
    calloutRenderStyleUpdating: (sender: any, args: CalloutRenderStyleUpdatingEventArgs) => void;
    ad4: string;
    kr(a: any, b: string): any;
    mf(a: string): string;
    get aa2(): IFastItemColumn$1<any>;
    set aa2(a: IFastItemColumn$1<any>);
    private aax;
    aek: string;
    get aa3(): IFastItemColumn$1<any>;
    set aa3(a: IFastItemColumn$1<any>);
    private aay;
    aen: string;
    get aa4(): IFastItemColumn$1<any>;
    set aa4(a: IFastItemColumn$1<any>);
    private aaz;
    ady: string;
    get aa1(): IFastItemColumn$1<any>;
    set aa1(a: IFastItemColumn$1<any>);
    private aaw;
    abr: boolean;
    ad1: string;
    aab: any[];
    adq: string;
    get aa0(): IFastItemColumn$1<any>;
    set aa0(a: IFastItemColumn$1<any>);
    private aav;
    private ab3;
    private ab6;
    private aes;
    protected ct(): SeriesView;
    q3(a: SeriesView): void;
    protected aal: CalloutLayerView;
    private ab7;
    ad7: string;
    aas: Series;
    adn: string;
    private aam;
    get aan(): CalloutPlacementPositionsCollection;
    set aan(a: CalloutPlacementPositionsCollection);
    aaa: LabelCollisionPlacementPositions[];
    abq: boolean;
    abw: boolean;
    abz: boolean;
    gv(a: Series): boolean;
    abv: boolean;
    abx: boolean;
    aby: boolean;
    ab0: boolean;
    aar: HighlightedValueLabelMode;
    get aag(): AutoCalloutVisibilityMode;
    set aag(a: AutoCalloutVisibilityMode);
    get aaf(): AutoCalloutVisibilityMode;
    set aaf(a: AutoCalloutVisibilityMode);
    static readonly afw: DependencyProperty;
    ace: number;
    abt: boolean;
    abs: boolean;
    acs: number;
    agp: Brush;
    agn: Brush;
    agl: Brush;
    agk: Brush;
    abu: boolean;
    act: number;
    ago: Brush;
    agm: Brush;
    get agu(): Thickness;
    ack: number;
    acm: number;
    acl: number;
    acj: number;
    aai: CalloutCollisionMode;
    acn: number;
    aco: number;
    aea: string;
    private aat;
    get aau(): FontInfo;
    protected yw(a: Series, b: boolean): void;
    private ab8;
    private ab9;
    protected yy(a: Frame, b: SeriesView): void;
    private acr;
    private acc;
    private acb;
    private ab4;
    private ab1;
    private aa5;
    private agr;
    protected sv(a: Rect, b: Rect): void;
    protected su(a: Rect, b: Rect): void;
    private abg;
    private abi;
    private acq;
    private agq;
    get ags(): Rect;
    set ags(a: Rect);
    private abf;
    private aez;
    private aec;
    private aeu;
    private aa6;
    private acu;
    private acv;
    private aa7;
    private aer;
    private aa8;
    private acp;
    private aca;
    private acw;
    protected xn(a: Series): boolean;
    qr(): void;
    private abh;
    aex(): void;
    calloutContentUpdating: (sender: any, args: CalloutContentUpdatingEventArgs) => void;
    calloutLabelUpdating: (sender: any, args: CalloutLabelUpdatingEventArgs) => void;
    calloutSeriesSelecting: (sender: any, args: CalloutSeriesSelectingEventArgs) => void;
    private ab5;
    private ae0;
    private abk;
    private abl;
    private acd;
    private abj;
    protected b3(): SeriesHitTestMode;
    a2(a: Point, b: boolean): DataContext;
    gx(a: Point, b: boolean): boolean;
    protected ae5(a: CalloutLayerFrame, b: boolean): void;
    protected y1(a: Frame, b: SeriesView): void;
    protected gb(): boolean;
    private aad;
    protected rc(a: any, b: string, c: any, d: any): void;
    private aah;
    private aac;
    private ae4;
    private abc;
    private abd;
    private aae;
    private aev;
    ax(a: AxisRange, b: NumericAxisBase, c: Rect): AxisRange;
    ae1(): void;
    ae2(): void;
    private aet;
    private aew;
    ae3(): void;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class CalloutLayerView extends AnnotationLayerView {
    static $t: Type;
    constructor(a: CalloutLayer);
    protected cn: CalloutLayer;
    private cs;
    a4(): void;
    private cp;
    private cv;
    private cx;
    private cw;
    cr: HashPool$2<CalloutAnnotationWrapper, CalloutView>;
    c6(a: Brush): Brush;
    protected bj(a: RenderingContext, b: boolean): void;
    protected cq(): FontInfo;
    ax(a: any): void;
    private ct;
    c8(a: TextBlock): Size;
    private cu;
    private co;
    c7(a: any, b: Thickness): Size;
    cz(a: CalloutView, b: number, c: number): void;
    c0(a: CalloutView, b: CalloutAnnotationWrapper, c: any): void;
    c1(a: Series, b: Brush): Brush;
    c4(): Brush;
    c2(): Brush;
    c5(a: Series, b: Brush): Brush;
    c3(a: Series, b: Brush): Brush;
    cy(): void;
}
/**
 * @hidden
 */
export declare class CalloutView extends Base {
    static $t: Type;
    constructor(a: CalloutLayerView);
    private a;
    y: Visibility;
    j(a: RenderingContext): void;
    private l;
    private t;
    private q;
    private s;
    get r(): Point;
    set r(a: Point);
    get p(): Brush;
    set p(a: Brush);
    get o(): Brush;
    set o(a: Brush);
    get n(): Brush;
    set n(a: Brush);
    get m(): Brush;
    set m(a: Brush);
    get e(): number;
    set e(a: number);
    private w;
    private v;
    get x(): Thickness;
    set x(a: Thickness);
    private c;
    get d(): number;
    set d(a: number);
    get h(): any;
    set h(a: any);
    f: number;
    g: number;
    u(): Size;
    private b;
    k(a: Series, b: CalloutAnnotationWrapper, c: any): void;
    i(a: CalloutLayer, b: FontInfo, c: any): void;
}
