import { RadialBaseChart } from "./RadialBaseChart";
import { ProportionalCategoryAngleAxis } from "./ProportionalCategoryAngleAxis";
import { NumericRadiusAxis } from "./NumericRadiusAxis";
import { PropertyChangedEventArgs, Type } from "igniteui-react-core";
import { PieChartSweepDirection } from "./PieChartSweepDirection";
import { CalloutCollisionMode } from "igniteui-react-core";
import { Brush } from "igniteui-react-core";
import { LegendEmptyValuesMode } from "igniteui-react-core";
import { OthersCategoryType } from "igniteui-react-core";
import { AxisRangeBufferMode } from "./AxisRangeBufferMode";
import { RadialLabelMode } from "igniteui-react-core";
import { CollisionAvoidanceType } from "./CollisionAvoidanceType";
import { RadialBase } from "./RadialBase";
import { Series } from "./Series";
import { RadialPieSeries } from "./RadialPieSeries";
import { DataSeries } from "igniteui-react-core";
import { Axis } from "./Axis";
import { MarkerType } from "./MarkerType";
import { DataSeriesType } from "igniteui-react-core";
import { XamDataChart } from "./XamDataChart";
import { OthersCategoryContext } from "./OthersCategoryContext";
/**
 * @hidden
 */
export declare abstract class DataPieBaseChart extends RadialBaseChart {
    static $t: Type;
    constructor();
    protected hk(): boolean;
    protected all(a: (arg1: RadialBase) => void): void;
    protected alm(a: (arg1: RadialBase, arg2: number) => void): void;
    protected alj(a: (arg1: RadialPieSeries) => void): void;
    protected alk(a: (arg1: RadialPieSeries, arg2: number) => void): void;
    protected xg(): void;
    protected c2(a: Series, b: number): MarkerType;
    protected xe(a: DataSeries): void;
    protected hg(a: DataSeries): boolean;
    protected xh(): void;
    private aiq;
    get angleAxis(): ProportionalCategoryAngleAxis;
    set angleAxis(a: ProportionalCategoryAngleAxis);
    private aij;
    get valueAxis(): NumericRadiusAxis;
    set valueAxis(a: NumericRadiusAxis);
    protected get_ai4(): boolean;
    protected get ai4(): boolean;
    protected dc(a: DataSeries, b: DataSeriesType): Series;
    protected vt(a: Series, b: number): void;
    private aiw;
    protected aaw(): Axis;
    protected aax(): Axis;
    protected u3(): void;
    protected aln(a: any, b: PropertyChangedEventArgs): void;
    protected alo(a: any, b: PropertyChangedEventArgs): void;
    protected ux(a: Series, b: number): void;
    protected agf(a: Axis): void;
    protected agd(a: Axis): void;
    protected vo(a: XamDataChart): void;
    protected wj(a: string, b: any, c: any): void;
    private aj3;
    get ak0(): string;
    set ak0(a: string);
    private ah6;
    get aia(): any[];
    set aia(a: any[]);
    private ajz;
    get akk(): string;
    set akk(a: string);
    private ah4;
    get ah8(): any[];
    set ah8(a: any[]);
    private aj1;
    get akt(): string;
    set akt(a: string);
    private ah5;
    get ah9(): any[];
    set ah9(a: any[]);
    private ajy;
    get akg(): string;
    set akg(a: string);
    private ah3;
    get ah7(): any[];
    set ah7(a: any[]);
    private aja;
    get ajk(): number;
    set ajk(a: number);
    private aio;
    get aip(): PieChartSweepDirection;
    set aip(a: PieChartSweepDirection);
    private aid;
    get aie(): CalloutCollisionMode;
    set aie(a: CalloutCollisionMode);
    private alq;
    get als(): Brush;
    set als(a: Brush);
    private alp;
    get alr(): Brush;
    set alr(a: Brush);
    private aj4;
    get alg(): string;
    set alg(a: string);
    private ajx;
    get ake(): string;
    set ake(a: string);
    private aih;
    get aii(): LegendEmptyValuesMode;
    set aii(a: LegendEmptyValuesMode);
    private aim;
    get ain(): OthersCategoryType;
    set ain(a: OthersCategoryType);
    private ajb;
    get ajl(): number;
    set ajl(a: number);
    private aj0;
    get akp(): string;
    set akp(a: string);
    ail(): OthersCategoryContext;
    private ajw;
    get akb(): string;
    set akb(a: string);
    private ai0;
    get ai6(): boolean;
    set ai6(a: boolean);
    private aib;
    get aic(): AxisRangeBufferMode;
    set aic(a: AxisRangeBufferMode);
    private ai8;
    get aji(): number;
    set aji(a: number);
    private ai9;
    get ajj(): number;
    set ajj(a: number);
    private aje;
    get ajq(): number;
    set ajq(a: number);
    private ai1;
    get ai7(): boolean;
    set ai7(a: boolean);
    private aju;
    get ajv(): number;
    set ajv(a: number);
    private ajg;
    get ajs(): number;
    set ajs(a: number);
    private ajf;
    get ajr(): number;
    set ajr(a: number);
    private ajh;
    get ajt(): number;
    set ajt(a: number);
    get ajp(): number;
    get ajo(): number;
    private ajc;
    get ajm(): number;
    set ajm(a: number);
    private ajd;
    get ajn(): number;
    set ajn(a: number);
    private aj2;
    get aky(): string;
    set aky(a: string);
    private ait;
    get aiv(): RadialLabelMode;
    set aiv(a: RadialLabelMode);
    private ais;
    get aiu(): RadialLabelMode;
    set aiu(a: RadialLabelMode);
    private aix;
    get ai2(): boolean;
    set ai2(a: boolean);
    private aiz;
    get ai5(): boolean;
    set ai5(a: boolean);
    private aif;
    get aig(): CollisionAvoidanceType;
    set aig(a: CollisionAvoidanceType);
    private aiy;
    get ai3(): boolean;
    set ai3(a: boolean);
}
