import { Base, INotifyPropertyChanged, Type, IEnumerable, PropertyChangedEventArgs, Point } from "igniteui-react-core";
import { IDataLegendTarget } from "igniteui-react-core";
import { IToolbarTarget } from "igniteui-react-core";
import { IDomainChartLike } from "./IDomainChartLike";
import { List$1 } from "igniteui-react-core";
import { Brush } from "igniteui-react-core";
import { IDomainChartWidget } from "./IDomainChartWidget";
import { XamDataChart } from "./XamDataChart";
import { DataSeriesAdapterImplementation } from "igniteui-react-core";
import { DataSeriesType } from "igniteui-react-core";
import { IDataSeriesAdapterRule } from "igniteui-react-core";
import { MarkerType } from "./MarkerType";
import { IAnnotationLayerProxy } from "./IAnnotationLayerProxy";
import { Color } from "igniteui-react-core";
import { IDomainChartToolbarProvider } from "./IDomainChartToolbarProvider";
import { ToolCommand } from "igniteui-react-core";
import { DataToolTipLayerGroupingMode } from "igniteui-react-core";
import { DataTooltipGroupedPositionX } from "igniteui-react-core";
import { DataTooltipGroupedPositionY } from "igniteui-react-core";
import { DataAbbreviationMode } from "igniteui-react-core";
import { DataLegendValueMode } from "igniteui-react-core";
import { Thickness } from "igniteui-react-core";
import { FontInfo } from "igniteui-react-core";
import { DataLegendHeaderDateMode } from "igniteui-react-core";
import { DataLegendHeaderTimeMode } from "igniteui-react-core";
import { DataLegendSummaryType } from "igniteui-react-core";
import { LegendItemBadgeShape } from "igniteui-react-core";
import { DataLegendUnitsMode } from "igniteui-react-core";
import { DataLegendLabelMode } from "igniteui-react-core";
import { DomainType } from "./DomainType";
import { ChartSortDescriptionCollection } from "./ChartSortDescriptionCollection";
import { FilterExpressionCollection } from "igniteui-react-core";
import { ChartSummaryDescriptionCollection } from "./ChartSummaryDescriptionCollection";
import { SeriesSelectionMode } from "./SeriesSelectionMode";
import { SeriesSelectionBehavior } from "./SeriesSelectionBehavior";
import { ChartSelectedItemCollection } from "./ChartSelectedItemCollection";
import { FilterStringErrorsParsingEventArgs } from "./FilterStringErrorsParsingEventArgs";
import { BrushCollection } from "igniteui-react-core";
import { IChartLegend } from "igniteui-react-core";
import { SeriesHighlightedValuesDisplayMode } from "igniteui-react-core";
import { Visibility } from "igniteui-react-core";
import { Rect } from "igniteui-react-core";
import { HorizontalAlignment } from "igniteui-react-core";
import { UnknownValuePlotting } from "igniteui-react-core";
import { SeriesOutlineMode } from "./SeriesOutlineMode";
import { MarkerOutlineMode } from "./MarkerOutlineMode";
import { MarkerFillMode } from "./MarkerFillMode";
import { MarkerTypeCollection } from "./MarkerTypeCollection";
import { MarkerAutomaticBehavior } from "./MarkerAutomaticBehavior";
import { TrendLineType } from "igniteui-react-core";
import { TrendLineTypeCollection } from "./TrendLineTypeCollection";
import { ComputedPlotAreaMarginMode } from "./ComputedPlotAreaMarginMode";
import { SeriesPlotAreaMarginHorizontalMode } from "./SeriesPlotAreaMarginHorizontalMode";
import { SeriesPlotAreaMarginVerticalMode } from "./SeriesPlotAreaMarginVerticalMode";
import { SeriesHighlightingMode } from "./SeriesHighlightingMode";
import { SeriesHighlightingBehavior } from "./SeriesHighlightingBehavior";
import { LegendHighlightingMode } from "./LegendHighlightingMode";
import { LegendItemBadgeMode } from "igniteui-react-core";
import { ToolTipType } from "./ToolTipType";
import { CrosshairsDisplayMode } from "./CrosshairsDisplayMode";
import { CalloutCollisionMode } from "igniteui-react-core";
import { CalloutPlacementPositionsCollection } from "./CalloutPlacementPositionsCollection";
import { ValueModeCollection } from "./ValueModeCollection";
import { SeriesViewerScrollbarMode } from "./SeriesViewerScrollbarMode";
import { SeriesViewerHorizontalScrollbarPosition } from "./SeriesViewerHorizontalScrollbarPosition";
import { SeriesViewerVerticalScrollbarPosition } from "./SeriesViewerVerticalScrollbarPosition";
import { Series } from "./Series";
import { DataSeries } from "igniteui-react-core";
import { IDataLegend } from "igniteui-react-core";
import { ICommandStateChangedListener } from "igniteui-react-core";
import { Axis } from "./Axis";
import { ObservableColorCollection } from "igniteui-react-core";
import { DataSeriesMarker } from "igniteui-react-core";
import { IDataLegendSeries } from "igniteui-react-core";
import { ToolActionInfo } from "igniteui-react-core";
import { IToolbarContextAccessor } from "igniteui-react-core";
import { ToolCommandExecutionState } from "igniteui-react-core";
import { ICommandAvailabilityListener } from "igniteui-react-core";
import { ChartSeriesEventArgs } from "./ChartSeriesEventArgs";
import { DomainChartSeriesPointerEventArgs } from "./DomainChartSeriesPointerEventArgs";
import { DomainChartPlotAreaPointerEventArgs } from "./DomainChartPlotAreaPointerEventArgs";
import { CalloutStyleUpdatingEventArgs } from "./CalloutStyleUpdatingEventArgs";
import { CalloutRenderStyleUpdatingEventArgs } from "./CalloutRenderStyleUpdatingEventArgs";
import { SeriesViewerSelectedSeriesItemsChangedEventArgs } from "./SeriesViewerSelectedSeriesItemsChangedEventArgs";
import { DataSourcePropertiesRequestedChangedEventArgs } from "igniteui-react-core";
/**
 * @hidden
 */
export declare abstract class DomainChart extends Base implements INotifyPropertyChanged, IDataLegendTarget, IToolbarTarget, IDomainChartLike {
    static $t: Type;
    protected l8: any;
    provideContainer(a: any): void;
    destroy(): void;
    private vr;
    protected vs(): void;
    protected vo(a: XamDataChart): void;
    protected vl(): void;
    protected vu(a: Series, b: number): void;
    protected wn(a: string, b: any, c: any): void;
    private l5;
    get tooltipTemplate(): any;
    set tooltipTemplate(a: any);
    private h0;
    get tooltipTemplates(): List$1<any>;
    set tooltipTemplates(a: List$1<any>);
    private ix;
    get j9(): number;
    set j9(a: number);
    private l4;
    private get toolTip();
    private set toolTip(value);
    private ja;
    get km(): number;
    set km(a: number);
    private jb;
    get kn(): number;
    set kn(a: number);
    private jc;
    get ko(): number;
    set ko(a: number);
    private i9;
    get kl(): number;
    set kl(a: number);
    private i5;
    get kh(): number;
    set kh(a: number);
    private i7;
    get kj(): number;
    set kj(a: number);
    private i6;
    get ki(): number;
    set ki(a: number);
    private i4;
    get kg(): number;
    set kg(a: number);
    private yp;
    get zq(): Brush;
    set zq(a: Brush);
    private yq;
    get zr(): Brush;
    set zr(a: Brush);
    private iu;
    protected get_j6(): number;
    protected set_j6(a: number): void;
    get j6(): number;
    set j6(a: number);
    private jd;
    get kp(): number;
    set kp(a: number);
    private i3;
    get kf(): number;
    set kf(a: number);
    private ie;
    get js(): number;
    set js(a: number);
    private lj;
    get ly(): number;
    set ly(a: number);
    private et;
    get eu(): (time: number) => number;
    set eu(a: (time: number) => number);
    private le;
    get lu(): number;
    set lu(a: number);
    private lh;
    get lx(): number;
    set lx(a: number);
    private lc;
    get ls(): number;
    set ls(a: number);
    protected vp(a: XamDataChart): void;
    protected vv(a: Series, b: number): void;
    protected vm(): void;
    private vw;
    k3: (arg1: HTMLElement) => any[];
    private xp;
    private ma;
    private hj;
    private k4;
    protected wo(a: string, b: any, c: any): void;
    private ck;
    get cl(): IDomainChartWidget;
    set cl(a: IDomainChartWidget);
    private m5;
    get tf(): string;
    set tf(a: string);
    private m7;
    get tq(): string;
    set tq(a: string);
    private eh;
    get dataChart(): XamDataChart;
    set dataChart(a: XamDataChart);
    bf: DataSeriesAdapterImplementation;
    get currentDataAdapter(): DataSeriesAdapterImplementation;
    private f3;
    private fj;
    sendCommandCompleted(a: ToolCommand): void;
    captureTargetImageToClipboard(a: (arg1: any, arg2: any) => void): void;
    private wg;
    bg: DataSeriesAdapterImplementation;
    private f7;
    private f6;
    get isDetached(): boolean;
    onDetachedFromUI(): void;
    onAttachedToUI(): void;
    constructor();
    protected vq(): void;
    private xn;
    private xm;
    private xo;
    bh(a: boolean): DataSeriesAdapterImplementation;
    protected abstract get h6(): List$1<DataSeriesType>;
    protected abstract get h5(): List$1<IDataSeriesAdapterRule>;
    protected h4: List$1<MarkerType>;
    protected he(a: DataSeriesType): boolean;
    notifyResized(): void;
    v5(): void;
    va(): void;
    vj(): void;
    propertyChanged: (sender: any, e: PropertyChangedEventArgs) => void;
    seriesDataChanged: (sender: any, e: PropertyChangedEventArgs) => void;
    protected w1(a: string): void;
    protected abstract vb(a: (arg1: Axis) => void, b: boolean): void;
    protected vc(a: (arg1: Series) => void): void;
    protected vd(a: (arg1: Series, arg2: number) => void): void;
    protected vh(a: (arg1: Series) => void): void;
    protected vi(a: (arg1: Series, arg2: number) => void): void;
    protected vf(a: (arg1: Series) => void): void;
    protected vg(a: (arg1: Series, arg2: number) => void): void;
    xd(): void;
    protected v7(a: (arg1: XamDataChart) => void): void;
    protected v8(a: (arg1: XamDataChart) => void, b: boolean): void;
    protected v9(a: (arg1: XamDataChart) => void, b: boolean, c: string): void;
    protected hg(a: DataSeries): boolean;
    protected g6(): boolean;
    private static readonly mj;
    private li;
    protected q6(a: DataSeries): string;
    private static mi;
    protected q7(a: DataSeries, b: DataSeriesType): string;
    protected abstract be(a: DataSeries): DataSeriesType;
    protected abstract dc(a: DataSeries, b: DataSeriesType): Series;
    q5(): string;
    private hc;
    private hb;
    protected wq(): void;
    protected u1(): void;
    private xq;
    private u0;
    private hv;
    protected ia(a: DataSeries): IEnumerable;
    protected ib(a: DataSeries): IEnumerable;
    private u9;
    private g2;
    protected xg(): void;
    protected df(seriesType_: DataSeriesType): Series;
    private c6;
    private c8;
    private da;
    private db;
    private c7;
    private c9;
    private de;
    private dd;
    private cd;
    protected get ce(): IAnnotationLayerProxy;
    private get g1();
    protected g4(a: Series): boolean;
    private xr;
    protected g7(): boolean;
    protected g8(): boolean;
    protected get_g5(): boolean;
    protected get g5(): boolean;
    protected h2(a: string, b: boolean): List$1<Series>;
    private uu;
    private ut;
    protected u2(a: Series, b: boolean): void;
    protected hk(): boolean;
    protected xl(a: Series, b: Series, c: DataSeries): void;
    protected abstract xf(a: DataSeries): void;
    protected abstract xe(a: DataSeries): void;
    protected xi(): void;
    wd(): void;
    private xj;
    protected xk(a: Series): void;
    protected abstract xh(): void;
    private wa;
    private wf;
    protected u6(): void;
    protected hq: boolean;
    protected u7(): void;
    protected zi(a: number): Brush;
    protected zl(a: number): Brush;
    protected zj(a: number): Brush;
    protected zk(a: number): Brush;
    protected zu(a: number): Color;
    protected fh(a: Color): ObservableColorCollection;
    protected aa(a: Color): BrushCollection;
    protected hz: List$1<Color>;
    protected get h1(): List$1<Color>;
    protected get_ho(): boolean;
    protected get ho(): boolean;
    l9(): any;
    vy(a: string, b: string): void;
    vz(a: string, b: string, c: Series): void;
    c0(a: DataSeriesMarker): MarkerType;
    private ch;
    private f9;
    attachDataLegend(a: IDataLegend): void;
    protected uz(a: IDataLegend): void;
    detachDataLegend(a: IDataLegend): void;
    protected u5(a: IDataLegend): void;
    getDataLegendSeries(): IDataLegendSeries[];
    protected o(): IDataLegendSeries[];
    zoomIn(a: number): void;
    zoomOut(a: number): void;
    resetZoom(): void;
    protected get_hf(): boolean;
    get hf(): boolean;
    private ci;
    get cj(): IDomainChartToolbarProvider;
    private wk;
    getDesiredToolbarActions(): ToolActionInfo[];
    onToolCommandExecuting(a: ToolCommand): ToolCommandExecutionState;
    private _commandCompleted;
    get commandCompleted(): (arg1: ToolCommand) => void;
    set commandCompleted(a: (arg1: ToolCommand) => void);
    private _invalidateActions;
    get invalidateActions(): () => void;
    set invalidateActions(a: () => void);
    private hw;
    provideContextAccessor(a: IToolbarContextAccessor): void;
    dismissContextAccessor(a: IToolbarContextAccessor): void;
    private vx;
    addCommandAvailabilityListener(a: ICommandAvailabilityListener): void;
    removeCommandAvailabilityListener(a: ICommandAvailabilityListener): void;
    private hx;
    addCommandStateChangedListener(a: ICommandStateChangedListener): void;
    removeCommandStateChangedListener(a: ICommandStateChangedListener): void;
    notifySeriesDataChanged(): void;
    v4(source_: any, a: number, b: any, c: any): void;
    v0(source_: any): void;
    v1(source_: any, a: number, b: any): void;
    v2(source_: any, a: number, b: any): void;
    private by;
    get bz(): DataToolTipLayerGroupingMode;
    set bz(a: DataToolTipLayerGroupingMode);
    private ik;
    get jx(): number;
    set jx(a: number);
    private il;
    get jy(): number;
    set jy(a: number);
    private ii;
    get jv(): number;
    set jv(a: number);
    private ij;
    get jw(): number;
    set jw(a: number);
    private bu;
    get bv(): DataTooltipGroupedPositionX;
    set bv(a: DataTooltipGroupedPositionX);
    private bw;
    get bx(): DataTooltipGroupedPositionY;
    set bx(a: DataTooltipGroupedPositionY);
    private fz;
    get gx(): boolean;
    set gx(a: boolean);
    static readonly pn: string;
    get m(): string[];
    set m(a: string[]);
    private e;
    get j(): string[];
    set j(a: string[]);
    private b;
    get l(): string[];
    set l(a: string[]);
    private d;
    get i(): string[];
    set i(a: string[]);
    private a;
    get bd(): DataAbbreviationMode;
    set bd(a: DataAbbreviationMode);
    private bc;
    get lo(): number;
    set lo(a: number);
    private k8;
    get lp(): number;
    set lp(a: number);
    private k9;
    get bt(): DataLegendValueMode;
    set bt(a: DataLegendValueMode);
    private bs;
    get qf(): string;
    set qf(a: string);
    private mv;
    get gy(): boolean;
    set gy(a: boolean);
    private f0;
    get ql(): string;
    set ql(a: string);
    private mw;
    get n(): any[];
    set n(a: any[]);
    private f;
    get aak(): Thickness;
    set aak(a: Thickness);
    private z8;
    get gz(): boolean;
    set gz(a: boolean);
    private f1;
    get qu(): string;
    set qu(a: string);
    private mx;
    get g0(): boolean;
    set g0(a: boolean);
    private f2;
    get aal(): Thickness;
    set aal(a: Thickness);
    private z9;
    get ze(): Brush;
    set ze(a: Brush);
    private yi;
    private e5;
    get fg(): FontInfo;
    set fg(a: FontInfo);
    get o5(): string;
    set o5(a: string);
    private mp;
    get k(): any[];
    set k(a: any[]);
    private c;
    get o1(): string;
    set o1(a: string);
    private mo;
    get bj(): DataLegendHeaderDateMode;
    set bj(a: DataLegendHeaderDateMode);
    private bi;
    get bl(): DataLegendHeaderTimeMode;
    set bl(a: DataLegendHeaderTimeMode);
    private bk;
    get pa(): string;
    set pa(a: string);
    private mq;
    get y6(): Brush;
    set y6(a: Brush);
    private ya;
    get aae(): Thickness;
    set aae(a: Thickness);
    private z2;
    get aad(): Thickness;
    set aad(a: Thickness);
    private z1;
    get gw(): boolean;
    set gw(a: boolean);
    private fy;
    private ex;
    get e8(): FontInfo;
    set e8(a: FontInfo);
    get y5(): Brush;
    set y5(a: Brush);
    private x9;
    get aac(): Thickness;
    set aac(a: Thickness);
    private z0;
    get aab(): Thickness;
    set aab(a: Thickness);
    private zz;
    get gv(): boolean;
    set gv(a: boolean);
    private fx;
    private ew;
    get e7(): FontInfo;
    set e7(a: FontInfo);
    get y9(): Brush;
    set y9(a: Brush);
    private yd;
    private e0;
    get fb(): FontInfo;
    set fb(a: FontInfo);
    get bp(): DataLegendSummaryType;
    set bp(a: DataLegendSummaryType);
    private bo;
    get pt(): string;
    set pt(a: string);
    private ms;
    get aah(): Thickness;
    set aah(a: Thickness);
    private z5;
    get aag(): Thickness;
    set aag(a: Thickness);
    private z4;
    get zb(): Brush;
    set zb(a: Brush);
    private yf;
    private e2;
    get fd(): FontInfo;
    set fd(a: FontInfo);
    get po(): string;
    set po(a: string);
    private mr;
    get y8(): Brush;
    set y8(a: Brush);
    private yc;
    private ez;
    get fa(): FontInfo;
    set fa(a: FontInfo);
    get pz(): string;
    set pz(a: string);
    private mt;
    get za(): Brush;
    set za(a: Brush);
    private ye;
    private e1;
    get fc(): FontInfo;
    set fc(a: FontInfo);
    get aaa(): Thickness;
    set aaa(a: Thickness);
    private zy;
    get cs(): LegendItemBadgeShape;
    set cs(a: LegendItemBadgeShape);
    private cq;
    get br(): DataLegendUnitsMode;
    set br(a: DataLegendUnitsMode);
    private bq;
    get p9(): string;
    set p9(a: string);
    private mu;
    get zd(): Brush;
    set zd(a: Brush);
    private yh;
    get aaj(): Thickness;
    set aaj(a: Thickness);
    private z7;
    private e4;
    get ff(): FontInfo;
    set ff(a: FontInfo);
    get aai(): Thickness;
    set aai(a: Thickness);
    private z6;
    get zc(): Brush;
    set zc(a: Brush);
    private yg;
    private e3;
    get fe(): FontInfo;
    set fe(a: FontInfo);
    get bn(): DataLegendLabelMode;
    set bn(a: DataLegendLabelMode);
    private bm;
    get y7(): Brush;
    set y7(a: Brush);
    private yb;
    get aaf(): Thickness;
    set aaf(a: Thickness);
    private z3;
    private ey;
    get e9(): FontInfo;
    set e9(a: FontInfo);
    seriesAdded: (sender: any, args: ChartSeriesEventArgs) => void;
    w3(a: Series): void;
    seriesRemoved: (sender: any, args: ChartSeriesEventArgs) => void;
    xb(a: Series): void;
    seriesPointerEnter: (sender: any, args: DomainChartSeriesPointerEventArgs) => void;
    w7(a: Series, b: any, c: Point): void;
    seriesPointerLeave: (sender: any, args: DomainChartSeriesPointerEventArgs) => void;
    w8(a: Series, b: any, c: Point): void;
    seriesPointerMove: (sender: any, args: DomainChartSeriesPointerEventArgs) => void;
    w9(a: Series, b: any, c: Point): void;
    seriesPointerDown: (sender: any, args: DomainChartSeriesPointerEventArgs) => void;
    w6(a: Series, b: any, c: Point): void;
    seriesPointerUp: (sender: any, args: DomainChartSeriesPointerEventArgs) => void;
    xa(a: Series, b: any, c: Point): void;
    seriesClick: (sender: any, args: DomainChartSeriesPointerEventArgs) => void;
    w4(a: Series, b: DomainChartSeriesPointerEventArgs): void;
    plotAreaPointerEnter: (sender: any, args: DomainChartPlotAreaPointerEventArgs) => void;
    wx(a: Point): void;
    plotAreaPointerLeave: (sender: any, args: DomainChartPlotAreaPointerEventArgs) => void;
    wy(a: Point): void;
    plotAreaPointerMove: (sender: any, args: DomainChartPlotAreaPointerEventArgs) => void;
    wz(a: Point): void;
    plotAreaPointerDown: (sender: any, args: DomainChartPlotAreaPointerEventArgs) => void;
    ww(a: Point): void;
    plotAreaPointerUp: (sender: any, args: DomainChartPlotAreaPointerEventArgs) => void;
    w0(a: Point): void;
    calloutStyleUpdating: (sender: any, args: CalloutStyleUpdatingEventArgs) => void;
    wu(a: any, b: CalloutStyleUpdatingEventArgs): void;
    calloutRenderStyleUpdating: (sender: any, args: CalloutRenderStyleUpdatingEventArgs) => void;
    wt(a: any, b: CalloutRenderStyleUpdatingEventArgs): void;
    selectedSeriesItemsChanged: (sender: any, e: SeriesViewerSelectedSeriesItemsChangedEventArgs) => void;
    w2(a: any, b: SeriesViewerSelectedSeriesItemsChangedEventArgs): void;
    focusedSeriesItemsChanged: (sender: any, e: SeriesViewerSelectedSeriesItemsChangedEventArgs) => void;
    wv(a: any, b: SeriesViewerSelectedSeriesItemsChangedEventArgs): void;
    private w5;
    private h3;
    wr(a: () => void): void;
    private fi;
    ws(a: () => void, b: boolean): {
        p1?: boolean;
    };
    protected get_hh(): boolean;
    protected get hh(): boolean;
    protected vn(a: XamDataChart, b: any): void;
    protected ve(): void;
    protected ae(a: BrushCollection): BrushCollection;
    protected zo(a: Brush): Brush;
    protected vt(a: Series, b: number): void;
    protected abstract u3(): void;
    protected get gm(): boolean;
    private fm;
    protected u8(): void;
    protected vk(): void;
    protected xc(a: XamDataChart): void;
    protected uy(a: Series, b: number): void;
    protected abstract ux(a: Series, b: number): void;
    protected c2(a: Series, b: number): MarkerType;
    protected c1(a: Series): MarkerType;
    protected c3(a: Series): MarkerType;
    protected me(): any;
    protected md(): any;
    protected get_g9(): boolean;
    protected get g9(): boolean;
    protected ic(): IEnumerable;
    protected wj(a: string, b: any, c: any): void;
    private hu;
    private hy;
    private wc;
    private uw;
    private uv;
    private wh;
    private wm;
    wb(a: any, b: DataSourcePropertiesRequestedChangedEventArgs): void;
    private xs;
    private wl;
    abstract get cb(): DomainType;
    private ax;
    private at;
    private as;
    private ej;
    private ek;
    private a5;
    private er;
    private es;
    private aw;
    private av;
    private au;
    private em;
    private el;
    private a4;
    get a3(): ChartSortDescriptionCollection;
    get az(): ChartSortDescriptionCollection;
    get ay(): ChartSortDescriptionCollection;
    get en(): FilterExpressionCollection;
    get eo(): FilterExpressionCollection;
    get a7(): ChartSummaryDescriptionCollection;
    private dw;
    get dy(): SeriesSelectionMode;
    set dy(a: SeriesSelectionMode);
    private dv;
    get dx(): SeriesSelectionMode;
    set dx(a: SeriesSelectionMode);
    private yo;
    get zp(): Brush;
    set zp(a: Brush);
    private yl;
    get zh(): Brush;
    set zh(a: Brush);
    private dt;
    get du(): SeriesSelectionBehavior;
    set du(a: SeriesSelectionBehavior);
    private an;
    get selectedSeriesItems(): ChartSelectedItemCollection;
    private am;
    get focusedSeriesItems(): ChartSelectedItemCollection;
    get a2(): ChartSortDescriptionCollection;
    get a1(): ChartSortDescriptionCollection;
    get a0(): ChartSortDescriptionCollection;
    get ep(): FilterExpressionCollection;
    get eq(): FilterExpressionCollection;
    get a6(): ChartSummaryDescriptionCollection;
    private m2;
    get r0(): string;
    set r0(a: string);
    private my;
    get q8(): string;
    set q8(a: string);
    private m0;
    get rw(): string;
    set rw(a: string);
    private mz;
    get ru(): string;
    set ru(a: string);
    private m1;
    get ry(): string;
    set ry(a: string);
    filterStringErrorsParsing: (sender: any, args: FilterStringErrorsParsingEventArgs) => void;
    private m3;
    get r2(): string;
    set r2(a: string);
    private l3;
    get itemsSource(): any;
    set itemsSource(a: any);
    private l1;
    get actualItemsSource(): any;
    set actualItemsSource(a: any);
    private l2;
    get highlightedItemsSource(): any;
    set highlightedItemsSource(a: any);
    private l0;
    get actualHighlightedItemsSource(): any;
    set actualHighlightedItemsSource(a: any);
    private h;
    get includedProperties(): string[];
    set includedProperties(a: string[]);
    private g;
    get excludedProperties(): string[];
    set excludedProperties(a: string[]);
    private r;
    get z(): BrushCollection;
    set z(a: BrushCollection);
    private u;
    get ad(): BrushCollection;
    set ad(a: BrushCollection);
    private p;
    get x(): BrushCollection;
    set x(a: BrushCollection);
    private q;
    get y(): BrushCollection;
    set y(a: BrushCollection);
    private cf;
    get legend(): IChartLegend;
    set legend(a: IChartLegend);
    private f8;
    protected get_ha(): boolean;
    protected set_ha(a: boolean): void;
    get ha(): boolean;
    set ha(a: boolean);
    private gb;
    protected get_hi(): boolean;
    protected set_hi(a: boolean): void;
    get hi(): boolean;
    set hi(a: boolean);
    private ge;
    protected get_hm(): boolean;
    protected set_hm(a: boolean): void;
    get hm(): boolean;
    set hm(a: boolean);
    private gg;
    protected get_hp(): boolean;
    protected set_hp(a: boolean): void;
    get hp(): boolean;
    set hp(a: boolean);
    private dg;
    protected get_dh(): SeriesHighlightedValuesDisplayMode;
    protected set_dh(a: SeriesHighlightedValuesDisplayMode): void;
    get dh(): SeriesHighlightedValuesDisplayMode;
    set dh(a: SeriesHighlightedValuesDisplayMode);
    private ga;
    protected get_hd(): boolean;
    protected set_hd(a: boolean): void;
    get hd(): boolean;
    set hd(a: boolean);
    private aam;
    protected get_aao(): Visibility;
    protected set_aao(a: Visibility): void;
    get aao(): Visibility;
    set aao(a: Visibility);
    private aan;
    protected get_aap(): Visibility;
    protected set_aap(a: Visibility): void;
    get aap(): Visibility;
    set aap(a: Visibility);
    private zv;
    get zx(): Rect;
    set zx(a: Rect);
    get zw(): Rect;
    private m6;
    get tj(): string;
    set tj(a: string);
    private m4;
    get s8(): string;
    set s8(a: string);
    private xu;
    get xw(): HorizontalAlignment;
    set xw(a: HorizontalAlignment);
    private xt;
    get xv(): HorizontalAlignment;
    set xv(a: HorizontalAlignment);
    private ee;
    get ef(): UnknownValuePlotting;
    set ef(a: UnknownValuePlotting);
    private i2;
    protected get_ke(): number;
    protected set_ke(a: number): void;
    get ke(): number;
    set ke(a: number);
    private i8;
    get kk(): number;
    set kk(a: number);
    private dm;
    get dn(): SeriesOutlineMode;
    set dn(a: SeriesOutlineMode);
    private cy;
    get cz(): MarkerOutlineMode;
    set cz(a: MarkerOutlineMode);
    private cw;
    get cx(): MarkerFillMode;
    set cx(a: MarkerFillMode);
    private iv;
    get j7(): number;
    set j7(a: number);
    private iw;
    get j8(): number;
    set j8(a: number);
    private c4;
    get c5(): MarkerTypeCollection;
    set c5(a: MarkerTypeCollection);
    private cu;
    get cv(): MarkerAutomaticBehavior;
    set cv(a: MarkerAutomaticBehavior);
    private s;
    get ab(): BrushCollection;
    set ab(a: BrushCollection);
    private t;
    get ac(): BrushCollection;
    set ac(a: BrushCollection);
    private lf;
    get lv(): number;
    set lv(a: number);
    private id;
    get jr(): number;
    set jr(a: number);
    private fl;
    get gl(): boolean;
    set gl(a: boolean);
    private v;
    get af(): BrushCollection;
    set af(a: BrushCollection);
    private eb;
    get ec(): TrendLineType;
    set ec(a: TrendLineType);
    private je;
    get kq(): number;
    set kq(a: number);
    private ed;
    get trendLineTypes(): TrendLineTypeCollection;
    set trendLineTypes(a: TrendLineTypeCollection);
    private gh;
    protected get_hr(): boolean;
    protected set_hr(a: boolean): void;
    get hr(): boolean;
    set hr(a: boolean);
    private fk;
    get gk(): boolean;
    set gk(a: boolean);
    private iz;
    get kb(): number;
    set kb(a: number);
    private i1;
    get kd(): number;
    set kd(a: number);
    private i0;
    get kc(): number;
    set kc(a: number);
    private iy;
    get ka(): number;
    set ka(a: number);
    protected wi(): void;
    private ld;
    get lt(): number;
    set lt(a: number);
    private lb;
    get lr(): number;
    set lr(a: number);
    private lg;
    get lw(): number;
    set lw(a: number);
    private a8;
    get a9(): ComputedPlotAreaMarginMode;
    set a9(a: ComputedPlotAreaMarginMode);
    protected ba(): ComputedPlotAreaMarginMode;
    private dp;
    get dq(): SeriesPlotAreaMarginHorizontalMode;
    set dq(a: SeriesPlotAreaMarginHorizontalMode);
    private dr;
    get ds(): SeriesPlotAreaMarginVerticalMode;
    set ds(a: SeriesPlotAreaMarginVerticalMode);
    private dk;
    get dl(): SeriesHighlightingMode;
    set dl(a: SeriesHighlightingMode);
    private di;
    get dj(): SeriesHighlightingBehavior;
    set dj(a: SeriesHighlightingBehavior);
    private cm;
    get cn(): LegendHighlightingMode;
    set cn(a: LegendHighlightingMode);
    private cr;
    get ct(): LegendItemBadgeShape;
    set ct(a: LegendItemBadgeShape);
    private co;
    get cp(): LegendItemBadgeMode;
    set cp(a: LegendItemBadgeMode);
    private lk;
    get lz(): number;
    set lz(a: number);
    private d9;
    get ea(): ToolTipType;
    set ea(a: ToolTipType);
    private bb;
    get crosshairsDisplayMode(): CrosshairsDisplayMode;
    set crosshairsDisplayMode(a: CrosshairsDisplayMode);
    private fw;
    get gu(): boolean;
    set gu(a: boolean);
    private x8;
    get y4(): Brush;
    set y4(a: Brush);
    private ih;
    get ju(): number;
    set ju(a: number);
    private x7;
    get y3(): Brush;
    set y3(a: Brush);
    private ft;
    get crosshairsAnnotationEnabled(): boolean;
    set crosshairsAnnotationEnabled(a: boolean);
    private fv;
    get gt(): boolean;
    set gt(a: boolean);
    private fu;
    get gs(): boolean;
    set gs(a: boolean);
    private x3;
    get yz(): Brush;
    set yz(a: Brush);
    private x5;
    get y1(): Brush;
    set y1(a: Brush);
    private x4;
    get y0(): Brush;
    set y0(a: Brush);
    private x6;
    get y2(): Brush;
    set y2(a: Brush);
    private k6;
    get lm(): number;
    set lm(a: number);
    private k7;
    get ln(): number;
    set ln(a: number);
    private gd;
    get shouldAvoidAxisAnnotationCollisions(): boolean;
    set shouldAvoidAxisAnnotationCollisions(a: boolean);
    private gf;
    get hn(): boolean;
    set hn(a: boolean);
    private f4;
    get finalValueAnnotationsVisible(): boolean;
    set finalValueAnnotationsVisible(a: boolean);
    private yj;
    get zf(): Brush;
    set zf(a: Brush);
    private yk;
    get zg(): Brush;
    set zg(a: Brush);
    private la;
    get lq(): number;
    set lq(a: number);
    private fn;
    get autoCalloutsVisible(): boolean;
    set autoCalloutsVisible(a: boolean);
    private fs;
    get gr(): boolean;
    set gr(a: boolean);
    private fo;
    get gn(): boolean;
    set gn(a: boolean);
    private gi;
    get hs(): boolean;
    set hs(a: boolean);
    private ag;
    get ah(): CalloutCollisionMode;
    set ah(a: CalloutCollisionMode);
    private fq;
    get gp(): boolean;
    set gp(a: boolean);
    private fr;
    get gq(): boolean;
    set gq(a: boolean);
    private fp;
    get go(): boolean;
    set go(a: boolean);
    private ig;
    get jt(): number;
    set jt(a: number);
    private xx;
    get yt(): Brush;
    set yt(a: Brush);
    private x1;
    get yx(): Brush;
    set yx(a: Brush);
    private x2;
    get yy(): Brush;
    set yy(a: Brush);
    private x0;
    get yw(): Brush;
    set yw(a: Brush);
    private xy;
    get yu(): Brush;
    set yu(a: Brush);
    private xz;
    get yv(): Brush;
    set yv(a: Brush);
    private k5;
    get ll(): number;
    set ll(a: number);
    private h8;
    get calloutsItemsSource(): IEnumerable;
    set calloutsItemsSource(a: IEnumerable);
    private ai;
    get aj(): CalloutPlacementPositionsCollection;
    set aj(a: CalloutPlacementPositionsCollection);
    private mm;
    get n3(): string;
    set n3(a: string);
    private mn;
    get n5(): string;
    set n5(a: string);
    private ml;
    get nq(): string;
    set nq(a: string);
    private mk;
    get nm(): string;
    set nm(a: string);
    private ev;
    get e6(): FontInfo;
    set e6(a: FontInfo);
    private eg;
    get valueLines(): ValueModeCollection;
    set valueLines(a: ValueModeCollection);
    private w;
    get valueLinesBrushes(): BrushCollection;
    set valueLinesBrushes(a: BrushCollection);
    private jf;
    get kr(): number;
    set kr(a: number);
    private gc;
    protected get_hl(): boolean;
    protected set_hl(a: boolean): void;
    get hl(): boolean;
    set hl(a: boolean);
    get d3(): SeriesViewerScrollbarMode;
    set d3(a: SeriesViewerScrollbarMode);
    private d1;
    get d4(): SeriesViewerScrollbarMode;
    set d4(a: SeriesViewerScrollbarMode);
    private d2;
    get d0(): SeriesViewerHorizontalScrollbarPosition;
    set d0(a: SeriesViewerHorizontalScrollbarPosition);
    private dz;
    get d8(): SeriesViewerVerticalScrollbarPosition;
    set d8(a: SeriesViewerVerticalScrollbarPosition);
    private d7;
    get zm(): Brush;
    set zm(a: Brush);
    private ym;
    get zn(): Brush;
    set zn(a: Brush);
    private yn;
    get j3(): number;
    set j3(a: number);
    private ir;
    get j2(): number;
    set j2(a: number);
    private iq;
    get jz(): number;
    set jz(a: number);
    private im;
    get j0(): number;
    set j0(a: number);
    private io;
    get j1(): number;
    set j1(a: number);
    private ip;
    get j5(): number;
    set j5(a: number);
    private it;
    get j4(): number;
    set j4(a: number);
    private is;
    get g3(): boolean;
    set g3(a: boolean);
    private f5;
    static readonly rp: string;
    get zs(): Brush;
    set zs(a: Brush);
    private yr;
    get zt(): Brush;
    set zt(a: Brush);
    private ys;
    get kv(): number;
    set kv(a: number);
    private jj;
    get ku(): number;
    set ku(a: number);
    private ji;
    get ks(): number;
    set ks(a: number);
    private jg;
    get ky(): number;
    set ky(a: number);
    private jm;
    get kt(): number;
    set kt(a: number);
    private jh;
    get kx(): number;
    set kx(a: number);
    private jl;
    get kw(): number;
    set kw(a: number);
    private jk;
    get ht(): boolean;
    set ht(a: boolean);
    private gj;
    static readonly ui: string;
    get k0(): number;
    set k0(a: number);
    private jo;
    get kz(): number;
    set kz(a: number);
    private jn;
    get k2(): number;
    set k2(a: number);
    private jq;
    get k1(): number;
    set k1(a: number);
    private jp;
}
