import { DomainChart } from "./DomainChart";
import { IEnumerable$1, Type } from "igniteui-react-core";
import { Brush } from "igniteui-react-core";
import { HorizontalAlignment } from "igniteui-react-core";
import { VerticalAlignment } from "igniteui-react-core";
import { Visibility } from "igniteui-react-core";
import { ValueAxisLabelLocation } from "./ValueAxisLabelLocation";
import { AngleAxisLabelLocation } from "./AngleAxisLabelLocation";
import { Axis } from "./Axis";
import { AxisLabelSettings } from "./AxisLabelSettings";
import { TitleSettings } from "./TitleSettings";
import { DataSeries } from "igniteui-react-core";
import { XamDataChart } from "./XamDataChart";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { AxisLabelsLocation } from "./AxisLabelsLocation";
/**
 * @hidden
 */
export declare abstract class RadialBaseChart extends DomainChart {
    static $t: Type;
    provideContainer(a: any): void;
    protected vs(): void;
    protected wn(a: string, b: any, c: any): void;
    private aay;
    get aa0(): (item: any) => string;
    set aa0(a: (item: any) => string);
    private aaz;
    get aa1(): (item: any) => string;
    set aa1(a: (item: any) => string);
    private abd;
    get acf(): number;
    set acf(a: number);
    private abf;
    get ach(): number;
    set ach(a: number);
    private abe;
    get acg(): number;
    set acg(a: number);
    private abc;
    get ace(): number;
    set ace(a: number);
    private abw;
    get ac2(): number;
    set ac2(a: number);
    private aby;
    get ac4(): number;
    set ac4(a: number);
    private abx;
    get ac3(): number;
    set ac3(a: number);
    private abv;
    get ac1(): number;
    set ac1(a: number);
    private agz;
    get ahf(): Brush;
    set ahf(a: Brush);
    private ag6;
    get ahm(): Brush;
    set ahm(a: Brush);
    private agx;
    get ahd(): Brush;
    set ahd(a: Brush);
    private agy;
    get ahe(): Brush;
    set ahe(a: Brush);
    private abq;
    get acs(): number;
    set acs(a: number);
    private ab9;
    get adf(): number;
    set adf(a: number);
    private abp;
    get acr(): number;
    set acr(a: number);
    private ab8;
    get ade(): number;
    set ade(a: number);
    private abs;
    get acu(): number;
    set acu(a: number);
    private acb;
    get adh(): number;
    set adh(a: number);
    private abr;
    get act(): number;
    set act(a: number);
    private aca;
    get adg(): number;
    set adg(a: number);
    private abo;
    get acq(): number;
    set acq(a: number);
    private ab7;
    get add(): number;
    set add(a: number);
    private ag5;
    get ahl(): Brush;
    set ahl(a: Brush);
    private ahc;
    get ahs(): Brush;
    set ahs(a: Brush);
    protected wo(a: string, b: any, c: any): void;
    private adn;
    get aea(): string;
    set aea(a: string);
    private adr;
    get afi(): string;
    set afi(a: string);
    private adp;
    get ae0(): string;
    set ae0(a: string);
    private adt;
    get af8(): string;
    set af8(a: string);
    private age;
    private agg;
    protected xf(a: DataSeries): void;
    protected abstract aaw(): Axis;
    protected abstract aax(): Axis;
    protected agh(a: (arg1: Axis) => void): void;
    protected agi(a: (arg1: Axis) => void, b: string): void;
    protected agn(a: (arg1: Axis) => void, b: boolean): void;
    protected agm(a: (arg1: Axis) => void): void;
    protected vb(a: (arg1: Axis) => void, b: boolean): void;
    protected agl(a: (arg1: TitleSettings) => void): void;
    protected agq(a: (arg1: TitleSettings) => void): void;
    protected ago(a: (arg1: AxisLabelSettings) => void): void;
    protected agj(a: (arg1: AxisLabelSettings) => void): void;
    acv(a: number): number;
    acx(a: number): number;
    acw(a: number): number;
    acy(a: number): number;
    protected xc(a: XamDataChart): void;
    static ae3(a: CategoryAxisBase, b: IEnumerable$1<DataSeries>): string;
    protected vn(a: XamDataChart, b: any): void;
    protected agd(a: Axis): void;
    protected agf(a: Axis): void;
    protected vk(): void;
    protected agb(a: Axis, b: (arg1: AxisLabelSettings) => void): void;
    protected agc(a: Axis, b: (arg1: TitleSettings) => void): void;
    protected wj(a: string, b: any, c: any): void;
    agp(): void;
    agk(): void;
    aa3(a: ValueAxisLabelLocation): AxisLabelsLocation;
    aa2(a: AngleAxisLabelLocation): AxisLabelsLocation;
    private adi;
    get adk(): any;
    set adk(a: any);
    private adj;
    get adl(): any;
    set adl(a: any);
    private ag0;
    get ahg(): Brush;
    set ahg(a: Brush);
    private ag7;
    get ahn(): Brush;
    set ahn(a: Brush);
    private abg;
    get aci(): number;
    set aci(a: number);
    private abz;
    get ac5(): number;
    set ac5(a: number);
    private abj;
    get acl(): number;
    set acl(a: number);
    private ab2;
    get ac8(): number;
    set ac8(a: number);
    private ag2;
    get ahi(): Brush;
    set ahi(a: Brush);
    private ag9;
    get ahp(): Brush;
    set ahp(a: Brush);
    private ag3;
    get ahj(): Brush;
    set ahj(a: Brush);
    private aha;
    get ahq(): Brush;
    set ahq(a: Brush);
    private abk;
    get acm(): number;
    set acm(a: number);
    private ab3;
    get ac9(): number;
    set ac9(a: number);
    private abl;
    get acn(): number;
    set acn(a: number);
    private ab4;
    get ada(): number;
    set ada(a: number);
    private ag4;
    get ahk(): Brush;
    set ahk(a: Brush);
    private ahb;
    get ahr(): Brush;
    set ahr(a: Brush);
    private abm;
    get aco(): number;
    set aco(a: number);
    private ab5;
    get adb(): number;
    set adb(a: number);
    private ado;
    get aer(): string;
    set aer(a: string);
    private ads;
    get afz(): string;
    set afz(a: string);
    private ag1;
    get ahh(): Brush;
    set ahh(a: Brush);
    private ag8;
    get aho(): Brush;
    set aho(a: Brush);
    private abb;
    get acd(): number;
    set acd(a: number);
    private abu;
    get ac0(): number;
    set ac0(a: number);
    private aba;
    get acc(): number;
    set acc(a: number);
    private abh;
    get acj(): number;
    set acj(a: number);
    private abi;
    get ack(): number;
    set ack(a: number);
    private abt;
    get acz(): number;
    set acz(a: number);
    private ab0;
    get ac6(): number;
    set ac6(a: number);
    private ab1;
    get ac7(): number;
    set ac7(a: number);
    private abn;
    get acp(): number;
    set acp(a: number);
    private ab6;
    get adc(): number;
    set adc(a: number);
    private aa6;
    get aa8(): boolean;
    set aa8(a: boolean);
    private aa7;
    get aa9(): boolean;
    set aa9(a: boolean);
    private ags;
    get agv(): HorizontalAlignment;
    set agv(a: HorizontalAlignment);
    private ahv;
    get ahy(): VerticalAlignment;
    set ahy(a: VerticalAlignment);
    private agr;
    get agu(): HorizontalAlignment;
    set agu(a: HorizontalAlignment);
    private agt;
    protected get_agw(): HorizontalAlignment;
    protected set_agw(a: HorizontalAlignment): void;
    get agw(): HorizontalAlignment;
    set agw(a: HorizontalAlignment);
    private aht;
    get ahw(): VerticalAlignment;
    set ahw(a: VerticalAlignment);
    private ahu;
    get ahx(): VerticalAlignment;
    set ahx(a: VerticalAlignment);
    private ahz;
    get ah1(): Visibility;
    set ah1(a: Visibility);
    private ah0;
    get ah2(): Visibility;
    set ah2(a: Visibility);
    private aa4;
    protected get_aa5(): ValueAxisLabelLocation;
    protected set_aa5(a: ValueAxisLabelLocation): void;
    get aa5(): ValueAxisLabelLocation;
    set aa5(a: ValueAxisLabelLocation);
    private aau;
    protected get_aav(): AngleAxisLabelLocation;
    protected set_aav(a: AngleAxisLabelLocation): void;
    get aav(): AngleAxisLabelLocation;
    set aav(a: AngleAxisLabelLocation);
    private adm;
    get ad1(): string;
    set ad1(a: string);
    private aaq;
    get aas(): any[];
    set aas(a: any[]);
    private adq;
    get ae9(): string;
    set ae9(a: string);
    private aar;
    get aat(): any[];
    set aat(a: any[]);
}
