import { Control } from "igniteui-react-core";
import { INotifyPropertyChanged, Base, Type, Point, EventArgs, PropertyChangedEventArgs, IEnumerable, IEnumerable$1, IList$1 } from "igniteui-react-core";
import { ILegendOwner } from "igniteui-react-core";
import { IInternalLegendOwner } from "igniteui-react-core";
import { IDataLegendTarget } from "igniteui-react-core";
import { IToolbarTarget } from "igniteui-react-core";
import { ISupportsAnimation } from "igniteui-react-core";
import { ISeriesViewerWidget } from "./ISeriesViewerWidget";
import { SRProvider } from "igniteui-react-core";
import { ToolCommand } from "igniteui-react-core";
import { HashSet$1 } from "igniteui-react-core";
import { IToolbarContextAccessor } from "igniteui-react-core";
import { SeriesPlotAreaMarginHorizontalMode } from "./SeriesPlotAreaMarginHorizontalMode";
import { SeriesPlotAreaMarginVerticalMode } from "./SeriesPlotAreaMarginVerticalMode";
import { SeriesViewerScrollbarMode } from "./SeriesViewerScrollbarMode";
import { IHighlightingManager } from "igniteui-react-core";
import { DoubleAnimator } from "igniteui-react-core";
import { BrushCollection } from "igniteui-react-core";
import { DependencyProperty } from "igniteui-react-core";
import { DependencyObject } from "igniteui-react-core";
import { MarkerAutomaticBehavior } from "./MarkerAutomaticBehavior";
import { IChartLegend } from "igniteui-react-core";
import { SeriesHighlightingMode } from "./SeriesHighlightingMode";
import { SeriesSelectionMode } from "./SeriesSelectionMode";
import { SeriesSelectionBehavior } from "./SeriesSelectionBehavior";
import { SeriesViewerHorizontalScrollbarPosition } from "./SeriesViewerHorizontalScrollbarPosition";
import { SeriesViewerVerticalScrollbarPosition } from "./SeriesViewerVerticalScrollbarPosition";
import { Brush } from "igniteui-react-core";
import { SeriesHighlightingBehavior } from "./SeriesHighlightingBehavior";
import { LegendHighlightingMode } from "./LegendHighlightingMode";
import { LegendItemBadgeShape } from "igniteui-react-core";
import { LegendItemBadgeMode } from "igniteui-react-core";
import { Rect } from "igniteui-react-core";
import { ChartHitTestMode } from "./ChartHitTestMode";
import { InteractionState } from "igniteui-react-core";
import { WindowResponse } from "./WindowResponse";
import { Visibility } from "igniteui-react-core";
import { IOverviewPlusDetailPane } from "igniteui-react-core";
import { SeriesViewerComponentsFromView } from "./SeriesViewerComponentsFromView";
import { ZoomCoercionMode } from "./ZoomCoercionMode";
import { ModifierKeys } from "igniteui-react-core";
import { SeriesHighlightedValuesDisplayMode } from "igniteui-react-core";
import { DataTemplate } from "igniteui-react-core";
import { HorizontalAlignment } from "igniteui-react-core";
import { CanvasRenderScheduler } from "igniteui-react-core";
import { SyncSettings } from "./SyncSettings";
import { IExecutionContext } from "igniteui-react-core";
import { ToolActionInfo } from "igniteui-react-core";
import { ToolCommandExecutionState } from "igniteui-react-core";
import { ICommandAvailabilityListener } from "igniteui-react-core";
import { ICommandStateChangedListener } from "igniteui-react-core";
import { List$1 } from "igniteui-react-core";
import { SeriesViewerComponentsForView } from "./SeriesViewerComponentsForView";
import { Dictionary$2 } from "igniteui-react-core";
import { IDataLegend } from "igniteui-react-core";
import { PropertyUpdatedEventArgs } from "igniteui-react-core";
import { NotifyCollectionChangedEventArgs } from "igniteui-react-core";
import { ObservableCollection$1 } from "igniteui-react-core";
import { Size } from "igniteui-react-core";
import { FrameworkElement } from "igniteui-react-core";
import { EventProxy } from "igniteui-react-core";
import { MouseEventArgs } from "igniteui-react-core";
import { MouseButtonEventArgs } from "igniteui-react-core";
import { Tuple$2 } from "igniteui-react-core";
import { ScalerParams } from "./ScalerParams";
import { SeriesViewerManipulationEventArgs } from "./SeriesViewerManipulationEventArgs";
import { IFastItemsSource } from "igniteui-react-core";
import { ChartResizeIdleEventArgs } from "./ChartResizeIdleEventArgs";
import { Key } from "igniteui-react-core";
import { RectChangedEventArgs } from "igniteui-react-core";
import { RefreshCompletedEventArgs } from "./RefreshCompletedEventArgs";
import { Thickness } from "igniteui-react-core";
import { AxisTitlePosition } from "./AxisTitlePosition";
import { FontInfo } from "igniteui-react-core";
import { CoercionInfo } from "./CoercionInfo";
import { IDataLegendSeries } from "igniteui-react-core";
import { CaptureImageSettings } from "igniteui-react-core";
import { CultureInfo } from "igniteui-react-core";
import { ImageCapturedEventArgs } from "igniteui-react-core";
import { ChartContentType } from "./ChartContentType";
import { ISchedulableRender } from "igniteui-react-core";
import { Rectangle } from "igniteui-react-core";
import { Path } from "igniteui-react-core";
import { Line } from "igniteui-react-core";
import { RenderingContext } from "igniteui-react-core";
import { TextBlock } from "igniteui-react-core";
import { ITileZoomTile } from "./ITileZoomTile";
import { RenderSurface } from "./RenderSurface";
import { PathGeometry } from "igniteui-react-core";
import { Geometry } from "igniteui-react-core";
import { DataContext } from "igniteui-react-core";
import { LabelPanelsArrangeState } from "./LabelPanelsArrangeState";
import { DataTemplateRenderInfo } from "igniteui-react-core";
import { DataTemplateMeasureInfo } from "igniteui-react-core";
import { AxisLabelsLocation } from "./AxisLabelsLocation";
import { IProvidesViewport } from "./IProvidesViewport";
import { ActualLegendItemBadgeShape } from "./ActualLegendItemBadgeShape";
import { StandardLegendItems } from "igniteui-react-core";
import { DomRenderer, DomWrapper } from "igniteui-react-core";
import { PointerTooltipStyle } from "./PointerTooltipStyle";
import { DefaultPaletteInfo } from "./DefaultPaletteInfo";
import { AxisRange } from "./AxisRange";
import { AxisAnnotationCollection } from "./AxisAnnotationCollection";
import { VerticalAlignment } from "igniteui-react-core";
import { Canvas } from "igniteui-react-core";
import { IFastItemsSourceProvider } from "igniteui-react-core";
import { AxisExtentType } from "./AxisExtentType";
import { DoubleCollection } from "igniteui-react-core";
import { LabelPosition } from "./LabelPosition";
import { BindingFormatter } from "igniteui-react-core";
import { LabelFontHeuristics } from "./LabelFontHeuristics";
import { AxisOrientation } from "./AxisOrientation";
import { Pool$1 } from "igniteui-react-core";
import { AxisComponentsFromView } from "./AxisComponentsFromView";
import { AxisRangeChangedEventArgs } from "./AxisRangeChangedEventArgs";
import { GeometryCollection } from "igniteui-react-core";
import { PathRenderingInfo } from "./PathRenderingInfo";
import { RenderRequestedEventArgs } from "./RenderRequestedEventArgs";
import { CategoryMode } from "./CategoryMode";
import { GridMode } from "./GridMode";
import { Panel } from "igniteui-react-core";
import { UIElement } from "igniteui-react-core";
import { TickmarkValues } from "./TickmarkValues";
import { ICategoryScaler } from "./ICategoryScaler";
import { FastItemsSourceEventArgs } from "igniteui-react-core";
import { FastItemsSourceEventAction } from "igniteui-react-core";
import { AxisRangeBufferMode } from "./AxisRangeBufferMode";
import { NumericAxisRenderingParameters } from "./NumericAxisRenderingParameters";
import { AxisRenderingParametersBase } from "./AxisRenderingParametersBase";
import { AutomaticSeriesPurpose } from "./AutomaticSeriesPurpose";
import { SeriesMatcher } from "./SeriesMatcher";
import { Stack$1 } from "igniteui-react-core";
import { RenderValidEventArgs } from "./RenderValidEventArgs";
import { SeriesLayerPropertyOverlayValueResolvingEventArgs } from "./SeriesLayerPropertyOverlayValueResolvingEventArgs";
import { HighlightingInfo } from "igniteui-react-core";
import { Marker } from "./Marker";
import { Polyline } from "igniteui-react-core";
import { ContentControl } from "igniteui-react-core";
import { Polygon } from "igniteui-react-core";
import { AutoMarginsAndAngleUpdateMode } from "./AutoMarginsAndAngleUpdateMode";
import { ComputedPlotAreaMarginMode } from "./ComputedPlotAreaMarginMode";
import { ILegendSeries } from "igniteui-react-core";
import { ILegendSeriesInternal } from "igniteui-react-core";
import { ILegendTemplateProvider } from "igniteui-react-core";
import { PenLineJoin } from "igniteui-react-core";
import { PenLineCap } from "igniteui-react-core";
import { Color } from "igniteui-react-core";
import { SeriesVisibleRangeMode } from "./SeriesVisibleRangeMode";
import { SeriesOutlineMode } from "./SeriesOutlineMode";
import { TransitionInSpeedType } from "./TransitionInSpeedType";
import { TransitionOutSpeedType } from "./TransitionOutSpeedType";
import { SeriesHitTestMode } from "./SeriesHitTestMode";
import { SeriesComponentsForView } from "./SeriesComponentsForView";
import { MarkerOutlineMode } from "./MarkerOutlineMode";
import { MarkerFillMode } from "./MarkerFillMode";
import { CollisionGeometry } from "igniteui-react-core";
import { SeriesPointOfInterest } from "./SeriesPointOfInterest";
import { ValueLayerValueMode } from "./ValueLayerValueMode";
import { TransitionOutCompletedEventArgs } from "./TransitionOutCompletedEventArgs";
import { ISortingAxis } from "./ISortingAxis";
import { SeriesComponentsFromView } from "./SeriesComponentsFromView";
import { IFastItemColumn$1 } from "igniteui-react-core";
import { MarkerType } from "./MarkerType";
import { Style } from "igniteui-react-core";
import { TrendLineManagerType } from "./TrendLineManagerType";
import { TrendLineType } from "igniteui-react-core";
import { Clipper } from "igniteui-react-core";
import { HashPool$2 } from "igniteui-react-core";
/**
 * @hidden
 */
export declare abstract class SeriesViewer extends Control implements INotifyPropertyChanged, ILegendOwner, IInternalLegendOwner, IDataLegendTarget, IToolbarTarget, ISupportsAnimation {
    static $t: Type;
    private _widget;
    get widget(): ISeriesViewerWidget;
    set widget(a: ISeriesViewerWidget);
    dc: SeriesViewerView;
    static staticInit(): void;
    private dv;
    private get dw();
    private an;
    ao(a: SeriesViewer): AutomaticSeriesManager;
    getDesiredToolbarActions(): ToolActionInfo[];
    onToolCommandExecuting(a: ToolCommand): ToolCommandExecutionState;
    addCommandAvailabilityListener(a: ICommandAvailabilityListener): void;
    removeCommandAvailabilityListener(a: ICommandAvailabilityListener): void;
    private gt;
    addCommandStateChangedListener(a: ICommandStateChangedListener): void;
    removeCommandStateChangedListener(a: ICommandStateChangedListener): void;
    private _commandCompleted;
    get commandCompleted(): (arg1: ToolCommand) => void;
    set commandCompleted(a: (arg1: ToolCommand) => void);
    private _invalidateActions;
    get invalidateActions(): () => void;
    set invalidateActions(a: () => void);
    private gq;
    get gr(): HashSet$1<IToolbarContextAccessor>;
    provideContextAccessor(a: IToolbarContextAccessor): void;
    dismissContextAccessor(a: IToolbarContextAccessor): void;
    private om;
    private a9;
    get ba(): IDataChartToolbarProvider;
    get fm(): boolean;
    private bb;
    get bc(): ISeriesViewerInteractionManager;
    get fe(): boolean;
    constructor();
    private rt;
    private oa;
    private ef;
    protected qb(a: any, b: NotifyCollectionChangedEventArgs): void;
    private ee;
    protected po(a: any, b: NotifyCollectionChangedEventArgs): void;
    private pv;
    private pt;
    oc(a: (arg1: Series) => void): void;
    private pw;
    private pu;
    private c4;
    oh(): void;
    private qw;
    protected get_fx(): boolean;
    get fx(): boolean;
    protected get_fw(): boolean;
    get fw(): boolean;
    oi(): void;
    get series(): SeriesCollection;
    private bs;
    private i7;
    private rv;
    private b0;
    get b1(): SeriesPlotAreaMarginHorizontalMode;
    set b1(a: SeriesPlotAreaMarginHorizontalMode);
    private b2;
    get b3(): SeriesPlotAreaMarginVerticalMode;
    set b3(a: SeriesPlotAreaMarginVerticalMode);
    ok(): void;
    protected o9(): void;
    private _skipDataCleanup;
    get skipDataCleanup(): boolean;
    set skipDataCleanup(a: boolean);
    protected rm(a: any): void;
    get e0(): boolean;
    private rw;
    oo(a: number, b: number, c: boolean, d: boolean): {
        p0?: number;
        p1?: number;
    };
    ey(): boolean;
    get gc(): boolean;
    protected get fa(): boolean;
    protected get er(): boolean;
    protected get eq(): boolean;
    get ep(): boolean;
    get dn(): IHighlightingManager;
    get dp(): IHighlightingManager;
    get dm(): IHighlightingManager;
    get bd(): ISeriesViewerScrollbarManager;
    private n6;
    private n7;
    private n5;
    de: DoubleAnimator;
    dg: DoubleAnimator;
    dd: DoubleAnimator;
    df: DoubleAnimator;
    private og;
    private ru;
    private ob;
    gi(a: number): boolean;
    gj(a: number): boolean;
    gh(a: number): boolean;
    of(): void;
    vz(a: number): Brush;
    v5(a: number): Brush;
    v3(a: number): Brush;
    v4(a: number): Brush;
    private vy;
    ag: BrushCollection;
    aj: BrushCollection;
    ah: BrushCollection;
    ai: BrushCollection;
    bh: MarkerAutomaticBehavior;
    ar: ChartContentManager;
    get wk(): Point;
    set wk(a: Point);
    private wj;
    ri(): void;
    get fd(): boolean;
    get legend(): IChartLegend;
    set legend(a: IChartLegend);
    static readonly t0: DependencyProperty;
    get en(): boolean;
    set en(a: boolean);
    get f6(): boolean;
    set f6(a: boolean);
    plotAreaMouseLeftButtonDown: (sender: any, e: PlotAreaMouseButtonEventArgs) => void;
    plotAreaMouseLeftButtonUp: (sender: any, e: PlotAreaMouseButtonEventArgs) => void;
    plotAreaClicked: (sender: any, e: PlotAreaMouseButtonEventArgs) => void;
    plotAreaMouseEnter: (sender: any, e: PlotAreaMouseEventArgs) => void;
    plotAreaMouseLeave: (sender: any, e: PlotAreaMouseEventArgs) => void;
    plotAreaMouseOver: (sender: any, e: PlotAreaMouseEventArgs) => void;
    p6(a: Point, b: boolean): void;
    private bi;
    private bm;
    p7(a: Point, b: boolean, c: boolean): void;
    static readonly sx: DependencyProperty;
    static readonly up: DependencyProperty;
    get fn(): boolean;
    set fn(a: boolean);
    static readonly tw: DependencyProperty;
    get gb(): boolean;
    set gb(a: boolean);
    static readonly us: DependencyProperty;
    get bz(): SeriesHighlightingMode;
    set bz(a: SeriesHighlightingMode);
    static readonly te: DependencyProperty;
    get cc(): SeriesSelectionMode;
    set cc(a: SeriesSelectionMode);
    static readonly um: DependencyProperty;
    get b7(): SeriesSelectionBehavior;
    set b7(a: SeriesSelectionBehavior);
    static readonly uj: DependencyProperty;
    get ca(): SeriesSelectionMode;
    set ca(a: SeriesSelectionMode);
    static readonly s7: DependencyProperty;
    get ci(): SeriesViewerScrollbarMode;
    set ci(a: SeriesViewerScrollbarMode);
    protected cg: SeriesViewerScrollbarMode;
    static readonly tm: DependencyProperty;
    get cj(): SeriesViewerScrollbarMode;
    set cj(a: SeriesViewerScrollbarMode);
    protected ch: SeriesViewerScrollbarMode;
    static readonly u6: DependencyProperty;
    get cf(): SeriesViewerHorizontalScrollbarPosition;
    set cf(a: SeriesViewerHorizontalScrollbarPosition);
    static readonly to: DependencyProperty;
    get cm(): SeriesViewerVerticalScrollbarPosition;
    set cm(a: SeriesViewerVerticalScrollbarPosition);
    static readonly u8: DependencyProperty;
    get v7(): Brush;
    set v7(a: Brush);
    static readonly ti: DependencyProperty;
    get v8(): Brush;
    set v8(a: Brush);
    static readonly tn: DependencyProperty;
    get h7(): number;
    set h7(a: number);
    static readonly tq: DependencyProperty;
    get h6(): number;
    set h6(a: number);
    static readonly tl: DependencyProperty;
    get h3(): number;
    set h3(a: number);
    static readonly th: DependencyProperty;
    get h4(): number;
    set h4(a: number);
    static readonly tj: DependencyProperty;
    get h5(): number;
    set h5(a: number);
    static readonly tk: DependencyProperty;
    get h9(): number;
    set h9(a: number);
    static readonly ts: DependencyProperty;
    get h8(): number;
    set h8(a: number);
    static readonly tr: DependencyProperty;
    get e2(): boolean;
    set e2(a: boolean);
    static readonly kz: string;
    static readonly tp: DependencyProperty;
    get wh(): Brush;
    set wh(a: Brush);
    static readonly u3: DependencyProperty;
    get wi(): Brush;
    set wi(a: Brush);
    static readonly u7: DependencyProperty;
    get iv(): number;
    set iv(a: number);
    static readonly va: DependencyProperty;
    get iu(): number;
    set iu(a: number);
    static readonly u5: DependencyProperty;
    get is(): number;
    set is(a: number);
    static readonly u2: DependencyProperty;
    get iy(): number;
    set iy(a: number);
    nw(): void;
    private p9;
    static readonly vd: DependencyProperty;
    get it(): number;
    set it(a: number);
    static readonly u4: DependencyProperty;
    get ix(): number;
    set ix(a: number);
    static readonly vc: DependencyProperty;
    get iw(): number;
    set iw(a: number);
    static readonly vb: DependencyProperty;
    get gn(): boolean;
    set gn(a: boolean);
    static readonly m6: string;
    static readonly u9: DependencyProperty;
    private cb;
    private b6;
    private by;
    private bv;
    get bw(): SeriesHighlightingBehavior;
    private b8;
    get b9(): SeriesSelectionMode;
    private b4;
    get b5(): SeriesSelectionBehavior;
    get bx(): SeriesHighlightingBehavior;
    set bx(a: SeriesHighlightingBehavior);
    static readonly tc: DependencyProperty;
    get be(): LegendHighlightingMode;
    set be(a: LegendHighlightingMode);
    static readonly tx: DependencyProperty;
    get bg(): LegendItemBadgeShape;
    set bg(a: LegendItemBadgeShape);
    static readonly tz: DependencyProperty;
    get bf(): LegendItemBadgeMode;
    set bf(a: LegendItemBadgeMode);
    static readonly ty: DependencyProperty;
    get ez(): boolean;
    set ez(a: boolean);
    static readonly s4: DependencyProperty;
    propertyChanged: (sender: any, e: PropertyChangedEventArgs) => void;
    propertyUpdated: (sender: any, e: PropertyUpdatedEventArgs) => void;
    protected q5(a: string, b: any, c: any): void;
    jn: any;
    px(): void;
    py(a: IEnumerable): void;
    qe(a: Series, b: any, c: any, d: Point): void;
    qi(a: Series, b: any, c: any, d: Point): void;
    qf(a: Series, b: any, c: any, d: Point): void;
    qg(a: Series, b: any, c: any, d: Point): void;
    qh(a: Series, b: any, c: any, d: Point): void;
    nm(a: Rect, b: ScalerParams): Tuple$2<boolean, number>;
    get ft(): boolean;
    private ea;
    o7(a: boolean, b: Point): void;
    o5(a: boolean, b: Point): void;
    qj(a: Series, b: any, c: any, d: Point): void;
    qk(a: Series, b: any, c: any, d: Point): void;
    seriesCursorMouseMove: (sender: any, e: ChartCursorEventArgs) => void;
    q9(a: Series, b: any): void;
    seriesMouseLeftButtonDown: (sender: any, e: DataChartMouseButtonEventArgs) => void;
    rd(a: Series, b: any, c: MouseButtonEventArgs, d: Point): void;
    seriesMouseLeftButtonUp: (sender: any, e: DataChartMouseButtonEventArgs) => void;
    seriesClick: (sender: any, e: DataChartMouseButtonEventArgs) => void;
    re(a: Series, b: any, c: MouseButtonEventArgs, d: Point): void;
    q8(a: Series, b: any, c: MouseButtonEventArgs, d: Point): void;
    qc(a: Series, b: any): void;
    private gy;
    private gz;
    private fg;
    private gv;
    private od;
    private gw;
    seriesMouseMove: (sender: any, e: ChartMouseEventArgs) => void;
    r0(a: Point): void;
    r1(a: Point): void;
    rf(a: Series, b: any, c: MouseEventArgs, d: Point): void;
    seriesMouseEnter: (sender: any, e: ChartMouseEventArgs) => void;
    rb(a: Series, b: any, c: MouseEventArgs, d: Point): void;
    seriesMouseLeave: (sender: any, e: ChartMouseEventArgs) => void;
    rc(a: Series, b: any, c: MouseEventArgs, d: Point): void;
    private d3;
    o6(): void;
    private d2;
    o4(): void;
    private ws;
    protected get_xb(): Rect;
    get xb(): Rect;
    private wq;
    get wx(): Rect;
    set wx(a: Rect);
    protected get_e1(): boolean;
    get e1(): boolean;
    w3(a: Rect, b: Rect, c: Rect): Rect;
    private d0;
    private wp;
    protected get_ww(): Rect;
    get ww(): Rect;
    w1(a: Rect, b: Rect, c: Rect): Rect;
    protected wv(a: Rect): Rect;
    w2(): Rect;
    protected r5(a: Axis): void;
    xc: Rect;
    gm: boolean;
    ek: boolean;
    f3: boolean;
    jl: number;
    private i6;
    get ja(): number;
    set ja(a: number);
    jg: number;
    jh: number;
    resizeIdle: (sender: any, e: ChartResizeIdleEventArgs) => void;
    jk: number;
    jj: number;
    jf: number;
    jc: number;
    jd: number;
    ji: number;
    protected fu: boolean;
    protected em: boolean;
    qz(a: Rect, b: Rect): void;
    private cd;
    ce(): SeriesViewerComponentsForView;
    private d7;
    nv(a: Point, b: boolean): void;
    fi: boolean;
    private at;
    get av(): ChartHitTestMode;
    set av(a: ChartHitTestMode);
    rh(): void;
    protected aw(): ChartHitTestMode;
    private as;
    get au(): ChartHitTestMode;
    set au(a: ChartHitTestMode);
    fj: boolean;
    seriesAnimating: (series: Series) => void;
    private dx;
    queueForAnimationIdle(a: () => void, b: number): void;
    getAnimationIdleVersionNumber(): number;
    isAnimationActive(): boolean;
    qd(a: Series): void;
    pq(): void;
    protected ql(): void;
    q7(a: Series): void;
    abstract fp(): boolean;
    abstract fq(): boolean;
    fo(): boolean;
    private d6;
    onDetachedFromUI(): void;
    onAttachedToUI(): void;
    get c3(): InteractionState;
    set c3(a: InteractionState);
    private d4;
    private cy;
    p0(a: Point): void;
    p1(a: Point, b: boolean): void;
    f1(a: Point, b: number): boolean;
    pj(a: Point): void;
    f0(a: Key): boolean;
    private ec;
    eu: boolean;
    private d1;
    get eo(): boolean;
    set eo(a: boolean);
    protected get_ff(): boolean;
    get ff(): boolean;
    pl(a: Point): void;
    get ex(): boolean;
    mv: string;
    p5(a: Point): void;
    pm(a: Point, b: boolean): void;
    pk(a: Point): void;
    get f2(): boolean;
    set f2(a: boolean);
    private qu;
    p4(a: Point): void;
    qv(a: Point, b: number, c: number, d: number): void;
    p3(a: number): void;
    qr(a: Point, b: number, c: number, d: number): void;
    pz(a: Point): void;
    p2(a: number): void;
    pp(a: Point): void;
    qq(a: Point, b: number, c: number, d: number): void;
    qn(): void;
    ps(a: Size): void;
    oe(): void;
    pc(a: Point, b: boolean): void;
    c1(a: boolean): InteractionState;
    viewerManipulationStarting: (sender: any, e: SeriesViewerManipulationEventArgs) => void;
    viewerManipulationEnding: (sender: any, e: SeriesViewerManipulationEventArgs) => void;
    private ei;
    qt(a: boolean, b: Point): void;
    qs(): void;
    r2(): void;
    n3(): void;
    ny(): void;
    nx(): void;
    qx(): void;
    rl(): void;
    rj(): void;
    pb(a: Point, b: boolean): void;
    f8(): boolean;
    private ed;
    get ge(): boolean;
    set ge(a: boolean);
    pa(a: Point, b: boolean, c: boolean): void;
    se(a: any, b: PropertyUpdatedEventArgs): void;
    sd(a: SyncLink, b: SyncLink): void;
    nz(a: Point): void;
    sh(a: Rect, b: boolean): void;
    si(a: Rect, b: boolean, c: boolean): void;
    qy(a: Rect, b: boolean): void;
    get fk(): boolean;
    private _gs;
    gs(): IEnumerable$1<SeriesViewer>;
    wn(a: Point): Point;
    wl(a: Point): Point;
    xa(a: Rect): Rect;
    wy(a: Rect): Rect;
    windowRectChanged: (sender: any, e: RectChangedEventArgs) => void;
    private rg;
    qp(a: Rect, b: Rect): void;
    sizeChanged: (sender: any, e: RectChangedEventArgs) => void;
    qm(a: Size, b: Size): void;
    e5: boolean;
    f4(a: Rect, b: Rect): boolean;
    actualWindowRectChanged: (sender: any, e: RectChangedEventArgs) => void;
    private q2;
    sj(a: number): void;
    sk(a: number): void;
    rr(): void;
    gridAreaRectChanged: (sender: any, e: RectChangedEventArgs) => void;
    private q3;
    protected get_fh(): boolean;
    get fh(): boolean;
    p8(a: Rect, b: Rect): void;
    cq: WindowResponse;
    on(): void;
    ew: boolean;
    i2: number;
    i1: number;
    private g7;
    get ht(): number;
    set ht(a: number);
    private g6;
    get hs(): number;
    set hs(a: number);
    i4: number;
    i3: number;
    private _syncChannel;
    get syncChannel(): string;
    set syncChannel(a: string);
    private cn;
    get actualSyncLink(): SyncLink;
    set actualSyncLink(a: SyncLink);
    gf: boolean;
    ol(): void;
    xh: Visibility;
    private eh;
    ph(): void;
    pf(): void;
    pg(): void;
    get c5(): IOverviewPlusDetailPane;
    protected sa(a: boolean): void;
    xg: Visibility;
    e4: boolean;
    gl: boolean;
    v6: Brush;
    wg: Brush;
    private cr;
    get cs(): ZoomCoercionMode;
    set cs(a: ZoomCoercionMode);
    ct(): ZoomCoercionMode;
    cu: ZoomCoercionMode;
    wa: Brush;
    vv: Brush;
    v9: Brush;
    f9: boolean;
    et(): boolean;
    el(): boolean;
    xd: Rect;
    ns(): void;
    private i9;
    private notifyCrosshairUpdate;
    sf(a: number, b: number): void;
    sg(a: number, b: number, c: number, d: number): void;
    hz(): number;
    h0(): number;
    private ig;
    private ie;
    protected q0(a: any, b: string, c: any, d: any): void;
    get fb(): boolean;
    protected get fz(): boolean;
    br: Series;
    r9(a: Point): void;
    private nl;
    sc(): void;
    protected o1(): void;
    sb(): void;
    private eg;
    protected gg: boolean;
    cz: InteractionState;
    c0: InteractionState;
    c2: InteractionState;
    vq: ModifierKeys;
    vr: ModifierKeys;
    vs: ModifierKeys;
    private wr;
    get w4(): Rect;
    set w4(a: Rect);
    bu: SeriesHighlightedValuesDisplayMode;
    private _selectedSeriesItems;
    get selectedSeriesItems(): ChartSelectedItemCollection;
    set selectedSeriesItems(a: ChartSelectedItemCollection);
    private _focusedSeriesItems;
    get focusedSeriesItems(): ChartSelectedItemCollection;
    set focusedSeriesItems(a: ChartSelectedItemCollection);
    selectedSeriesItemsChanged: (sender: any, e: SeriesViewerSelectedSeriesItemsChangedEventArgs) => void;
    qa(a: any, b: SeriesViewerSelectedSeriesItemsChangedEventArgs): void;
    focusedSeriesItemsChanged: (sender: any, e: SeriesViewerSelectedSeriesItemsChangedEventArgs) => void;
    pn(a: any, b: SeriesViewerSelectedSeriesItemsChangedEventArgs): void;
    g1: Date;
    go: boolean;
    protected r4(): void;
    nn(a: Rect, b: Rect): void;
    f5(): boolean;
    protected o2(a: Rect, b: Rect): void;
    iz: number;
    i0: number;
    private w7;
    refreshCompleted: (sender: any, e: RefreshCompletedEventArgs) => void;
    q6(): void;
    protected abstract db(): SeriesViewerView;
    protected qo(a: SeriesViewerView): void;
    wd: Brush;
    vw: Brush;
    static w6: Rect;
    sl: DataTemplate;
    su: DataTemplate;
    sr: DataTemplate;
    ss: DataTemplate;
    sm: DataTemplate;
    sp: DataTemplate;
    sn: DataTemplate;
    st: DataTemplate;
    sq: DataTemplate;
    so: DataTemplate;
    ml: string;
    vp: HorizontalAlignment;
    vo: HorizontalAlignment;
    private js;
    get ms(): string;
    set ms(a: string);
    private jr;
    get mg(): string;
    set mg(a: string);
    private vu;
    get wf(): Brush;
    set wf(a: Brush);
    private vt;
    get we(): Brush;
    set we(a: Brush);
    private hm;
    get iq(): number;
    set iq(a: number);
    private hk;
    get io(): number;
    set io(a: number);
    private hl;
    get ip(): number;
    set ip(a: number);
    private hj;
    get im(): number;
    set im(a: number);
    private hi;
    get il(): number;
    set il(a: number);
    private hg;
    get ij(): number;
    set ij(a: number);
    private hh;
    get ik(): number;
    set ik(a: number);
    private hf;
    get ii(): number;
    set ii(a: number);
    l9: string;
    xe(): Thickness;
    xf(): Thickness;
    ap(a: Axis): AxisTitlePosition;
    aq(a: Axis): AxisTitlePosition;
    abstract getFontInfo(): FontInfo;
    getFontHeight(): number;
    protected get_fy(): boolean;
    get fy(): boolean;
    pe(): void;
    abstract getFontBrush(): Brush;
    abstract vx(): Brush;
    jp: any;
    provideContainer(a: any): void;
    pd(a: number, b: number): void;
    notifyContainerResized(): void;
    wz(): Rect;
    n4(): void;
    wm(): Point;
    di(): FontInfo;
    dh(): FontInfo;
    v0(): Brush;
    v1(): Brush;
    nq(a: Series): void;
    rn(a: Series): void;
    al: CanvasRenderScheduler;
    am: CanvasRenderScheduler;
    ak: CanvasRenderScheduler;
    private eb;
    get fv(): boolean;
    set fv(a: boolean);
    private dz;
    get ej(): boolean;
    set ej(a: boolean);
    private _syncSettings;
    get syncSettings(): SyncSettings;
    set syncSettings(a: SyncSettings);
    np(a: any): void;
    rp(a: any): void;
    oy(source_: any, a: number, b: any, c: any): void;
    op(source_: any): void;
    ow(source_: any, a: number, b: any): void;
    ox(source_: any, a: number, b: any): void;
    destroyed: boolean;
    protected jm: any;
    protected gp: Dictionary$2<string, any>;
    fs: boolean;
    destroy(): void;
    protected n2(): void;
    rz(source_: any): void;
    rq(): void;
    ry(a: string, source_: any): void;
    ro(a: string, b: boolean): void;
    protected rx(a: Series, b: any): void;
    protected r7(a: any): void;
    protected r8(): void;
    private hn;
    get ir(): number;
    set ir(a: number);
    private hc;
    get ib(): number;
    set ib(a: number);
    private he;
    get ih(): number;
    set ih(a: number);
    private ha;
    get hw(): number;
    set hw(a: number);
    private g9;
    get hv(): number;
    set hv(a: number);
    private g8;
    get hu(): number;
    set hu(a: number);
    f7(): boolean;
    private d5;
    get e7(): boolean;
    set e7(a: boolean);
    private hd;
    get ic(): number;
    set ic(a: number);
    private hb;
    get ia(): number;
    set ia(a: number);
    static cv(a: string, b: any): CoercionInfo;
    private jq;
    get lh(): string;
    set lh(a: string);
    private g3;
    get hp(): number;
    set hp(a: number);
    private g2;
    get ho(): number;
    set ho(a: number);
    ga: boolean;
    private wo;
    get wt(): Rect;
    set wt(a: Rect);
    w0(): Rect;
    e3: boolean;
    private oj;
    w5(): Rect;
    protected wu(): Rect;
    jo(a: number, b: number): any;
    private g4;
    get hq(): number;
    set hq(a: number);
    private g5;
    get hr(): number;
    set hr(a: number);
    o0(): void;
    oz(): void;
    flush(): void;
    n9(a: boolean, b: boolean, c: boolean): void;
    gk(): boolean;
    private sv;
    private a0;
    protected rk(a: DependencyObject, b: (arg1: boolean) => void): void;
    protected r3(a: DependencyObject): void;
    n0(): void;
    e8: boolean;
    e9: boolean;
    e6: boolean;
    pr(): void;
    private d8;
    get fl(): boolean;
    nr(): void;
    fr(): boolean;
    private i8;
    je(): number;
    dl(): FontInfo;
    dk(): FontInfo;
    r6(): void;
    protected es: boolean;
    wc: Brush;
    wb: Brush;
    id: number;
    fc: boolean;
    seriesDataUpdated: (sender: any, e: EventArgs) => void;
    ra(): void;
    ot(): void;
    ou(): void;
    private ov;
    os(a: Point): void;
    private gu;
    attachDataLegend(a: IDataLegend): void;
    detachDataLegend(a: IDataLegend): void;
    get isDetached(): boolean;
    dy: () => void;
    seriesDataChanged: (sender: any, e: PropertyChangedEventArgs) => void;
    getDataLegendSeries(): IDataLegendSeries[];
    no(a: Rect): void;
    w8(a: Rect): Rect;
    w9(a: Rect): Rect;
    protected gx: List$1<CaptureImageSettings>;
    nt(a: CaptureImageSettings): void;
    private nu;
    protected j5(a: CaptureImageSettings, b: (arg1: string, arg2: any) => void): string;
    imageCaptured: (sender: any, args: ImageCapturedEventArgs) => void;
    protected q4(a: CaptureImageSettings, b: string, c?: any): void;
    notifySeriesDataChanged(): void;
    h1(): number;
    h2(): number;
    private cw;
    private get cx();
    private g0;
    private d9;
    o8(a: Size): void;
    private rs;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare abstract class SeriesViewerView extends Base implements ISchedulableRender {
    static $t: Type;
    constructor(a: SeriesViewer);
    l(): IExecutionContext;
    co(): void;
    p: SeriesViewer;
    c4(): void;
    e(): Series;
    private cn;
    a: CanvasRenderScheduler;
    n: IOverviewPlusDetailPane;
    private dn;
    private dm;
    em(): void;
    private ct;
    private cs;
    o: OverviewPlusDetailViewportHost;
    cb(a: number, b: number, c: RenderSurface): void;
    d5(): void;
    cd(): void;
    d7(): void;
    ck(): void;
    cc(): void;
    ce(): void;
    dy(a: Series): void;
    dc(): void;
    private er;
    aq(a: Series): boolean;
    protected g: SeriesCollection;
    protected b: AxisCollection;
    private ai;
    get au(): boolean;
    set au(a: boolean);
    bp(a: Series): void;
    dt(a: RenderingContext): void;
    bx(): void;
    bt(): void;
    cf(): void;
    ca(): void;
    dr(): void;
    protected fi: Rectangle;
    protected ff: Path;
    d8(): void;
    eg(a: Rect): void;
    bw(): void;
    df(): void;
    eo(a: number, b: number, c: number, d: number): void;
    protected fe: Line;
    protected fd: Line;
    ed(): void;
    cl(): void;
    eh(a: number, b: number, c: number, d: number): void;
    d9(): void;
    cg(): void;
    cj(): void;
    private e6;
    private e7;
    en(a: Rect, b: Rect): void;
    ec(): void;
    ep(a: Rect): void;
    dw(a: Axis): void;
    dx(a: Axis): void;
    bo(a: Axis): void;
    bl(a: Axis): void;
    private h;
    i(): SeriesViewerComponentsFromView;
    static aw(a: Series): List$1<Series>;
    d2(): void;
    j: SeriesViewerViewManager;
    protected w: RenderingContext;
    z: RenderingContext;
    y: RenderingContext;
    x: RenderingContext;
    an: boolean;
    ao: boolean;
    bi: any;
    c0(a: any): void;
    private al;
    protected cy(a: Point, b: boolean): void;
    protected cz(a: Point, b: boolean): void;
    protected c3(a: Point): void;
    protected cx(a: Point, b: boolean, c: boolean): void;
    du(a: RenderingContext): void;
    protected get_ap(): boolean;
    get ap(): boolean;
    k: EventProxy;
    ef(): void;
    a9: number;
    f(a: Point, b: boolean, c: DataContext, d: boolean): {
        ret: Series;
        p2: DataContext;
    };
    bd(): number;
    bc(): number;
    a8: number;
    a7: number;
    private e9;
    private aj;
    cu(): void;
    c1(a: number, b: number): void;
    private fg;
    private fh;
    b6(a: Rectangle): void;
    b9(a: Rectangle): void;
    b8(): void;
    d3(): void;
    private a1;
    private az;
    private a0;
    private ay;
    private ak;
    private aa;
    private b2;
    private ek;
    v(): FontInfo;
    u(): FontInfo;
    private e5;
    private e4;
    private bf;
    private a2;
    private be;
    fm(): Thickness;
    fl(): Thickness;
    protected dv(a: Rect): void;
    cq(): void;
    private fa;
    protected d0(): void;
    isValid(): boolean;
    preRender(): void;
    protected ds(): void;
    protected ab: boolean;
    protected d1(): void;
    c2(): void;
    cw(): void;
    fb(): Rect;
    e8(): Point;
    private d6;
    ee(): void;
    dp(): void;
    protected as(a: Point): boolean;
    c8(a: Point, b: boolean, c: boolean): void;
    protected c7(a: Point): void;
    protected c6(a: Point): void;
    protected c9(a: Point): void;
    d4(): void;
    get ez(): ModifierKeys;
    eq(a: Rect): void;
    cr(a: boolean): void;
    bk(a: boolean): void;
    protected el(): void;
    private af;
    get isDirty(): boolean;
    set isDirty(a: boolean);
    undirty(a: boolean): void;
    get index(): number;
    postRender(): void;
    b7(): void;
    protected ae: boolean;
    ch(): void;
    ea(): void;
    bv(a: boolean): void;
    bm(a: any): void;
    ei(a: number): void;
    ej(a: number): void;
    bn(a: any): void;
    dz(a: any): void;
    da(a: Brush): void;
    bu(a: Point): void;
    av: boolean;
    m(a: boolean): InteractionState;
    c5(): void;
    private et;
    private es;
    bb(a: TextBlock, b: FontInfo): number;
    ba(a: string, b: FontInfo): number;
    dj(): void;
    private eu;
    di(): void;
    de(): void;
    c(a: Axis): AxisTitlePosition;
    d(a: Axis): AxisTitlePosition;
    dk(): void;
    dl(): void;
    t(): FontInfo;
    e3(): Brush;
    q(): FontInfo;
    e0(): Brush;
    s(): FontInfo;
    r(): FontInfo;
    e2(): Brush;
    e1(): Brush;
    get a4(): number;
    get a5(): number;
    get a6(): number;
    get a3(): number;
    get ew(): TextBlock;
    get ev(): TextBlock;
    fc(): Rect;
    fk(): Thickness;
    fj(): Thickness;
    private ad;
    private ac;
    dd(a: any, b: any): void;
    dh(a: any, b: any): void;
    ey(): HorizontalAlignment;
    ex(): HorizontalAlignment;
    private ag;
    bq(): void;
    am(): boolean;
    b5(): void;
    cp(): void;
    at(a: Point): boolean;
    dq(): void;
    private ax;
    b3(a: Dictionary$2<any, ITileZoomTile>, b: List$1<ITileZoomTile>, c: number): void;
    bh(a: Rect, b: ITileZoomTile, c: number): any;
    b0(): void;
    b1(a: ITileZoomTile): void;
    cm(): void;
    ar: boolean;
    private bg;
    by(): void;
    br(): void;
    bz(a: number): void;
    bs(): void;
    private ah;
    ci(): void;
    eb(): void;
    dg(): void;
    cv(): void;
    db(): void;
    b4(a: any): void;
    bj(a: number, b: number, c: number): any;
}
/**
 * @hidden
 */
export declare class OverviewPlusDetailViewportHost extends Base implements IProvidesViewport {
    static $t: Type;
    constructor(a: SeriesViewerView);
    a: SeriesViewerView;
    getViewInfo(a: Rect, b: Rect): {
        p0: Rect;
        p1: Rect;
    };
    getEffectiveViewport(): Rect;
    getMainContentViewport(): Rect;
}
/**
 * @hidden
 */
export declare class LegendTemplates extends Base {
    static $t: Type;
    private static readonly z;
    private static readonly ae;
    private static readonly ad;
    private static readonly ah;
    private static readonly ab;
    private static readonly y;
    private static readonly aa;
    private static readonly ac;
    static af(a: Series): DataTemplate;
    static a(a: DataTemplateRenderInfo): RenderingContext;
    static v(a: DataContext): void;
    private static b;
    private static c;
    static u(a: DataTemplateRenderInfo, b: number, c: Brush, d: Brush, e: number, f: number, g: number, h: number): void;
    static s(a: DataTemplateRenderInfo): void;
    static r(a: DataTemplateRenderInfo, b: number, c: number): void;
    static t(a: DataTemplateRenderInfo, b?: number): void;
    static j(a: DataTemplateRenderInfo): void;
    static n(a: DataTemplateRenderInfo): void;
    static o(a: DataTemplateRenderInfo): void;
    static q(a: DataTemplateRenderInfo): void;
    static p(a: DataTemplateRenderInfo): void;
    static i(a: DataTemplateRenderInfo): void;
    static l(a: DataTemplateRenderInfo): void;
    static m(a: DataTemplateRenderInfo): void;
    static k(a: DataTemplateRenderInfo): void;
    static g(a: DataTemplateRenderInfo): void;
    private static readonly w;
    private static readonly x;
    static resolveLegendItemTemplate(a: StandardLegendItems): DataTemplate;
    static e(a: DataTemplateRenderInfo): void;
    static f(a: DataTemplateMeasureInfo): void;
    static d(a: DataTemplateMeasureInfo): void;
    static h(a: DataTemplateMeasureInfo): void;
}
/**
 * @hidden
 */
export declare class SeriesViewerViewManager extends Base {
    static $t: Type;
    ae: DomRenderer;
    protected af: DomWrapper;
    protected aj: DomWrapper;
    protected ai: DomWrapper;
    protected ag: DomWrapper;
    ak: DomWrapper;
    t: RenderingContext;
    w: RenderingContext;
    v: RenderingContext;
    u: RenderingContext;
    x: RenderingContext;
    f: EventProxy;
    private j;
    constructor(a: SeriesViewerView);
    protected ah: DomWrapper;
    bj(): void;
    bg(a: any): void;
    static by(a: DomRenderer, b: () => void): void;
    private bi;
    ba(): void;
    g(): IOverviewPlusDetailPane;
    bm(): void;
    bn(): void;
    b3(): Brush;
    private ab;
    private aa;
    private ac;
    az(a: number, b: number, c: number): void;
    b8(): Point;
    y(): boolean;
    bc(a: boolean): void;
    a8(a: BrushCollection, b: BrushCollection, c: Brush, d: FontInfo, e: Brush): {
        p0: BrushCollection;
        p1: BrushCollection;
        p2: Brush;
        p3: FontInfo;
        p4: Brush;
    };
    e(): DefaultPaletteInfo;
    a7(a: number, b: number[], c: Brush, d: Brush, e: number, f: boolean): {
        p0: number;
        p1: number[];
        p2: Brush;
        p3: Brush;
        p4: number;
        p5: boolean;
    };
    ay(): void;
    bu(x_: number): void;
    private ad;
    bv(y_: number): void;
    au(a: any): void;
    a9(): void;
    bo(): void;
    av(a: any): void;
    bk(a: any): void;
    bd(): void;
    private l;
    p(): FontInfo;
    private ca;
    ce(): Thickness;
    private aq;
    as(): string;
    private ap;
    ar(): string;
    private b9;
    cd(): Thickness;
    private b0;
    b5(): Brush;
    private bz;
    b4(): Brush;
    private k;
    o(): FontInfo;
    private a;
    c(): AxisTitlePosition;
    private b;
    d(): AxisTitlePosition;
    private n;
    r(): FontInfo;
    private b2;
    b7(): Brush;
    private m;
    q(): FontInfo;
    private b1;
    b6(): Brush;
    private cb;
    cf(): Thickness;
    private cc;
    cg(): Thickness;
    bp(): void;
    private bx;
    private br;
    private bq;
    private bs;
    private bt;
    a6(a: number, b: number): void;
    private h;
    i(): PointerTooltipStyle;
    bb(a: boolean): void;
    private z;
    an(a: Rect, b: ITileZoomTile, c: number): any;
    a3(a: ITileZoomTile): void;
    a2(): void;
    bl(a: List$1<ITileZoomTile>): void;
    private al;
    a0(): void;
    aw(): void;
    private am;
    a1(a: number): void;
    ax(): void;
    private s;
    be(): void;
    bw(a: boolean): void;
    a4(): void;
    a5(): void;
    bh(): void;
    bf(): void;
    ao(a: number, b: number, c: number): any;
    at(a: number, b: number, c: number, d: string, e?: (arg1: string, arg2: any) => void): string;
}
/**
 * @hidden
 */
export declare class AutoRangeCalculator extends Base {
    static $t: Type;
    static a(a: NumericAxisBase, b: number, c: number, d: boolean, e: number, f: number, g: number): {
        p5: number;
        p6: number;
    };
}
/**
 * @hidden
 */
export interface IAxisAnnotationManager {
    owner: Axis;
    onAutoAnnotionsChanged(a: Axis, b: AxisAnnotationCollection, c: NotifyCollectionChangedEventArgs): void;
    onAutoAnnotionsReset(a: Axis, b: AxisAnnotationCollection, c: EventArgs): void;
    onAnnotionsChanged(a: Axis, b: AxisAnnotationCollection, c: NotifyCollectionChangedEventArgs): void;
    onAnnotionsReset(a: Axis, b: AxisAnnotationCollection, c: EventArgs): void;
    onAddAnnotations(a: Axis): void;
    arrangeAnnotations(a: Axis, b: AxisLabelPanelBaseView, c: List$1<FrameworkElement>, d: List$1<Rect>, e: boolean, f: number, g: number, h: number, i: number, j: number): void;
}
/**
 * @hidden
 */
export declare let IAxisAnnotationManager_$type: Type;
/**
 * @hidden
 */
export declare class AxisLabelSettings extends Base implements INotifyPropertyChanged {
    static $t: Type;
    constructor();
    private ah;
    get textStyle(): string;
    set textStyle(a: string);
    private a6;
    get textColor(): Brush;
    set textColor(a: Brush);
    get location(): AxisLabelsLocation;
    set location(a: AxisLabelsLocation);
    private b;
    get visibility(): Visibility;
    set visibility(a: Visibility);
    private bb;
    get showFirstLabel(): boolean;
    set showFirstLabel(a: boolean);
    private i;
    c: AxisLabelsLocation;
    a: Axis;
    registerAxis(a: Axis): void;
    unregisterAxis(a: Axis): void;
    get angle(): number;
    set angle(a: number);
    private n;
    get extent(): number;
    set extent(a: number);
    private p;
    get maximumExtent(): number;
    set maximumExtent(a: number);
    private r;
    get maximumExtentPercentage(): number;
    set maximumExtentPercentage(a: number);
    private s;
    set margin(a: number);
    get leftMargin(): number;
    set leftMargin(a: number);
    private q;
    get rightMargin(): number;
    set rightMargin(a: number);
    private t;
    get topMargin(): number;
    set topMargin(a: number);
    private u;
    get bottomMargin(): number;
    set bottomMargin(a: number);
    private o;
    private a3;
    get horizontalAlignment(): HorizontalAlignment;
    set horizontalAlignment(a: HorizontalAlignment);
    private a8;
    get verticalAlignment(): VerticalAlignment;
    set verticalAlignment(a: VerticalAlignment);
    propertyChanged: (sender: any, e: PropertyChangedEventArgs) => void;
    propertyUpdated: (sender: any, e: PropertyUpdatedEventArgs) => void;
    a0(a: string, b: any, c: any): void;
    protected az(a: any, b: string, c: any, d: any): void;
    k(): boolean;
    l(): boolean;
    static readonly extentPropertyDefault: number;
    get j(): boolean;
    private f;
    get g(): FontInfo;
    set g(a: FontInfo);
    h(a: DomRenderer): FontInfo;
}
/**
 * @hidden
 */
export declare class TitleSettings extends AxisLabelSettings {
    static $t: Type;
    constructor();
    private bd;
    get position(): AxisTitlePosition;
    set position(a: AxisTitlePosition);
    protected az(a: any, b: string, c: any, d: any): void;
}
/**
 * @hidden
 */
export declare abstract class Axis extends Control implements INotifyPropertyChanged {
    static $t: Type;
    a4(): AxisView;
    a5: AxisView;
    hv(a: AxisView): void;
    abstract ag(): number[];
    hh(): void;
    private bt;
    get bu(): SRProvider;
    private a9;
    get ba(): IAxisVisualDataManager;
    ek(): number;
    f4(): any;
    f3(): any;
    protected get_cb(): boolean;
    get cb(): boolean;
    protected get_cj(): boolean;
    get cj(): boolean;
    protected get_b9(): boolean;
    get b9(): boolean;
    protected get_cm(): boolean;
    get cm(): boolean;
    protected get_cp(): boolean;
    get cp(): boolean;
    protected get_cn(): boolean;
    get cn(): boolean;
    d5(a: Point): number;
    protected get_ce(): boolean;
    get ce(): boolean;
    protected get_ck(): boolean;
    get ck(): boolean;
    protected get_cl(): boolean;
    get cl(): boolean;
    protected get_cc(): boolean;
    get cc(): boolean;
    protected get_cd(): boolean;
    get cd(): boolean;
    ak(): Axis;
    constructor();
    private a7;
    get a8(): IAxisAnnotationManager;
    get ca(): boolean;
    private hf;
    private hg;
    private hd;
    private he;
    provideRenderer(a: DomRenderer): void;
    au: (item: any) => string;
    hs(a: Rect, b: Rect): void;
    abstract av(): AxisLabelPanelBase;
    ac(): void;
    iu: Canvas;
    get bo(): IFastItemsSourceProvider;
    set bo(a: IFastItemsSourceProvider);
    private bn;
    get bi(): SeriesViewer;
    set bi(a: SeriesViewer);
    private bh;
    get bg(): XamDataChart;
    set bg(a: XamDataChart);
    readonly bs: (sender: any, e: RectChangedEventArgs) => void;
    private by;
    get c6(): boolean;
    set c6(a: boolean);
    private dm;
    get e8(): number;
    set e8(a: number);
    private dg;
    get dy(): number;
    set dy(a: number);
    private dt;
    get fe(): number;
    set fe(a: number);
    private dq;
    get fb(): number;
    set fb(a: number);
    private as;
    get at(): AxisExtentType;
    set at(a: AxisExtentType);
    private dl;
    get e7(): number;
    set e7(a: number);
    dx: number;
    private ds;
    get fd(): number;
    set fd(a: number);
    private dp;
    get fa(): number;
    set fa(a: number);
    private bk;
    private bj;
    get bm(): FontInfo;
    set bm(a: FontInfo);
    private f5;
    get gz(): string;
    set gz(a: string);
    private dn;
    get e9(): number;
    set e9(a: number);
    dz: number;
    private du;
    get ff(): number;
    set ff(a: number);
    private dr;
    get fc(): number;
    set fc(a: number);
    private fq;
    get fv(): number;
    set fv(a: number);
    private fp;
    get fu(): number;
    set fu(a: number);
    private fo;
    get ft(): number;
    set ft(a: number);
    fr: number;
    private kn;
    get kq(): VerticalAlignment;
    set kq(a: VerticalAlignment);
    private dw;
    get fh(): number;
    set fh(a: number);
    private dv;
    get fg(): number;
    set fg(a: number);
    ik(): void;
    private h8;
    private h9;
    iv: TextBlock;
    g8: string;
    j2: Brush;
    jy: Brush;
    fi: number;
    j6: DoubleCollection;
    j1: Brush;
    jz: Brush;
    jw: Brush;
    et: number;
    j4: DoubleCollection;
    j0: Brush;
    jx: Brush;
    ew: number;
    j5: DoubleCollection;
    j3: Brush;
    fk: number;
    j7: DoubleCollection;
    fj: number;
    d0: number;
    private io;
    cf: boolean;
    ch: boolean;
    ci: boolean;
    cu: boolean;
    private bw;
    private dh;
    get b4(): boolean;
    get b7(): boolean;
    ij(a: number): void;
    id(): void;
    eh(): number;
    ey(): number;
    cv: boolean;
    cw: boolean;
    cx: boolean;
    bz: boolean;
    c5: boolean;
    get c4(): boolean;
    set c4(a: boolean);
    static readonly js: DependencyProperty;
    fs: number;
    b1: boolean;
    az: AxisLabelSettings;
    d7(): number;
    ju(): HorizontalAlignment;
    ko(): VerticalAlignment;
    jv(): HorizontalAlignment;
    kp(): VerticalAlignment;
    d9(): number;
    eb(): number;
    ea(): number;
    d8(): number;
    ee(): number;
    eg(): number;
    ef(): number;
    ed(): number;
    a0(): AxisLabelsLocation;
    a1(): AxisLabelsLocation;
    aj: Axis;
    fx: any;
    rangeChanged: (sender: any, e: AxisRangeChangedEventArgs) => void;
    protected h6(a: AxisRangeChangedEventArgs): void;
    bf: TitleSettings;
    ec(): number;
    d6(): number;
    get an(): AxisAnnotationCollection;
    private al;
    get ao(): AxisAnnotationCollection;
    private am;
    private j9;
    get kh(): Rect;
    set kh(a: Rect);
    kg: Rect;
    ip(): void;
    c8(a: Rect, b: Rect, c: AxisView): boolean;
    co(): boolean;
    dd: List$1<any>;
    de: List$1<LabelPosition>;
    aw: AxisLabelPanelBase;
    protected is(a: Rect, b: Rect): void;
    private bx;
    get cq(): boolean;
    set cq(a: boolean);
    protected ke(): Rect;
    ka: Rect;
    protected it(a: Rect, b: Rect): void;
    h7(): void;
    a6: ContentInfo;
    fn: DomRenderer;
    ai: BindingFormatter;
    protected hz(a: any, b: string, c: any, d: any): void;
    hx(): void;
    hy(): void;
    private _coercionMethods;
    get coercionMethods(): any;
    set coercionMethods(a: any);
    private bv;
    protected get_expectFunctions(): boolean;
    protected set_expectFunctions(a: boolean): void;
    get expectFunctions(): boolean;
    set expectFunctions(a: boolean);
    cy: boolean;
    private ig;
    c7: boolean;
    protected hu(a: GeometryCollection, b: number, c: number, d: Rect): void;
    protected ht(a: GeometryCollection, b: number, c: Rect, d: PathRenderingInfo, e: boolean): void;
    protected ir(a: GeometryCollection, b: number, c: number, d: Rect): void;
    protected iq(a: GeometryCollection, b: number, c: Rect, d: PathRenderingInfo, e: boolean): void;
    private cg;
    protected ii(a: number, b: number, c: Rect, d: Rect, e: Rect, f: number, g: number): {
        p0: number;
        p1: number;
    };
    d1(a: number, b: number, c: number, d: PathRenderingInfo): number;
    hk(a: GeometryCollection): void;
    protected hj(): void;
    ia(): void;
    ib(a: boolean): void;
    renderRequested: (sender: any, e: RenderRequestedEventArgs) => void;
    bc: LabelFontHeuristics;
    static ev: number;
    e1(): number;
    e5(): number;
    e3(): number;
    e4(): number;
    e2(): number;
    ez(): number;
    d3(a: number, b: boolean, c: Rect, d: Rect, e: Rect): number;
    private es;
    private ej;
    cz(a: number, b: number, c: Rect, d: Rect, e: Rect): boolean;
    protected ei(a: number, b: Rect, c: Rect, d: Rect): number;
    e0(): number;
    protected get c0(): boolean;
    cr: boolean;
    hn(a: boolean): void;
    private dj;
    private b2;
    ie(): void;
    protected b6(): boolean;
    d2(a: number, b: ScalerParams): number;
    protected ih(): void;
    private dk;
    bb(): LabelFontHeuristics;
    bl(): FontInfo;
    private ho;
    cs: boolean;
    c1(): boolean;
    c2(a: boolean): boolean;
    c3(): boolean;
    hl(): void;
    protected ic(a: boolean): void;
    im(): void;
    propertyChanged: (sender: any, e: PropertyChangedEventArgs) => void;
    propertyUpdated: (sender: any, e: PropertyUpdatedEventArgs) => void;
    protected h5(a: string, b: any, c: any): void;
    df: List$1<Series>;
    ct(a: Series): boolean;
    b0(a: Series): boolean;
    f2: any;
    gi: string;
    ah: any[];
    fz(a: any, b: string): any;
    private da;
    protected gu(a: string): string;
    private c9;
    protected f0(a: any, b: string, c: string): any;
    f1(a: any): any;
    gf(a: number): string;
    ex(): number;
    el(a: number, b: ScalerParams): number;
    em(a: number, b: ScalerParams, c: CategoryMode): number;
    kd(a: Rect): Rect;
    kc(): Rect;
    kb(): Rect;
    protected kf(a: Rect, b: Rect): Rect;
    en(a: number, b: Rect, c: Rect): number;
    hq(a: IList$1<number>, b: number, c: number, d: ScalerParams): void;
    hp(a: IList$1<number[]>, b: IList$1<number>, c: number, d: number, e: ScalerParams): void;
    eo(a: number, b: ScalerParams): number;
    ep(a: number, b: ScalerParams, c: CategoryMode): number;
    eq(a: number, b: Rect, c: Rect): number;
    hr(a: IList$1<number>, b: number, c: number, d: ScalerParams): void;
    e6(a: number): number;
    abstract get a2(): AxisOrientation;
    km: Size;
    hw(a: Size): void;
    il(): void;
    ap: AxisComponentsForView;
    aq(): AxisComponentsForView;
    d4: number;
    private di;
    get eu(): number;
    set eu(a: number);
    b8(): boolean;
    er(): number;
    protected hi(): void;
    hm(a: AxisRangeChangedEventArgs): void;
    br: Pool$1<TextBlock>;
    bq: Pool$1<TextBlock>;
    bp: Pool$1<Rectangle>;
    get ki(): Path;
    get kj(): Path;
    get kl(): Path;
    get kk(): Path;
    be(): SyncSettings;
    ar(): AxisComponentsFromView;
    private ax;
    get ay(): AxisLabelSettings;
    h0(a: RenderingContext, b: RenderingContext): void;
    b5(): boolean;
    fy(): any;
    private _db;
    db(): IEnumerable$1<Series>;
    dc(): IEnumerable$1<Series>;
    h1(a: string): void;
    h4(a: any): void;
    h3(a: any): void;
    fm: CultureInfo;
    j8(a: number, b: Rect, c: Rect, d: Rect, e: Rect): Geometry;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class AxisCollection extends ObservableCollection$1<Axis> {
    static $t: Type;
    constructor();
    collectionResetting: (sender: any, e: EventArgs) => void;
    protected p(): void;
}
/**
 * @hidden
 */
export declare class AxisLabelManager extends Base {
    static $t: Type;
    e: List$1<any>;
    f: List$1<LabelPosition>;
    b: AxisLabelPanelBase;
    a: Axis;
    c: (arg1: number) => void;
    constructor();
    n(a: Rect, b: Rect): void;
    i(a: any, b: LabelPosition): void;
    t(): void;
    static j(a: FrameworkElement, b: AxisLabelSettings): void;
    private static k;
    private static l;
    static m(a: FrameworkElement, b: TitleSettings): void;
    h(a: FrameworkElement): void;
    r(a: number): void;
    o(a: number): void;
    u(a: number): FrameworkElement;
    s(a: number): void;
    get d(): boolean;
    q(): void;
    p(): void;
    g(): void;
}
/**
 * @hidden
 */
export declare abstract class AxisLabelPanelBase extends Panel {
    static $t: Type;
    ae(): AxisLabelPanelBaseView;
    ck(a: AxisLabelPanelBaseView): void;
    af: AxisLabelPanelBaseView;
    c0: Rect;
    cb(): void;
    cs(): void;
    cr(): void;
    constructor();
    bz: number;
    ad: Axis;
    private ak;
    get a2(): boolean;
    set a2(a: boolean);
    private a6;
    get bc(): List$1<any>;
    set bc(a: List$1<any>);
    bd: List$1<LabelPosition>;
    c7: Rect;
    private cz;
    get c8(): Rect;
    set c8(a: Rect);
    private cy;
    get c4(): Rect;
    set c4(a: Rect);
    c5: Rect;
    private bf;
    get bj(): number;
    set bj(a: number);
    b0: () => boolean;
    be: List$1<FrameworkElement>;
    bb: List$1<Rect>;
    ag: AxisLabelSettings;
    bq(): number;
    ao: boolean;
    c6: Rect;
    co(): void;
    ar: boolean;
    as: boolean;
    ay: boolean;
    az: boolean;
    a0: boolean;
    b2: any;
    al: boolean;
    protected an(a: List$1<Rect>, b: List$1<boolean>): boolean;
    protected b1(a: number, b: List$1<Rect>, c: List$1<boolean>): {
        ret: number;
        p1?: List$1<Rect>;
    };
    a8(): List$1<Rect>;
    b9(): void;
    b5(a: Size): void;
    get ap(): boolean;
    bo(): number;
    bt(): number;
    au(a: number, b: Rect): boolean;
    bn(a: any): number;
    by(a: any): number;
    bp(a: any): number;
    bm(a: any): number;
    aq(): boolean;
    protected cw(a: Rect, b: Rect): void;
    protected cg(a: Rect, b: Rect): void;
    ba(): List$1<Rect>;
    a9(a: List$1<Rect>): List$1<Rect>;
    protected c1(a: number, b: Rect, c: Thickness): Rect;
    protected at(a: List$1<Rect>, b: List$1<number>, c: Thickness): boolean;
    protected a7(a: List$1<Rect>): List$1<number>;
    bs(a: number, b: Size): number;
    br(a: number, b: Size): number;
    bw(): number;
    bu(): number;
    bv(): number;
    bx(): number;
    c9(a: Size): Size;
    protected get am(): boolean;
    c3(): Rect;
    protected b8(a: Size): void;
    protected b7(a: Size): void;
    protected cc(): void;
    protected a5(): IEnumerable$1<number>;
    get ah(): AxisLabelsLocation;
    cv(a: GeometryCollection, b: number, c: number, d: number, e: Rect, f: PathRenderingInfo): void;
    cf(a: GeometryCollection, b: number, c: number, d: number, e: Rect, f: PathRenderingInfo): void;
    cp(a: FrameworkElement, b: number): void;
    protected get_ax(): boolean;
    get ax(): boolean;
    ac(a: Rect, b: number): Point[];
    c2(a: Rect, b: number): Rect;
    cq(a: FrameworkElement): void;
    ce(a: FrameworkElement, b: number): void;
    db(a: Size): Size;
    static readonly cx: DependencyProperty;
    get bk(): number;
    set bk(a: number);
    bg: number;
    av(): boolean;
    aw(): boolean;
    aj(a: TitleSettings): AxisTitlePosition;
    ai(): AxisLabelsLocation;
    a1(a: AxisLabelsLocation): boolean;
    private _a3;
    a3(): IEnumerable$1<any>;
    b4(a: number, b: TextBlock, c: number, d: number, e: number): string;
    ca(a: any): void;
    cj(a: FrameworkElement): void;
    private _a4;
    a4(): IEnumerable$1<any>;
    protected bh: number;
    protected bi: number;
    cd(): void;
    cu(): void;
    ch(): void;
    bl(a: Rect): number;
    da: Size;
    cl(): void;
    ct(): void;
    ci(): void;
    cm(a: RenderingContext): void;
    b6(): void;
    cn(): void;
}
/**
 * @hidden
 */
export declare abstract class CategoryAxisBase extends Axis implements ICategoryScaler {
    static $t: Type;
    a4(): AxisView;
    ag(): number[];
    protected get_cd(): boolean;
    hv(a: AxisView): void;
    kr: CategoryAxisBaseView;
    protected ei(a: number, b: Rect, c: Rect, d: Rect): number;
    constructor();
    c8(a: Rect, b: Rect, c: AxisView): boolean;
    l6(): void;
    l5(): void;
    k2: List$1<number>;
    protected get_cb(): boolean;
    mj(a: Point, b: boolean, c: number): Rect;
    mk(a: Point, b: boolean, c: number, d: boolean): Rect;
    kv: IFastItemsSource;
    private ku;
    get itemsSource(): IEnumerable;
    set itemsSource(a: IEnumerable);
    static readonly me: DependencyProperty;
    private lh;
    lj: number;
    get lk(): number;
    set lk(a: number);
    get categoryMode(): CategoryMode;
    set categoryMode(a: CategoryMode);
    private ks;
    k5: number;
    protected lf(a: Rect, b: Rect, c: Rect): number;
    lc: number;
    k4: number;
    ld: number;
    le: number;
    kz: boolean;
    get ll(): number;
    set ll(a: number);
    private li;
    eo(a: number, b: ScalerParams): number;
    getUnscaledValue3(a: number, b: Rect, c: Rect, d: CategoryMode): number;
    getCategorySize(a: Rect, b: Rect, c: Rect): number;
    k8(a: Rect, b: Rect, c: Rect): number;
    getGroupCenter(a: number, b: Rect, c: Rect, d: Rect): number;
    lg(a: number): number;
    private _k1;
    private k1;
    private kx;
    ky(a: SeriesViewer): boolean;
    private _k0;
    private k0;
    private kw;
    ma(a: boolean): void;
    protected lm(): number;
    protected hz(a: any, b: string, c: any, d: any): void;
    protected ly(): void;
    l0(a: any, b: FastItemsSourceEventArgs): void;
    protected l7(a: FastItemsSourceEventArgs): void;
    private mb;
    ct(a: Series): boolean;
    b0(a: Series): boolean;
    private l8;
    lx(): void;
    l9(): void;
    lz(a: NotifyCollectionChangedEventArgs): void;
    l4(a: number, b: any, c: any): void;
    l1(): void;
    l2(a: number, b: any): void;
    l3(a: number, b: any): void;
    k9(a: Rect, b: Rect, c: Rect, d: number): number;
    la(a: Rect, b: Rect, c: Rect, d: number, e: number): number;
    getSeriesOffset(a: Rect, b: Rect, c: Rect, d: number, e: number): number;
    get isVertical(): boolean;
    j$d(a: number, b: ScalerParams): number;
    j$c(a: number, b: ScalerParams): number;
    j$e(a: IList$1<number[]>, b: IList$1<number>, c: number, d: number, e: ScalerParams): void;
    j$f(a: IList$1<number>, b: number, c: number, d: ScalerParams): void;
    j$g(a: IList$1<number>, b: number, c: number, d: ScalerParams): void;
    get j$b(): boolean;
    j$a(): number[];
    static $$p: string[];
}
/**
 * @hidden
 */
export declare abstract class HorizontalAxisLabelPanelBase extends AxisLabelPanelBase {
    static $t: Type;
    ae(): AxisLabelPanelBaseView;
    ck(a: AxisLabelPanelBaseView): void;
    dc: HorizontalAxisLabelPanelBaseView;
    dp: number;
    dl: number;
    dn: number;
    dm: number;
    b9(): void;
    de(): boolean;
    df(): boolean;
    aq(): boolean;
    a8(): List$1<Rect>;
    dr(a: List$1<Rect>, b: List$1<boolean>, c: number): void;
    private dq;
    private ds;
    protected dt(a: List$1<Rect>, b: List$1<boolean>): void;
    protected du(): void;
    protected get_ax(): boolean;
    cp(a: FrameworkElement, b: number): void;
    protected dg(): boolean;
    protected dd(): boolean;
    protected b1(a: number, b: List$1<Rect>, c: List$1<boolean>): {
        ret: number;
        p1?: List$1<Rect>;
    };
    c3(): Rect;
    dk(): number;
    dh(): number;
    dj(): number;
    di(): number;
    protected cc(): void;
    a9(a: List$1<Rect>): List$1<Rect>;
}
/**
 * @hidden
 */
export declare class HorizontalAxisLabelPanel extends HorizontalAxisLabelPanelBase {
    static $t: Type;
    ai(): AxisLabelsLocation;
    a1(a: AxisLabelsLocation): boolean;
}
/**
 * @hidden
 */
export declare abstract class NumericAxisBase extends Axis {
    static $t: Type;
    a4(): AxisView;
    ag(): number[];
    hv(a: AxisView): void;
    d2(a: number, b: ScalerParams): number;
    k1: NumericAxisBaseView;
    protected get_cj(): boolean;
    constructor();
    get ky(): AxisRangeBufferMode;
    set ky(a: AxisRangeBufferMode);
    private kw;
    get kz(): AxisRangeBufferMode;
    set kz(a: AxisRangeBufferMode);
    static readonly nw: DependencyProperty;
    mc: number;
    get l4(): number;
    set l4(a: number);
    private lw;
    ma: number;
    f4(): any;
    get l7(): number;
    set l7(a: number);
    private lz;
    mb: number;
    get l3(): number;
    set l3(a: number);
    private lv;
    f3(): any;
    l9: number;
    private ly;
    get l6(): number;
    set l6(a: number);
    l8: number;
    private lu;
    get l2(): number;
    set l2(a: number);
    ex(): number;
    private mh;
    get mk(): number;
    set mk(a: number);
    private mg;
    get mj(): number;
    set mj(a: number);
    private mi;
    get ml(): number;
    set ml(a: number);
    mo: number;
    private le;
    get li(): boolean;
    set li(a: boolean);
    ls: boolean;
    md: number;
    private lx;
    get l5(): number;
    set l5(a: number);
    me: number;
    lo: boolean;
    private lc;
    get lg(): boolean;
    set lg(a: boolean);
    lj: boolean;
    private ld;
    get lh(): boolean;
    set lh(a: boolean);
    get lp(): boolean;
    mm: number;
    mn: number;
    k4: NumericAxisRenderer;
    protected lq: boolean;
    protected lr: boolean;
    protected ic(a: boolean): void;
    protected it(a: Rect, b: Rect): void;
    h4(a: any): void;
    h3(a: any): void;
    ks: BindingFormatter;
    protected hz(a: any, b: string, c: any, d: any): void;
    protected ni(): void;
    ku: AxisRange;
    kv(): AxisRange;
    l1: number;
    l0: number;
    private lt;
    private k0;
    ng(a: NumericAxisBase, b: number, c: number, d: boolean, e: number, f: number, g: number): {
        p5: number;
        p6: number;
    };
    private kx;
    c3(): boolean;
    hl(): void;
    nj(a: AxisRangeChangedEventArgs): void;
    ct(a: Series): boolean;
    b0(a: Series): boolean;
    k3(a: AxisLabelManager): NumericAxisRenderer;
    k2(): NumericAxisRenderer;
    kt: (item: any) => string;
    mq: string;
    kr: any[];
    ln: boolean;
    k6(): NumericAxisRenderingParameters;
    nh(): void;
    k7(): NumericScaler;
    mp(): number;
    k5(a: Rect, b: Rect, c: Rect, d: Rect): NumericAxisRenderingParameters;
    mf(a: number): number;
    lk(): boolean;
    get lm(): boolean;
    get ll(): boolean;
    private nk;
    static readonly nz: DependencyProperty;
    get la(): TickmarkValues;
    set la(a: TickmarkValues);
    private k8;
    get k9(): TickmarkValues;
    set k9(a: TickmarkValues);
    private lb;
    get lf(): boolean;
    set lf(a: boolean);
    static $$p: string[];
}
/**
 * @hidden
 */
export declare abstract class NumericScaler extends DependencyObject {
    static $t: Type;
    static readonly ac: Rect;
    abstract t(a: NumericAxisBase, b: number, c: number, d: number, e: number): {
        p3: number;
        p4: number;
    };
    l: number;
    k: number;
    protected o: number;
    protected n: number;
    y(a: number): void;
    x(a: number): void;
    protected w(a: string, b: any, c: any): void;
    private z;
    protected m: number;
    abstract q(a: number, b: ScalerParams): number;
    abstract p(a: number, b: ScalerParams): number;
    j(a: IList$1<number>, b: number, c: number, d: ScalerParams): IList$1<number>;
    v(a: IList$1<number>, b: number, c: number, d: ScalerParams): void;
    u(a: IList$1<number[]>, b: IList$1<number>, c: number, d: number, e: ScalerParams): void;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class AxisRendererBase extends Base {
    static $t: Type;
    constructor(a: AxisLabelManager);
    u: () => void;
    o: (viewportRect: Rect, windowRect: Rect) => boolean;
    v: () => void;
    m: (p: AxisRenderingParametersBase, value: number) => number;
    l: (p: AxisRenderingParametersBase, geometry: GeometryCollection, startValue: number, endValue: number) => void;
    k: (p: AxisRenderingParametersBase, geometry: GeometryCollection, value: number) => void;
    q: (p: AxisRenderingParametersBase, value: number) => boolean;
    n: (p: AxisRenderingParametersBase, value: number) => boolean;
    j: (p: AxisRenderingParametersBase) => void;
    e: (p: AxisRenderingParametersBase) => void;
    p: (p: AxisRenderingParametersBase, position: number, isLastLabel: boolean) => boolean;
    h: (p: AxisRenderingParametersBase, value: number) => LabelPosition;
    t: (p: AxisRenderingParametersBase, value: number) => number;
    b: AxisLabelManager;
    g: (item: any, fromAbbreviator: boolean) => any;
    d: (viewportRect: Rect, windowRect: Rect, effectiveViewportRect: Rect, contentViewport: Rect) => AxisRenderingParametersBase;
    r: (p: AxisRenderingParametersBase, value: number, absoluteIndex: number, interval: number) => number;
    a: (p: AxisRenderingParametersBase, value: number, absolueIndex: number, interval: number) => number;
    f: (index: number, window: Rect, viewport: Rect, effectiveViewport: Rect) => number;
    i: (index: number) => number;
    c(a: boolean, b: Rect, c: Rect, d: Rect, e: Rect): AxisRenderingParametersBase;
    private aa;
    private ab;
    protected x(a: Rect, b: Rect): void;
    private z;
    private s;
    private y;
    w(a: AxisRenderingParametersBase, b: number, c: number, d: number): any;
}
/**
 * @hidden
 */
export declare class NumericAxisRenderer extends AxisRendererBase {
    static $t: Type;
    constructor(a: AxisLabelManager);
    w(a: AxisRenderingParametersBase, b: number, c: number, d: number): any;
    private ac;
    private ad;
    private ae;
}
/**
 * @hidden
 */
export declare class VerticalAxisLabelPanel extends AxisLabelPanelBase {
    static $t: Type;
    ae(): AxisLabelPanelBaseView;
    ck(a: AxisLabelPanelBaseView): void;
    dc: VerticalAxisLabelPanelView;
    dl: number;
    di: number;
    dk: number;
    dj: number;
    b9(): void;
    bt(): number;
    de(): number;
    dg(): number;
    dh(): number;
    df(): number;
    a8(): List$1<Rect>;
    private dm;
    private dn;
    cp(a: FrameworkElement, b: number): void;
    protected dd(): boolean;
    c3(): Rect;
    aj(a: TitleSettings): AxisTitlePosition;
    ai(): AxisLabelsLocation;
    a1(a: AxisLabelsLocation): boolean;
    protected cc(): void;
}
/**
 * @hidden
 */
export declare class ViewportUtils extends Base {
    static $t: Type;
    static e(a: number, b: Rect, c: Rect, d: Rect): number;
    static b(a: number, b: Rect, c: Rect, d: Rect): number;
    static i(a: number, b: Rect, c: Rect, d: Rect): number;
    static g(a: number, b: Rect, c: Rect, d: Rect): number;
    static d(a: number, b: Rect, c: Rect, d: Rect): number;
    static a(a: number, b: Rect, c: Rect, d: Rect): number;
    static h(a: number, b: Rect, c: Rect, d: Rect): number;
    static f(a: number, b: Rect, c: Rect): number;
    static c(a: number, b: Rect, c: Rect): number;
    static j(a: number, b: Rect, c: Rect): number;
}
/**
 * @hidden
 */
export interface IHasCategoryAxis {
    readonly categoryAxis: CategoryAxisBase;
    getOffsetValue(): number;
    getCategoryWidth(): number;
}
/**
 * @hidden
 */
export declare let IHasCategoryAxis_$type: Type;
/**
 * @hidden
 */
export interface IHasCategoryModePreference extends IHasCategoryAxis {
    preferredCategoryMode(a: CategoryAxisBase): CategoryMode;
}
/**
 * @hidden
 */
export declare let IHasCategoryModePreference_$type: Type;
/**
 * @hidden
 */
export declare class AutomaticSeriesManager extends Base {
    static $t: Type;
    private g;
    private c;
    e(a: AutomaticSeriesPurpose): boolean;
    constructor(a: SeriesViewer);
    private i;
    private n;
    private m;
    protected f: boolean;
    private j;
    private k;
    l(a: AutomaticSeriesPurpose): void;
    private h;
    private d;
    private a;
    get b(): AutomaticSeriesRequestCollection;
}
/**
 * @hidden
 */
export declare class AutomaticSeriesRequest extends Base {
    static $t: Type;
    a: AutomaticSeriesPurpose;
    d: Series;
    b: Series;
    c: Series;
    e: boolean;
    f: boolean;
}
/**
 * @hidden
 */
export declare class AutomaticSeriesRequestCollection extends ObservableCollection$1<AutomaticSeriesRequest> {
    static $t: Type;
    constructor();
}
/**
 * @hidden
 */
export declare class ChartSelection extends Base {
    static $t: Type;
    private _item;
    get item(): any;
    set item(a: any);
    private _series;
    get series(): Series;
    set series(a: Series);
    private b;
    get c(): SeriesMatcher;
    set c(a: SeriesMatcher);
    equals(a: any): boolean;
    getHashCode(): number;
    g(a: SeriesViewer): void;
}
/**
 * @hidden
 */
export declare class ChartSelectedItemCollection extends ObservableCollection$1<ChartSelection> {
    static $t: Type;
    constructor();
    collectionResetting: (sender: any, e: EventArgs) => void;
    protected p(): void;
}
/**
 * @hidden
 */
export declare class SeriesMatcherHelper extends Base {
    static $t: Type;
    static a(a: SeriesViewer, b: SeriesMatcher): Series[];
    private static b;
}
/**
 * @hidden
 */
export declare class SeriesLayer extends DependencyObject implements INotifyPropertyChanged {
    static $t: Type;
    private _source;
    get source(): Series;
    set source(a: Series);
    private _target;
    get target(): Series;
    set target(a: Series);
    private z;
    constructor();
    private ak;
    au(): void;
    at(): void;
    get t(): boolean;
    private a3;
    private a4;
    private a5;
    private a2;
    private ah;
    private an;
    private ag;
    private ao;
    n: IExecutionContext;
    private u;
    private ar;
    private as;
    private y;
    az(a: Series, b: DependencyProperty): void;
    a0(a: Series, b: DependencyProperty): void;
    private r;
    private af;
    private al;
    private p;
    private aa;
    private ab;
    private v;
    private w;
    private x;
    private av;
    propertyChanged: (sender: any, e: PropertyChangedEventArgs) => void;
    private ax;
    protected q: boolean;
    am(a: Series, b: Series): void;
    private ay;
    private a1;
    ap(a: Series): void;
    private aq;
    private aw;
    ai(a: Series, b: Series, c: DependencyProperty, d: any): any;
    private s;
    private ad;
    private ae;
    ac: number;
    get m(): SeriesLayerPropertyOverlayCollection;
    private l;
    private o;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class SeriesLayerCollection extends ObservableCollection$1<SeriesLayer> {
    static $t: Type;
    constructor();
    collectionResetting: (sender: any, e: EventArgs) => void;
    protected p(): void;
}
/**
 * @hidden
 */
export declare class SeriesLayerManager extends Base {
    static $t: Type;
    a: Series;
    private b;
    private i;
    private n;
    private m;
    h(a: Series, b: SeriesLayerCollection, c: NotifyCollectionChangedEventArgs): void;
    j(a: Series, b: SeriesLayerCollection, c: EventArgs): void;
    e(a: Series, b: SeriesLayerCollection, c: NotifyCollectionChangedEventArgs): void;
    f(a: Series, b: SeriesLayerCollection, c: EventArgs): void;
    c(a: Series, b: SeriesLayerCollection, c: NotifyCollectionChangedEventArgs): void;
    private g;
    private l;
    private k;
    d(a: Series, b: SeriesLayerCollection, c: EventArgs): void;
}
/**
 * @hidden
 */
export declare class SeriesLayerPropertyOverlay extends DependencyObject implements INotifyPropertyChanged {
    static $t: Type;
    o: boolean;
    k: SeriesLayerPropertyOverlay;
    propertyChanged: (sender: any, e: PropertyChangedEventArgs) => void;
    propertyUpdated: (sender: any, e: PropertyUpdatedEventArgs) => void;
    private ah;
    q: boolean;
    protected n: boolean;
    private ag;
    private m;
    w: any;
    s: any;
    t(a: any, b: any, c: Series): any;
    private aj;
    private v;
    private ai;
    private u;
    r: boolean;
    p: boolean;
    get aa(): string;
    ad: string;
    y: string;
    x: any;
    valueResolving: (sender: any, e: SeriesLayerPropertyOverlayValueResolvingEventArgs) => void;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class SeriesLayerPropertyOverlayCollection extends ObservableCollection$1<SeriesLayerPropertyOverlay> {
    static $t: Type;
    constructor();
    collectionResetting: (sender: any, e: EventArgs) => void;
    protected p(): void;
}
/**
 * @hidden
 */
export interface IDataChartToolbarProvider {
    container: any;
    getDesiredToolbarActions(a: SeriesViewer): ToolActionInfo[];
    onToolCommandExecuting(a: SeriesViewer, b: ToolCommand): ToolCommandExecutionState;
    onTargetPropertyChanged(a: SeriesViewer, b: string, c: any, d: any): void;
}
/**
 * @hidden
 */
export declare let IDataChartToolbarProvider_$type: Type;
/**
 * @hidden
 */
export interface ISeriesViewerScrollbarManager {
    executionContext: IExecutionContext;
    animator: DoubleAnimator;
    owner: SeriesViewer;
    onHorizontalScrollbarModeChanged(a: SeriesViewerScrollbarMode): void;
    onVerticalScrollbarModeChanged(a: SeriesViewerScrollbarMode): void;
    updateScrollbars(a: SeriesViewer, b: Rect, c: Rect, d: Rect, e: Rect): void;
    updateBarDimensions(a: SeriesViewer, b: number, c: number, d: number, e: boolean, f: number, g: number, h: number, i: number, j: number, k: boolean, l: number, m: number): void;
    updateBarAppearance(a: SeriesViewer, b: Brush, c: Brush, d: Brush, e: Brush, f: number, g: number, h: number, i: number): void;
    onCrosshairMoved(a: Point): void;
    shouldHandleInteraction(a: Point, b: boolean): boolean;
    onScrollbarDrag(a: Point, b: boolean): void;
    onScrollbarDragComplete(a: Point, b: boolean): void;
    onScrollbarDragCancel(): void;
    updateVerticalScrollbarPosition(a: SeriesViewerVerticalScrollbarPosition): void;
    updateHorizontalScrollbarPosition(a: SeriesViewerHorizontalScrollbarPosition): void;
}
/**
 * @hidden
 */
export declare let ISeriesViewerScrollbarManager_$type: Type;
/**
 * @hidden
 */
export interface ISeriesInteractionManager {
    a$m(a: Series, b: Point, c: number, d: Axis, e: ScalerParams, f: number, g: number, h: (arg1: Point) => number): number;
    a$p(a: Series, b: IList$1<number>, c: Point, d: Axis, e: ScalerParams, f: number, g: (arg1: Point) => number, h: boolean, i: boolean): number;
    a$o(a: Series, b: number, c: IList$1<number>, d: number, e: number, f: number, g: number, h: number, i: boolean): number;
    a$r(a: Series, b: Point, c: boolean, d: Axis, e: (arg1: Point) => number, f: IList$1<number>): number;
    a$f(a: Series, b: Point, c: boolean): boolean;
    a$b(a: Series, b: CategoryAxisBase, c: List$1<number[]>, d: number, e: number, f: Point, g: boolean): number[][];
    a$a(a: Series, b: CategoryAxisBase, c: List$1<number[]>, d: number, e: number, f: Point, g: boolean): number[];
    a$g(a: Series, b: Point, c: boolean, d: PathGeometry): boolean;
    a$h(a: Series, b: Point, c: PathGeometry): boolean;
    a$q(a: Series, b: Point, c: boolean, d: Axis, e: (arg1: Point) => number, f: IList$1<number>): number;
    a$n(a: Series, b: Point, c: Axis): number;
    a$i(a: Series, b: Point, c: boolean): boolean;
    a$au(a: Series, b: Point, c: boolean, d: boolean, e: number, f: Axis, g: Axis, h: (arg1: Point, arg2: boolean, arg3: boolean) => number, i: (arg1: Point, arg2: boolean) => number, j: (arg1: Point, arg2: boolean) => number): Point;
    a$ab(a: Series, b: any, c: Point, d: boolean, e: boolean, f: boolean, g: boolean, h: boolean, i: boolean): void;
    a$y(): void;
    a$at(a: Series, b: HighlightingInfo, c: HighlightingInfo, d: HighlightingInfo, e: number, f: number, g: number, h: number, i: number, j: number, k: Brush, l: boolean): Brush;
    a$l(a: Series, b: HighlightingInfo, c: HighlightingInfo, d: HighlightingInfo, e: number): number;
    a$k(a: Series, b: HighlightingInfo, c: HighlightingInfo, d: HighlightingInfo, e: number, f: number, g: number, h: number, i: number, j: number, k: number, l: number, m: boolean): number;
    a$ae(a: Series, b: Point, c: any, d: any, e: boolean): void;
    a$ar(a: Series, b: Point): void;
    a$ah(a: Series, b: Point, c: any, d: any, e: boolean): void;
    a$af(a: Series, b: Point, c: any, d: any, e: boolean): void;
    a$ac(a: Series, b: Point, c: any, d: any): void;
    a$ag(a: Series, b: Point, c: any, d: any): void;
    a$ad(a: Series, b: Point, c: any, d: any): void;
    a$ai(a: Series, b: Point, c: any, d: any): void;
    a$aj(a: Series, b: Point, c: any, d: any): void;
    a$t(a: Series): string;
    a$u(a: Series): string;
    readonly a$c: boolean;
    readonly a$s: any;
    a$as(a: Series, b: any): void;
    a$aq(a: Series, b: Point, c: (arg1: any) => void): void;
    a$aa(a: Series): void;
    a$ap(a: Series): void;
    readonly a$e: boolean;
    readonly a$j: Dictionary$2<string, SeriesView>;
    readonly a$d: boolean;
    a$z(a: Series, b: Rect, c: Rect, d: string, e: number): void;
    a$ak(a: Series, b: SeriesViewer): void;
    a$al(a: Series, b: string, c: SeriesViewer): void;
    a$x(a: Series, b: any, c: number): void;
    a$v(a: Series): void;
    a$an(a: Series, b: any, c: number): void;
    a$ao(a: Series): void;
    a$w(a: Series, b: any, c: number): void;
    a$am(a: Series, b: any, c: number): void;
}
/**
 * @hidden
 */
export declare let ISeriesInteractionManager_$type: Type;
/**
 * @hidden
 */
export interface ISeriesViewerInteractionManager {
    f$a(a: SeriesViewer): ChartHitTestMode;
    f$aj(a: SeriesViewer): void;
    f$t(a: SeriesViewer, b: Point): void;
    f$ah(a: SeriesViewer, b: Point): void;
    f$u(a: SeriesViewer, b: Point, c: boolean): void;
    f$s(a: SeriesViewer, b: Point): void;
    f$ao(a: SeriesViewer, b: Point): void;
    f$ag(a: SeriesViewer, b: Point): void;
    f$ap(a: SeriesViewer, b: Point, c: number, d: number, e: number): void;
    f$af(a: SeriesViewer, b: number): void;
    f$al(a: SeriesViewer, b: Point, c: number, d: number, e: number): void;
    f$ac(a: SeriesViewer, b: Point): void;
    f$ae(a: SeriesViewer, b: number): void;
    f$v(a: SeriesViewer, b: Point): void;
    f$ab(a: SeriesViewer, b: Point): void;
    f$ak(a: SeriesViewer, b: Point, c: number, d: number, e: number): void;
    f$q(a: SeriesViewer, b: Point, c: boolean): void;
    f$an(a: SeriesViewer): void;
    f$am(a: SeriesViewer): void;
    f$at(a: SeriesViewer): void;
    f$n(a: SeriesViewer): void;
    f$k(a: SeriesViewer): void;
    f$p(a: SeriesViewer, b: Point, c: boolean): void;
    f$o(a: SeriesViewer, b: Point, c: boolean, d: boolean): void;
    f$ar(a: SeriesViewer): void;
    f$ai(a: SeriesViewer): void;
    f$g(a: SeriesViewer, b: Key): boolean;
    f$h(a: SeriesViewer, b: Point, c: number): boolean;
    f$r(a: SeriesViewer, b: Point): void;
    f$m(a: SeriesViewer): void;
    f$l(a: SeriesViewer): void;
    readonly f$e: IHighlightingManager;
    readonly f$f: IHighlightingManager;
    readonly f$d: IHighlightingManager;
    readonly f$b: ISeriesViewerScrollbarManager;
    f$as(a: SeriesViewer, b: Point): void;
    f$j(a: Series, b: any, c: number): void;
    f$aq(a: Series, b: any, c: number): void;
    f$c(a: SeriesViewer, b: SeriesCollection, c: RenderingContext, d: Point, e: boolean, f: DataContext, g: boolean): {
        ret: Series;
        p5: DataContext;
    };
    f$i(a: SeriesViewer, b: Point): boolean;
    f$z(a: SeriesViewer, b: SeriesCollection, c: RenderingContext, d: Point, e: boolean, f: boolean): void;
    f$y(a: SeriesViewer, b: Point): void;
    f$x(a: SeriesViewer, b: EventProxy, c: Point): void;
    f$aa(a: SeriesViewer, b: EventProxy, c: Point): void;
    f$w(a: SeriesViewer, b: Point, c: boolean): void;
    f$ad(a: SeriesViewer, b: boolean): void;
}
/**
 * @hidden
 */
export declare let ISeriesViewerInteractionManager_$type: Type;
/**
 * @hidden
 */
export interface IDataChartVisualDataManager {
    exportVisualData(a: XamDataChart): any;
}
/**
 * @hidden
 */
export declare let IDataChartVisualDataManager_$type: Type;
/**
 * @hidden
 */
export interface IAxisVisualDataManager {
    exportVisualData(a: Axis): any;
}
/**
 * @hidden
 */
export declare let IAxisVisualDataManager_$type: Type;
/**
 * @hidden
 */
export interface ISeriesVisualDataManager {
    exportVisualData(a: Series, b: Rect): any;
    exportMarkerVisualData(a: MarkerSeries, b: any): void;
    getMarkerVisualData(a: Series, b: Marker, c: DataTemplate): any;
    copyVisualData(a: any, b: any): void;
    exportTrendlineData(a: Series, b: any, c: Polyline): void;
    exportStackedVisualData(a: Series, b: Rect): any;
    createFragmentVisualData(a: Series, b: Rect, c: string, d: string): any;
    addSubSeriesVisualData(a: any, b: any): void;
    addSubSeriesLayerVisualData(a: any, b: any): void;
    exportRectangleData(a: any, b: Rectangle, c: string, d: string[]): void;
    exportMarkerVisualDataFromMarker(a: Series, b: any, c: ContentControl): void;
    exportPathData(a: any, b: Path, c: string, d: string[]): void;
    exportPolylineData(a: any, b: Polyline, c: string, d: string[]): void;
    exportPolygonData(a: any, b: Polygon, c: string, d: string[]): void;
    exportSeriesPixelsData(a: any, b: number[], c: number, d: number): void;
    addPointerTooltipData(a: any, b: any, c: number, d: number, e: List$1<string>): void;
    addPointerTooltipWithDataLegend(a: any, b: any, c: number, d: number, e: any): void;
    exportPointerTooltipData(a: Polygon, b: Polyline, c: Rectangle, d: Rect): any;
    exportCalloutData(a: number, b: number, c: number, d: number, e: any, f: Rectangle, g: TextBlock, h: FontInfo, i: Line, j: string, k: string[]): void;
    exportLayerVisualData(a: Series, b: any): void;
}
/**
 * @hidden
 */
export declare let ISeriesVisualDataManager_$type: Type;
/**
 * @hidden
 */
export declare class XamDataChart extends SeriesViewer {
    static $t: Type;
    static y6: number;
    static y5: number;
    private _xsr;
    private get XSRP();
    private xo;
    get xp(): IDataChartVisualDataManager;
    static staticInit(): void;
    static zi(a: Series): number;
    constructor();
    protected q0(a: any, b: string, c: any, d: any): void;
    ri(): void;
    pe(): void;
    protected o2(a: Rect, b: Rect): void;
    protected o9(): void;
    aap(): void;
    private aak;
    private abk;
    private aar;
    private xu;
    private xt;
    private xr;
    private xq;
    private abl;
    private abm;
    protected get_e1(): boolean;
    x9: boolean;
    hz(): number;
    h0(): number;
    protected r4(): void;
    zg: number;
    zh: number;
    private yp;
    get y1(): number;
    set y1(a: number);
    private yq;
    get y2(): number;
    set y2(a: number);
    fp(): boolean;
    fq(): boolean;
    x6: boolean;
    yj: boolean;
    x7: boolean;
    ya: boolean;
    xn: GridMode;
    x3: boolean;
    ye: boolean;
    yf: boolean;
    y8: number;
    y4: number;
    y3: number;
    get x1(): boolean;
    protected get_fy(): boolean;
    get x2(): boolean;
    yh: boolean;
    yd: boolean;
    yg: boolean;
    yi: boolean;
    xi: AutoMarginsAndAngleUpdateMode;
    x8: boolean;
    yc: boolean;
    yb: boolean;
    private yr;
    private ys;
    private y9;
    private za;
    protected get_fx(): boolean;
    protected get_fw(): boolean;
    aao(): void;
    aan(): void;
    aam(a: AxisLabelPanelBase, b: Rect, c: Rect, d: Rect): void;
    private zf;
    private y7;
    private aaj;
    abj: Brush;
    abh: Brush;
    abi: Brush;
    get axes(): AxisCollection;
    private xj;
    private aag;
    private aah;
    axisRangeChanged: (sender: any, e: ChartAxisRangeChangedEventArgs) => void;
    private aai;
    private static aal;
    sd(a: SyncLink, b: SyncLink): void;
    private xx;
    getFontInfo(): FontInfo;
    aaq(): void;
    getFontBrush(): Brush;
    protected n2(): void;
    vx(): Brush;
    f7(): boolean;
    protected r8(): void;
    ey(): boolean;
    private x5;
    protected db(): SeriesViewerView;
    protected qo(a: SeriesViewerView): void;
    xw: XamDataChartView;
    rj(): void;
    private x0;
    static zl: string;
    private ym;
    get yy(): number;
    set yy(a: number);
    static zn: string;
    private yo;
    get y0(): number;
    set y0(a: number);
    static zm: string;
    private yn;
    get yz(): number;
    set yz(a: number);
    static zk: string;
    private yl;
    get yx(): number;
    set yx(a: number);
    xl: ComputedPlotAreaMarginMode;
    xs: SeriesPlotAreaMarginHorizontalMode;
    xv: SeriesPlotAreaMarginVerticalMode;
    private yu;
    get zc(): number;
    set zc(a: number);
    private yw;
    get ze(): number;
    set ze(a: number);
    private yv;
    get zd(): number;
    set zd(a: number);
    private yt;
    get zb(): number;
    set zb(a: number);
    protected wv(a: Rect): Rect;
    w2(): Rect;
    zj(): any;
    zy(): string;
    qx(): void;
    rl(): void;
    yk(a: Axis): List$1<Axis>;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class LabelPanelArranger extends Base {
    static $t: Type;
    static e(a: List$1<AxisLabelPanelBase>, b: Rect): Rect;
    private static a;
    static b(a: AxisLabelPanelBase): AxisLabelsLocation;
    private static c;
    static d(a: List$1<AxisLabelPanelBase>, b: LabelPanelsArrangeState, c: Rect, d: (arg1: AxisLabelPanelBase, arg2: Rect) => void): void;
}
/**
 * @hidden
 */
export declare class ChartContentManager extends DependencyObject {
    static $t: Type;
    private l;
    private r;
    private t;
    private get u();
    private set u(value);
    constructor(a: SeriesViewer);
    k(a: ChartContentType, b: DependencyObject, c: (arg1: boolean) => void): ContentInfo;
    ad(a: ChartContentType, b: DependencyObject): void;
    private m;
    private v;
    aa(a: DomRenderer): void;
    z(): void;
    ac(a: ChartContentType, b: DependencyObject, c: ContentInfo, d: boolean): void;
    private q;
    private j;
    y(): void;
    private w;
    private _s;
    private s;
    x(a: Size): void;
    o: boolean;
    n: boolean;
    p: boolean;
    ae(a: ChartContentType, b: DependencyObject, c: ContentInfo, d: Rect): void;
    ab(a: Axis, b: ContentInfo): void;
}
/**
 * @hidden
 */
export declare class ContentInfo extends Base {
    static $t: Type;
    h: DependencyObject;
    a: (arg1: boolean) => void;
    b: boolean;
    c: boolean;
    i: Rect;
    get d(): boolean;
    g(): void;
    f(): void;
    e: boolean;
}
/**
 * @hidden
 */
export declare abstract class Series extends Control implements INotifyPropertyChanged, IProvidesViewport, ILegendSeries, ILegendSeriesInternal, ILegendOwner, ILegendTemplateProvider, IDataLegendSeries {
    static $t: Type;
    cw: SeriesView;
    private static j1;
    kh: number;
    wn: Rect;
    gd(): boolean;
    protected get_dataLegendKey(): string;
    get dataLegendKey(): string;
    l5: string;
    ml: string;
    get group(): string;
    get parentKey(): string;
    get parentTitle(): string;
    ey: boolean;
    private jz;
    get j0(): DomRenderer;
    set j0(a: DomRenderer);
    provideRenderer(a: DomRenderer): void;
    ng(): string;
    constructor();
    j7(): number;
    cd: SeriesLayerManager;
    private ov;
    private ow;
    private or;
    private os;
    private op;
    private oq;
    private ot;
    private qs;
    private qy;
    private qx;
    private ou;
    sp(a: MarkerOutlineMode): void;
    so(a: MarkerFillMode): void;
    sq(a: number): void;
    private static readonly u8;
    protected ox(a: any, b: PropertyChangedEventArgs): void;
    private dr;
    get ds(): SRProvider;
    private bb;
    get bc(): ISeriesVisualDataManager;
    protected get ho(): Dictionary$2<string, SeriesView>;
    private a9;
    get ba(): ISeriesInteractionManager;
    get fj(): boolean;
    dd: DoubleAnimator;
    q3(a: SeriesView): void;
    q0(): void;
    q1(): void;
    cu(): SeriesView;
    protected ct(): SeriesView;
    sz: Canvas;
    hc(): boolean;
    kr(a: any, b: string): any;
    mf(a: string): string;
    onLegendItemOver(a: any): void;
    onLegendItemPointerUp(a: any): void;
    onLegendItemPointerDown(a: any): void;
    onLegendItemEnter(a: any): void;
    onLegendItemLeave(a: any): void;
    private hi;
    protected nf(a: string): string;
    private hh;
    protected ks(a: any, b: string, c: string): any;
    is(a: Point): number;
    j6(a: Point): number;
    protected get_ft(): boolean;
    get ft(): boolean;
    a0(): CategoryAxisBase;
    j4(a: Point): number;
    wz(): Thickness;
    w1(a: SeriesPlotAreaMarginHorizontalMode, b: SeriesPlotAreaMarginVerticalMode): Thickness;
    w0(a: SeriesPlotAreaMarginHorizontalMode, b: SeriesPlotAreaMarginVerticalMode): Thickness;
    cl(): SeriesPlotAreaMarginHorizontalMode;
    cm(): SeriesPlotAreaMarginVerticalMode;
    ko(a: Point): any;
    p6(a: Rect, b: List$1<ChartSelection>, c: SeriesSelectionBehavior): void;
    ak(a: Rect, b: SeriesSelectionBehavior): ChartSelection[];
    protected kx(a: Series, b: Point): any;
    protected dj(a: Series, b: any, c: Point, d: boolean): HighlightingInfo;
    protected dk(a: Series, b: any, c: Point, d: boolean): HighlightingInfo;
    j3(): number;
    j8(): number;
    kd(): number;
    get container(): ILegendOwner;
    get hasSubItems(): boolean;
    protected ej(): boolean;
    forSubItems(a: (arg1: any) => void): void;
    protected p4(a: (arg1: any) => void): void;
    p5(a: (arg1: Series) => boolean): void;
    get ei(): boolean;
    p3(a: (arg1: Series) => boolean): void;
    ne(): string;
    v1(): Brush;
    v2(): Brush;
    resolveLegendIndex(): number;
    bq(): Series;
    protected get_eu(): boolean;
    get eu(): boolean;
    protected get_er(): boolean;
    get er(): boolean;
    protected get_eq(): boolean;
    get eq(): boolean;
    protected get_et(): boolean;
    get et(): boolean;
    protected get_es(): boolean;
    get es(): boolean;
    protected get_ev(): boolean;
    get ev(): boolean;
    protected get_isVertical(): boolean;
    get isVertical(): boolean;
    protected get_isFragment(): boolean;
    get isFragment(): boolean;
    protected get_ex(): boolean;
    get ex(): boolean;
    protected get_ew(): boolean;
    get ew(): boolean;
    protected get_em(): boolean;
    get em(): boolean;
    protected get_f6(): boolean;
    get f6(): boolean;
    protected get_fl(): boolean;
    get fl(): boolean;
    protected get_fk(): boolean;
    get fk(): boolean;
    protected get_f1(): boolean;
    get f1(): boolean;
    protected get_e1(): boolean;
    get e1(): boolean;
    protected get_ez(): boolean;
    get ez(): boolean;
    protected get_f7(): boolean;
    get f7(): boolean;
    protected get_fs(): boolean;
    get fs(): boolean;
    protected get_fr(): boolean;
    get fr(): boolean;
    protected get_fp(): boolean;
    get fp(): boolean;
    protected get_fo(): boolean;
    get fo(): boolean;
    protected get_f4(): boolean;
    get f4(): boolean;
    protected get_f2(): boolean;
    get f2(): boolean;
    protected get_fz(): boolean;
    get fz(): boolean;
    protected get_fq(): boolean;
    get fq(): boolean;
    protected get_fx(): boolean;
    get fx(): boolean;
    protected get_fu(): boolean;
    get fu(): boolean;
    protected get_isStacked(): boolean;
    get isStacked(): boolean;
    protected get_e8(): boolean;
    get e8(): boolean;
    protected get_fv(): boolean;
    get fv(): boolean;
    protected get_e0(): boolean;
    get e0(): boolean;
    protected get_fd(): boolean;
    get fd(): boolean;
    protected get_fy(): boolean;
    get fy(): boolean;
    protected get_isValueOverlay(): boolean;
    get isValueOverlay(): boolean;
    protected get_fg(): boolean;
    get fg(): boolean;
    protected get_isSummarizationSupported(): boolean;
    get isSummarizationSupported(): boolean;
    get isLayer(): boolean;
    bp(): Series;
    protected get_ek(): boolean;
    get ek(): boolean;
    protected get_fb(): boolean;
    get fb(): boolean;
    protected get_fa(): boolean;
    get fa(): boolean;
    protected get_e9(): boolean;
    get e9(): boolean;
    protected get_fc(): boolean;
    get fc(): boolean;
    protected get_e3(): boolean;
    get e3(): boolean;
    protected get_e4(): boolean;
    get e4(): boolean;
    iq(a: Point, b: number, c: Axis, d: ScalerParams, e: number): number;
    protected ir(a: Point, b: number, c: Axis, d: ScalerParams, e: number, f: number, g: (arg1: Point) => number): number;
    protected get_he(): boolean;
    get he(): boolean;
    protected i8(a: IList$1<number>, b: Point, c: Axis, d: ScalerParams, e: number, f: (arg1: Point) => number, g: boolean, h: boolean): number;
    iw(a: number, b: IList$1<number>, c: number, d: number, e: number, f: number, g: number, h: boolean): number;
    kc(a: Point, b: boolean, c: Axis, d: (arg1: Point) => number, e: IList$1<number>): number;
    iv(a: boolean): number;
    aj(a: Point): Point[][];
    al(a: Point): Point[][];
    protected gw(a: Point, b: boolean): boolean;
    an(a: CategoryAxisBase, b: List$1<number[]>, c: number, d: number, e: Point, f: boolean): number[][];
    am(a: CategoryAxisBase, b: List$1<number[]>, c: number, d: number, e: Point, f: boolean): number[];
    protected gy(a: Point, b: boolean, c: PathGeometry): boolean;
    protected gz(a: Point, b: PathGeometry): boolean;
    ka(a: Point, b: boolean, c: Axis, d: (arg1: Point) => number, e: IList$1<number>): number;
    iu(a: Point, b: Axis): number;
    kb(a: Point, b: boolean): number;
    j9(a: Point, b: boolean): number;
    i6(a: Point, b: boolean, c: boolean): number;
    wh(a: Point, b: boolean, c: boolean): Point;
    ws(a: Point): Rect;
    ao(a: Point): Rect[];
    wt(a: Point): Rect;
    ap(a: Point): Rect[];
    ar(a: number, b: number): CollisionGeometry;
    wu(a: Point): Rect;
    wv(a: Point): Rect;
    protected g0(a: Point, b: boolean): boolean;
    protected wj(a: Point, b: boolean, c: boolean, d: number, e: Axis, f: Axis, g: (arg1: Point, arg2: boolean, arg3: boolean) => number, h: (arg1: Point, arg2: boolean) => number, i: (arg1: Point, arg2: boolean) => number): Point;
    i2(a: Point, b: boolean, c: boolean): number;
    wd(a: Point, b: boolean, c: boolean): Point;
    i4(a: Point, b: boolean, c: boolean): number;
    wf(a: Point, b: boolean, c: boolean): Point;
    wi(a: Point, b: boolean, c: boolean): Point;
    i7(a: Point, b: boolean, c: boolean): number;
    we(a: Point, b: boolean, c: boolean): Point;
    i3(a: Point, b: boolean, c: boolean): number;
    wg(a: Point, b: boolean, c: boolean): Point;
    i5(a: Point, b: boolean, c: boolean): number;
    j5(a: Point): number;
    ix(): number;
    static po(a: Series, b: SeriesViewer, c: boolean): void;
    it(a: Point): number;
    kp(a: Point): any;
    kj: any;
    protected o1(a: Series, b: any): void;
    protected k1(a: Series): any;
    au(a: boolean): BindingFormatter;
    ed(a: List$1<SeriesPointOfInterest>, b: boolean, c: boolean, d: number, e: boolean): boolean;
    je(a: Marker): number;
    jd(a: any): number;
    mg(): string;
    i9(a: ValueLayerValueMode, b: Axis): number;
    aq(a: ValueLayerValueMode): number[];
    wk(a: ValueLayerValueMode): Point;
    wl(a: number[]): Point;
    propertyChanged: (sender: any, e: PropertyChangedEventArgs) => void;
    propertyUpdated: (sender: any, e: PropertyUpdatedEventArgs) => void;
    protected raisePropertyChanged(a: string, b: any, c: any): void;
    private k4;
    private kz;
    private static hg;
    tr(a: string): DependencyProperty;
    protected get_hasMarkers(): boolean;
    get hasMarkers(): boolean;
    protected get_en(): boolean;
    get en(): boolean;
    p9(): void;
    qa(): void;
    protected vs(a: number): Brush;
    protected vy(a: Brush): Brush;
    protected vv(a: number): Brush;
    protected vt(a: number): Brush;
    protected vu(a: number): Brush;
    vq(): Brush;
    vr(): Brush;
    s3(): DataTemplate;
    ip(): number;
    wm(a: Point): Point;
    ww(a: Rect): Rect;
    wc(a: Point): Point;
    ky(a: any, b: Point): any;
    ge(a: any): boolean;
    ay(a: Axis): AxisRange;
    az(a: Rect): AxisRange;
    wy(): Size;
    ax(a: AxisRange, b: NumericAxisBase, c: Rect): AxisRange;
    protected p0(): void;
    protected d9: boolean;
    ru(a: boolean): void;
    transitionOutCompleted: (sender: any, e: TransitionOutCompletedEventArgs) => void;
    renderRequested: (sender: any, e: RenderRequestedEventArgs) => void;
    private pk;
    private bu;
    protected get bv(): SeriesHighlightedValuesDisplayMode;
    protected set bv(a: SeriesHighlightedValuesDisplayMode);
    rv(a: boolean): void;
    private ce;
    get cf(): SeriesLayerPropertyOverlayCollection;
    protected get_eo(): boolean;
    protected get eo(): boolean;
    protected gc(): boolean;
    private rh;
    private pi;
    private b5;
    private static hk;
    private static hl;
    static pp(): void;
    static nx(a: string): string;
    static ny(a: string): string;
    static pb(a: Dictionary$2<string, string>, b: Dictionary$2<string, string>): void;
    protected r4(a: any, b: SeriesLayerPropertyOverlayValueResolvingEventArgs): void;
    protected r2(a: any, b: SeriesLayerPropertyOverlayValueResolvingEventArgs): void;
    protected r1(a: any, b: SeriesLayerPropertyOverlayValueResolvingEventArgs): void;
    protected r3(a: any, b: SeriesLayerPropertyOverlayValueResolvingEventArgs): void;
    protected get_gu(): boolean;
    protected get gu(): boolean;
    private pm;
    protected ht(): List$1<SeriesLayerPropertyOverlay>;
    private qb;
    protected hu(): List$1<SeriesLayerPropertyOverlay>;
    get fw(): boolean;
    private dw;
    protected qz(): void;
    renderValid: (sender: any, e: RenderValidEventArgs) => void;
    g2: boolean;
    g5: boolean;
    protected o3(): void;
    gl: boolean;
    protected qq(): void;
    protected q2(): void;
    private rr;
    protected o8(): void;
    cv: SeriesView;
    rw(a: Rect, b: RenderSurface): void;
    rb(): void;
    rx(): void;
    rt(a: Rect, b: Rect, c: RenderSurface, d: string, e: number): void;
    bd(): ITrendLineManager;
    getEffectiveViewport1(a: SeriesView): Rect;
    getMainContentViewport(): Rect;
    wo(a: SeriesView): Rect;
    wr(a: Rect): Rect;
    wq(a: SeriesView): Rect;
    getEffectiveViewport(): Rect;
    rn(): void;
    protected get_ef(): boolean;
    get ef(): boolean;
    protected get_el(): boolean;
    get el(): boolean;
    private ro;
    rp(a: string): void;
    getViewInfo(a: Rect, b: Rect): {
        p0: Rect;
        p1: Rect;
    };
    hf(a: Rect, b: Rect, c: SeriesView): boolean;
    o7(a: boolean, b: SeriesView): void;
    protected d6(): boolean;
    d7(a: SeriesView): boolean;
    q4(a: Rect, b: Rect): void;
    protected sv(a: Rect, b: Rect): void;
    protected su(a: Rect, b: Rect): void;
    a1: ContentInfo;
    private dz;
    get g1(): boolean;
    set g1(a: boolean);
    protected p2(a: Series): void;
    protected qo(): void;
    protected hw: Stack$1<string>;
    ri(a: string): void;
    qi(): void;
    qn(): void;
    protected get_fh(): boolean;
    get fh(): boolean;
    protected get_isUsableInLegend(): boolean;
    get isUsableInLegend(): boolean;
    protected qv(): void;
    qp(): void;
    protected q5(): void;
    q6(): void;
    protected gs: boolean;
    protected gt: boolean;
    protected gb(): boolean;
    protected q7(a: boolean): void;
    private d0;
    protected get g3(): boolean;
    protected set g3(a: boolean);
    private d1;
    protected get g6(): boolean;
    protected set g6(a: boolean);
    protected get g4(): boolean;
    protected get g7(): boolean;
    protected v(): void;
    protected w(a: Visibility, b: Visibility): void;
    protected qu(): void;
    protected qh(): void;
    as: BindingFormatter;
    at: BindingFormatter;
    private py;
    private pq;
    protected rc(a: any, b: string, c: any, d: any): void;
    private vw;
    private vx;
    private vz;
    protected sk(): void;
    ss(a: Point): void;
    pu(a: any): void;
    pz(): void;
    px(): void;
    pt(a: any): void;
    ps(a: any): void;
    eg(a: any): boolean;
    pr(a: any): void;
    pn(): void;
    protected get_ff(): boolean;
    protected get ff(): boolean;
    d8: boolean;
    protected ph(a: Series): void;
    get c4(): SyncLink;
    set c4(a: SyncLink);
    private c3;
    get dc(): SeriesViewer;
    set dc(a: SeriesViewer);
    private db;
    get da(): XamDataChart;
    set da(a: XamDataChart);
    readonly hz: (sender: any, e: NotifyCollectionChangedEventArgs) => void;
    readonly bi: (sender: any, e: PropertyUpdatedEventArgs) => void;
    readonly dq: (sender: any, e: RectChangedEventArgs) => void;
    get itemsSource(): IEnumerable;
    set itemsSource(a: IEnumerable);
    static readonly t4: DependencyProperty;
    highlightedItemsSource: IEnumerable;
    dp: IFastItemsSource;
    jw: (sender: any, e: FastItemsSourceEventArgs) => void;
    protected pd(a: FastItemsSourceEventAction, b: number, c: number, d: string): void;
    get legend(): IChartLegend;
    set legend(a: IChartLegend);
    static readonly ua: DependencyProperty;
    get sy(): Control;
    set sy(a: Control);
    private sw;
    k0(): any;
    protected sx(): Control;
    get a5(): IChartLegend;
    set a5(a: IChartLegend);
    private a4;
    legendItemVisibility: Visibility;
    get legendItemBadgeTemplate(): DataTemplate;
    set legendItemBadgeTemplate(a: DataTemplate);
    static readonly t7: DependencyProperty;
    s0: DataTemplate;
    private s2;
    vh: Brush;
    vg: Brush;
    c2: StandardLegendItems;
    c1: StandardLegendItems;
    legendItemBadgeShape: LegendItemBadgeShape;
    be: LegendItemBadgeMode;
    get legendItemTemplate(): DataTemplate;
    set legendItemTemplate(a: DataTemplate);
    static readonly t8: DependencyProperty;
    get s1(): DataTemplate;
    set s1(a: DataTemplate);
    static readonly to: DependencyProperty;
    get index(): number;
    set index(a: number);
    static readonly tz: DependencyProperty;
    st(): void;
    pl(a: string): void;
    protected fi(a: string, b: string, c: Brush, d: Brush): boolean;
    protected sl(): void;
    de: (time: number) => number;
    df: (time: number) => number;
    dg: (time: number) => number;
    ec: boolean;
    ke: number;
    jr: number;
    d4(): boolean;
    sb(): void;
    private dy;
    private h3;
    get ie(): number;
    set ie(a: number);
    protected jl(): number;
    jk: number;
    private h7;
    protected get ik(): number;
    protected set ik(a: number);
    jv: number;
    private h4;
    protected get ih(): number;
    protected set ih(a: number);
    r0(): void;
    js: number;
    private h5;
    protected get ii(): number;
    protected set ii(a: number);
    jt: number;
    private h6;
    protected get ij(): number;
    protected set ij(a: number);
    ju: number;
    title: any;
    mj: string;
    w2: Visibility;
    vk: Brush;
    ve: Brush;
    vl: Brush;
    vn: Brush;
    v4: Brush;
    vp: Brush;
    vj: Brush;
    vo: Brush;
    vf: Brush;
    vm: Brush;
    safeActualBrush: Brush;
    v0: Brush;
    vi: Brush;
    wa: PenLineJoin;
    bw: SeriesHighlightedValuesDisplayMode;
    gh: boolean;
    ji: number;
    jq: number;
    ig: number;
    im: number;
    v8: PenLineCap;
    v7: DoubleCollection;
    toolTip: any;
    private bx;
    get by(): SeriesHighlightingMode;
    set by(a: SeriesHighlightingMode);
    private co;
    get cq(): SeriesSelectionMode;
    set cq(a: SeriesSelectionMode);
    private cn;
    get cp(): SeriesSelectionMode;
    set cp(a: SeriesSelectionMode);
    protected get_gf(): boolean;
    get gf(): boolean;
    pw(): void;
    protected bz(): SeriesHighlightingMode;
    protected cs(): SeriesSelectionMode;
    protected cr(): SeriesSelectionMode;
    protected f0(a: SeriesHighlightingMode): boolean;
    private h1;
    get ib(): number;
    set ib(a: number);
    jf: number;
    private h2;
    get ic(): number;
    set ic(a: number);
    jg: number;
    ep: boolean;
    e2: boolean;
    fe: boolean;
    ha: boolean;
    protected d3: boolean;
    private dx;
    protected pg(): void;
    private eh;
    protected pv(): void;
    private rj;
    hv: List$1<UIElement>;
    gv(a: Series): boolean;
    private pc;
    protected ku(a: number): any;
    protected kt(a: number, b: boolean): any;
    protected kv(a: number): any;
    protected get_isColoredItemwise(): boolean;
    get isColoredItemwise(): boolean;
    gm: boolean;
    gk: boolean;
    gj: boolean;
    e6: boolean;
    protected get_e7(): boolean;
    get e7(): boolean;
    jn: number;
    v6: Color;
    hd: boolean;
    jo: number;
    jp: number;
    il: number;
    ia: number;
    sh(): void;
    jh: number;
    id: number;
    sj(): void;
    si(): void;
    protected jm(): number;
    private dv;
    get e5(): boolean;
    set e5(a: boolean);
    gq: boolean;
    d5: boolean;
    private cx;
    get cy(): SeriesVisibleRangeMode;
    set cy(a: SeriesVisibleRangeMode);
    cz(): SeriesVisibleRangeMode;
    c0: SeriesVisibleRangeMode;
    private ch;
    get ci(): SeriesOutlineMode;
    set ci(a: SeriesOutlineMode);
    ck(): SeriesOutlineMode;
    cj: SeriesOutlineMode;
    a3(a: any): DataContext;
    kf: number;
    kg: number;
    c6: TransitionInSpeedType;
    c9: TransitionOutSpeedType;
    protected c5(): TransitionInSpeedType;
    protected c8(): TransitionOutSpeedType;
    km: any;
    rs(): void;
    protected eb: boolean;
    rz(): void;
    q9(): void;
    q8(): void;
    ra(): void;
    rq(): void;
    o4(): void;
    qd(): void;
    private static _hr;
    static hr(a: (arg1: number) => number, b: number, c: number): IEnumerable$1<number>;
    static hq(a: (arg1: number) => number, b: number): IEnumerable$1<number>;
    v9: PenLineCap;
    private br;
    bs(): SeriesComponentsForView;
    lw: string;
    ag: any[];
    lz: string;
    ah: any[];
    r6(a: Canvas): void;
    ja(): number;
    jb(): number;
    jc(): number;
    private d2;
    protected get_g8(): boolean;
    protected set_g8(a: boolean): void;
    protected get g8(): boolean;
    protected set g8(a: boolean);
    get gi(): boolean;
    f9: boolean;
    o5(): void;
    dh(a: any, b: Point, c: boolean): HighlightingInfo;
    di(a: any, b: Point, c: boolean): HighlightingInfo;
    qw(a: Point, b: any, c: any, d: boolean): void;
    sa(a: Point): void;
    private oz;
    private o6;
    oy(a: IChartLegend, b: IChartLegend): void;
    private o0;
    rm(a: IFastItemsSourceProvider): void;
    rl(a: IFastItemsSourceProvider): void;
    protected a6(): IChartLegend;
    protected go(): boolean;
    protected gp(): boolean;
    gg(a: boolean): boolean;
    protected pe(a: Axis): void;
    protected rk(a: Axis): void;
    bt(): SeriesComponentsFromView;
    sn(a: Canvas): void;
    r9(a: Point, b: (arg1: any) => void): void;
    protected get_hb(): boolean;
    get hb(): boolean;
    rd(a: RenderingContext, b: RenderingContext): void;
    rf(a: Rect): void;
    p8(a: NotifyCollectionChangedEventArgs): void;
    ql(a: number, b: any, c: any): void;
    qg(): void;
    qj(a: number, b: any): void;
    qk(a: number, b: any): void;
    sg(): void;
    k3: any;
    jy: (arg1: any) => any;
    gx(a: Point, b: boolean): boolean;
    protected _coercionMethods: any;
    protected get_coercionMethods(): any;
    protected set_coercionMethods(a: any): void;
    get coercionMethods(): any;
    set coercionMethods(a: any);
    private du;
    protected get_expectFunctions(): boolean;
    protected set_expectFunctions(a: boolean): void;
    get expectFunctions(): boolean;
    set expectFunctions(a: boolean);
    a2(a: Point, b: boolean): DataContext;
    private b1;
    get b4(): SeriesHitTestMode;
    set b4(a: SeriesHitTestMode);
    protected b3(): SeriesHitTestMode;
    private b0;
    get b2(): SeriesHitTestMode;
    set b2(a: SeriesHitTestMode);
    protected dl(a: string): IFastItemColumn$1<number>;
    protected dm(a: string): IFastItemColumn$1<number>;
    protected dn(a: string): IFastItemColumn$1<any>;
    protected get wx(): Rect;
    protected get_fn(): boolean;
    get fn(): boolean;
    protected get_fm(): boolean;
    get fm(): boolean;
    r8(a: boolean): void;
    r7(a: Brush, b: Brush): void;
    dt: (arg1: SeriesViewer) => void;
    protected pa(a: any, b: any): void;
    kn(): any;
    protected p1(a: any): void;
    private wb;
    qe(a: Point): void;
    protected qt(a: Point): void;
    qf(): void;
    qm(): void;
    aw(a: Axis): Axis;
    ai(): Axis[];
    iz(): number;
    static i0(a: IFastItemColumn$1<number>, b: ISortingAxis): number;
    static i1(a: IList$1<number>, b: ISortingAxis): number;
    qr(): void;
    private h8;
    get io(): number;
    set io(a: number);
    private h9;
    get jj(): number;
    set jj(a: number);
    protected sr(): void;
    kq(a: any): any;
    get ll(): string;
    get k7(): string;
    get la(): string;
    get lj(): string;
    get lt(): string;
    get ls(): string;
    get ln(): string;
    protected sm(): void;
    av(): ActualLegendItemBadgeShape;
    protected bf(a: LegendItemBadgeShape): LegendItemBadgeShape;
    private bg;
    private hm;
    private hs;
    protected bk(): Series;
    protected bm(): Series;
    b6: SeriesLayer;
    get cc(): SeriesLayerCollection;
    private b9;
    get cb(): SeriesLayerCollection;
    private b8;
    get actualLayers(): SeriesLayerCollection;
    private b7;
    private hp;
    protected get ee(): boolean;
    bo: Series;
    bl: Series;
    protected r5(a: Series, b: Series): void;
    private hn;
    sd(a: string): void;
    sf(a: string): void;
    f5(a: string): boolean;
    private hj;
    sc(a: string): void;
    se(a: string, b: boolean): void;
    gn(a: string): boolean;
    f3(): boolean;
    kw(): any;
    bn(a: number, b: SeriesLayer): Series;
    protected qc(a: Series): void;
    private o2;
    private pf;
    protected ry(a: Series): void;
    ga(a: DependencyProperty): boolean;
    gr(a: DependencyProperty): boolean;
    private o9;
    private kk;
    pj(a: SeriesLayer): void;
    getDataLegendBadge(): DataTemplate;
    private a8;
    getDataLegendBadgeContext(): any;
    getDataLegendBadgeContextAtPosition(a: number, b: number): any;
    getDataLegendBadgeShapeAndMarker(): string;
    mc(): string;
    md(a: Series, b: DataTemplate): string;
    getDataLegendSeriesTitle(): string;
    iy(a: any, b: string): number;
    getDataLegendResolvedWorldPositionX(a: number): number;
    getDataLegendResolvedWorldPositionY(a: number): number;
    getDataLegendSeriesContextAt(a: number, b: number): any;
    me(): string;
    getDataLegendAxisLabelFromCursorPosition(a: number, b: number): any;
    private h0;
    v5(a: Brush): Brush;
    cg(): SeriesMatcher;
    private f8;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare abstract class MarkerSeries extends Series {
    static $t: Type;
    xb: MarkerSeriesView;
    constructor();
    protected hu(): List$1<SeriesLayerPropertyOverlay>;
    w0(a: SeriesPlotAreaMarginHorizontalMode, b: SeriesPlotAreaMarginVerticalMode): Thickness;
    q3(a: SeriesView): void;
    protected get_hasMarkers(): boolean;
    protected get_en(): boolean;
    vq(): Brush;
    vr(): Brush;
    s3(): DataTemplate;
    mc(): string;
    xf: MarkerType;
    private xc;
    get xd(): MarkerType;
    set xd(a: MarkerType);
    private xe;
    private xk;
    private xj;
    pw(): void;
    xi: boolean;
    get xh(): boolean;
    private w7;
    get w8(): MarkerOutlineMode;
    set w8(a: MarkerOutlineMode);
    xa(): MarkerOutlineMode;
    sp(a: MarkerOutlineMode): void;
    w9: MarkerOutlineMode;
    private w3;
    get w4(): MarkerFillMode;
    set w4(a: MarkerFillMode);
    w6(): MarkerFillMode;
    so(a: MarkerFillMode): void;
    sq(a: number): void;
    w5: MarkerFillMode;
    x7: DataTemplate;
    xo: number;
    ip(): number;
    x5: DataTemplate;
    x6: DataTemplate;
    private static x4;
    static get x8(): DataTemplate;
    get yo(): Brush;
    set yo(a: Brush);
    static readonly yd: DependencyProperty;
    ym: Brush;
    yp: Brush;
    yn: Brush;
    yq: Style;
    xn: boolean;
    xl(): boolean;
    protected qu(): void;
    protected rc(a: any, b: string, c: any, d: any): void;
    static xt(a: MarkerType): string;
    static xg(a: Series, b: MarkerType): MarkerType;
    protected vt(a: number): Brush;
    protected vu(a: number): Brush;
    protected sl(): void;
    protected p1(a: any): void;
    protected xm(a: Point, b: boolean): boolean;
    a2(a: Point, b: boolean): DataContext;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class SyncLink extends FrameworkElement implements INotifyPropertyChanged, IFastItemsSourceProvider {
    static $t: Type;
    constructor();
    ak: string;
    protected aq(a: any, b: string, c: any, d: any): void;
    releaseFastItemsSource(a: IEnumerable): IFastItemsSource;
    static aj: (arg1: IEnumerable) => IFastItemsSource;
    private static af;
    getFastItemsSource(a: IEnumerable): IFastItemsSource;
    ag(a: IEnumerable): IFastItemsSource;
    private ah;
    av: Rect;
    private aw;
    private ax;
    private ab;
    private ac;
    get ai(): IList$1<SeriesViewer>;
    private ad;
    al(a: SeriesViewer): void;
    as(a: SeriesViewer): void;
    private ao;
    private am;
    an(a: SeriesViewer, b: Point): void;
    ap(a: SeriesViewer, b: Rect): void;
    at(a: SeriesViewer, b: Rect): void;
    au(a: SeriesViewer, b: Rect, c: boolean): void;
    propertyChanged: (sender: any, e: PropertyChangedEventArgs) => void;
    propertyUpdated: (sender: any, e: PropertyUpdatedEventArgs) => void;
    protected ar(a: string, b: any, c: any): void;
}
/**
 * @hidden
 */
export declare class SyncLinkManager extends Base {
    static $t: Type;
    private static b;
    static instance(): SyncLinkManager;
    private d;
    get e(): number;
    constructor();
    getLink(a: string): SyncLink;
    releaseLink(a: SyncLink): void;
}
/**
 * @hidden
 */
export declare class SyncManager extends Base {
    static $t: Type;
    static e(a: SeriesViewer): void;
    static c(a: SeriesViewer): void;
    static b(a: SeriesViewer, b: string, c: string): void;
    static d(a: DependencyObject, b: SyncSettings): void;
    static a(a: DependencyObject): SyncSettings;
}
/**
 * @hidden
 */
export interface ITrendLineManager {
    readonly g$a: TrendLineManagerType;
    readonly g$n: Polyline;
    readonly g$c: boolean;
    g$b: TrendLineType;
    g$f: number;
    g$d: boolean;
    g$k(a: List$1<Point>): void;
    g$l(a: List$1<Point>, b: Clipper): void;
    g$g(a: Canvas, b: Series): void;
    g$j(): void;
    g$h(): void;
    g$m(): void;
    g$i(a: FastItemsSourceEventAction, b: number, c: number, d: string): void;
    g$e(a: any, b: string, c: any, d: any): boolean;
}
/**
 * @hidden
 */
export declare let ITrendLineManager_$type: Type;
/**
 * @hidden
 */
export declare class ChartCollection extends ObservableCollection$1<SeriesViewer> {
    static $t: Type;
    constructor();
    collectionResetting: (sender: any, e: EventArgs) => void;
    protected p(): void;
}
/**
 * @hidden
 */
export declare class SeriesCollection extends ObservableCollection$1<Series> {
    static $t: Type;
    constructor();
    collectionResetting: (sender: any, e: EventArgs) => void;
    protected p(): void;
}
/**
 * @hidden
 */
export declare class PlotAreaMouseEventArgs extends EventArgs {
    static $t: Type;
    constructor(a: SeriesViewer, b: Point, c: Point);
    private _chartPosition;
    get chartPosition(): Point;
    set chartPosition(a: Point);
    private _plotAreaPosition;
    get plotAreaPosition(): Point;
    set plotAreaPosition(a: Point);
    private _isDuringManipulation;
    get isDuringManipulation(): boolean;
    set isDuringManipulation(a: boolean);
    private _viewer;
    get viewer(): SeriesViewer;
    set viewer(a: SeriesViewer);
}
/**
 * @hidden
 */
export declare class PlotAreaMouseButtonEventArgs extends EventArgs {
    static $t: Type;
    constructor(a: SeriesViewer, b: Point, c: Point);
    private _chartPosition;
    get chartPosition(): Point;
    set chartPosition(a: Point);
    private _plotAreaPosition;
    get plotAreaPosition(): Point;
    set plotAreaPosition(a: Point);
    private _manipulationOccurred;
    get manipulationOccurred(): boolean;
    set manipulationOccurred(a: boolean);
    private _viewer;
    get viewer(): SeriesViewer;
    set viewer(a: SeriesViewer);
}
/**
 * @hidden
 */
export declare class ChartCursorEventArgs extends EventArgs {
    static $t: Type;
    constructor(a: SeriesViewer, b: Series, c: any);
    toString(): string;
    private _item;
    get item(): any;
    set item(a: any);
    private _series;
    get series(): Series;
    set series(a: Series);
    private _seriesViewer;
    get seriesViewer(): SeriesViewer;
    set seriesViewer(a: SeriesViewer);
    get chart(): XamDataChart;
}
/**
 * @hidden
 */
export declare class SeriesViewerSelectedSeriesItemsChangedEventArgs extends EventArgs {
    static $t: Type;
    private _oldItems;
    get oldItems(): ChartSelectedItemCollection;
    set oldItems(a: ChartSelectedItemCollection);
    private _newItems;
    get newItems(): ChartSelectedItemCollection;
    set newItems(a: ChartSelectedItemCollection);
    private _currentItems;
    get currentItems(): ChartSelectedItemCollection;
    set currentItems(a: ChartSelectedItemCollection);
    constructor(a: ChartSelectedItemCollection, b: ChartSelectedItemCollection, c: ChartSelectedItemCollection);
}
/**
 * @hidden
 */
export declare class DataChartMouseButtonEventArgs extends EventArgs {
    static $t: Type;
    private j;
    constructor(a: SeriesViewer, b: Series, c: any, d: MouseButtonEventArgs, e: Point);
    toString(): string;
    protected i: MouseButtonEventArgs;
    get handled(): boolean;
    set handled(a: boolean);
    private d;
    get cancelSelection(): boolean;
    set cancelSelection(a: boolean);
    getPosition(a: UIElement): Point;
    get originalSource(): any;
    private _item;
    get item(): any;
    set item(a: any);
    private _series;
    get series(): Series;
    set series(a: Series);
    private _plotAreaPosition;
    get plotAreaPosition(): Point;
    set plotAreaPosition(a: Point);
    get chartPosition(): Point;
    private _chart;
    get chart(): SeriesViewer;
    set chart(a: SeriesViewer);
}
/**
 * @hidden
 */
export declare class ChartMouseEventArgs extends EventArgs {
    static $t: Type;
    constructor(a: SeriesViewer, b: Series, c: any, d: MouseEventArgs, e: Point);
    toString(): string;
    private f;
    getPosition(a: UIElement): Point;
    get originalSource(): any;
    private _item;
    get item(): any;
    set item(a: any);
    private _series;
    get series(): Series;
    set series(a: Series);
    private _plotAreaPosition;
    get plotAreaPosition(): Point;
    set plotAreaPosition(a: Point);
    private g;
    get chartPosition(): Point;
    private _chart;
    get chart(): SeriesViewer;
    set chart(a: SeriesViewer);
}
/**
 * @hidden
 */
export declare class AxisComponentsForView extends Base {
    static $t: Type;
    a: AxisLabelPanelBase;
}
/**
 * @hidden
 */
export declare class AxisLabelPanelBaseView extends Base {
    static $t: Type;
    protected a: AxisLabelPanelBase;
    aw: Path;
    constructor(a: AxisLabelPanelBase);
    aa(a: FrameworkElement, b: Rect, c: number, d: number, e: number, f: number): void;
    z(a: Rectangle, b: TextBlock, c: LabelPosition, d: Rect, e: number, f: number, g: number, h: number): void;
    ae(a: FrameworkElement): void;
    ah(a: any): void;
    ai(a: any, b: Size): void;
    aj(a: FrameworkElement, b: number): void;
    ar(a: Rectangle, b: TextBlock, c: LabelPosition, d: Rect, e: number, f: number, g: number, h: number, i: number): void;
    ad(a: Rectangle): void;
    x(a: TextBlock, b: number, c: number, d: number): string;
    af(): void;
    g(): IEnumerable$1<any>;
    l(a: any): number;
    n(a: any): number;
    an(): void;
    m(a: any): number;
    w(a: any): number;
    ax(a: any): Size;
    ac(): void;
    ak(): void;
    protected e: RenderingContext;
    f(): RenderingContext;
    al(a: RenderingContext): void;
    y(): void;
    protected am(): void;
    private av;
    protected ap(a: TextBlock): void;
    ao(): void;
    d(): FontInfo;
    at(): Brush;
    private c;
    ag(): void;
    private h;
    private as;
    private i;
    j(): number;
    k(): number;
    protected aq(): void;
    ab(a: Size): void;
    protected ay(): Thickness;
    v(): number;
    s(): number;
    t(): number;
    u(): number;
    au(): GeometryCollection;
    b(): PathRenderingInfo;
    r(): number;
    p(): number;
    q(): number;
    o(): number;
}
/**
 * @hidden
 */
export declare class AxisView extends Base implements ISchedulableRender {
    static $t: Type;
    protected a: Axis;
    constructor(a: Axis);
    al(): void;
    an(a: any): void;
    bd: Path;
    be: Path;
    bg: Path;
    bf: Path;
    a3(): TextBlock;
    aw(a: TextBlock): void;
    ay(a: TextBlock): void;
    ax(a: TextBlock): void;
    bi(): Rectangle;
    t(a: Rectangle): void;
    v(a: Rectangle): void;
    u(a: Rectangle): void;
    ao(): void;
    p(): boolean;
    get index(): number;
    ai(): void;
    ag(): void;
    ac(): void;
    a1(a: Visibility): void;
    at(): void;
    ab(a: AxisLabelSettings): void;
    private b;
    c(): AxisComponentsFromView;
    ae(a: GeometryCollection): void;
    a4(): GeometryCollection;
    e(): PathRenderingInfo;
    a7(): GeometryCollection;
    a5(): GeometryCollection;
    f(): PathRenderingInfo;
    a6(): GeometryCollection;
    g(): PathRenderingInfo;
    protected get d(): AxisLabelPanelBase;
    az(a: Axis, b: Rect, c: Rect): void;
    ad(): void;
    av(a: number): void;
    a0(a: List$1<any>, b: List$1<LabelPosition>): void;
    au(a: number): void;
    aa(): void;
    private h;
    s(a: number): string;
    z(): void;
    aq(): void;
    l(): boolean;
    protected o(): boolean;
    m(): boolean;
    protected r(dataItem_: any): string;
    q(dataItem_: any): any;
    protected k: RenderingContext;
    j: RenderingContext;
    ak(a: RenderingContext, b: RenderingContext): void;
    private _isDirty;
    get isDirty(): boolean;
    set isDirty(a: boolean);
    protected aj(): void;
    undirty(a: boolean): void;
    private bh;
    protected ar(a: boolean): void;
    postRender(): void;
    private bb;
    protected as(): void;
    ah(): void;
    af(a: SeriesViewer): void;
    y(a: SeriesViewer): void;
    i(): FontInfo;
    n(): boolean;
    ap(): void;
    x(): void;
    a2(): void;
    w(a: AxisLabelSettings, b: string): void;
    preRender(): void;
    isValid(): boolean;
    a8(a: TextBlock): Point;
    a9(): Point;
    bc(): Rect;
    ba(a: TextBlock): Point;
    bj(a: TextBlock): Thickness;
    am(): void;
}
/**
 * @hidden
 */
export declare class CategoryAxisBaseView extends AxisView {
    static $t: Type;
    protected bk: CategoryAxisBase;
    constructor(a: CategoryAxisBase);
    s(a: number): string;
    bl(a: List$1<any>): number;
}
/**
 * @hidden
 */
export declare class HorizontalAxisLabelPanelBaseView extends AxisLabelPanelBaseView {
    static $t: Type;
    protected az: HorizontalAxisLabelPanelBase;
    constructor(a: HorizontalAxisLabelPanelBase);
    a1(): void;
    a0(): boolean;
    a2(a: List$1<Rect>): void;
}
/**
 * @hidden
 */
export declare class NumericAxisBaseView extends AxisView {
    static $t: Type;
    protected bk: NumericAxisBase;
    constructor(a: NumericAxisBase);
    bl(): void;
    protected o(): boolean;
    m(): boolean;
    protected r(dataItem_: any): string;
    s(a: number): string;
}
/**
 * @hidden
 */
export declare class VerticalAxisLabelPanelView extends AxisLabelPanelBaseView {
    static $t: Type;
    protected az: VerticalAxisLabelPanel;
    constructor(a: VerticalAxisLabelPanel);
    a0(): void;
    d(): FontInfo;
    protected ay(): Thickness;
    at(): Brush;
    a1(a: List$1<Rect>, b: number): void;
}
/**
 * @hidden
 */
export declare class XamDataChartView extends SeriesViewerView {
    static $t: Type;
    constructor(a: XamDataChart);
    protected fn: XamDataChart;
    fr(a: any): void;
    protected ds(): void;
    d4(): void;
    fw: Brush;
    fs: Brush;
    ft: Brush;
    fv: Brush;
    fu: Brush;
    fp: number;
    fq: number;
    protected d1(): void;
    fo: FontInfo;
}
/**
 * @hidden
 */
export declare class SeriesView extends Base implements ISchedulableRender, IProvidesViewport {
    static $t: Type;
    protected f: Series;
    v: boolean;
    constructor(a: Series);
    getDefaultTooltipTemplate(): string;
    a1(): void;
    k(): IExecutionContext;
    private i;
    protected get j(): IExecutionContext;
    ap(a: number, b: Series): void;
    au(a: Series): void;
    d: DataContext;
    a4(): void;
    getEffectiveViewport(): Rect;
    bb(): void;
    as(): void;
    getMainContentViewport(): Rect;
    get ae(): DomRenderer;
    l(a: string): FontInfo;
    private _isDirty;
    get isDirty(): boolean;
    set isDirty(a: boolean);
    protected get_index(): number;
    get index(): number;
    protected a2(): void;
    undirty(a: boolean): void;
    private cb;
    a6(): void;
    private b1;
    b5(): Brush;
    b2(a: Brush): Brush;
    ad: number;
    private ac;
    protected bh(a: boolean): void;
    private b6;
    protected br(a: any, b: number, c: boolean): void;
    protected bu(a: any, b: number, c: boolean): void;
    protected ai(a: number, b: boolean): any;
    protected aj(a: number): any;
    protected ak(a: number): any;
    protected bs(a: any, b: number): void;
    protected bv(a: any, b: number): void;
    protected bt(a: any, b: number): void;
    protected bw(a: any, b: number): void;
    protected bo(a: boolean): void;
    protected bp(): void;
    protected bq(): void;
    private b0;
    protected b4(a: number): Brush;
    protected b3(): Brush;
    protected bj(a: RenderingContext, b: boolean): void;
    protected bi(a: RenderingContext, b: boolean): void;
    a9(): void;
    ay(): void;
    az(): void;
    private g;
    h(): SeriesComponentsFromView;
    bm(a: Canvas): void;
    w(): boolean;
    a8(): void;
    a7(): void;
    bk(): void;
    aq(): void;
    bl(): void;
    ar(): void;
    c(a: any): DataContext;
    protected m: RenderingContext;
    protected n: RenderingContext;
    a3(a: RenderingContext, b: RenderingContext): void;
    private b7;
    get b9(): Rect;
    set b9(a: Rect);
    b8: Rect;
    protected get_ca(): Rect;
    get ca(): Rect;
    private o;
    get t(): boolean;
    set t(a: boolean);
    at(a: SeriesViewer): void;
    a: CanvasRenderScheduler;
    ao(a: SeriesViewer): void;
    postRender(): void;
    protected bc(): void;
    b(a: number): DataContext;
    be(a: RenderSurface): void;
    ax(a: any): void;
    bx(): void;
    a5(): void;
    ba(): void;
    getViewInfo(a: Rect, b: Rect): {
        p0: Rect;
        p1: Rect;
    };
    r(): boolean;
    protected u: boolean;
    by(): void;
    bg(): void;
    protected an(): void;
    a0(): void;
    preRender(): void;
    isValid(): boolean;
    q: boolean;
    s: boolean;
    bd(a: RenderSurface): void;
    al: string;
    bz(type_: StandardLegendItems): DataTemplate;
    private y;
    get aa(): List$1<ITrendLineManager>;
    e(): ITrendLineManager;
    bf(a: ITrendLineManager): void;
    private p;
    private z;
    bn(a: FrameworkElement, b: number, c: number): void;
    av(a: TextBlock, b: FontInfo): void;
    aw(a: TextBlock, b: FontInfo): void;
    cc(a: string, b: FontInfo): Size;
    private x;
    private ab;
}
/**
 * @hidden
 */
export declare abstract class MarkerSeriesView extends SeriesView {
    static $t: Type;
    protected ch: MarkerSeries;
    private cm;
    private co;
    private cn;
    constructor(a: MarkerSeries);
    a4(): void;
    cy(): void;
    c8(): Size;
    c5(a: boolean): void;
    protected cl: List$1<Marker>;
    cg(): Marker;
    abstract cw(a: (arg1: Marker) => void): void;
    cx(a: (arg1: Marker) => void): void;
    c1(a: Marker): void;
    c3(a: Marker): void;
    c2(a: Marker): void;
    ci(): boolean;
    cv(): void;
    cp(): void;
    c7(a: Marker): Rect;
    cs(a: string): void;
    ct(): void;
    cq(): void;
    cu(): void;
    cr(): void;
    c4(): void;
    ck: boolean;
    protected bv(a: any, b: number): void;
    private cd;
    protected bw(a: any, b: number): void;
    b(a: number): DataContext;
    private c6;
    protected bi(a: RenderingContext, b: boolean): void;
    cz(a: HashPool$2<any, Marker>): void;
    c0(a: Pool$1<Marker>): void;
    ce(a: Point): Marker;
    private cf;
    private cj;
}
/**
 * @hidden
 */
export declare class ChartAxisRangeChangedEventArgs extends EventArgs {
    static $t: Type;
    constructor(a: SeriesViewer, b: Axis, c: number, d: number, e: number, f: number);
    private _chart;
    get chart(): SeriesViewer;
    set chart(a: SeriesViewer);
    private _axis;
    get axis(): Axis;
    set axis(a: Axis);
    private _oldMinimumValue;
    get oldMinimumValue(): number;
    set oldMinimumValue(a: number);
    private _minimumValue;
    get minimumValue(): number;
    set minimumValue(a: number);
    private _oldMaximumValue;
    get oldMaximumValue(): number;
    set oldMaximumValue(a: number);
    private _maximumValue;
    get maximumValue(): number;
    set maximumValue(a: number);
}
